/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-react-core";
import { StringBuilder } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let ComboEditorVisualModelExport = /*@__PURE__*/ (() => {
    class ComboEditorVisualModelExport extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.i = 0;
            this.b = null;
            this.n = 0;
            this.as = null;
            this.ar = null;
            this.j = 0;
            this._dropDownButtonVisible = false;
            this.o = 0;
            this.y = null;
            this.c = null;
            this.ab = null;
            this.ac = null;
            this.ad = null;
            this.t = 0;
            this.z = null;
            this.aa = null;
            this._actualLabelVisible = false;
            this._actualNoMatchesFoundLabel = null;
            this.d = null;
            this.e = null;
            this.ag = null;
            this.ah = null;
            this.ai = null;
            this.u = 0;
            this.ae = null;
            this.af = null;
            this.aj = null;
            this._rowSeparatorsVisible = false;
            this.f = null;
            this.ao = null;
            this.ap = null;
            this.aq = null;
            this.v = 0;
            this.am = null;
            this.an = null;
            this.g = null;
            this.p = 0;
            this.h = null;
            this.q = 0;
            this.r = 0;
            this.s = 0;
            this.al = null;
            this.w = null;
        }
        get dropDownButtonVisible() {
            return this._dropDownButtonVisible;
        }
        set dropDownButtonVisible(a) {
            this._dropDownButtonVisible = a;
        }
        get actualLabelVisible() {
            return this._actualLabelVisible;
        }
        set actualLabelVisible(a) {
            this._actualLabelVisible = a;
        }
        get actualNoMatchesFoundLabel() {
            return this._actualNoMatchesFoundLabel;
        }
        set actualNoMatchesFoundLabel(a) {
            this._actualNoMatchesFoundLabel = a;
        }
        get rowSeparatorsVisible() {
            return this._rowSeparatorsVisible;
        }
        set rowSeparatorsVisible(a) {
            this._rowSeparatorsVisible = a;
        }
        ak() {
            let a = new StringBuilder(0);
            a.l("{");
            a.l("actualBackgroundColor : " + this.a.serialize() + ", ");
            a.l("actualBaseTheme : " + this.i + ", ");
            a.l("actualBorderColor : " + this.b.serialize() + ", ");
            a.l("actualBorderWidth : " + this.n + ", ");
            a.l("actualContentPadding : { left: " + this.as.left + ",top: " + this.as.top + ",right: " + this.as.right + ",bottom: " + this.as.bottom + "},");
            a.l("actualDensity : " + this.j + ", ");
            a.l("dropDownButtonVisible : " + this.dropDownButtonVisible + ", ");
            a.l("actualFocusUnderlineOpacity : " + this.o + ", ");
            a.l("label : \"" + this.y + "\", ");
            a.l("actualLabelTextColor : " + this.c.serialize() + ", ");
            if (!stringIsNullOrEmpty(this.ab)) {
                a.l("labelFontStyle : \"" + this.ab + "\", ");
            }
            if (!stringIsNullOrEmpty(this.ac)) {
                a.l("labelFontVariant : \"" + this.ac + "\", ");
            }
            if (!stringIsNullOrEmpty(this.ad)) {
                a.l("labelFontWeight : \"" + this.ad + "\", ");
            }
            if (!stringIsNullOrEmpty(this.z)) {
                a.l("labelFontFamily : \"" + this.z + "\", ");
            }
            if (!stringIsNullOrEmpty(this.aa)) {
                a.l("labelFontStretch : \"" + this.aa + "\", ");
            }
            if (!isNaN_(this.t)) {
                a.l("labelFontSize : " + this.t + ", ");
            }
            a.l("actualLabelVisible : " + this.actualLabelVisible + ", ");
            a.l("actualNoMatchesFoundLabel :\"" + this.actualNoMatchesFoundLabel + "\", ");
            a.l("actualNoMatchesFoundLabelBackgroundColor : " + this.d.serialize() + ", ");
            a.l("actualNoMatchesFoundLabelTextColor : " + this.e.serialize() + ", ");
            if (!stringIsNullOrEmpty(this.ag)) {
                a.l("noMatchesFoundLabelFontStyle : \"" + this.ag + "\", ");
            }
            if (!stringIsNullOrEmpty(this.ah)) {
                a.l("noMatchesFoundLabelFontVariant : \"" + this.ah + "\", ");
            }
            if (!stringIsNullOrEmpty(this.ai)) {
                a.l("noMatchesFoundLabelFontWeight : \"" + this.ai + "\", ");
            }
            if (!stringIsNullOrEmpty(this.ae)) {
                a.l("noMatchesFoundLabelFontFamily : \"" + this.ae + "\", ");
            }
            if (!stringIsNullOrEmpty(this.af)) {
                a.l("noMatchesFoundLabelFontStretch : \"" + this.af + "\", ");
            }
            if (!isNaN_(this.u)) {
                a.l("noMatchesFoundLabelFontSize : " + this.u + ", ");
            }
            a.l("placeholder : \"" + this.aj + "\", ");
            a.l("rowSeparatorsVisible : " + this.rowSeparatorsVisible + ", ");
            a.l("actualTextColor : " + this.f.serialize() + ", ");
            if (!stringIsNullOrEmpty(this.ao)) {
                a.l("textStyleFontStyle : \"" + this.ao + "\", ");
            }
            if (!stringIsNullOrEmpty(this.ap)) {
                a.l("textStyleFontVariant : \"" + this.ap + "\", ");
            }
            if (!stringIsNullOrEmpty(this.aq)) {
                a.l("textStyleFontWeight : \"" + this.aq + "\", ");
            }
            if (!stringIsNullOrEmpty(this.am)) {
                a.l("textStyleFontFamily : \"" + this.am + "\", ");
            }
            if (!stringIsNullOrEmpty(this.an)) {
                a.l("textStyleFontStretch : \"" + this.an + "\", ");
            }
            if (!isNaN_(this.v)) {
                a.l("textStyleFontSize : " + this.v + ", ");
            }
            a.l("actualUnderlineColor : " + this.g.serialize() + ", ");
            a.l("actualUnderlineOpacity : " + this.p + ", ");
            a.l("actualUnderlineRippleColor : " + this.h.serialize() + ", ");
            a.l("actualUnderlineRippleOpacity : " + this.q + ", ");
            a.l("actualUnderlineRippleWidth : " + this.r + ", ");
            a.l("actualUnderlineWidth : " + this.s + ", ");
            a.l("text : \"" + this.al + "\", ");
            if (this.w != null) {
                a.l("value : \"" + this.w.toString() + "\", ");
            }
            a.l("}");
            return a.toString();
        }
    }
    ComboEditorVisualModelExport.$t = /*@__PURE__*/ markType(ComboEditorVisualModelExport, 'ComboEditorVisualModelExport');
    return ComboEditorVisualModelExport;
})();
