/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-react-core";
/**
 * Indicates the selection mode to use for the grid.
 */
export var ListPanelSelectionMode = /*@__PURE__*/ (function (ListPanelSelectionMode) {
    /**
     * No selection should be peformed based on interaction.
     */
    ListPanelSelectionMode[ListPanelSelectionMode["None"] = 0] = "None";
    /**
     * A single row is permitted to be selected at a time from interaction.
     */
    ListPanelSelectionMode[ListPanelSelectionMode["SingleRow"] = 1] = "SingleRow";
    /**
     * Multiple rows are permitted to be selected at a time from interaction.
     */
    ListPanelSelectionMode[ListPanelSelectionMode["MultipleRow"] = 2] = "MultipleRow";
    return ListPanelSelectionMode;
})({});
/**
 * @hidden
 */
export let ListPanelSelectionMode_$type = /*@__PURE__*/ markEnum('ListPanelSelectionMode', 'None,0|SingleRow,1|MultipleRow,2');
