/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Number_$type, String_$type, typeCast, markType } from "igniteui-react-core";
import { JsonDictionaryObject } from "igniteui-react-core";
import { DescriptionTreeNode } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DataSeriesToDescriptionCustomization } from "igniteui-react-core";
import { DescriptionPropertyValue } from "igniteui-react-core";
import { DescriptionSerializerBuilder } from "igniteui-react-core";
import { DescriptionSerializer } from "igniteui-react-core";
import { stringSplit } from "igniteui-react-core";
import { stringContains, stringReplace, stringJoin } from "igniteui-react-core";
/**
 * @hidden
 */
export let PropertyEditorTreeTransformer = /*@__PURE__*/ (() => {
    class PropertyEditorTreeTransformer extends Base {
        constructor(a, b, c) {
            super();
            this.b = new DescriptionTreeNode();
            this.e = new List$1(DataSeriesToDescriptionCustomization.$, 0);
            this.c = null;
            this.d = false;
            this.c = a;
            this.b = new DescriptionTreeNode();
            this.b.i = b;
            this.d = c;
            let d = new JsonDictionaryObject();
        }
        a() {
            return this.e.toArray();
        }
        k(a, b, c) {
            if (a == null) {
                return;
            }
            this.f(a, -1, b, this.b, c, null);
        }
        f(a, b, c, d, e, f) {
            if (a == null) {
                return null;
            }
            let g = stringSplit(a, ['.', '['], 0);
            let h = g[0];
            let i = g.length > 1;
            let j = false;
            let k = new List$1(Number_$type, 0);
            let l = new List$1(String_$type, 0);
            if (stringContains(h, "]")) {
                j = true;
                h = stringReplace(h, "]", "");
                let m = h.split(',');
                for (let n = 0; n < m.length; n++) {
                    let o = m[n];
                    if (stringContains(o, "as")) {
                        let p = o.indexOf("as");
                        let q = o.substr(0, p).trim();
                        let r = o.substr(p + 2).trim();
                        if (q.trim() == "*") {
                            k.add(-1);
                            l.add(r);
                        }
                        else {
                            k.add(parseInt(q));
                            l.add(r);
                        }
                        e = r;
                        h = q;
                    }
                }
            }
            let s = null;
            if (!j) {
                s = this.c.getMetadata(e, h);
            }
            else {
                s = f;
            }
            if (i) {
                if (j) {
                    let t = d.b;
                    for (let u = 0; u < k.count; u++) {
                        h = k._inner[u].toString();
                        let v = l._inner[u];
                        let w = parseInt(stringReplace(stringReplace(h, "[", ""), "]", ""));
                        let x = false;
                        if (w == -1) {
                            x = true;
                            w = 0;
                        }
                        {
                            let y = new List$1(Base.$, 0);
                            for (let z = 0; z <= w; z++) {
                                if (t != null && z < t.length) {
                                    let aa = t[z];
                                    if (typeCast(DescriptionTreeNode.$, aa) !== null && z == w) {
                                        aa.i = v;
                                    }
                                    y.add1(aa);
                                }
                                else {
                                    let ab = this.g(f, true, v);
                                    if (ab != null) {
                                        y.add1(ab);
                                    }
                                }
                            }
                            t = y.toArray();
                            let ac = t[w];
                            let ad = new List$1(String_$type, 1, g);
                            ad.removeAt(0);
                            let ae = s.collectionElementType;
                            if (v != null) {
                                ae = v;
                            }
                            let af = this.f(stringJoin(".", ...ad.toArray()), x ? -1 : w, c, ac, ae, s);
                            if (af != null) {
                                t[w] = af;
                            }
                            d.b = t;
                        }
                    }
                }
                else {
                    let ag = d;
                    if (!ag.c(h)) {
                        ag.o(h, this.g(s, false, null), s);
                    }
                    let ah = ag.a(h);
                    let ai = new List$1(String_$type, 1, g);
                    ai.removeAt(0);
                    let aj = this.f(stringJoin(".", ...ai.toArray()), -1, c, ah, s.specificExternalType, s);
                    if (aj != null) {
                        ag.o(h, aj, s);
                    }
                }
            }
            else {
                if (typeCast(DescriptionPropertyValue.$, d) !== null) {
                    d = d.b;
                }
                let ak = d;
                let al = this.h(c, s);
                if (this.d) {
                    let am = new DataSeriesToDescriptionCustomization();
                    am.matchType = e;
                    am.propertyName = h;
                    if (b != -1) {
                        am.matchParentIndex = b;
                    }
                    am.propertyValue = al;
                    this.e.add(am);
                }
                ak.o(h, al, s);
            }
            return null;
        }
        i(a) {
            if (a == null) {
                return null;
            }
            if (a.length < 1) {
                return "";
            }
            return a.substr(0, 1).toLowerCase() + a.substr(1);
        }
        h(a, b) {
            if (b == null) {
                return null;
            }
            if (a == null) {
                if (b.knownType == 1 && b.specificExternalType == "double") {
                    return NaN;
                }
                return null;
            }
            switch (b.knownType) {
                case 10: return a;
                case 7: return a;
                case 4: return a.toString();
                case 6: return a;
                case 23: return a;
                case 9: return a;
                case 5: return a.toString();
                case 16: return a;
                case 20: return a;
                case 22: return a;
                case 15: return a;
                case 3: return a;
                case 19: return a;
                case 8: return a;
                case 13: return a;
                case 18: return a;
                case 1: return a;
                case 11: return a;
                case 14: return a;
                case 12: return a;
                case 2: return a;
                case 21: return a;
                case 17: return a;
                case 0: return a;
            }
            return null;
        }
        g(a, b, c) {
            if (!b && (a.knownType == 10 || a.knownType == 9)) {
                return new Array(0);
            }
            else {
                let d = new DescriptionTreeNode();
                if (c != null) {
                    d.i = c;
                }
                else {
                    d.i = a.specificExternalType != null ? a.specificExternalType : a.specificType;
                }
                return d;
            }
        }
        j() {
            let a = new DescriptionSerializerBuilder();
            let b = new DescriptionSerializer();
            let c = "root";
            a.f("{");
            a.i();
            a.f("\"descriptions\": {");
            a.i();
            a.e("\"" + c + "\"");
            a.e(": ");
            b.t(this.c, this.b, a);
            a.f("");
            a.h();
            a.e("}");
            a.h();
            a.f("}");
            return a.toString();
        }
    }
    PropertyEditorTreeTransformer.$t = /*@__PURE__*/ markType(PropertyEditorTreeTransformer, 'PropertyEditorTreeTransformer');
    return PropertyEditorTreeTransformer;
})();
