import { IgrPropertyEditorDescriptionObject } from "./igr-property-editor-description-object";
import { IgrPropertyEditorDescriptionObjectCollection } from "./igr-property-editor-description-object-collection";
import { PropertyEditorPropertyDescriptionCoercingValueEventArgs as PropertyEditorPropertyDescriptionCoercingValueEventArgs_internal } from "./PropertyEditorPropertyDescriptionCoercingValueEventArgs";
import { PropertyEditorDescriptionObjectCollection as PropertyEditorDescriptionObjectCollection_internal } from "./PropertyEditorDescriptionObjectCollection";
import { PropertyEditorDescriptionObject } from "./PropertyEditorDescriptionObject";
import { SyncableObservableCollection$1 } from "igniteui-react-core";
export class IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs {
    createImplementation() {
        return new PropertyEditorPropertyDescriptionCoercingValueEventArgs_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._complexValues = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get value() {
        return this.i.value;
    }
    set value(v) {
        this.i.value = v;
    }
    get complexValue() {
        const r = this.i.complexValue;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrPropertyEditorDescriptionObject();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set complexValue(v) {
        v == null ? this.i.complexValue = null : this.i.complexValue = v.i;
    }
    get complexValues() {
        if (this._complexValues === null) {
            let coll = new IgrPropertyEditorDescriptionObjectCollection();
            let innerColl = this.i.complexValues;
            if (!innerColl) {
                innerColl = new PropertyEditorDescriptionObjectCollection_internal();
            }
            this._complexValues = coll._fromInner(innerColl);
            this.i.complexValues = innerColl;
        }
        return this._complexValues;
    }
    set complexValues(v) {
        if (this._complexValues !== null) {
            this._complexValues._setSyncTarget(null);
            this._complexValues = null;
        }
        let coll = new IgrPropertyEditorDescriptionObjectCollection();
        this._complexValues = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(PropertyEditorDescriptionObject.$type);
        let innerColl = this.i.complexValues;
        if (!innerColl) {
            innerColl = new PropertyEditorDescriptionObjectCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._complexValues._setSyncTarget(syncColl);
        this.i.complexValues = innerColl;
    }
}
