import { ToolActionButtonDisplayType_$type } from "./ToolActionButtonDisplayType";
import { IgrToolAction } from "./igr-tool-action";
import { ToolActionButton } from "./ToolActionButton";
import { ensureEnum } from "igniteui-react-core";
export class IgrToolActionButton extends IgrToolAction {
    createImplementation() {
        return new ToolActionButton();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets the display type for the button.
    */
    get displayType() {
        return this.i.g5;
    }
    set displayType(v) {
        this.i.g5 = ensureEnum(ToolActionButtonDisplayType_$type, v);
    }
    /**
     * Gets or sets the button corner radius.
    */
    get cornerRadius() {
        return this.i.g9;
    }
    set cornerRadius(v) {
        this.i.g9 = +v;
    }
}
