import { IgrToolAction } from "./igr-tool-action";
import { ToolActionColorEditor } from "./ToolActionColorEditor";
import { brushToString, stringToBrush } from "igniteui-react-core";
export class IgrToolActionColorEditor extends IgrToolAction {
    createImplementation() {
        return new ToolActionColorEditor();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets the value for the input.
    */
    get value() {
        return brushToString(this.i.hb);
    }
    set value(v) {
        this.i.hb = stringToBrush(v);
    }
}
