import { IgrToolAction } from "./igr-tool-action";
import { ToolActionPopupOpeningEventArgs as ToolActionPopupOpeningEventArgs_internal } from "./ToolActionPopupOpeningEventArgs";
import { ensureBool } from "igniteui-react-core";
export class IgrToolActionPopupOpeningEventArgs {
    createImplementation() {
        return new ToolActionPopupOpeningEventArgs_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get sourceAction() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrToolAction._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set sourceAction(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    get cancel() {
        return this.i.b;
    }
    set cancel(v) {
        this.i.b = ensureBool(v);
    }
}
