/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { XComponentBridge } from "igniteui-react-inputs";
import { Base, runOn, delegateCombine, enumGetBox, delegateRemove, EnumUtil, typeCast, Array_$type, markType } from "igniteui-react-core";
import { NativeUIComboSelectedItemsChangedEventArgs } from "igniteui-react-core";
import { NativeUIDisplayDensity_$type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
/**
 * @hidden
 */
var ComboEditorBridge = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ComboEditorBridge, _super);
    function ComboEditorBridge(a) {
        var _this = _super.call(this, a) || this;
        _this.u = null;
        _this.v = null;
        return _this;
    }
    ComboEditorBridge.prototype.addHandler = function (a, b, c, d) {
        switch (c) {
            case 20:
                var e = a;
                e.selectedValueChanged = delegateCombine(e.selectedValueChanged, runOn(this, this.w));
                this.u = d;
                this.v = b;
                break;
        }
    };
    ComboEditorBridge.prototype.w = function (a, b) {
        if (this.u != null) {
            var c = new NativeUIComboSelectedItemsChangedEventArgs();
            if (a.value == null) {
                c.a = [];
            }
            else {
                c.a = [a.value];
            }
            this.u(this.v, c);
        }
    };
    ComboEditorBridge.prototype.getValue = function (a, b) {
        switch (b) {
            case 1:
                var c = a.density;
                var d = 1;
                switch (c) {
                    case 0:
                        d = 0;
                        break;
                    case 1:
                        d = 1;
                        break;
                    case 2:
                        d = 2;
                        break;
                    case 3:
                        d = 3;
                        break;
                    case 4:
                        d = 4;
                        break;
                }
                return enumGetBox(NativeUIDisplayDensity_$type, d);
            case 88: return a.gg;
            case 87: return a.j;
            case 8: return a.itemsSource;
            case 86: return [a.value];
        }
        return _super.prototype.getValue.call(this, a, b);
    };
    ComboEditorBridge.prototype.removeHandler = function (a, b, c, d) {
        switch (c) {
            case 20:
                var e = a;
                e.selectedValueChanged = delegateRemove(e.selectedValueChanged, runOn(this, this.w));
                this.u = null;
                this.v = null;
                break;
        }
    };
    ComboEditorBridge.prototype.setValue = function (a, b, c) {
        switch (b) {
            case 1:
                var d = 0;
                switch (EnumUtil.getEnumValue(NativeUIDisplayDensity_$type, c)) {
                    case 0:
                        d = 0;
                        break;
                    case 1:
                        d = 1;
                        break;
                    case 3:
                        d = 3;
                        break;
                    case 4:
                        d = 4;
                        break;
                    case 2:
                        d = 2;
                        break;
                }
                a.density = d;
                return;
            case 88:
                a.gg = c;
                return;
            case 87:
                a.j = [c];
                return;
            case 8:
                var e = false;
                if (c != null) {
                    if (typeCast(Array_$type, c) !== null) {
                        var h = c;
                        for (var g = 0; g < h.length; g++) {
                            var f = h[g];
                            if (typeof f === 'string') {
                                e = true;
                                break;
                            }
                            break;
                        }
                    }
                }
                if (e) {
                    var i = c;
                    var j = new List$1(Base.$, 0);
                    for (var l = 0; l < i.length; l++) {
                        var k = i[l];
                        var m = {};
                        m.label = k;
                        j.add1(m);
                    }
                    a.itemsSource = j.toArray();
                }
                else {
                    a.itemsSource = c;
                }
                return;
            case 86:
                a.value = (c != null && c.length > 0) ? c[0] : null;
                return;
        }
        _super.prototype.setValue.call(this, a, b, c);
    };
    ComboEditorBridge.$t = markType(ComboEditorBridge, 'ComboEditorBridge', XComponentBridge.$);
    return ComboEditorBridge;
}(XComponentBridge));
export { ComboEditorBridge };
