/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, fromEnum, runOn, Point_$type, Delegate_$type, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, Number_$type, delegateRemove, typeCast, delegateCombine, typeGetValue, fromEn, getInstanceType, EventArgs } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { DOMExecutionContext } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { NativeUIComponent } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { ListPanelVisualModel } from "./ListPanelVisualModel";
import { Rect } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { ListPanelSelectionMode_$type } from "./ListPanelSelectionMode";
import { ListPanelActivationMode_$type } from "./ListPanelActivationMode";
import { ListPanelSelectionBehavior_$type } from "./ListPanelSelectionBehavior";
import { ListPanelSelectedItemsCollection } from "./ListPanelSelectedItemsCollection";
import { ListPanelSelectedKeysCollection } from "./ListPanelSelectedKeysCollection";
import { IDataSource_$type } from "igniteui-react-core";
import { ScrollbarStyle_$type } from "igniteui-react-core";
import { ListPanelOrientation_$type } from "./ListPanelOrientation";
import { DeviceUtils } from "igniteui-react-core";
import { FastIterationDictionary$2 } from "igniteui-react-core";
import { Stack$1 } from "igniteui-react-core";
import { ListPanelPrimaryKeyValue } from "./ListPanelPrimaryKeyValue";
import { NativeUIInputsFactory } from "igniteui-react-core";
import { ListPanelViewportChangedEventArgs } from "./ListPanelViewportChangedEventArgs";
import { DataSourceSpecialRow } from "igniteui-react-core";
import { ListPanelSelectedItemsChangedEventArgs } from "./ListPanelSelectedItemsChangedEventArgs";
import { ListPanelSelectedKeysChangedEventArgs } from "./ListPanelSelectedKeysChangedEventArgs";
import { ListPanelSelectionChangedEventArgs } from "./ListPanelSelectionChangedEventArgs";
import { ListPanelActiveRowChangedEventArgs } from "./ListPanelActiveRowChangedEventArgs";
import { ListPanelContentRefreshedEventArgs } from "./ListPanelContentRefreshedEventArgs";
import { ListPanelItemPresenter } from "./ListPanelItemPresenter";
import { Thickness } from "igniteui-react-core";
import { ListPanelTemplateWidthRequestedEventArgs } from "./ListPanelTemplateWidthRequestedEventArgs";
import { ListPanelTemplateHeightRequestedEventArgs } from "./ListPanelTemplateHeightRequestedEventArgs";
import { ListPanelColumnDefinition } from "./ListPanelColumnDefinition";
import { ArrayExtension } from "igniteui-react-core";
import { ListPanelVisualData } from "./ListPanelVisualData";
import { ListPanelItemVisualData } from "./ListPanelItemVisualData";
import { BrushUtil } from "igniteui-react-core";
import { truncate, isNaN_ } from "igniteui-react-core";
import { IDataSourceUpdateNotifier_$type } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { HashSet$1 } from "igniteui-react-core";
import { ListPanelRowRange } from "./ListPanelRowRange";
/**
 * @hidden
 */
var ListPanelView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ListPanelView, _super);
    function ListPanelView() {
        var _this = _super.call(this) || this;
        _this.p = null;
        _this.o = null;
        _this.a = null;
        _this.j = null;
        _this.n = null;
        _this.e = null;
        _this.m = null;
        _this.g = new List$1(Delegate_$type, 0);
        _this.b = ((function () {
            var $ret = new FontInfo();
            $ret.q = "Verdana";
            $ret.f = 13;
            $ret.t = "Normal";
            $ret.v = "Normal";
            $ret.r = "Normal";
            return $ret;
        })());
        _this.ag = new Size();
        _this.c = null;
        _this._gridExternal = null;
        _this.f = false;
        _this.l = null;
        _this.k = null;
        return _this;
    }
    ListPanelView.prototype.s = function () {
        return this.j;
    };
    ListPanelView.prototype.ab = function () {
    };
    ListPanelView.prototype.z = function (a) {
        var e_1, _a;
        var _this = this;
        if (a == null) {
            try {
                for (var _b = __values(fromEnum(this.g)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b();
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.j = null;
            return;
        }
        this.a.k = new DOMExecutionContext(a);
        this.j = a;
        this.n = this.j.createElement("canvas");
        this.e = new RenderingContext(new CanvasViewRenderer(), this.j.get2DCanvasContext(this.n));
        this.m = this.j.createElement("div");
        this.ae();
        NativeUIComponent.au(this.s(), 9, function (c) {
            var d = c;
            _this.a.fx(d);
            _this.k = d.an;
        });
        var c = Math.round(a.rootWrapper.width());
        var d = Math.round(a.rootWrapper.height());
        this.j.rootWrapper.setStyleProperty("position", "relative");
        this.g.add(a.rootWrapper.listen("mousedown", runOn(this, this.t)));
        this.g.add(a.rootWrapper.listen("mouseup", runOn(this, this.u)));
    };
    ListPanelView.prototype.t = function (a) {
        var b = { $type: Point_$type, x: a.pageX - this.j.rootWrapper.getOffset().left, y: a.pageY - this.j.rootWrapper.getOffset().top };
        this.a.gg(b, a.button == 0, a.shiftKey, a.ctrlKey);
    };
    ListPanelView.prototype.u = function (a) {
        var b = { $type: Point_$type, x: a.pageX - this.j.rootWrapper.getOffset().left, y: a.pageY - this.j.rootWrapper.getOffset().top };
        this.a.gh(b, a.button == 0, a.shiftKey, a.ctrlKey);
    };
    Object.defineProperty(ListPanelView.prototype, "contentGrid", {
        get: function () {
            return this.k;
        },
        enumerable: false,
        configurable: true
    });
    ListPanelView.prototype.ae = function () {
    };
    ListPanelView.prototype.ad = function () {
        if (this.j != null) {
        }
    };
    ListPanelView.prototype.y = function () {
        if (this.j == null) {
            return;
        }
        var a = this.j.rootWrapper.width();
        var b = this.j.rootWrapper.height();
        this.k.setRawStyleProperty("width", "");
        this.k.setRawStyleProperty("height", "");
        var c = this.k.outerWidth();
        var d = this.k.outerHeight();
        if (a != 0 && b != 0) {
            c = a;
            d = b;
        }
        this.ag = new Size(1, c, d);
        this.a.onSizeChanged(this.ag.width, this.ag.height);
        if (!this.a.aw.d.isEmpty && (a != this.a.aw.d.width || b != this.a.aw.d.height)) {
            this.a.setViewport(this.a.aw.d.left, this.a.aw.d.top, this.a.aw.d.left + a, this.a.aw.d.top + b);
        }
        if (this.a.aw.d.isEmpty && a > 0 && b > 0) {
            this.a.setViewport(0, 0, a, b);
        }
    };
    ListPanelView.prototype.af = function () {
        var a = this.j;
        if (null == a) {
            return;
        }
        var b = a.rootWrapper;
        if (null != b) {
            NativeUI.q(b, this.a.h0);
            NativeUI.m(b, this.a.hu);
        }
    };
    ListPanelView.prototype.d = function () {
        return this.b;
    };
    ListPanelView.prototype.aa = function () {
    };
    ListPanelView.prototype.ac = function () {
    };
    ListPanelView.prototype.x = function (a, b) {
        this.k.setStyleProperty("min-width", a + "px");
        this.k.setStyleProperty("min-height", b + "px");
        this.a.externalListPanel.onContentSizeChanged();
    };
    ListPanelView.prototype.h = function () {
        return this.ag.width;
    };
    ListPanelView.prototype.i = function (a) {
        this.c = this.a.a3();
        return FontUtil.measureStringWidth(a, this.c, this.e);
    };
    ListPanelView.prototype.w = function (a, b) {
        if (this.l == null) {
            this.l = this.j.createElement("div");
        }
        b(this.l.getNativeElement());
    };
    ListPanelView.prototype.v = function () {
        this.a.externalObject.ensureStretch();
    };
    ListPanelView.$t = markType(ListPanelView, 'ListPanelView');
    return ListPanelView;
}(Base));
export { ListPanelView };
/**
 * @hidden
 */
var ListPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ListPanel, _super);
    function ListPanel() {
        var _this = _super.call(this) || this;
        _this._view = null;
        _this.a4 = null;
        _this.bc = false;
        _this.a5 = null;
        _this.y = null;
        _this.propertyChanged = null;
        _this.eb = null;
        _this.viewportChanged = null;
        _this.aw = null;
        _this.df = -1;
        _this.dg = -1;
        _this.ap = 0;
        _this.bf = true;
        _this.hr = null;
        _this.a8 = true;
        _this.hp = null;
        _this.hn = null;
        _this.c8 = truncate(DeviceUtils.g(1));
        _this.da = truncate(DeviceUtils.g(1));
        _this.c9 = truncate(DeviceUtils.g(1));
        _this.c7 = truncate(DeviceUtils.g(1));
        _this.q = 0;
        _this.ak = 1;
        _this.b = null;
        _this.a = null;
        _this.an = null;
        _this.o = null;
        _this.selectedItemsChanged = null;
        _this.selectedKeysChanged = null;
        _this.selectionChanged = null;
        _this.activeRowChanged = null;
        _this.af = new ListPanelSelectedItemsCollection();
        _this.ai = new ListPanelSelectedKeysCollection();
        _this.i = null;
        _this.c = new Array(0);
        _this.bs = false;
        _this.di = -1;
        _this.cy = DeviceUtils.g(42);
        _this.a1 = null;
        _this.bb = true;
        _this.ec = null;
        _this.cz = 0;
        _this.cx = NaN;
        _this.cw = 0;
        _this.bl = false;
        _this.be = false;
        _this.bk = false;
        _this.dh = -1;
        _this.contentRefreshed = null;
        _this.rowUpdating = null;
        _this.a0 = new FastIterationDictionary$2(Number_$type, ListPanelItemModel.$, 0);
        _this.itemWidthRequested = null;
        _this.itemHeightRequested = null;
        _this.az = new FastIterationDictionary$2(ListPanelItemModel.$, ListPanelItemModel.$, 0);
        _this.cv = new Stack$1(ListPanelItemModel.$);
        _this.cp = new List$1(Number_$type, 0);
        _this.co = new List$1(Number_$type, 0);
        _this.ct = new List$1(Number_$type, 0);
        _this.cs = new List$1(Number_$type, 0);
        _this.dl = -1;
        _this.cu = null;
        _this.ax = 1;
        _this.hq = null;
        _this.bp = true;
        _this.bi = true;
        _this.dc = -1;
        _this.dd = -1;
        _this.l = null;
        _this.bw = false;
        _this.k = null;
        _this.ho = ListPanel.hv;
        _this.z = ListPanel.aa;
        _this.bg = ListPanel.br;
        _this.hs = ListPanel.hw;
        _this.dj = -1;
        _this.dk = -1;
        _this.bh = true;
        _this.db = 0;
        _this._viewportManager = null;
        _this.cq = new List$1(Number_$type, 0);
        _this.cr = new List$1(Number_$type, 0);
        _this.ck = new List$1(Base.$, 0);
        _this.cl = new List$1(ListPanelPrimaryKeyValue.$, 0);
        _this.cm = new List$1(Base.$, 0);
        _this.cn = new List$1(ListPanelPrimaryKeyValue.$, 0);
        _this.ba = false;
        _this.a9 = false;
        _this.bd = false;
        _this.bj = false;
        _this.bn = false;
        _this.bm = false;
        _this.cj = false;
        _this.de = -1;
        _this.bo = false;
        _this.a7 = null;
        _this.v = null;
        _this.itemClicked = null;
        _this.ao = new ListPanelSelectionManager(_this);
        _this.p = new ListPanelActivationManager(_this);
        NativeUIInputsFactory.n();
        _this.aw = new ListPanelVisualModel();
        var a = new ListPanelView();
        a.a = _this;
        _this.view = a;
        _this.view.ab();
        _this.af.ag(runOn(_this, _this.hd));
        _this.ai.an(runOn(_this, _this.he));
        return _this;
    }
    Object.defineProperty(ListPanel.prototype, "view", {
        get: function () {
            return this._view;
        },
        set: function (a) {
            this._view = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "a6", {
        get: function () {
            if (this.a5 == null) {
                this.a5 = new SRProvider(this.view.j);
                this.a5.cb("Layouts");
            }
            return this.a5;
        },
        enumerable: false,
        configurable: true
    });
    ListPanel.prototype.fx = function (a) {
        this.y = new ListPanelLayoutPanel(a);
    };
    ListPanel.prototype.onSizeChanged = function (a, b) {
        var c = this.cx;
        var d = this.cw;
        this.cx = this.view.h();
        if (this.ab != 1) {
            if (d != this.cw || c != (isNaN_(this.cx) ? 0 : this.cx)) {
                this.view.x(this.cx, this.cw);
            }
        }
        this.g3();
    };
    ListPanel.prototype.setViewport = function (a, b, c, d) {
        this.df = -1;
        this.dg = -1;
        var e = c - a;
        var f = new Rect(0, a, b, c - a, d - b);
        if (f.x != this.aw.d.x || f.y != this.aw.d.y || f.width != this.aw.d.width || f.height != this.aw.d.height) {
            var g_1 = this.aw.d;
            this.aw.d = f;
            this.g4();
            if (this.viewportChanged != null) {
                this.viewportChanged(this, ((function () {
                    var $ret = new ListPanelViewportChangedEventArgs();
                    $ret.g = f.x;
                    $ret.d = g_1.x;
                    $ret.h = f.y;
                    $ret.e = g_1.y;
                    $ret.f = f.width;
                    $ret.c = g_1.width;
                    $ret.a = f.height;
                    $ret.b = g_1.height;
                    return $ret;
                })()));
            }
        }
    };
    ListPanel.prototype.ad = function (a, b) {
        if (this.actualDataSource == null) {
            return null;
        }
        if (b < 0 || b > this.actualDataSource.actualCount - 1) {
            return null;
        }
        var c = this.actualDataSource.getItemAtIndex(b);
        if (c == null) {
            return null;
        }
        return this.ac(a, c);
    };
    ListPanel.prototype.ac = function (a, item_) {
        var b = (item_ != null && item_.$$isSpecialRow !== undefined);
        if (a == null) {
            if (item_ == null) {
                return null;
            }
            return ListPanelPrimaryKeyValue.createIdentityKey(item_);
        }
        if (b) {
            var c = item_;
            if (this.actualDataSource.isSectionContentVisible || !this.actualDataSource.isSectionHeaderNormalRow || c.rowType != 1) {
                return ListPanelPrimaryKeyValue.createIdentityKey(item_);
            }
            else if (c.rowType == 1) {
                var d = c.getSectionKeys();
                for (var e = 0; e < d.length; e++) {
                    for (var f = 0; f < a.length; f++) {
                        if (a[f] != d[e]) {
                            return ListPanelPrimaryKeyValue.createIdentityKey(item_);
                        }
                    }
                }
            }
        }
        var g = new Array(a.length);
        for (var h = 0; h < a.length; h++) {
            g[h] = this.actualDataSource.getItemProperty(item_, a[h]);
        }
        return new ListPanelPrimaryKeyValue(a, g);
    };
    ListPanel.prototype.d6 = function (a) {
        if (this.actualDataSource == null) {
            return -1;
        }
        if (this.actualDataSource.actualPrimaryKey != null && this.actualDataSource.isKeyIndexLookupSupported) {
            return this.actualDataSource.indexOfKey(a.value);
        }
        return -1;
    };
    ListPanel.prototype.ee = function (a) {
        var b = this.d6(a);
        if (b == -1) {
            if (a.value != null && a.value.length == 1) {
                return a.value[0];
            }
            return null;
        }
        return this.actualDataSource.getItemAtIndex(b);
    };
    ListPanel.prototype.e = function () {
        if (this.actualDataSource != null) {
            return this.actualDataSource.actualPrimaryKey;
        }
        return this.d;
    };
    Object.defineProperty(ListPanel.prototype, "aq", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.gi("SelectionMode", enumGetBox(ListPanelSelectionMode_$type, b), enumGetBox(ListPanelSelectionMode_$type, this.ap));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "bv", {
        get: function () {
            return this.bf;
        },
        set: function (a) {
            var b = this.bf;
            this.bf = a;
            if (this.bf != b) {
                this.gi("IsActiveRowStyleEnabled", b, this.bf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "hz", {
        get: function () {
            return this.hr;
        },
        set: function (a) {
            var b = this.hr;
            this.hr = a;
            if (this.hr != b) {
                this.gi("SelectedBackground", b, this.hr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "bq", {
        get: function () {
            return this.a8;
        },
        set: function (a) {
            this.a8 = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "hx", {
        get: function () {
            return this.hp;
        },
        set: function (a) {
            var b = this.hp;
            this.hp = a;
            if (this.hp != b) {
                this.gi("NormalBackground", b, this.hp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "ht", {
        get: function () {
            return this.hn;
        },
        set: function (a) {
            var b = this.hn;
            this.hn = a;
            if (this.hn != b) {
                this.gi("ActivationBorder", b, this.hn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "dn", {
        get: function () {
            return this.c8;
        },
        set: function (a) {
            var b = this.c8;
            this.c8 = a;
            if (this.c8 != b) {
                this.gi("ActivationBorderLeftWidth", b, this.c8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "dq", {
        get: function () {
            return this.da;
        },
        set: function (a) {
            var b = this.da;
            this.da = a;
            if (this.da != b) {
                this.gi("ActivationBorderTopWidth", b, this.da);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "dp", {
        get: function () {
            return this.c9;
        },
        set: function (a) {
            var b = this.c9;
            this.c9 = a;
            if (this.c9 != b) {
                this.gi("ActivationBorderRightWidth", b, this.c9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "dm", {
        get: function () {
            return this.c7;
        },
        set: function (a) {
            var b = this.c7;
            this.c7 = a;
            if (this.c7 != b) {
                this.gi("ActivationBorderBottomWidth", b, this.c7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "r", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            if (b != this.q) {
                this.gi("ActivationMode", enumGetBox(ListPanelActivationMode_$type, b), enumGetBox(ListPanelActivationMode_$type, this.q));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.gi("SelectionBehavior", enumGetBox(ListPanelSelectionBehavior_$type, b), enumGetBox(ListPanelSelectionBehavior_$type, this.ak));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "f", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (this.b != b) {
                this.gi("PrimaryKey", b, this.b);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "d", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (this.a != b) {
                this.gi("ActualPrimaryKey", b, this.a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "ao", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            this.an = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "p", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            this.o = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "ag", {
        get: function () {
            return this.af;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "aj", {
        get: function () {
            return this.ai;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "itemsSource", {
        get: function () {
            return this.eb;
        },
        set: function (a) {
            var b = this.eb;
            this.eb = a;
            if (b != this.eb) {
                this.gi("ItemsSource", b, this.eb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "g", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (this.c != b) {
                this.gi("SchemaIncludedProperties", b, this.c);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "actualDataSource", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.i;
            this.i = a;
            if (this.i != b) {
                this.gi("ActualDataSource", b, this.i);
            }
        },
        enumerable: false,
        configurable: true
    });
    ListPanel.prototype.notifySizeChanged = function () {
        this.view.y();
    };
    ListPanel.prototype.destroy = function () {
        this.provideContainer(null);
    };
    ListPanel.prototype.provideContainer = function (a) {
        this.view.z(a);
    };
    Object.defineProperty(ListPanel.prototype, "ea", {
        get: function () {
            return this.di;
        },
        set: function (a) {
            var b = this.di;
            this.di = a;
            if (b != this.di) {
                this.gi("RowHeight", b, this.di);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "c2", {
        get: function () {
            return this.cy;
        },
        set: function (a) {
            var b = this.cy;
            this.cy = a;
            if (b != this.cy) {
                this.gi("ActualRowHeight", b, this.cy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "a2", {
        get: function () {
            return this.a1;
        },
        set: function (a) {
            var b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.gi("CellTextStyle", b, this.a1);
            }
        },
        enumerable: false,
        configurable: true
    });
    ListPanel.prototype.a3 = function () {
        if (this.a2 == null) {
            return this.view.d();
        }
        return this.a2;
    };
    Object.defineProperty(ListPanel.prototype, "bt", {
        get: function () {
            return this.ab == 1;
        },
        enumerable: false,
        configurable: true
    });
    ListPanel.prototype.gi = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.gv(a, b, c);
    };
    ListPanel.prototype.fj = function (a, b) {
        this.ge();
    };
    ListPanel.prototype.gy = function () {
        if (this.bk) {
            return;
        }
        this.bk = true;
        this.k.enqueueAction(runOn(this, this.fm));
    };
    ListPanel.prototype.fm = function () {
        if (!this.bk) {
            return;
        }
        this.bk = false;
        this.fu();
        if (this.bp) {
            this.fh();
        }
        this.gz();
        this.g2();
        if (this.contentRefreshed != null) {
            this.contentRefreshed(this, new ListPanelContentRefreshedEventArgs());
        }
    };
    ListPanel.prototype.fu = function () {
        if (this.bi) {
            this.fg();
            if (this.ab == 1) {
                this.y.g(new Size(1, this.cx, this.cw));
            }
        }
    };
    ListPanel.prototype.g2 = function () {
        if (this.actualDataSource == null) {
            return;
        }
        this.dh = this.actualDataSource.actualCount;
        for (var a = 0; a < this.az.o.count; a++) {
            if (this.az.p._inner[a]) {
                continue;
            }
            var b = this.az.o._inner[a];
            var c = this.az.q._inner[a];
            this.y.f(c);
        }
        var d = 0;
        var e = this.r != 0;
        for (var f = 0; f < this.a0.o.count; f++) {
            if (this.a0.p._inner[f]) {
                continue;
            }
            var g = this.a0.o._inner[f];
            var h = this.a0.q._inner[f];
            this.fq(h);
            this.fs(h);
            this.fo(h);
            this.y.d(this, h);
        }
    };
    ListPanel.prototype.fs = function (a) {
        if (a.p) {
            if (a.k) {
                a.b.a.bg = new Thickness(1, this.dn, this.dq, this.dp, this.dm);
            }
            else {
                a.b.a.bg = new Thickness(0, 0);
            }
            a.p = false;
            if (a.j) {
                a.b.a.a9 = this.ht;
            }
            else {
                a.b.a.a9 = null;
            }
            if (a.n) {
                a.b.a.a8 = this.hz;
            }
            else {
                a.b.a.a8 = this.hx;
            }
        }
    };
    ListPanel.prototype.fo = function (a) {
        if (a.m) {
            a.m = false;
            this.ft(a);
        }
    };
    ListPanel.prototype.ft = function (a) {
        if (this.rowUpdating != null) {
            var b_1 = this.c4(a.v);
            this.rowUpdating(this, ((function () {
                var $ret = new ListPanelTemplateItemUpdatingEventArgs();
                $ret.a = a;
                $ret.b = a.b.a.bl(0);
                $ret.d = a.b.a.an;
                $ret.c = b_1;
                return $ret;
            })()));
        }
    };
    ListPanel.prototype.fq = function (a) {
        var _this = this;
        if (a.b != null) {
            return;
        }
        a.b = new ListPanelItemPresenter();
        NativeUIComponent.av(this.view.s(), [7, 0], [2, 2], function (b) {
            var c = b[0];
            var d = b[1];
            d.h = 3;
            d.f = 3;
            c.bn(d);
            if (_this.ab == 0) {
                c.f = 3;
            }
            else {
                c.f = 0;
            }
            a.b.a = c;
            if (_this.hx != null) {
                a.b.a.a8 = _this.hx;
            }
        });
    };
    ListPanel.prototype.fh = function () {
        if (!this.bp) {
            return;
        }
        this.bp = false;
        this.fw();
        this.dc = this.d8();
        this.dd = this.d9();
        this.aw.c = this.dc;
        this.aw.b = this.dd;
        if (this.dc == -1 || this.dd == -1) {
            return;
        }
        var a = new List$1(Number_$type, 0);
        for (var b = 0; b < this.a0.o.count; b++) {
            if (this.a0.p._inner[b]) {
                continue;
            }
            var c = this.a0.o._inner[b];
            var d = this.a0.q._inner[b];
            if (c < this.dc || c > this.dd) {
                a.add(c);
            }
        }
        for (var e = 0; e < a.count; e++) {
            this.g5(a._inner[e]);
        }
        for (var f = this.dc; f <= this.dd; f++) {
            this.fp(f);
            var g = this.a0.item(f);
            g.u = this.c6(f);
            g.s = this.c5(f);
        }
    };
    ListPanel.prototype.c5 = function (a) {
        if (this.ab == 0) {
            return 0;
        }
        else if (this.ab == 2) {
            var b = this.d4(a);
            return this.ct._inner[b];
        }
        else {
            return this.ct._inner[a];
        }
    };
    ListPanel.prototype.d4 = function (a) {
        var b = a % this.cu.count;
        return b;
    };
    ListPanel.prototype.d5 = function (a) {
        var b = Math.floor(a / this.cu.count);
        return truncate(b);
    };
    ListPanel.prototype.c6 = function (a) {
        if (this.ab == 1) {
            return 0;
        }
        else if (this.ab == 2) {
            var b = this.d5(a);
            if (this.bx) {
                return this.cp._inner[b];
            }
            else {
                return b * this.c2;
            }
        }
        else {
            if (this.bx) {
                return this.cp._inner[a];
            }
            else {
                return a * this.c2;
            }
        }
    };
    ListPanel.prototype.fp = function (a) {
        if (this.a0.d(a)) {
            return;
        }
        var b = this.x(a);
        if (b.i) {
            this.az.f(b);
            b.i = false;
            b.o = true;
        }
        this.a0.s(a, b);
    };
    ListPanel.prototype.x = function (a) {
        var b = this.cv.f > 0 ? this.cv.e() : new ListPanelItemModel();
        b.v = a;
        b.t = this.c2;
        return b;
    };
    ListPanel.prototype.g5 = function (a) {
        var b = this.a0.item(a);
        this.g1(b);
        this.a0.f(a);
        b.i = true;
        this.az.s(b, b);
    };
    ListPanel.prototype.g1 = function (a) {
        this.cv.h(a);
    };
    ListPanel.prototype.d9 = function () {
        if (this.actualDataSource == null || this.actualDataSource.actualSchema == null || this.actualDataSource.actualCount == 0) {
            return -1;
        }
        if (!this.aw.d.isEmpty) {
            if (this.ab == 0) {
                if (this.bx) {
                    this.fu();
                    var a = this.aw.d.bottom;
                    var b = this.dw(a);
                    if (this.cp._inner[b] + this.co._inner[b] < a) {
                        b += 1;
                    }
                    return Math.max(0, Math.min(b, this.actualDataSource.actualCount - 1));
                }
                else {
                    var c = this.aw.d.bottom;
                    var d = truncate(Math.ceil(c / this.c2));
                    return Math.max(0, Math.min(d, this.actualDataSource.actualCount - 1));
                }
            }
            else if (this.ab == 2) {
                if (this.bx) {
                    this.fu();
                    var e = this.aw.d.bottom;
                    var f = this.dw(e);
                    if (this.cp._inner[f] + this.co._inner[f] < e) {
                        f += 1;
                    }
                    f = f * this.cu.count;
                    f += this.cu.count;
                    return Math.max(0, Math.min(f, this.actualDataSource.actualCount - 1));
                }
                else {
                    var g = this.aw.d.bottom;
                    var h = truncate(Math.floor(g / this.c2));
                    h = h * this.cu.count;
                    return Math.max(0, Math.min(h, this.actualDataSource.actualCount - 1));
                }
            }
            else {
                {
                    this.fu();
                    var i = this.aw.d.right;
                    var j = this.dx(i);
                    if (this.ct._inner[j] + this.cs._inner[j] < i) {
                        j += 1;
                    }
                    return Math.max(0, Math.min(j, this.actualDataSource.actualCount - 1));
                }
            }
        }
        return this.actualDataSource.actualCount - 1;
    };
    ListPanel.prototype.dw = function (a) {
        var b = -1;
        b = ArrayExtension.binarySearch$11(Number_$type, this.cp, function (c) { return a < c ? -1 : (a > c ? 1 : 0); });
        if (b < 0) {
            b = ~b;
            b--;
        }
        if (b < 0) {
            b = 0;
        }
        if (b > this.cp.count - 1) {
            b = this.cp.count - 1;
        }
        return b;
    };
    ListPanel.prototype.dx = function (a) {
        var b = -1;
        b = ArrayExtension.binarySearch$11(Number_$type, this.ct, function (c) { return a < c ? -1 : (a > c ? 1 : 0); });
        if (b < 0) {
            b = ~b;
            b--;
        }
        if (b < 0) {
            b = 0;
        }
        if (b > this.ct.count - 1) {
            b = this.ct.count - 1;
        }
        return b;
    };
    ListPanel.prototype.d8 = function () {
        if (this.actualDataSource == null || this.actualDataSource.actualSchema == null || this.actualDataSource.actualCount == 0) {
            return -1;
        }
        if (!this.aw.d.isEmpty) {
            if (this.ab == 0) {
                if (this.bx) {
                    this.fu();
                    var a = this.aw.d.top;
                    var b = this.dw(a);
                    if (this.cp._inner[b] > a) {
                        b -= 1;
                    }
                    return Math.max(0, Math.min(b, this.actualDataSource.actualCount - 1));
                }
                else {
                    var c = this.aw.d.top;
                    var d = truncate(Math.floor(c / this.c2));
                    return Math.max(0, Math.min(d, this.actualDataSource.actualCount - 1));
                }
            }
            else if (this.ab == 2) {
                if (this.bx) {
                    this.fu();
                    var e = this.aw.d.top;
                    var f = this.dw(e);
                    if (this.cp._inner[f] > e) {
                        f -= 1;
                    }
                    f = f * this.cu.count;
                    return Math.max(0, Math.min(f, this.actualDataSource.actualCount - 1));
                }
                else {
                    var g = this.aw.d.top;
                    var h = truncate(Math.floor(g / this.c2));
                    h = h * this.cu.count;
                    return Math.max(0, Math.min(h, this.actualDataSource.actualCount - 1));
                }
            }
            else {
                {
                    this.fu();
                    var i = this.aw.d.left;
                    var j = this.dx(i);
                    if (this.ct._inner[j] > i) {
                        j -= 1;
                    }
                    return Math.max(0, Math.min(j, this.actualDataSource.actualCount - 1));
                }
            }
        }
        return 0;
    };
    ListPanel.prototype.c4 = function (a) {
        if (this.ab == 2) {
            a = this.d4(a);
        }
        if (this.cs.count > 0 && a < this.cs.count) {
            return this.cs._inner[a];
        }
        return 0;
    };
    ListPanel.prototype.c3 = function (a) {
        if (this.ab == 2) {
            a = this.d5(a);
        }
        if (this.co.count > 0 && a < this.co.count) {
            return this.co._inner[a];
        }
        return this.c2;
    };
    ListPanel.prototype.fg = function () {
        var _this = this;
        this.co.clear();
        this.cp.clear();
        this.cs.clear();
        this.ct.clear();
        var a = this.r != 0;
        var b = this.dq + this.dm;
        var c = this.dn + this.dp;
        if (this.actualDataSource != null && this.actualDataSource.actualSchema != null) {
            var d = this.cw;
            var e = isNaN_(this.cx) ? 0 : this.cx;
            if (this.ab == 0) {
                if (this.bx) {
                    var f = 0;
                    var _loop_1 = function (g) {
                        this_1.cp.add(f);
                        var h = this_1.c2;
                        if (this_1.itemHeightRequested != null) {
                            var i = ((function () {
                                var $ret = new ListPanelTemplateHeightRequestedEventArgs();
                                $ret.b = g;
                                $ret.c = _this.actualDataSource.getItemAtIndex(g);
                                $ret.a = h;
                                return $ret;
                            })());
                            this_1.itemHeightRequested(this_1, i);
                            h = i.a;
                            if (a) {
                                h += b;
                            }
                            f += h;
                        }
                        this_1.co.add(h);
                    };
                    var this_1 = this;
                    for (var g = 0; g < this.actualDataSource.actualCount; g++) {
                        _loop_1(g);
                    }
                    this.cw = f;
                }
                else {
                    this.cw = this.c2 * this.actualDataSource.actualCount;
                }
            }
            else if (this.ab == 2) {
                var j = new List$1(ListPanelColumnDefinition.$, 0);
                var k = this.ds(j, 0x7FFFFFFF);
                if (this.bx) {
                    var l = 0;
                    var _loop_2 = function (m) {
                        this_2.cp.add(l);
                        var n = this_2.c2;
                        var o = 0;
                        var p = m * j.count;
                        var _loop_4 = function (q) {
                            var r = q + p;
                            if (r > this_2.actualDataSource.actualCount - 1) {
                                return "continue";
                            }
                            if (this_2.itemHeightRequested != null) {
                                var s = ((function () {
                                    var $ret = new ListPanelTemplateHeightRequestedEventArgs();
                                    $ret.b = r;
                                    $ret.c = _this.actualDataSource.getItemAtIndex(r);
                                    $ret.a = n;
                                    return $ret;
                                })());
                                this_2.itemHeightRequested(this_2, s);
                                var t = s.a;
                                if (a) {
                                    t += b;
                                }
                                o = Math.max(o, t);
                            }
                        };
                        for (var q = 0; q < j.count; q++) {
                            _loop_4(q);
                        }
                        n = o;
                        l += n;
                        this_2.co.add(n);
                    };
                    var this_2 = this;
                    for (var m = 0; m < k; m++) {
                        _loop_2(m);
                    }
                    this.cw = l;
                }
                else {
                    this.cw = this.c2 * k;
                }
                this.cu = j;
                this.dl = k;
                var u = 0;
                for (var v = 0; v < this.cu.count; v++) {
                    this.ct.add(u);
                    this.cs.add(this.cu._inner[v].a);
                    u += this.cu._inner[v].a;
                }
            }
            else {
                this.cw = this.c2;
                {
                    var w = 0;
                    var _loop_3 = function (x) {
                        this_3.ct.add(w);
                        var y = 0;
                        if (this_3.itemWidthRequested != null) {
                            var z = ((function () {
                                var $ret = new ListPanelTemplateWidthRequestedEventArgs();
                                $ret.b = x;
                                $ret.c = _this.actualDataSource.getItemAtIndex(x);
                                $ret.a = y;
                                return $ret;
                            })());
                            this_3.itemWidthRequested(this_3, z);
                            y = z.a;
                            if (a) {
                                y += c;
                            }
                            w += y;
                        }
                        this_3.cs.add(y);
                    };
                    var this_3 = this;
                    for (var x = 0; x < this.actualDataSource.actualCount; x++) {
                        _loop_3(x);
                    }
                    this.cx = w;
                }
            }
            if (d != this.cw || e != (isNaN_(this.cx) ? 0 : this.cx)) {
                this.view.x(this.cx, this.cw);
            }
        }
    };
    ListPanel.prototype.ds = function (a, b) {
        var _this = this;
        var c = 0;
        var d = 0;
        var e = 0;
        var f = this.view.h();
        f -= 5;
        var g = 0;
        var h = f;
        var i = this.actualDataSource.actualCount;
        var _loop_5 = function (j) {
            var k = 0;
            if (this_4.itemWidthRequested != null) {
                var l = ((function () {
                    var $ret = new ListPanelTemplateWidthRequestedEventArgs();
                    $ret.b = j;
                    $ret.c = _this.actualDataSource.getItemAtIndex(j);
                    $ret.a = k;
                    return $ret;
                })());
                this_4.itemWidthRequested(this_4, l);
                k = l.a;
            }
            if ((g + k > f && e > 0) || e >= b) {
                if (d != 0 && e < b && b > 1) {
                    var m = a._inner[e];
                    m.a = k;
                    this_4.g7(f, a);
                    if (a.count == 0) {
                        return { value: 0 };
                    }
                    return { value: this_4.ds(a, a.count) };
                }
                b = Math.max(Math.min(b, e), 1);
                d++;
                var n = f - g;
                if (n < h) {
                    h = n;
                }
                g = 0;
                e = 0;
            }
            if (a.count <= e) {
                var o = new ListPanelColumnDefinition();
                o.a = k;
                a.add(o);
                e++;
            }
            else {
                var p = a._inner[e];
                if (k > p.a) {
                    var q = k - p.a;
                    p.a = k;
                    if (q > h && b > 1) {
                        this_4.g7(f, a);
                        if (a.count == 0) {
                            return { value: 0 };
                        }
                        return { value: this_4.ds(a, a.count) };
                    }
                    else {
                        h -= q;
                        if (h < 0) {
                            h = 0;
                        }
                        e++;
                    }
                }
                else {
                    k = p.a;
                    e++;
                }
            }
            g += k;
        };
        var this_4 = this;
        for (var j = 0; j < i; j++) {
            var state_1 = _loop_5(j);
            if (typeof state_1 === "object")
                return state_1.value;
        }
        return d + 1;
    };
    ListPanel.prototype.g7 = function (a, b) {
        var e_2, _a;
        var c = 0;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                c += d.a;
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        while (c > a) {
            if (b.count < 1) {
                return;
            }
            c -= b._inner[b.count - 1].a;
            b.removeAt(b.count - 1);
        }
    };
    ListPanel.prototype.fv = function () {
        if (this.bk) {
            this.fm();
        }
    };
    Object.defineProperty(ListPanel.prototype, "ay", {
        get: function () {
            return this.ax;
        },
        set: function (a) {
            var b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.gi("ScrollbarStyle", enumGetBox(ScrollbarStyle_$type, b), enumGetBox(ScrollbarStyle_$type, this.ax));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "hy", {
        get: function () {
            return this.hq;
        },
        set: function (a) {
            var b = this.hq;
            this.hq = a;
            if (b != this.hq) {
                this.gi("ScrollbarBackground", b, this.hq);
            }
        },
        enumerable: false,
        configurable: true
    });
    ListPanel.prototype.g3 = function () {
        var a = isNaN_(this.cx) ? 0 : this.cx;
        var b = this.cw;
        this.bl = true;
        this.f1(this.cz);
        if (a != (isNaN_(this.cx) ? 0 : this.cx) || b != this.cw) {
            this.externalListPanel.onContentSizeChanged();
        }
        this.bl = false;
        this.f2();
        this.gy();
    };
    ListPanel.prototype.f2 = function () {
        this.bp = true;
        this.dc = -1;
        this.dd = -1;
    };
    ListPanel.prototype.f1 = function (a) {
        this.bi = true;
        this.cz = a;
    };
    ListPanel.prototype.fw = function () {
        if (this.be) {
            this.be = false;
            this.g3();
            this.f0();
        }
    };
    ListPanel.prototype.g4 = function () {
        if (this.be) {
            this.fw();
        }
        else {
            this.f2();
            this.gy();
            this.fv();
        }
    };
    ListPanel.prototype.d0 = function () {
        if (this.bp) {
            this.fh();
        }
        return this.dd;
    };
    ListPanel.prototype.dy = function () {
        if (this.bp) {
            this.fh();
        }
        return this.dc;
    };
    ListPanel.prototype.ch = function () {
        return this.dc >= 0 && this.dd >= 0;
    };
    ListPanel.prototype.f0 = function () {
        if (!this.ch()) {
            return;
        }
        var a = this.dy();
        var b = this.d0();
        this.fz(a, b);
    };
    ListPanel.prototype.fz = function (a, b) {
        var c = this.dy();
        var d = this.d0();
        if (b < c || a > d) {
            return;
        }
        if (a < c) {
            a = c;
        }
        if (b > d) {
            b = d;
        }
        this.gz();
        this.g4();
    };
    ListPanel.prototype.gz = function () {
        if (this.actualDataSource == null || this.actualDataSource.actualCount == 0) {
            return;
        }
        var a = this.r != 0;
        var b = this.aq != 0;
        for (var c = 0; c < this.a0.q.count; c++) {
            if (this.a0.p._inner[c]) {
                continue;
            }
            var d = this.a0.q._inner[c];
            d.x = this.actualDataSource.getItemAtIndex(d.v);
            d.t = this.c2;
            if (a) {
                if (this.p.c(d)) {
                    d.j = true;
                }
                else {
                    d.j = false;
                }
                d.k = true;
            }
            if (b) {
                if (this.ao.j(d)) {
                    d.n = true;
                }
                else {
                    d.n = false;
                }
                d.k = false;
            }
        }
    };
    ListPanel.prototype.g0 = function (a) {
        if (this.actualDataSource == null || this.actualDataSource.actualCount == 0) {
            return;
        }
        if (this.a0.d(a)) {
            var b = this.a0.item(a);
            b.x = this.actualDataSource.getItemAtIndex(b.v);
            b.t = this.c2;
        }
    };
    ListPanel.prototype.gx = function () {
        if (!this.be) {
            this.be = true;
            this.f2();
            this.gy();
        }
    };
    ListPanel.prototype.fy = function (a) {
        this.g0(a);
    };
    ListPanel.prototype.ge = function () {
        if (this.be) {
            this.fw();
        }
        else {
            this.g3();
            this.f0();
        }
    };
    Object.defineProperty(ListPanel.prototype, "externalListPanel", {
        get: function () {
            return this.l;
        },
        set: function (a) {
            this.l = a;
        },
        enumerable: false,
        configurable: true
    });
    ListPanel.prototype.cg = function () {
        return this.aq != 0 || this.r != 0;
    };
    ListPanel.prototype.gv = function (a, b, c) {
        var _this = this;
        switch (a) {
            case "SchemaIncludedProperties":
                if (this.i != null) {
                    this.i.schemaIncludedProperties = this.g;
                }
                break;
            case "ItemsSource":
                if (this.i != null) {
                    var d = this.i;
                    d.schemaChanged = delegateRemove(d.schemaChanged, runOn(this, this.fj));
                    this.i.updateNotifier = null;
                }
                if (typeCast(IDataSource_$type, this.itemsSource) !== null) {
                    this.actualDataSource = this.itemsSource;
                }
                else {
                    var e = this.externalListPanel.createLocalDataSource(this.itemsSource, this.g);
                    this.actualDataSource = e;
                }
                if (this.i != null) {
                    var f = this.i;
                    f.schemaChanged = delegateCombine(f.schemaChanged, runOn(this, this.fj));
                    this.i.updateNotifier = new ListPanelDataSourceNotificationBridge(this);
                    if (this.i.actualSchema != null) {
                        this.gx();
                        this.k.enqueueAction(function () { return _this.ge(); });
                    }
                }
                break;
            case "RowHeight":
                this.c2 = this.ea;
                break;
            case "CellTextStyle":
                this.f0();
                break;
            case "BackgroundColor":
                this.f0();
                break;
            case "TextColor":
                this.f0();
                break;
            case "Orientation":
            case "ActualRowHeight":
                this.g3();
                break;
            case "ScrollbarStyle":
                this.externalListPanel.setScrollbarStyle(this.ay);
                break;
            case "ScrollbarBackground":
                this.externalListPanel.setScrollbarColor(this.hy);
                break;
            case "ActiveRow":
                this.de = typeGetValue(b);
                this.bo = true;
                if (this.dr != -1 && this.dr >= 0) {
                    this.p.k(this.dr);
                }
                else {
                    this.p.o();
                }
                this.bo = false;
                break;
            case "SelectedBackground":
            case "ActivationBorder":
            case "ActivationBorderLeftWidth":
            case "ActivationBorderRightWidth":
            case "ActivationBorderBottomWidth":
            case "ActivationBorderTopWidth":
                this.gx();
                break;
            case "ActivationMode":
                this.bw = this.cg();
                break;
            case "SelectionMode":
                this.bw = this.cg();
                switch (this.aq) {
                    case 1:
                        if (this.aj.count > 1) {
                            var g = this.aj._inner[this.aj.count - 1];
                            this.aj.clear();
                            this.aj.add(g);
                        }
                        break;
                    case 2: break;
                    case 0:
                        if (this.aj.count > 0) {
                            this.aj.clear();
                        }
                        break;
                }
                break;
        }
    };
    ListPanel.prototype.h1 = function () {
        var a = this.cw;
        var b = 0;
        if (!isNaN_(a) && a >= 0) {
            b = a;
        }
        var c = 0;
        if (this.ab == 1) {
            for (var d = 0; d < this.cs.count; d++) {
                var e = this.cs._inner[d];
                if (!isNaN_(e) && e >= 0) {
                    c += e;
                }
            }
        }
        else if (this.ab == 2) {
            for (var f = 0; f < this.cs.count; f++) {
                var g = this.cs._inner[f];
                if (!isNaN_(g) && g >= 0) {
                    c += g;
                }
            }
        }
        else {
            if (!isNaN_(this.cx) && this.cx >= 0) {
                c = this.cx;
            }
        }
        return new Size(1, c, b);
    };
    ListPanel.prototype.gd = function (a, b) {
        if (this.r == 1 && this.dr != -1) {
            if (this.dr >= a && this.dr <= b) {
                if (this.activeRowChanged != null) {
                    var c = new ListPanelActiveRowChangedEventArgs();
                    c.newActiveRow = this.dr;
                    c.oldActiveRow = this.dr;
                    this.activeRowChanged(this, c);
                }
            }
        }
        var d = this.dy();
        var e = this.d0();
        if (b < d || a > e) {
            return;
        }
        if (a < d) {
            a = d;
        }
        if (b > e) {
            b = e;
        }
        if (!this.ch()) {
            return;
        }
        if (this.d2() != this.dh) {
            this.g3();
        }
        else {
            this.g4();
        }
        this.fi();
    };
    ListPanel.prototype.fi = function () {
        if (this.aw.d.isEmpty) {
            return;
        }
        if (this.ab == 1) {
            if (this.aw.d.right > this.absoluteWidth || this.aw.d.left > this.absoluteWidth) {
                var a = this.d2() - 1;
                if (a < 0) {
                    a = 0;
                }
                this.ha(a);
            }
        }
        else {
            if (this.aw.d.bottom > this.absoluteHeight || this.aw.d.top > this.absoluteHeight) {
                var b = this.d2() - 1;
                if (b < 0) {
                    b = 0;
                }
                this.ha(b);
            }
        }
        if (this.ab == 2) {
            if (this.aw.d.right > this.absoluteWidth || this.aw.d.left > this.absoluteWidth) {
                this.g9(this.cu.count - 1);
            }
        }
    };
    ListPanel.prototype.gs = function (a, b, c) {
        if (this.ab == 0) {
            if (this.bx) {
                var d = this.c2;
                if (this.itemHeightRequested != null) {
                    var e = new ListPanelTemplateHeightRequestedEventArgs();
                    e.c = c;
                    e.b = a;
                    e.a = d;
                    this.itemHeightRequested(this, e);
                    d = e.a;
                }
                var f = this.co._inner[a];
                this.co._inner[a] = d;
                var g = d - f;
                for (var h = a; h < this.actualDataSource.actualCount; h++) {
                    this.cp._inner[h] += g;
                }
            }
        }
        else if (this.ab == 2) {
            this.g3();
            return;
        }
        else {
            var i = 0;
            if (this.itemWidthRequested != null) {
                var j = new ListPanelTemplateWidthRequestedEventArgs();
                j.c = c;
                j.b = a;
                j.a = i;
                this.itemWidthRequested(this, j);
                i = j.a;
            }
            var k = this.cs._inner[a];
            this.cs._inner[a] = i;
            var l = i - k;
            for (var m = a; m < this.actualDataSource.actualCount; m++) {
                this.ct._inner[m] += l;
            }
        }
        this.fy(a);
    };
    ListPanel.prototype.gc = function () {
        this.g3();
    };
    ListPanel.prototype.gf = function (a, b) {
        if (this.ab == 0) {
            if (this.bx) {
                var c = this.c2;
                if (this.itemHeightRequested != null) {
                    var d = new ListPanelTemplateHeightRequestedEventArgs();
                    d.c = b;
                    d.b = a;
                    d.a = c;
                    this.itemHeightRequested(this, d);
                    c = d.a;
                }
                this.co.insert(a, c);
                var e = 0;
                if (a > 0) {
                    var f = this.cp._inner[a - 1];
                    e = f + this.co._inner[a - 1];
                }
                this.cp.insert(a, e);
                for (var g = a; g < this.actualDataSource.actualCount; g++) {
                    this.cp._inner[g] += c;
                }
            }
        }
        else if (this.ab == 2) {
            this.g3();
            return;
        }
        else {
            var h = 0;
            if (this.itemWidthRequested != null) {
                var i = new ListPanelTemplateWidthRequestedEventArgs();
                i.c = b;
                i.b = a;
                i.a = h;
                this.itemWidthRequested(this, i);
                h = i.a;
            }
            this.cs.insert(a, h);
            var j = 0;
            if (a > 0) {
                var k = this.ct._inner[a - 1];
                j = k + this.cs._inner[a - 1];
            }
            this.ct.insert(a, j);
            for (var l = a; l < this.actualDataSource.actualCount; l++) {
                this.ct._inner[l] += h;
            }
        }
        this.gx();
    };
    ListPanel.prototype.gj = function (a, b) {
        if (this.ab == 0) {
            var c = this.co._inner[a];
            for (var d = a + 1; d < this.actualDataSource.actualCount; d++) {
                this.cp._inner[d] -= c;
            }
            this.co.removeAt(a);
            this.cp.removeAt(a);
        }
        else if (this.ab == 2) {
            this.g3();
            return;
        }
        else {
            var e = this.cs._inner[a];
            for (var f = a + 1; f < this.actualDataSource.actualCount; f++) {
                this.ct._inner[f] -= e;
            }
            this.cs.removeAt(a);
            this.ct.removeAt(a);
        }
        this.gx();
    };
    ListPanel.prototype.f6 = function (a, b, c) {
        if (this.i != null) {
            this.i.notifySetItem(a, b, c);
        }
    };
    ListPanel.prototype.f3 = function () {
        if (this.i != null) {
            this.i.notifyClearItems();
        }
    };
    ListPanel.prototype.f4 = function (a, b) {
        if (this.i != null) {
            this.i.notifyInsertItem(a, b);
        }
        ;
    };
    ListPanel.prototype.f5 = function (a, b) {
        if (this.i != null) {
            this.i.notifyRemoveItem(a, b);
        }
        ;
    };
    ListPanel.prototype.dt = function (a) {
        if (this.i == null) {
            return -1;
        }
        return this.i.indexOfItem(a);
    };
    ListPanel.prototype.du = function (a) {
        if (this.i == null) {
            return -1;
        }
        return this.i.indexOfKey(a);
    };
    Object.defineProperty(ListPanel.prototype, "hu", {
        get: function () {
            return this.ho;
        },
        set: function (a) {
            var b = this.ho;
            this.ho = a;
            if (b != this.ho) {
                this.gi("BackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "ab", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.z;
            this.z = a;
            if (b != this.z) {
                this.gi("Orientation", enumGetBox(ListPanelOrientation_$type, b), enumGetBox(ListPanelOrientation_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "bx", {
        get: function () {
            return this.bg;
        },
        set: function (a) {
            var b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.gi("IsCustomRowHeightEnabled", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "h0", {
        get: function () {
            return this.hs;
        },
        set: function (a) {
            var b = this.hs;
            this.hs = a;
            if (b != this.hs) {
                this.gi("TextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "absoluteWidth", {
        get: function () {
            return this.cx;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanel.prototype, "absoluteHeight", {
        get: function () {
            return this.cw;
        },
        enumerable: false,
        configurable: true
    });
    ListPanel.prototype.ed = function () {
        var e_3, _a;
        var _this = this;
        var a = new ListPanelVisualData();
        var b = this.y.h();
        a.c = b.left;
        a.d = b.top;
        a.e = b.width;
        a.b = b.height;
        try {
            for (var _b = __values(fromEnum(this.a0.n)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                a.a.add(c.a(this.y));
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        a.a.aa(function (d, e) {
            if (_this.ab == 0) {
                return d.c < e.c ? -1 : d.c == e.c ? 0 : 1;
            }
            else if (_this.ab == 2) {
                if (d.c == e.c) {
                    return d.b < e.b ? -1 : d.b == e.b ? 0 : 1;
                }
                return d.c < e.c ? -1 : d.c == e.c ? 0 : 1;
            }
            else {
                return d.b < e.b ? -1 : d.b == e.b ? 0 : 1;
            }
        });
        return a;
    };
    ListPanel.prototype.ev = function () {
        var a = this.ed();
        return a.serialize();
    };
    Object.defineProperty(ListPanel.prototype, "by", {
        get: function () {
            return this.bh;
        },
        set: function (a) {
            this.bh = a;
        },
        enumerable: false,
        configurable: true
    });
    ListPanel.prototype.hc = function () {
        if (this.aq == 2) {
            this.ao.v();
        }
    };
    ListPanel.prototype.b7 = function (a, b, c) {
        if (this.by) {
            switch (a) {
                case 30:
                    if (c) {
                        this.hc();
                        return true;
                    }
                    break;
                case 32:
                    var d = false;
                    return d;
            }
        }
        return false;
    };
    ListPanel.prototype.bz = function () {
        return this.db == -1;
    };
    Object.defineProperty(ListPanel.prototype, "dr", {
        get: function () {
            return this.db;
        },
        set: function (a) {
            var b = this.db;
            this.db = a;
            if (b != this.db) {
                this.gi("ActiveRow", b, this.db);
            }
        },
        enumerable: false,
        configurable: true
    });
    ListPanel.prototype.ff = function (a, b, c) {
        if (c === void 0) {
            c = false;
        }
        if (!this.aw.a) {
            return;
        }
        if (!c) {
            if (a <= this.dy()) {
                this.ha(a);
            }
            else if (a >= this.d0()) {
                if (b) {
                    this.ha(a);
                }
                else {
                    this.g8(a);
                }
            }
        }
        if (this.ab == 2) {
            var d = this.dz();
            var e = this.d1();
            var f = this.d3(a);
            if (f <= d) {
                this.hb(f);
            }
            else if (f >= e) {
                this.g9(f);
            }
        }
    };
    ListPanel.prototype.g9 = function (a) {
        var b = truncate(this.aw.d.top);
        if (this.dg != -1) {
            b = this.dg;
        }
        if (this.ab == 2) {
            var c = 0;
            var d = 0;
            for (d = 0; d < this.cu.count; d++) {
                c += this.cu._inner[d].a;
                if (a == d) {
                    break;
                }
            }
            c -= this.aw.d.width;
            if (c < 0) {
                c = 0;
            }
            this.dg = b;
            this.df = truncate(c);
            this.viewportManager.moveViewportTo(truncate(c), b);
        }
    };
    ListPanel.prototype.hb = function (a) {
        var b = truncate(this.aw.d.top);
        if (this.dg != -1) {
            b = this.dg;
        }
        if (this.ab == 2) {
            var c = 0;
            var d = 0;
            for (d = 0; d < this.cu.count; d++) {
                if (a == d) {
                    break;
                }
                c += this.cu._inner[d].a;
            }
            this.dg = b;
            this.df = truncate(c);
            this.viewportManager.moveViewportTo(truncate(c), b);
        }
    };
    ListPanel.prototype.d3 = function (a) {
        if (this.ab == 2) {
            var b = this.d4(a);
            return b;
        }
        return -1;
    };
    ListPanel.prototype.d1 = function () {
        if (this.ab == 2) {
            var a = 0;
            var b = 0;
            for (b = 0; b < this.cu.count; b++) {
                a += this.cu._inner[b].a;
                if (a > this.aw.d.right) {
                    return Math.min(Math.max(b - 1, 0), this.cu.count - 1);
                }
            }
            return Math.min(b, this.cu.count - 1);
        }
        return -1;
    };
    ListPanel.prototype.dz = function () {
        if (this.ab == 2) {
            var a = 0;
            var b = 0;
            for (b = 0; b < this.cu.count; b++) {
                a += this.cu._inner[b].a;
                if (a > this.aw.d.left) {
                    return Math.min(Math.max(b, 0), this.cu.count - 1);
                }
            }
            return b;
        }
        return -1;
    };
    ListPanel.prototype.ha = function (a) {
        if (this.aw.d.isEmpty) {
            return;
        }
        var b = truncate(this.aw.d.left);
        if (this.df != -1) {
            b = this.df;
        }
        var c = 0;
        var d = 0;
        if (a < 0) {
            a = 0;
        }
        if (a >= this.d2()) {
            a = this.d2() - 1;
        }
        var e = 0;
        e = truncate(Math.floor(a));
        if (this.ab == 2) {
            e = truncate(Math.floor(e / this.cu.count));
        }
        if (this.cp.count > 0) {
            c = truncate(Math.floor(this.cp._inner[e]));
        }
        else {
            c = truncate(Math.floor(this.c2 * e));
        }
        if (a - truncate(Math.floor(a)) > 0) {
            var f = a - truncate(Math.floor(a));
            var g = f * this.co._inner[e];
            c = truncate(Math.floor(c + g));
        }
        c = Math.max(c, 0);
        if (this.cw > 0 && this.aw.d.height > 0 && c + this.aw.d.height > this.cw) {
            c = truncate(Math.round(this.cw - this.aw.d.height));
        }
        if (c < 0) {
            c = 0;
        }
        this.dg = c;
        this.df = b;
        this.viewportManager.moveViewportTo(b, c);
    };
    ListPanel.prototype.g8 = function (a) {
        var b = truncate(this.aw.d.left);
        if (this.df != -1) {
            b = this.df;
        }
        var c = 0;
        if (a < 0) {
            a = 0;
        }
        if (a >= this.d2()) {
            a = this.d2() - 1;
        }
        var d = truncate(Math.floor(a));
        if (this.ab == 2) {
            d = truncate(Math.floor(d / this.cu.count));
        }
        if (this.cp.count == 0) {
            c = truncate(Math.round((this.c2 * a) + this.c2));
        }
        else {
            c = truncate(Math.floor(this.cp._inner[d] + this.co._inner[d]));
        }
        if (a - truncate(Math.floor(a)) > 0) {
            var e = a - truncate(Math.floor(a));
            var f = e * this.co._inner[d];
            c = truncate(Math.floor(c + f));
        }
        c = Math.max(c, 0);
        if (this.cw > 0 && this.aw.d.height > 0) {
            c -= truncate(Math.round(this.aw.d.height));
        }
        if (this.cw > 0 && this.aw.d.height > 0 && c + this.aw.d.height > this.cw) {
            c = truncate(Math.round(this.cw - this.aw.d.height));
        }
        if (c < 0) {
            c = 0;
        }
        this.dg = c;
        this.df = b;
        this.viewportManager.moveViewportTo(b, c);
    };
    Object.defineProperty(ListPanel.prototype, "viewportManager", {
        get: function () {
            return this._viewportManager;
        },
        set: function (a) {
            this._viewportManager = a;
        },
        enumerable: false,
        configurable: true
    });
    ListPanel.prototype.b1 = function (a, b) {
        if (this.ab == 1) {
            return false;
        }
        if (this.r == 0 || this.bz()) {
            return false;
        }
        var c = this.dr;
        if (c > this.d2() - 1) {
            return false;
        }
        var d = c + 1;
        if (this.ab == 2) {
            d = c + this.cu.count;
        }
        if (b) {
            d = this.d2() - 1;
        }
        if (d > this.d2() - 1) {
            d = this.d2() - 1;
        }
        if (d == c) {
            return false;
        }
        this.dr = d;
        if (this.aw.a) {
            this.ff(d, false);
        }
        this.bm = false;
        if (this.aq == 2 && a) {
            if (this.dk == -1) {
                this.dk = c;
            }
            var e = Math.min(this.dk, d);
            var f = Math.max(this.dk, d);
            this.hf(e, f);
        }
        else {
            this.dk = -1;
            this.dj = -1;
            this.cq.clear();
            this.cr.clear();
        }
        this.gr();
        return true;
    };
    ListPanel.prototype.gr = function () {
        if (this.bm && this.selectionChanged != null) {
            this.selectionChanged(this, new ListPanelSelectionChangedEventArgs());
            this.bm = false;
        }
    };
    ListPanel.prototype.hf = function (a, b) {
        for (var c = a; c <= b; c++) {
            if (this.cq.contains(c)) {
                continue;
            }
            if (!this.cr.contains(c)) {
                var d = this.ad(this.e(), c);
                if (d != null) {
                    if (this.ao.h(d)) {
                        this.cq.add(c);
                        continue;
                    }
                    else {
                        this.cr.add(c);
                        this.aj.add(d);
                        this.ao.z(c);
                    }
                }
            }
        }
        for (var e = 0; e < this.cr.count; e++) {
            if (this.cr._inner[e] < a || this.cr._inner[e] > b) {
                var f = this.ad(this.e(), this.cr._inner[e]);
                if (f != null) {
                    this.cr.removeAt(e);
                    e--;
                    var g = this.aj.indexOf(f);
                    var h = this.ag._inner[g];
                    this.aj.remove(f);
                    this.cl.remove(f);
                    this.cn.remove(f);
                    this.ck.remove1(h);
                    this.cm.remove1(h);
                }
            }
        }
    };
    ListPanel.prototype.b2 = function (a, b) {
        if (this.r == 0 || this.bz()) {
            return false;
        }
        var c = this.dr;
        var d = this.dr;
        if (b) {
            if (d >= this.d2() - 1) {
                return false;
            }
            d = this.d2() - 1;
        }
        else if (this.ab == 2 && this.d3(d) == this.cu.count - 1) {
            return false;
        }
        var e = -1;
        if (this.ab == 2) {
            e = this.d3(d);
            var f = (d - e) + this.cu.count;
            if (f > this.d2() - 1) {
                f = this.d2() - 1;
            }
            d = f;
        }
        if (d == c) {
            return false;
        }
        this.dr = d;
        this.ff(d, false);
        return true;
    };
    ListPanel.prototype.b6 = function (a, b) {
        var c = this.db;
        var d = this.db;
        if (b) {
            if (d <= 0) {
                return false;
            }
            d = 0;
        }
        else if (this.ab == 2 && this.d3(d) == 0) {
            return false;
        }
        var e = -1;
        if (this.ab == 2) {
            e = this.d3(d);
            var f = (d - e);
            if (f < 0) {
                f = 0;
            }
            d = f;
        }
        if (d == c) {
            return false;
        }
        this.dr = d;
        this.ff(d, false);
        return true;
    };
    ListPanel.prototype.b8 = function (a, b) {
        if (this.ab == 0) {
            return false;
        }
        if (this.r == 0 || this.bz()) {
            return false;
        }
        var c = this.dr;
        if (c <= 0) {
            return false;
        }
        var d = c - 1;
        if (b) {
            d = 0;
        }
        if (b && this.ab == 2) {
            d = (c - this.d3(c));
            if (d < 0) {
                d = 0;
            }
        }
        if (d < 0) {
            d = 0;
        }
        if (d == c) {
            return false;
        }
        this.dr = d;
        if (this.aw.a) {
            this.ff(d, false);
        }
        this.bm = false;
        if (this.aq == 2 && a) {
            if (this.dk == -1) {
                this.dk = c;
            }
            var e = Math.min(this.dk, d);
            var f = Math.max(this.dk, d);
            this.hf(e, f);
        }
        else {
            this.dk = -1;
            this.dj = -1;
            this.cq.clear();
            this.cr.clear();
        }
        this.gr();
        return true;
    };
    ListPanel.prototype.b9 = function (a, b) {
        if (this.r == 0 || this.bz()) {
            return false;
        }
        var c = this.dy();
        var d = this.d0();
        var e = d - c;
        var f = Math.min(d + 1, this.d2() - 1);
        {
            this.dr = f;
        }
        this.ff(f, true);
        return true;
    };
    ListPanel.prototype.ca = function (a, b) {
        if (this.r == 0 || this.bz()) {
            return false;
        }
        var c = this.dy();
        var d = this.d0();
        var e = d - c;
        var f = Math.max(c - e - 1, 0);
        {
            this.dr = f;
        }
        this.ff(f, false);
        return true;
    };
    ListPanel.prototype.cb = function (a, b) {
        if (this.ab == 0) {
            return false;
        }
        if (this.r == 0 || this.bz()) {
            return false;
        }
        var c = this.dr;
        if (c <= 0) {
            return false;
        }
        var d = c - 1;
        if (b) {
            d = this.d2() - 1;
        }
        if (b && this.ab == 2) {
            d = (c - this.d3(c)) + this.cu.count;
            if (d > this.d2() - 1) {
                d = this.d2() - 1;
            }
        }
        if (d > this.d2() - 1) {
            d = this.d2() - 1;
        }
        if (d == c) {
            return false;
        }
        this.dr = d;
        if (this.aw.a) {
            this.ff(d, false);
        }
        this.bm = false;
        if (this.aq == 2 && a) {
            if (this.dk == -1) {
                this.dk = c;
            }
            var e = Math.min(this.dk, d);
            var f = Math.max(this.dk, d);
            this.hf(e, f);
        }
        else {
            this.dk = -1;
            this.dj = -1;
            this.cq.clear();
            this.cr.clear();
        }
        this.gr();
        return true;
    };
    ListPanel.prototype.cd = function (a, b) {
        if (this.r == 0 || this.bz()) {
            return false;
        }
        if (this.ab == 0) {
            return this.b1(a, b);
        }
        return this.cb(a, b);
    };
    ListPanel.prototype.gu = function () {
    };
    ListPanel.prototype.ce = function (a, b) {
        if (this.ab == 1) {
            return false;
        }
        if (this.r == 0 || this.bz()) {
            return false;
        }
        var c = this.dr;
        if (c <= 0) {
            return false;
        }
        var d = c - 1;
        if (this.ab == 2) {
            d = c - this.cu.count;
            if (d < 0) {
                d = 0;
            }
        }
        if (b) {
            d = 0;
        }
        if (d <= 0) {
            d = 0;
        }
        if (d == c) {
            return false;
        }
        this.dr = d;
        if (this.aw.a) {
            this.ff(d, false);
        }
        this.bm = false;
        if (this.aq == 2 && a) {
            if (this.dk == -1) {
                this.dk = c;
            }
            var e = Math.min(this.dk, d);
            var f = Math.max(this.dk, d);
            this.hf(e, f);
        }
        else {
            this.dk = -1;
            this.dj = -1;
            this.cq.clear();
            this.cr.clear();
        }
        this.gr();
        return true;
    };
    ListPanel.prototype.b3 = function (a, b) {
        return false;
    };
    ListPanel.prototype.b4 = function () {
        return false;
    };
    ListPanel.prototype.b5 = function () {
        return false;
    };
    ListPanel.prototype.cc = function (a, b) {
        return false;
    };
    ListPanel.prototype.fr = function () {
        this.view.v();
    };
    Object.defineProperty(ListPanel.prototype, "bu", {
        get: function () {
            return this.bd;
        },
        set: function (a) {
            this.bd = a;
        },
        enumerable: false,
        configurable: true
    });
    ListPanel.prototype.fe = function (a) {
        if (a === void 0) {
            a = false;
        }
        this.ck.clear();
        this.cl.clear();
        this.cm.clear();
        this.cn.clear();
        this.a9 = true;
        this.ba = a;
    };
    ListPanel.prototype.fn = function () {
        if (this.a9) {
            this.bu = true;
            this.hm(this.ck, this.cl, this.cm, this.cn);
            this.bu = false;
        }
        this.a9 = false;
    };
    Object.defineProperty(ListPanel.prototype, "b0", {
        get: function () {
            return this.bj;
        },
        set: function (a) {
            var b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.gi("NotifyOnAllSelectionChanges", b, this.bj);
            }
        },
        enumerable: false,
        configurable: true
    });
    ListPanel.prototype.hm = function (a, b, c, d) {
        if (a.count == 0 && b.count == 0 && c.count == 0 && d.count == 0) {
            return;
        }
        var e = this.b0;
        this.b0 = false;
        if (!this.bn) {
            if (!this.ba) {
                if (a.count > 0) {
                    this.ag.o(a);
                    this.aj.o(b);
                    this.bm = true;
                }
                if (c.count > 0) {
                    this.aj.ah = true;
                    this.ag.af = true;
                    for (var f = c.count - 1; f >= 0; f--) {
                        var g = this.aj.al(d._inner[f]);
                        if (g >= 0) {
                            this.ag.removeAt(g);
                            this.aj.removeAt(g);
                        }
                    }
                    this.ag.af = false;
                    this.aj.ah = false;
                    this.bm = true;
                }
            }
        }
        this.b0 = e;
        this.gm(c, a);
        this.gp(d, b);
    };
    ListPanel.prototype.hd = function (a, b) {
        var e_4, _a, e_5, _b, e_6, _c;
        var _this = this;
        this.bm = true;
        if (!this.bu && this.actualDataSource != null) {
            if (!this.bn) {
                this.bn = true;
                switch (b.action) {
                    case 0:
                        if (b.newItems != null) {
                            for (var c = 0; c < b.newItems.count; c++) {
                                var d = this.ac(this.e(), b.newItems.item(c));
                                this.aj.ae.insert(c + b.newStartingIndex, d);
                            }
                        }
                        break;
                    case 1:
                        if (b.oldItems != null) {
                            for (var e = 0; e < b.oldItems.count; e++) {
                                this.aj.ae.removeAt(b.oldStartingIndex);
                            }
                        }
                        break;
                    case 2:
                        if (b.oldItems != null) {
                            for (var f = 0; f < b.oldItems.count; f++) {
                                this.aj.ae.removeAt(b.oldStartingIndex);
                            }
                        }
                        if (b.newItems != null) {
                            for (var g = 0; g < b.newItems.count; g++) {
                                var h = this.ac(this.e(), b.newItems.item(g));
                                this.aj.ae.insert(g + b.newStartingIndex, h);
                            }
                        }
                        break;
                    case 4:
                        this.aj.clear();
                        try {
                            for (var _d = __values(fromEnum(this.ag.ae)), _e = _d.next(); !_e.done; _e = _d.next()) {
                                var i = _e.value;
                                var j = this.ac(this.e(), i);
                                this.aj.add(j);
                            }
                        }
                        catch (e_4_1) {
                            e_4 = { error: e_4_1 };
                        }
                        finally {
                            try {
                                if (_e && !_e.done && (_a = _d.return))
                                    _a.call(_d);
                            }
                            finally {
                                if (e_4)
                                    throw e_4.error;
                            }
                        }
                        break;
                }
                this.ao.af();
                this.bn = false;
            }
        }
        if (this.b0) {
            if (this.selectedItemsChanged != null) {
                var k_1 = null;
                if (b.newItems != null && b.newItems.count > 0) {
                    k_1 = new ListPanelSelectedItemsCollection();
                    try {
                        for (var _f = __values(fromEn(b.newItems)), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var l = _g.value;
                            k_1.add1(l);
                        }
                    }
                    catch (e_5_1) {
                        e_5 = { error: e_5_1 };
                    }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return))
                                _b.call(_f);
                        }
                        finally {
                            if (e_5)
                                throw e_5.error;
                        }
                    }
                }
                var m_1 = null;
                if (b.oldItems != null && b.oldItems.count > 0) {
                    m_1 = new ListPanelSelectedItemsCollection();
                    try {
                        for (var _h = __values(fromEn(b.oldItems)), _j = _h.next(); !_j.done; _j = _h.next()) {
                            var n = _j.value;
                            m_1.add1(n);
                        }
                    }
                    catch (e_6_1) {
                        e_6 = { error: e_6_1 };
                    }
                    finally {
                        try {
                            if (_j && !_j.done && (_c = _h.return))
                                _c.call(_h);
                        }
                        finally {
                            if (e_6)
                                throw e_6.error;
                        }
                    }
                }
                this.selectedItemsChanged(this, ((function () {
                    var $ret = new ListPanelSelectedItemsChangedEventArgs();
                    $ret.addedItems = k_1;
                    $ret.removedItems = m_1;
                    $ret.currentItems = _this.ag;
                    return $ret;
                })()));
            }
        }
    };
    ListPanel.prototype.he = function (a, b) {
        var e_7, _a, e_8, _b, e_9, _c;
        var _this = this;
        if (!this.bu && this.actualDataSource != null) {
            if (!this.bn) {
                this.bn = true;
                switch (b.action) {
                    case 0:
                        if (b.newItems != null) {
                            for (var c = 0; c < b.newItems.count; c++) {
                                var d = this.ee(b.newItems.item(c));
                                this.ag.ae.insert1(c + b.newStartingIndex, d);
                            }
                        }
                        break;
                    case 1:
                        if (b.oldItems != null) {
                            for (var e = 0; e < b.oldItems.count; e++) {
                                this.ag.ae.removeAt(b.oldStartingIndex);
                            }
                        }
                        break;
                    case 2:
                        if (b.oldItems != null) {
                            for (var f = 0; f < b.oldItems.count; f++) {
                                this.ag.ae.removeAt(b.oldStartingIndex);
                            }
                        }
                        if (b.newItems != null) {
                            for (var g = 0; g < b.newItems.count; g++) {
                                var h = this.ee(b.newItems.item(g));
                                this.ag.ae.insert1(g + b.newStartingIndex, h);
                            }
                        }
                        break;
                    case 4:
                        this.ag.clear();
                        try {
                            for (var _d = __values(fromEnum(this.aj.ae)), _e = _d.next(); !_e.done; _e = _d.next()) {
                                var i = _e.value;
                                var j = this.ee(i);
                                this.ag.add1(j);
                            }
                        }
                        catch (e_7_1) {
                            e_7 = { error: e_7_1 };
                        }
                        finally {
                            try {
                                if (_e && !_e.done && (_a = _d.return))
                                    _a.call(_d);
                            }
                            finally {
                                if (e_7)
                                    throw e_7.error;
                            }
                        }
                        break;
                }
                this.ao.af();
                this.bn = false;
            }
        }
        if (this.b0) {
            if (this.selectedKeysChanged != null) {
                var k_2 = null;
                if (b.newItems != null && b.newItems.count > 0) {
                    k_2 = new ListPanelSelectedKeysCollection();
                    k_2.ag = false;
                    try {
                        for (var _f = __values(fromEn(b.newItems)), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var l = _g.value;
                            k_2.add(l);
                        }
                    }
                    catch (e_8_1) {
                        e_8 = { error: e_8_1 };
                    }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return))
                                _b.call(_f);
                        }
                        finally {
                            if (e_8)
                                throw e_8.error;
                        }
                    }
                }
                var m_2 = null;
                if (b.oldItems != null && b.oldItems.count > 0) {
                    m_2 = new ListPanelSelectedKeysCollection();
                    m_2.ag = false;
                    try {
                        for (var _h = __values(fromEn(b.oldItems)), _j = _h.next(); !_j.done; _j = _h.next()) {
                            var n = _j.value;
                            m_2.add(n);
                        }
                    }
                    catch (e_9_1) {
                        e_9 = { error: e_9_1 };
                    }
                    finally {
                        try {
                            if (_j && !_j.done && (_c = _h.return))
                                _c.call(_h);
                        }
                        finally {
                            if (e_9)
                                throw e_9.error;
                        }
                    }
                }
                this.selectedKeysChanged(this, ((function () {
                    var $ret = new ListPanelSelectedKeysChangedEventArgs();
                    $ret.addedKeys = k_2;
                    $ret.removedKeys = m_2;
                    $ret.currentKeys = _this.aj;
                    return $ret;
                })()));
            }
        }
    };
    ListPanel.prototype.hj = function (a, b) {
        this.gx();
    };
    ListPanel.prototype.gk = function (a, b) {
        if (a == null) {
            var c = this.aj.ae.indexOf(b);
            if (c > -1 && this.ag.ae.count > 0) {
                a = this.ag.ae._inner[c];
            }
        }
        if (a == null) {
            return;
        }
        this.bu = true;
        if (!this.a9) {
            this.fd(a, b, true);
        }
        else {
            this.ck.add1(a);
            this.cl.add(b);
            if (this.ba) {
                this.fd(a, b, false);
            }
        }
        this.bu = false;
    };
    ListPanel.prototype.hk = function (a, b) {
        this.gx();
    };
    ListPanel.prototype.gl = function (a, b) {
        if (a == null) {
            var c = this.aj.ae.indexOf(b);
            if (c > -1 && this.ag.ae.count > 0) {
                a = this.ag.ae._inner[c];
            }
        }
        if (a == null) {
            return;
        }
        this.bu = true;
        if (!this.a9) {
            this.g6(a, b, true);
        }
        else {
            this.cm.add1(a);
            this.cn.add(b);
            if (this.ba) {
                this.g6(a, b, false);
            }
        }
        this.bu = false;
    };
    ListPanel.prototype.fd = function (a, b, c) {
        var d = this.b0;
        this.b0 = false;
        if (!this.bn) {
            this.ag.add1(a);
            this.aj.add(b);
        }
        this.b0 = d;
        if (c) {
            this.gn(null, a);
            this.go(null, b);
        }
    };
    ListPanel.prototype.hl = function (a, b, c) {
        var d = this.b0;
        this.b0 = false;
        var e = this.ag.ae._inner[a];
        if (!this.bn) {
            this.ag.ae._inner[a] = b;
        }
        this.b0 = d;
        this.gn(b, b);
    };
    ListPanel.prototype.g6 = function (a, b, c) {
        var d = this.b0;
        this.b0 = false;
        if (!this.bn) {
            this.ag.remove1(a);
            this.aj.remove(b);
        }
        this.b0 = d;
        if (c) {
            this.gn(a, null);
            this.go(b, null);
        }
    };
    ListPanel.prototype.gn = function (a, b) {
        if (!this.cj && this.selectedItemsChanged != null) {
            var c = new ListPanelSelectedItemsChangedEventArgs();
            c.currentItems = this.ag;
            if (a != null) {
                var d = new ListPanelSelectedItemsCollection();
                d.add1(a);
                c.removedItems = d;
            }
            if (b != null) {
                var e = new ListPanelSelectedItemsCollection();
                e.add1(b);
                c.addedItems = e;
            }
            this.selectedItemsChanged(this, c);
        }
    };
    ListPanel.prototype.go = function (a, b) {
        if (!this.cj && this.selectedKeysChanged != null) {
            var c = new ListPanelSelectedKeysChangedEventArgs();
            c.currentKeys = this.aj;
            if (a != null) {
                c.removedKeys = new ListPanelSelectedKeysCollection();
                c.removedKeys.ag = false;
                c.removedKeys.add(a);
            }
            if (b != null) {
                c.addedKeys = new ListPanelSelectedKeysCollection();
                c.addedKeys.ag = false;
                c.addedKeys.add(b);
            }
            this.selectedKeysChanged(this, c);
        }
    };
    ListPanel.prototype.gm = function (a, b) {
        if (!this.cj && this.selectedItemsChanged != null) {
            var c = new ListPanelSelectedItemsChangedEventArgs();
            c.currentItems = this.ag;
            if (a != null) {
                c.removedItems = new ListPanelSelectedItemsCollection();
                c.removedItems.o(a);
            }
            if (b != null) {
                c.addedItems = new ListPanelSelectedItemsCollection();
                c.addedItems.o(b);
            }
            this.selectedItemsChanged(this, c);
        }
    };
    ListPanel.prototype.gp = function (a, b) {
        if (!this.cj && this.selectedKeysChanged != null) {
            var c = new ListPanelSelectedKeysChangedEventArgs();
            c.currentKeys = this.aj;
            if (a != null) {
                c.removedKeys = new ListPanelSelectedKeysCollection();
                c.removedKeys.ag = false;
                c.removedKeys.o(a);
            }
            if (b != null) {
                c.addedKeys = new ListPanelSelectedKeysCollection();
                c.addedKeys.ag = false;
                c.addedKeys.o(b);
            }
            this.selectedKeysChanged(this, c);
        }
    };
    ListPanel.prototype.fk = function () {
        if (this.aq == 1 || this.aq == 2) {
            if (this.ag.ae.count > 0) {
                var a = new List$1(Base.$, 0);
                var b = new List$1(ListPanelPrimaryKeyValue.$, 0);
                for (var c = 0; c < this.ag.ae.count; c++) {
                    a.add1(this.ag.ae._inner[c]);
                    b.add(this.aj.ae._inner[c]);
                }
                this.bu = true;
                this.ag.clear();
                this.aj.clear();
                this.cj = true;
                this.ao.af();
                this.cj = false;
                this.bu = false;
                this.gm(a, null);
                this.gp(b, null);
                this.ao.z(-1);
            }
        }
    };
    ListPanel.prototype.h = function (a) {
        if (this.actualDataSource == null) {
            return 0;
        }
        if (a < 0 || a >= this.d2()) {
            return 0;
        }
        return this.actualDataSource.getRowType(a);
    };
    ListPanel.prototype.d7 = function (a, b, c, d) {
        if (this.actualDataSource == null || c < 0) {
            return -1;
        }
        for (var e = c; e <= d; e++) {
            if (e > this.actualDataSource.actualCount - 1) {
                break;
            }
            var f = this.actualDataSource.getItemAtIndex(e);
            if (f == null) {
                continue;
            }
            var g = this.ac(a, f);
            if (g == null) {
                continue;
            }
            if (g.value != null && g.value.length == 1 && g.value[0] != null && getInstanceType(g.value[0]) == DataSourceSpecialRow.$ && b.value != null && b.value.length == 1 && b.value[0] != null && getInstanceType(b.value[0]) == DataSourceSpecialRow.$) {
                var h = typeCast(DataSourceSpecialRow.$, g.value[0]);
                var i = typeCast(DataSourceSpecialRow.$, b.value[0]);
                if (h.rowType == i.rowType) {
                    if (h.rowType == 3 && h.targetRow == i.targetRow) {
                        return e;
                    }
                }
            }
            if (g.equals(b)) {
                return e;
            }
        }
        return -1;
    };
    ListPanel.prototype.eg = function (a) {
        if (a < 0 || a > this.actualDataSource.actualCount - 1) {
            return null;
        }
        return this.actualDataSource.getItemAtIndex(a);
    };
    ListPanel.prototype.dv = function (a, b, c, d) {
        var e = this.d7(a, b, c, d);
        if (e >= 0) {
            return e;
        }
        return this.d6(b);
    };
    ListPanel.prototype.d2 = function () {
        if (this.actualDataSource == null) {
            return 0;
        }
        return this.actualDataSource.actualCount;
    };
    ListPanel.prototype.eh = function (a) {
        var b = a.v;
        if (b < 0 || b > this.actualDataSource.actualCount - 1) {
            return null;
        }
        return this.actualDataSource.getItemAtIndex(b);
    };
    ListPanel.prototype.gq = function (a, b, c) {
        this.bu = true;
        this.hl(a, b, c);
        this.bu = false;
    };
    ListPanel.prototype.hh = function (a, b) {
        this.gx();
    };
    ListPanel.prototype.f8 = function (a) {
        if (!this.bo) {
            this.dr = a;
        }
        if (this.activeRowChanged != null) {
            var b = new ListPanelActiveRowChangedEventArgs();
            b.newActiveRow = this.dr;
            b.oldActiveRow = this.de;
            this.activeRowChanged(this, b);
        }
        this.f9();
    };
    ListPanel.prototype.hi = function (a, b) {
        this.gx();
    };
    ListPanel.prototype.gb = function (a) {
        var b = this.dr;
        if (!this.bo) {
            this.dr = a;
        }
        if (this.activeRowChanged != null) {
            var c = new ListPanelActiveRowChangedEventArgs();
            c.newActiveRow = this.dr;
            c.oldActiveRow = b;
            this.activeRowChanged(this, c);
        }
        this.f9();
    };
    ListPanel.prototype.f9 = function () {
    };
    ListPanel.prototype.ci = function (a) {
        var b = this.dt(a);
        if (b == -1) {
            return false;
        }
        this.ha(b);
        return true;
    };
    ListPanel.prototype.gg = function (a, b, c, d) {
        if (this.bw) {
            var e = this.w(a);
            this.v = e;
        }
    };
    ListPanel.prototype.w = function (a) {
        for (var b = 0; b < this.a0.o.count; b++) {
            if (this.a0.p._inner[b]) {
                continue;
            }
            var c = this.a0.o._inner[b];
            var d = this.a0.q._inner[b];
            if (this.cf(d, a)) {
                return d;
            }
        }
        return null;
    };
    ListPanel.prototype.cf = function (a, b) {
        var c = b.y + this.aw.d.top;
        var d = b.x + this.aw.d.left;
        var e = this.cx;
        var f = this.c2;
        var g = a.v;
        var h = -1;
        if (this.ab == 2) {
            g = this.d5(g);
            h = this.d4(g);
            e = this.cu._inner[h].a;
        }
        if (this.bx) {
            f = this.co._inner[g];
        }
        if (this.ab == 1) {
            e = this.cs._inner[g];
        }
        if (d >= a.s && d <= a.s + e && c >= a.u && c <= a.u + f) {
            return true;
        }
        return false;
    };
    ListPanel.prototype.gh = function (a, b, c, d) {
        if (this.bw) {
            var e = this.w(a);
            if (e != null && e == this.v) {
                this.ga(e, b, c, d);
            }
        }
    };
    ListPanel.prototype.ga = function (a, b, c, d) {
        var _this = this;
        if (b) {
            this.dk = -1;
            this.dj = -1;
            this.cq.clear();
            this.cr.clear();
            this.bm = false;
            this.ao.o(a, c, d, this.al == 0);
            this.gr();
            if (this.r == 1) {
                this.p.n(a);
            }
        }
        if (this.itemClicked != null) {
            this.itemClicked(a, ((function () {
                var $ret = new ListPanelItemEventArgs();
                $ret.itemInfo = a;
                $ret.listPanel = _this;
                $ret.isLeftButton = b;
                $ret.isDoubleClick = false;
                return $ret;
            })()));
        }
    };
    ListPanel.$t = markType(ListPanel, 'ListPanel', Base.$, [INotifyPropertyChanged_$type]);
    ListPanel.hv = null;
    ListPanel.aa = 0;
    ListPanel.br = false;
    ListPanel.hw = BrushUtil.h(255, 24, 29, 31);
    return ListPanel;
}(Base));
export { ListPanel };
/**
 * @hidden
 */
var ListPanelTemplateItemUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ListPanelTemplateItemUpdatingEventArgs, _super);
    function ListPanelTemplateItemUpdatingEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.d = null;
        _this.c = 0;
        _this.b = null;
        return _this;
    }
    ListPanelTemplateItemUpdatingEventArgs.$t = markType(ListPanelTemplateItemUpdatingEventArgs, 'ListPanelTemplateItemUpdatingEventArgs');
    return ListPanelTemplateItemUpdatingEventArgs;
}(Base));
export { ListPanelTemplateItemUpdatingEventArgs };
/**
 * @hidden
 */
var ListPanelDataSourceNotificationBridge = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ListPanelDataSourceNotificationBridge, _super);
    function ListPanelDataSourceNotificationBridge(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.a = a;
        return _this;
    }
    ListPanelDataSourceNotificationBridge.prototype.rangeActualized = function (a, b) {
        this.a.gd(a, b);
    };
    ListPanelDataSourceNotificationBridge.prototype.notifySetItem = function (a, b, c) {
        this.a.gs(a, b, c);
    };
    ListPanelDataSourceNotificationBridge.prototype.notifyClearItems = function () {
        this.a.gc();
    };
    ListPanelDataSourceNotificationBridge.prototype.notifyInsertItem = function (a, b) {
        this.a.gf(a, b);
    };
    ListPanelDataSourceNotificationBridge.prototype.notifyRemoveItem = function (a, b) {
        this.a.gj(a, b);
    };
    ListPanelDataSourceNotificationBridge.$t = markType(ListPanelDataSourceNotificationBridge, 'ListPanelDataSourceNotificationBridge', Base.$, [IDataSourceUpdateNotifier_$type]);
    return ListPanelDataSourceNotificationBridge;
}(Base));
export { ListPanelDataSourceNotificationBridge };
/**
 * @hidden
 */
var ListPanelLayoutPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ListPanelLayoutPanel, _super);
    function ListPanelLayoutPanel(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.a = a;
        return _this;
    }
    ListPanelLayoutPanel.prototype.g = function (a) {
        this.a.ae = a.width;
        this.a.y = a.height;
    };
    ListPanelLayoutPanel.prototype.h = function () {
        return this.a.be();
    };
    ListPanelLayoutPanel.prototype.b = function (a) {
        return this.a.bs(a);
    };
    ListPanelLayoutPanel.prototype.c = function (a) {
        return this.a.bt(a);
    };
    ListPanelLayoutPanel.prototype.d = function (a, b) {
        if (!b.l) {
            b.l = true;
            this.a.bn(b.b.a);
        }
        if (a.ab == 0) {
            if (!isNaN_(a.absoluteWidth)) {
                b.b.a.ae = a.absoluteWidth;
            }
            b.b.a.y = a.c3(b.v);
        }
        else if (a.ab == 2) {
            b.b.a.ae = a.c4(b.v);
            b.b.a.y = a.c3(b.v);
        }
        else {
            b.b.a.ae = a.c4(b.v);
            b.b.a.y = a.absoluteHeight;
        }
        if (b.o) {
            b.o = false;
            this.a.bu(b.b.a, b.s);
            this.a.bv(b.b.a, b.u);
        }
    };
    ListPanelLayoutPanel.prototype.e = function (a) {
        this.a.bv(a, -1000);
        this.a.bu(a, -1000);
    };
    ListPanelLayoutPanel.prototype.f = function (a) {
        a.s = -1000;
        a.u = -1000;
        if (a.b != null) {
            this.e(a.b.a);
        }
    };
    ListPanelLayoutPanel.$t = markType(ListPanelLayoutPanel, 'ListPanelLayoutPanel');
    return ListPanelLayoutPanel;
}(Base));
export { ListPanelLayoutPanel };
/**
 * @hidden
 */
var ListPanelItemModel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ListPanelItemModel, _super);
    function ListPanelItemModel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.i = false;
        _this.v = 0;
        _this.t = 0;
        _this.w = null;
        _this.b = null;
        _this.e = false;
        _this.l = false;
        _this.g = true;
        _this.h = true;
        _this.q = 0;
        _this.r = 0;
        _this.c = false;
        _this.d = false;
        _this.f = false;
        return _this;
    }
    Object.defineProperty(ListPanelItemModel.prototype, "x", {
        get: function () {
            return this.w;
        },
        set: function (a) {
            if (this.w != a) {
                this.m = true;
            }
            this.w = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanelItemModel.prototype, "m", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanelItemModel.prototype, "o", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            this.g = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanelItemModel.prototype, "p", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            this.h = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanelItemModel.prototype, "s", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            if (b != this.q) {
                this.o = true;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanelItemModel.prototype, "u", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.r;
            this.r = a;
            if (b != this.r) {
                this.o = true;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanelItemModel.prototype, "j", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.p = true;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanelItemModel.prototype, "k", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            var b = this.d;
            this.d = a;
            if (b != this.d) {
                this.p = true;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanelItemModel.prototype, "n", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            var b = this.f;
            this.f = a;
            if (b != this.f) {
                this.p = true;
            }
        },
        enumerable: false,
        configurable: true
    });
    ListPanelItemModel.prototype.a = function (a) {
        var b = new ListPanelItemVisualData();
        b.b = a.b(this.b.a);
        b.c = a.c(this.b.a);
        var c = this.b.a.be();
        b.d = c.width;
        b.a = c.height;
        return b;
    };
    ListPanelItemModel.$t = markType(ListPanelItemModel, 'ListPanelItemModel');
    return ListPanelItemModel;
}(Base));
export { ListPanelItemModel };
/**
 * @hidden
 */
var ListPanelItemEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ListPanelItemEventArgs, _super);
    function ListPanelItemEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._itemInfo = null;
        _this._listPanel = null;
        _this._isLeftButton = false;
        _this._isDoubleClick = false;
        return _this;
    }
    Object.defineProperty(ListPanelItemEventArgs.prototype, "itemInfo", {
        get: function () {
            return this._itemInfo;
        },
        set: function (a) {
            this._itemInfo = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanelItemEventArgs.prototype, "listPanel", {
        get: function () {
            return this._listPanel;
        },
        set: function (a) {
            this._listPanel = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanelItemEventArgs.prototype, "isLeftButton", {
        get: function () {
            return this._isLeftButton;
        },
        set: function (a) {
            this._isLeftButton = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ListPanelItemEventArgs.prototype, "isDoubleClick", {
        get: function () {
            return this._isDoubleClick;
        },
        set: function (a) {
            this._isDoubleClick = a;
        },
        enumerable: false,
        configurable: true
    });
    ListPanelItemEventArgs.$t = markType(ListPanelItemEventArgs, 'ListPanelItemEventArgs', EventArgs.$);
    return ListPanelItemEventArgs;
}(EventArgs));
export { ListPanelItemEventArgs };
/**
 * @hidden
 */
var ListPanelSelectionManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ListPanelSelectionManager, _super);
    function ListPanelSelectionManager(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.d = new FastIterationDictionary$2(ListPanelPrimaryKeyValue.$, Number_$type, 0);
        _this.c = new FastIterationDictionary$2(ListPanelPrimaryKeyValue.$, FastIterationDictionary$2.$.specialize(Number_$type, Number_$type), 0);
        _this.e = false;
        _this.m = -1;
        _this.b = null;
        _this.a = a;
        return _this;
    }
    ListPanelSelectionManager.prototype.ab = function (a) {
        if (!this.f(a)) {
            return;
        }
        if (this.j(a)) {
            this.ac(a);
        }
        else {
            this.w(a);
        }
    };
    ListPanelSelectionManager.prototype.f = function (a) {
        return true;
    };
    ListPanelSelectionManager.prototype.aa = function (a) {
        if (!this.f(a)) {
            return;
        }
        this.e = true;
        this.w(a);
        this.e = false;
    };
    ListPanelSelectionManager.prototype.n = function (a) {
        return a.v;
    };
    ListPanelSelectionManager.prototype.j = function (a) {
        var b = this.n(a);
        if (b == -1) {
            return false;
        }
        if (this.g(b)) {
            return false;
        }
        var c = this.a.ad(this.a.e(), b);
        if (c == null) {
            return false;
        }
        var d = this.d.d(c);
        if (d) {
            var e = this.d.item(c);
            if (e == -1) {
                this.d.item(c, b);
            }
            else if (this.d.item(c) != b) {
                return false;
            }
            var f = this.a.aj.al(c);
            if (f >= 0) {
                if (this.a.ag.ae._inner[f] == null) {
                    var g = this.a.eh(a);
                    this.a.gq(f, g, c);
                }
            }
        }
        return d;
    };
    ListPanelSelectionManager.prototype.g = function (a) {
        return false;
    };
    ListPanelSelectionManager.prototype.h = function (a) {
        return this.d.d(a);
    };
    ListPanelSelectionManager.prototype.i = function () {
        return this.a.aq == 1 || this.a.aq == 2;
    };
    ListPanelSelectionManager.prototype.ac = function (a) {
        var b = this.n(a);
        if (b == -1) {
            return;
        }
        if (this.g(b)) {
            return;
        }
        var c = this.a.ad(this.a.e(), b);
        if (this.h(c)) {
            this.ad(c, b, false);
        }
    };
    ListPanelSelectionManager.prototype.w = function (a) {
        if (this.a.aq == 0) {
            return;
        }
        var b = false;
        var c = null;
        var d = null;
        var e = this.n(a);
        if (e > -1) {
            if (!this.g(e)) {
                c = this.a.ad(this.a.e(), e);
            }
        }
        if (this.a.aq == 1 || this.e) {
            var f = this.d.o;
            var g = this.d.p;
            var h = new List$1(ListPanelPrimaryKeyValue.$, 0);
            var i = new List$1(Number_$type, 0);
            for (var j = 0; j < f.count; j++) {
                if (g._inner[j]) {
                    continue;
                }
                if (f._inner[j].equals(c)) {
                    b = true;
                    continue;
                }
                if (d != null && f._inner[j].equals(d)) {
                    b = true;
                    continue;
                }
                h.add(f._inner[j]);
                i.add(this.d.q._inner[j]);
            }
            this.a.fe();
            this.d.g = true;
            for (var k = 0; k < h.count; k++) {
                this.ad(h._inner[k], i._inner[k], false);
            }
            this.d.g = false;
            this.a.fn();
        }
        if (c == null || b) {
            return;
        }
        if (this.i()) {
            this.x(c, e, false);
        }
    };
    ListPanelSelectionManager.prototype.x = function (a, b, c) {
        var d = true;
        var e = false;
        if (!c) {
            if (this.a.h(b) == 3) {
                var f = typeCast(DataSourceSpecialRow.$, a.value[0]);
                if (f.targetRow != null) {
                    var g = this.a.ac(this.a.e(), f.targetRow);
                    var h = this.a.d7(this.a.e(), g, this.a.dy(), this.a.d0());
                    this.y(g, h, f.targetRow, true);
                }
                e = true;
                d = false;
            }
        }
        var i = null;
        if (!e) {
            i = this.a.eg(b);
        }
        this.y(a, b, i, d);
    };
    ListPanelSelectionManager.prototype.y = function (a, b, c, d) {
        if (!this.d.d(a)) {
            this.d.s(a, b);
            if (this.a.aw.c != null && this.a.aw.b != null) {
                var e = (b >= this.a.aw.c && b <= this.a.aw.b);
                if (c == null) {
                    e = true;
                }
                if (e) {
                    this.a.hj(this.a, b);
                }
            }
        }
        if (d) {
            this.a.gk(c, a);
        }
    };
    ListPanelSelectionManager.prototype.ae = function (a, b, c, d) {
        if (this.d.d(a)) {
            this.d.f(a);
            if (this.a.aw.c != -1 && this.a.aw.b != -1) {
                var e = (b >= this.a.aw.c && b <= this.a.aw.b);
                if (c == null) {
                    e = true;
                }
                if (e) {
                    var f = this.a.ad(this.a.e(), b);
                    if (f != null && f.equals(a) && b >= 0) {
                        this.a.hk(this.a, b);
                    }
                }
            }
        }
        if (d) {
            this.a.gl(c, a);
        }
    };
    ListPanelSelectionManager.prototype.ad = function (a, b, c) {
        var d = true;
        var e = false;
        if (!c) {
            if (this.a.h(b) == 3) {
                var f = typeCast(DataSourceSpecialRow.$, a.value[0]);
                if (f.targetRow != null) {
                    var g = this.a.ac(this.a.e(), f.targetRow);
                    var h = this.a.d7(this.a.e(), g, this.a.dy(), this.a.d0());
                    this.ae(g, h, f.targetRow, true);
                }
                e = true;
                d = false;
            }
        }
        var i = null;
        if (!e) {
            i = this.a.eg(b);
        }
        this.ae(a, b, i, d);
    };
    ListPanelSelectionManager.prototype.af = function () {
        var a = this.l();
        var b = new Dictionary$2(ListPanelPrimaryKeyValue.$, Number_$type, 0);
        for (var c = 0; c < a.count; c++) {
            var d = a.item(c);
            var e = -1;
            if (this.d.d(d)) {
                e = this.d.item(d);
            }
            if (e == -1) {
                e = this.a.d7(this.a.e(), d, this.a.dy(), this.a.d0());
            }
            if (!b.containsKey(d)) {
                b.addItem(d, e);
            }
            if (!this.h(d)) {
                this.x(d, e, true);
            }
        }
        var f = this.d.o;
        var g = this.d.p;
        var h = new List$1(ListPanelPrimaryKeyValue.$, 0);
        var i = new List$1(Number_$type, 0);
        for (var j = 0; j < f.count; j++) {
            if (g._inner[j]) {
                continue;
            }
            var k = f._inner[j];
            if (!b.containsKey(k)) {
                h.add(k);
                i.add(this.d.q._inner[j]);
            }
        }
        for (var l = 0; l < i.count; l++) {
            this.ad(h._inner[l], i._inner[l], false);
        }
        for (var m = 0; m < this.a.ag.ae.count; m++) {
            var n = this.a.ac(this.a.e(), this.a.ag.ae._inner[m]);
            if (n != null && !b.containsKey(n)) {
                var o = -1;
                if (this.d.d(n)) {
                    o = this.d.item(n);
                }
                if (o == -1) {
                    o = this.a.dv(this.a.e(), n, this.a.dy(), this.a.d0());
                }
                this.ad(n, o, false);
            }
        }
    };
    ListPanelSelectionManager.prototype.l = function () {
        return this.a.aj.ae;
    };
    ListPanelSelectionManager.prototype.q = function () {
        this.p();
    };
    ListPanelSelectionManager.prototype.r = function (a) {
        for (var b = 0; b < this.d.o.count; b++) {
            if (this.d.p._inner[b]) {
                continue;
            }
            var c = this.d.o._inner[b];
            var d = this.d.q._inner[b];
            if (d >= a) {
                this.d.item(c, d + 1);
            }
        }
        for (var e = 0; e < this.c.o.count; e++) {
            if (this.c.p._inner[e]) {
                continue;
            }
            var f = this.c.o._inner[e];
            var g = this.c.q._inner[e];
            for (var h = 0; h < g.o.count; h++) {
                if (this.c.item(f).p._inner[h]) {
                    continue;
                }
                var i = g.o._inner[h];
                var j = this.c.item(f).item(i);
                if (j >= a) {
                    this.c.item(f).item(i, j + 1);
                }
            }
        }
    };
    ListPanelSelectionManager.prototype.u = function (a, b, c) {
        this.ae(a, b, c, true);
    };
    ListPanelSelectionManager.prototype.s = function (a, b) {
        var c = new List$1(ListPanelPrimaryKeyValue.$, 0);
        var d = new List$1(Number_$type, 0);
        for (var e = 0; e < this.d.o.count; e++) {
            if (this.d.p._inner[e]) {
                continue;
            }
            var f = this.d.o._inner[e];
            var g = this.d.q._inner[e];
            if (g == a) {
                c.add(f);
                d.add(g);
            }
            if (g > a) {
                this.d.item(f, g - 1);
            }
        }
        for (var h = 0; h < c.count; h++) {
            this.u(c._inner[h], d._inner[h], b);
        }
        for (var i = 0; i < this.c.o.count; i++) {
            if (this.c.p._inner[i]) {
                continue;
            }
            var j = this.c.o._inner[i];
            var k = this.c.q._inner[i];
            for (var l = 0; l < k.o.count; l++) {
                if (this.c.item(j).p._inner[l]) {
                    continue;
                }
                var m = k.o._inner[l];
                var n = this.c.item(j).item(m);
                if (n == a) {
                    this.c.item(j).item(m, -1);
                }
                if (n > a) {
                    this.c.item(j).item(m, n - 1);
                }
            }
        }
    };
    ListPanelSelectionManager.prototype.t = function (a) {
        var b = new List$1(ListPanelPrimaryKeyValue.$, 0);
        var c = new List$1(Number_$type, 0);
        for (var d = 0; d < this.d.o.count; d++) {
            if (this.d.p._inner[d]) {
                continue;
            }
            var e = this.d.o._inner[d];
            var f = this.d.q._inner[d];
            if (f == a) {
                b.add(e);
                c.add(f);
            }
        }
        for (var g = 0; g < b.count; g++) {
            this.ad(b._inner[g], c._inner[g], true);
        }
    };
    ListPanelSelectionManager.prototype.p = function () {
        var a = new List$1(Number_$type, 0);
        var b = new HashSet$1(Number_$type, 0);
        for (var c = 0; c < this.d.o.count; c++) {
            if (this.d.p._inner[c]) {
                continue;
            }
            var d = this.d.o._inner[c];
            a.add(this.d.item(d));
            var e = this.a.d7(this.a.e(), d, this.a.dy(), this.a.d0());
            b.add_1(e);
            this.d.item(d, -1);
        }
        for (var f = 0; f < a.count; f++) {
            if (!b.contains(a._inner[f])) {
                this.a.hk(this.a, a._inner[f]);
            }
        }
    };
    ListPanelSelectionManager.prototype.k = function (a) {
        return this.a.aq == 2;
    };
    ListPanelSelectionManager.prototype.z = function (a) {
        this.m = a;
    };
    ListPanelSelectionManager.prototype.o = function (a, b, c, d) {
        var _this = this;
        if (d === void 0) {
            d = false;
        }
        if (!this.f(a)) {
            return;
        }
        b = this.k(this.a.aq) ? b : false;
        if (!b || this.m == -1) {
            if (c || d) {
                this.ab(a);
            }
            else {
                this.aa(a);
            }
            this.b = null;
            if (this.j(a)) {
                this.m = a.v;
            }
            else {
                this.m = -1;
            }
        }
        else {
            var e = ((function () {
                var $ret = new ListPanelRowRange();
                $ret.f = Math.min(_this.m, a.v);
                $ret.d = Math.max(_this.m, a.v);
                return $ret;
            })());
            this.a.fe();
            if (this.b != null) {
                for (var f = this.b.f; f <= this.b.d; f++) {
                    if (!e.b(f)) {
                        var g = this.a.ad(this.a.e(), f);
                        if (g != null && this.d.d(g)) {
                            this.ad(g, f, false);
                        }
                    }
                }
            }
            for (var h = e.f; h <= e.d; h++) {
                var i = this.a.ad(this.a.e(), h);
                if (i != null && !this.d.d(i)) {
                    this.x(i, h, false);
                }
            }
            this.a.fn();
            this.b = e;
        }
    };
    ListPanelSelectionManager.prototype.v = function () {
        if (this.a.actualDataSource == null) {
            return;
        }
        this.a.fe();
        var a = this.a.d2();
        for (var b = 0; b < a; b++) {
            var c = this.a.actualDataSource.getItemAtIndex(b);
            if (typeCast(DataSourceSpecialRow.$, c) !== null) {
                continue;
            }
            var d = this.a.ad(this.a.e(), b);
            if (d != null && !this.d.d(d)) {
                this.x(d, b, false);
            }
        }
        this.a.fn();
    };
    ListPanelSelectionManager.$t = markType(ListPanelSelectionManager, 'ListPanelSelectionManager');
    return ListPanelSelectionManager;
}(Base));
export { ListPanelSelectionManager };
/**
 * @hidden
 */
var ListPanelActivationManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ListPanelActivationManager, _super);
    function ListPanelActivationManager(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.b = false;
        _this.g = -1;
        _this.h = -1;
        _this.j = null;
        _this.a = a;
        return _this;
    }
    ListPanelActivationManager.prototype.v = function (a) {
        if (!this.f(a)) {
            return;
        }
        if (this.c(a)) {
            this.q(a);
        }
        else {
            this.n(a);
        }
    };
    ListPanelActivationManager.prototype.f = function (a) {
        return true;
    };
    ListPanelActivationManager.prototype.c = function (a) {
        var b = false;
        var c = this.i(a);
        if (c == -1) {
            return false;
        }
        if (this.g < 0) {
            return false;
        }
        if (c != this.g) {
            return false;
        }
        b = this.d(c);
        return b;
    };
    ListPanelActivationManager.prototype.i = function (a) {
        return a.v;
    };
    ListPanelActivationManager.prototype.d = function (a) {
        return this.g == a;
    };
    ListPanelActivationManager.prototype.e = function () {
        return this.a.r == 1;
    };
    ListPanelActivationManager.prototype.o = function () {
        if (this.g >= 0) {
            this.p(this.g, true);
        }
    };
    ListPanelActivationManager.prototype.q = function (a) {
        var b = this.i(a);
        if (b == -1) {
            return;
        }
        if (this.d(b)) {
            this.p(b, true);
        }
    };
    ListPanelActivationManager.prototype.n = function (a) {
        this.m(a);
    };
    ListPanelActivationManager.prototype.m = function (a) {
        if (!this.f(a)) {
            return;
        }
        if (!this.e()) {
            return;
        }
        if (this.g >= 0) {
            this.p(this.g, false);
        }
        var b = this.i(a);
        if (b == -1) {
            return;
        }
        if (!this.d(b)) {
            this.l(b, true);
        }
    };
    ListPanelActivationManager.prototype.k = function (a) {
        if (!this.e()) {
            return;
        }
        if (a == this.g) {
            return;
        }
        if (this.g >= 0) {
            this.p(this.g, false);
        }
        var b = a;
        if (b == -1) {
            return;
        }
        if (!this.d(b)) {
            this.l(b, true);
        }
    };
    ListPanelActivationManager.prototype.l = function (a, b) {
        if (a != this.g) {
            this.g = a;
            if (a >= 0) {
                if (a >= 0 && a < this.a.d2()) {
                }
                this.a.hh(this.a, a);
            }
            if (b) {
                this.a.f8(a);
            }
        }
    };
    ListPanelActivationManager.prototype.p = function (a, b) {
        if (this.d(a)) {
            this.g = -1;
            if (a >= 0) {
                {
                    {
                        if (a >= 0 && a < this.a.d2()) {
                        }
                        this.a.hi(this.a, a);
                    }
                }
            }
            if (b) {
                this.a.gb(a);
            }
        }
    };
    ListPanelActivationManager.prototype.r = function () {
        this.g = -1;
    };
    ListPanelActivationManager.prototype.s = function (a) {
    };
    ListPanelActivationManager.prototype.t = function (a) {
    };
    ListPanelActivationManager.prototype.u = function (a) {
    };
    ListPanelActivationManager.$t = markType(ListPanelActivationManager, 'ListPanelActivationManager');
    return ListPanelActivationManager;
}(Base));
export { ListPanelActivationManager };
