/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, markType } from "igniteui-react-core";
import { ToolContextBindingMode_$type } from "igniteui-react-core";
import { PropertyUpdatedEventArgs } from "igniteui-react-core";
/**
 * @hidden
 */
var ToolContextBinding = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolContextBinding, _super);
    function ToolContextBinding() {
        var _this = _super.call(this) || this;
        _this.c = 1;
        _this.e = null;
        _this.f = null;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        return _this;
    }
    ToolContextBinding.b = function (a) {
        return ((function () {
            var $ret = new ToolContextBinding();
            $ret.d = a.bindingMode;
            $ret.h = a.contextKey;
            $ret.j = a.propertyName;
            return $ret;
        })());
    };
    Object.defineProperty(ToolContextBinding.prototype, "d", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != a) {
                this.l("BindingMode", enumGetBox(ToolContextBindingMode_$type, b), enumGetBox(ToolContextBindingMode_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolContextBinding.prototype, "h", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            var b = this.e;
            this.e = a;
            if (b != a) {
                this.l("ContextKey", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolContextBinding.prototype, "j", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            var b = this.f;
            this.f = a;
            if (b != a) {
                this.l("PropertyName", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    ToolContextBinding.prototype.l = function (a, b, c) {
        this.m(a, b, c);
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    ToolContextBinding.prototype.m = function (a, b, c) {
    };
    ToolContextBinding.$t = markType(ToolContextBinding, 'ToolContextBinding', Base.$, [INotifyPropertyChanged_$type]);
    return ToolContextBinding;
}(Base));
export { ToolContextBinding };
