import { ListPanelActiveRowChangedEventArgs as ListPanelActiveRowChangedEventArgs_internal } from "./ListPanelActiveRowChangedEventArgs";
/**
 * Information about the change to the selected cells in the grid.
*/
var IgrListPanelActiveRowChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrListPanelActiveRowChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrListPanelActiveRowChangedEventArgs.prototype.createImplementation = function () {
        return new ListPanelActiveRowChangedEventArgs_internal();
    };
    Object.defineProperty(IgrListPanelActiveRowChangedEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanelActiveRowChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrListPanelActiveRowChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrListPanelActiveRowChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrListPanelActiveRowChangedEventArgs.prototype, "newActiveRow", {
        /**
         * The new active row.
        */
        get: function () {
            return this.i.newActiveRow;
        },
        set: function (v) {
            this.i.newActiveRow = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanelActiveRowChangedEventArgs.prototype, "oldActiveRow", {
        /**
         * The old active row.
        */
        get: function () {
            return this.i.oldActiveRow;
        },
        set: function (v) {
            this.i.oldActiveRow = +v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrListPanelActiveRowChangedEventArgs;
}());
export { IgrListPanelActiveRowChangedEventArgs };
