import { ListPanelSelectionChangedEventArgs as ListPanelSelectionChangedEventArgs_internal } from "./ListPanelSelectionChangedEventArgs";
/**
 * Event arguments for the SelectionChanged event.
*/
var IgrListPanelSelectionChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrListPanelSelectionChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrListPanelSelectionChangedEventArgs.prototype.createImplementation = function () {
        return new ListPanelSelectionChangedEventArgs_internal();
    };
    Object.defineProperty(IgrListPanelSelectionChangedEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanelSelectionChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrListPanelSelectionChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrListPanelSelectionChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    return IgrListPanelSelectionChangedEventArgs;
}());
export { IgrListPanelSelectionChangedEventArgs };
