import { IgrPropertyEditorDescriptionObject } from "./igr-property-editor-description-object";
import { IgrPropertyEditorDescriptionObjectCollection } from "./igr-property-editor-description-object-collection";
import { PropertyEditorPropertyDescriptionCoercingValueEventArgs as PropertyEditorPropertyDescriptionCoercingValueEventArgs_internal } from "./PropertyEditorPropertyDescriptionCoercingValueEventArgs";
import { PropertyEditorDescriptionObjectCollection as PropertyEditorDescriptionObjectCollection_internal } from "./PropertyEditorDescriptionObjectCollection";
import { PropertyEditorDescriptionObject } from "./PropertyEditorDescriptionObject";
import { SyncableObservableCollection$1 } from "igniteui-react-core";
var IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs() {
        this.mounted = false;
        this._complexValues = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs.prototype.createImplementation = function () {
        return new PropertyEditorPropertyDescriptionCoercingValueEventArgs_internal();
    };
    Object.defineProperty(IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs.prototype, "value", {
        get: function () {
            return this.i.value;
        },
        set: function (v) {
            this.i.value = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs.prototype, "complexValue", {
        get: function () {
            var r = this.i.complexValue;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrPropertyEditorDescriptionObject();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.complexValue = null : this.i.complexValue = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs.prototype, "complexValues", {
        get: function () {
            if (this._complexValues === null) {
                var coll = new IgrPropertyEditorDescriptionObjectCollection();
                var innerColl = this.i.complexValues;
                if (!innerColl) {
                    innerColl = new PropertyEditorDescriptionObjectCollection_internal();
                }
                this._complexValues = coll._fromInner(innerColl);
                this.i.complexValues = innerColl;
            }
            return this._complexValues;
        },
        set: function (v) {
            if (this._complexValues !== null) {
                this._complexValues._setSyncTarget(null);
                this._complexValues = null;
            }
            var coll = new IgrPropertyEditorDescriptionObjectCollection();
            this._complexValues = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(PropertyEditorDescriptionObject.$type);
            var innerColl = this.i.complexValues;
            if (!innerColl) {
                innerColl = new PropertyEditorDescriptionObjectCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._complexValues._setSyncTarget(syncColl);
            this.i.complexValues = innerColl;
        },
        enumerable: false,
        configurable: true
    });
    return IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs;
}());
export { IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs };
