import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { ToolContextBinding as ToolContextBinding_internal } from './ToolContextBinding';
import { IgrToolContextBinding as IgrToolContextBinding } from './igr-tool-context-binding';
var IgrToolContextBindingCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrToolContextBindingCollection, _super);
    function IgrToolContextBindingCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrToolContextBinding.$type) {
            IgrToolContextBinding.$type = markType(IgrToolContextBinding, "IgrToolContextBinding");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrToolContextBindingCollection.prototype._createInnerColl = function () {
        if (!IgrToolContextBinding.$type) {
            IgrToolContextBinding.$type = markType(IgrToolContextBinding, "IgrToolContextBinding");
        }
        var coll = new SyncableObservableCollection$2(IgrToolContextBinding.$type, ToolContextBinding_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrToolContextBinding();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrToolContextBindingCollection;
}(IgCollection));
export { IgrToolContextBindingCollection };
