import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { NativeUIGrid } from "igniteui-react-core";
import { ListPanel } from "./ListPanel";
import { NativeUIPopup } from "igniteui-react-core";
import { NativeUIInput } from "igniteui-react-core";
import { NativeUIContent } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { IDataSource } from "igniteui-react-core";
import { InputGroupDisplayType } from "igniteui-react-inputs";
import { ComboEditorTextChangedEventArgs } from "./ComboEditorTextChangedEventArgs";
import { ComboEditorValueChangedEventArgs } from "./ComboEditorValueChangedEventArgs";
import { ComboEditorVisualModelExport } from "./ComboEditorVisualModelExport";
import { ComboEditorGotFocusEventArgs } from "./ComboEditorGotFocusEventArgs";
import { ComboEditorLostFocusEventArgs } from "./ComboEditorLostFocusEventArgs";
import { KeyEventArgs } from "igniteui-react-core";
import { InputChangeEventArgs } from "igniteui-react-inputs";
import { NativeUIKeyEventArgs } from "igniteui-react-core";
import { NativeUIInputChangingEventArgs } from "igniteui-react-core";
import { IDataSourceUpdateNotifier } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class ComboEditorView extends Base {
    static $t: Type;
    constructor(a: ComboEditor);
    g(): void;
    r(): Rect;
    f(a: NativeUIGrid, b: (arg1: ListPanel) => void): void;
    i(): void;
    private b;
    h(): void;
    private q;
    a: ComboEditor;
    c: DomRenderer;
    k(a: NativeUIInput): void;
    l(a: string): void;
    o(): void;
    n(): void;
    p(): void;
    j(a: DomRenderer): void;
    d(): any;
    m(a: NativeUIContent, b: FontInfo): void;
    e(a: NativeUIGrid, b: ListPanel): void;
}
/**
 * @hidden
 */
export declare class ComboEditor extends Base implements INotifyPropertyChanged {
    static $t: Type;
    static ag: BaseControlTheme;
    d0: any;
    kk: Brush;
    kl: Brush;
    c8: number;
    k5: Thickness;
    jh: CornerRadius;
    km: Brush;
    c9: number;
    kn: Brush;
    da: number;
    db: number;
    ko: Brush;
    dc: number;
    dd: number;
    kp: Brush;
    de: number;
    kq: Brush;
    df: number;
    dg: number;
    dh: number;
    static kh: Brush;
    static kj: Brush;
    static ki: Brush;
    constructor();
    private gy;
    private bi;
    private get bj();
    protected aa(): ComboEditorView;
    protected ip(a: string, b: any, c: any): void;
    private a0;
    private get a1();
    ab: ComboEditorView;
    focus(a: boolean): void;
    setName(a: string): void;
    private bl;
    get disallowTabFocus(): boolean;
    set disallowTabFocus(a: boolean);
    private c;
    get g(): string[];
    set g(a: string[]);
    private jt;
    get kf(): Brush;
    set kf(a: Brush);
    private ji;
    get j4(): Brush;
    set j4(a: Brush);
    private af;
    get ai(): BaseControlTheme;
    set ai(a: BaseControlTheme);
    private ae;
    get ah(): BaseControlTheme;
    set ah(a: BaseControlTheme);
    private ju;
    get kg(): Brush;
    set kg(a: Brush);
    private jj;
    get j5(): Brush;
    set j5(a: Brush);
    private cm;
    get c6(): number;
    set c6(a: number);
    private cc;
    get cw(): number;
    set cw(a: number);
    private k2;
    get k4(): Thickness;
    set k4(a: Thickness);
    private k1;
    get k3(): Thickness;
    set k3(a: Thickness);
    private je;
    get jg(): CornerRadius;
    set jg(a: CornerRadius);
    private jd;
    get jf(): CornerRadius;
    set jf(a: CornerRadius);
    private b;
    get f(): string[];
    set f(a: string[]);
    private al;
    get density(): ControlDisplayDensity;
    set density(a: ControlDisplayDensity);
    private ak;
    get am(): ControlDisplayDensity;
    set am(a: ControlDisplayDensity);
    private bw;
    get dropDownButtonVisible(): boolean;
    set dropDownButtonVisible(a: boolean);
    private jv;
    get ks(): Brush;
    set ks(a: Brush);
    private jk;
    get j6(): Brush;
    set j6(a: Brush);
    private cn;
    get di(): number;
    set di(a: number);
    private cd;
    get cx(): number;
    set cx(a: number);
    private jw;
    get kt(): Brush;
    set kt(a: Brush);
    private jl;
    get j7(): Brush;
    set j7(a: Brush);
    private co;
    get dj(): number;
    set dj(a: number);
    private ce;
    get cy(): number;
    set cy(a: number);
    private cp;
    get dk(): number;
    set dk(a: number);
    private cf;
    get cz(): number;
    set cz(a: number);
    private jx;
    get ku(): Brush;
    set ku(a: Brush);
    private jm;
    get j8(): Brush;
    set j8(a: Brush);
    private cq;
    get dl(): number;
    set dl(a: number);
    private cg;
    get c0(): number;
    set c0(a: number);
    private cr;
    get dm(): number;
    set dm(a: number);
    private ch;
    get c1(): number;
    set c1(a: number);
    private du;
    get itemsSource(): any;
    set itemsSource(a: any);
    get actualDataSource(): IDataSource;
    private f1;
    get fz(): string;
    set fz(a: string);
    private jy;
    get kv(): Brush;
    set kv(a: Brush);
    private jn;
    get j9(): Brush;
    set j9(a: Brush);
    static ay: FontInfo;
    private as;
    get a2(): FontInfo;
    set a2(a: FontInfo);
    private ap;
    get av(): FontInfo;
    set av(a: FontInfo);
    private bs;
    get actualLabelVisible(): boolean;
    set actualLabelVisible(a: boolean);
    private f4;
    get f5(): string;
    set f5(a: string);
    private er;
    get actualNoMatchesFoundLabel(): string;
    set actualNoMatchesFoundLabel(a: string);
    private jz;
    get kw(): Brush;
    set kw(a: Brush);
    static readonly et: string;
    private jo;
    get ka(): Brush;
    set ka(a: Brush);
    private j0;
    get kx(): Brush;
    set kx(a: Brush);
    private jp;
    get kb(): Brush;
    set kb(a: Brush);
    static az: FontInfo;
    private at;
    get a3(): FontInfo;
    set a3(a: FontInfo);
    private aq;
    get aw(): FontInfo;
    set aw(a: FontInfo);
    private gc;
    get gb(): string;
    set gb(a: string);
    static kr: Brush;
    private j1;
    get ky(): Brush;
    set ky(a: Brush);
    private jq;
    get kc(): Brush;
    set kc(a: Brush);
    private au;
    get a4(): FontInfo;
    set a4(a: FontInfo);
    private ar;
    get ax(): FontInfo;
    set ax(a: FontInfo);
    private j2;
    get kz(): Brush;
    set kz(a: Brush);
    private jr;
    get kd(): Brush;
    set kd(a: Brush);
    private cs;
    get dn(): number;
    set dn(a: number);
    private ci;
    get c2(): number;
    set c2(a: number);
    private j3;
    get k0(): Brush;
    set k0(a: Brush);
    private js;
    get ke(): Brush;
    set ke(a: Brush);
    private ct;
    get dp(): number;
    set dp(a: number);
    private cj;
    get c3(): number;
    set c3(a: number);
    private cu;
    get dq(): number;
    set dq(a: number);
    private ck;
    get c4(): number;
    set c4(a: number);
    private cv;
    get dr(): number;
    set dr(a: number);
    private cl;
    get c5(): number;
    set c5(a: number);
    private bk;
    get bu(): boolean;
    set bu(a: boolean);
    private d6;
    get gg(): string;
    set gg(a: string);
    private d5;
    get text(): string;
    set text(a: string);
    private d;
    get j(): string[];
    set j(a: string[]);
    private a;
    get e(): string[];
    set e(a: string[]);
    private dv;
    get value(): any;
    set value(a: any);
    private q;
    get s(): InputGroupDisplayType;
    set s(a: InputGroupDisplayType);
    private dx;
    ft(): string;
    private dy;
    private fr;
    private fs;
    private h;
    i(): string[];
    h8(a: any): void;
    private b2;
    private io;
    iy(a: string): void;
    jc(): void;
    private i3;
    closeUp(): void;
    destroy(): void;
    dropDown(): void;
    select(): void;
    notifySizeChanged(): void;
    provideRenderer(a: DomRenderer): void;
    dw(): any;
    fk(): string;
    u(): ComboEditorVisualModelExport;
    private bn;
    get b4(): boolean;
    set b4(a: boolean);
    private bq;
    get b9(): boolean;
    set b9(a: boolean);
    private br;
    get cb(): boolean;
    set cb(a: boolean);
    gotFocus: (sender: any, args: ComboEditorGotFocusEventArgs) => void;
    lostFocus: (sender: any, args: ComboEditorLostFocusEventArgs) => void;
    textValueChanged: (sender: any, args: ComboEditorTextChangedEventArgs) => void;
    selectedValueChanged: (sender: any, args: ComboEditorValueChangedEventArgs) => void;
    keyDown: (sender: any, args: KeyEventArgs) => void;
    change: (sender: any, args: InputChangeEventArgs) => void;
    changing: (sender: any, args: InputChangeEventArgs) => void;
    h1(a: ComboEditorGotFocusEventArgs): void;
    h4(a: ComboEditorLostFocusEventArgs): void;
    ic(a: ComboEditorTextChangedEventArgs): void;
    private h9;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected h6(a: string, b: any, c: any): void;
    h3(a: NativeUIKeyEventArgs): void;
    hq(a: NativeUIInputChangingEventArgs): void;
    private a6;
    private a9;
    private a7;
    private bd;
    private bg;
    private ac;
    private static readonly d2;
    private static readonly d4;
    private static readonly d3;
    private d7;
    private ca;
    private dt;
    private b6;
    private l;
    private v;
    private b5;
    private b1;
    private b0;
    private by;
    private ba;
    private a5;
    get ad(): ListPanel;
    private get b7();
    get bh(): NativeUIPopup;
    id(a: NativeUIGrid): void;
    h0(): void;
    hp(): void;
    protected h5(): void;
    private n;
    private gv;
    private gw;
    private g0;
    get bb(): NativeUIGrid;
    private b3;
    private g1;
    get be(): NativeUIInput;
    private g2;
    private ig;
    ht(a: number, b: number): void;
    hw(a: number, b: any, c: any): void;
    hs(): void;
    hu(a: number, b: any): void;
    hv(a: number, b: any): void;
    hz(a: number, b: number): void;
    ia(a: number, b: any, c: any): void;
    hr(): void;
    h2(a: number, b: any): void;
    h7(a: number, b: any): void;
    g5(): void;
    private m;
    private bz;
    private ha;
    private hc;
    private hm;
    private ho;
    private hx;
    private hy;
    private il;
    private im;
    private ir;
    it(a: number): void;
    private ds;
    private iw;
    private i0;
    private iz;
    private i1;
    i5(): void;
    private i2;
    private i4;
    private i6;
    private i7;
    private i8;
    private gt;
    private ie;
    private ih;
    private ii;
    bo: boolean;
    private ij;
    private ik;
    gx(): void;
    g6(a: boolean): void;
    private i9;
    private ja;
    private gu;
    iv(a: boolean): void;
    private b8;
    private jb;
    private g8;
    private iu;
    private get bc();
    private ib;
    private g9;
    private hb;
    private hd;
    private bp;
    private he;
    private hf;
    private hg;
    private hh;
    private hi;
    private hj;
    private bm;
    private a8;
    private bf;
    private hk;
    private hl;
}
/**
 * @hidden
 */
export declare class ComboEditorDataSourceNotificationHandler extends Base implements IDataSourceUpdateNotifier {
    static $t: Type;
    private a;
    private b;
    constructor(a: ComboEditor, b: boolean);
    rangeActualized(a: number, b: number): void;
    notifySetItem(a: number, b: any, c: any): void;
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
}
