import { INativeUIElementBridge } from "igniteui-react-core";
import { Type } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { BrushCollection } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
/**
 * @hidden
 */
export interface INativeUIToolbarBridge extends INativeUIElementBridge {
    flushRefresh(a: any): void;
    notifySizeChanged(a: any, b: Size): void;
    setBrushContextItem(a: any, b: string, c: Brush): void;
    getBrushContextItem(a: any, b: string): Brush;
    setBrushCollectionContextItem(a: any, b: string, c: BrushCollection): void;
    getBrushCollectionContextItem(a: any, b: string): BrushCollection;
    setDoubleContextItem(a: any, b: string, c: number): void;
    getDoubleContextItem(a: any, b: string): number;
    setStringContextItem(a: any, b: string, c: string): void;
    getStringContextItem(a: any, b: string): string;
    setBoolContextItem(a: any, b: string, c: boolean): void;
    getBoolContextItem(a: any, b: string): boolean;
    setColorContextItem(a: any, b: string, c: Color): void;
    getColorContextItem(a: any, b: string): Color;
    setDataContextItem(a: any, b: string, c: any): void;
    getDataContextItem(a: any, b: string): any;
}
/**
 * @hidden
 */
export declare let INativeUIToolbarBridge_$type: Type;
