import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { NativeUIToolbar } from "./NativeUIToolbar";
import { PropertyEditorPropertyDescriptionCollection } from "./PropertyEditorPropertyDescriptionCollection";
import { PropertyEditorPanelUpdateMode } from "./PropertyEditorPanelUpdateMode";
import { IDataSource } from "igniteui-react-core";
import { IExecutionContext } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { PropertyEditorPanelColumnDefinition } from "./PropertyEditorPanelColumnDefinition";
import { TypeDescriptionContext } from "igniteui-react-core";
import { ComponentRenderer } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PropertyEditorPropertyDescription } from "./PropertyEditorPropertyDescription";
import { DataSeriesToDescriptionCustomization } from "igniteui-react-core";
import { PropertyEditorPropertyDescriptionDescription } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class PropertyEditorPanelView extends Base {
    static $t: Type;
    private n;
    private m;
    constructor();
    p(): any;
    a: PropertyEditorPanel;
    v(): void;
    i: DomRenderer;
    l: DomWrapper;
    e: RenderingContext;
    k: DomWrapper;
    t(a: DomRenderer): void;
    y(): void;
    x(): void;
    s(): void;
    z(): void;
    private b;
    private aa;
    private c;
    private _gridExternal;
    d(): FontInfo;
    u(): void;
    w(): void;
    r(): void;
    g(): number;
    h(a: string): number;
    f: boolean;
    private j;
    q(a: any, b: (arg1: any) => void): void;
}
/**
 * @hidden
 */
export declare class PropertyEditorPanel extends Base implements INotifyPropertyChanged {
    static $t: Type;
    p: PropertyEditorPanelView;
    l: NativeUIToolbar;
    private v;
    private ac;
    private ad;
    private z;
    private get aa();
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    private ca;
    private b5;
    private bx;
    private aj;
    notifySizeChanged(): void;
    bw(a: NativeUIToolbar, b: any): void;
    private b9;
    private b3;
    private cf;
    private cg;
    private ce;
    private ci;
    private ch;
    private cl;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    b4(a: string): void;
    private q;
    get actualProperties(): PropertyEditorPropertyDescriptionCollection;
    set actualProperties(a: PropertyEditorPropertyDescriptionCollection);
    private r;
    get properties(): PropertyEditorPropertyDescriptionCollection;
    set properties(a: PropertyEditorPropertyDescriptionCollection);
    private aw;
    get az(): number;
    set az(a: number);
    private n;
    get o(): PropertyEditorPanelUpdateMode;
    set o(a: PropertyEditorPanelUpdateMode);
    private au;
    get av(): number;
    set av(a: number);
    private w;
    get x(): FontInfo;
    set x(a: FontInfo);
    y(): FontInfo;
    private a1;
    d: IDataSource;
    protected b6(a: string, b: any, c: any): void;
    protected cb(a: string, b: any, c: any): void;
    private an;
    private ar;
    k: IExecutionContext;
    private ai;
    private cd;
    private aq;
    private bt;
    private ck;
    private a4;
    private c;
    protected bm(a: PropertyEditorPropertyDescription): string;
    private u;
    private bl;
    private b8;
    at: ObservableCollection$1<PropertyEditorPanelColumnDefinition>;
    cj(): void;
    cs(): Size;
    private a5;
    private ah;
    private ab;
    private a2;
    private b7;
    private a;
    static b(a: TypeDescriptionContext, b: string, c: PropertyEditorPropertyDescriptionDescription[]): DataSeriesToDescriptionCustomization[];
    private ap;
    private ao;
    private as;
    private bg;
    private bu;
    private static bv;
    b1(a: number, b: any, c: any): void;
    by(): void;
    bz(a: number, b: any): void;
    b0(a: number, b: any): void;
    private g;
    get i(): TypeDescriptionContext;
    set i(a: TypeDescriptionContext);
    private h;
    get j(): TypeDescriptionContext;
    set j(a: TypeDescriptionContext);
    private e;
    get f(): ComponentRenderer;
    set f(a: ComponentRenderer);
    private a0;
    get a3(): any;
    set a3(a: any);
    private a6;
    get be(): string;
    set be(a: string);
    private ae;
    get ak(): boolean;
    set ak(a: boolean);
    private ag;
    get am(): boolean;
    set am(a: boolean);
    private af;
    get al(): boolean;
    set al(a: boolean);
    static cp: Brush;
    private cm;
    get co(): Brush;
    set co(a: Brush);
    static cq: Brush;
    cn: Brush;
    get cr(): Brush;
    set cr(a: Brush);
    private ay;
    private ax;
    private m;
    private br;
}
