import { ListPanelActiveRowChangedEventArgs as ListPanelActiveRowChangedEventArgs_internal } from "./ListPanelActiveRowChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Information about the change to the selected cells in the grid.
*/
export declare class IgrListPanelActiveRowChangedEventArgs {
    protected createImplementation(): ListPanelActiveRowChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): ListPanelActiveRowChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The new active row.
    */
    get newActiveRow(): number;
    set newActiveRow(v: number);
    /**
     * The old active row.
    */
    get oldActiveRow(): number;
    set oldActiveRow(v: number);
}
