import { IgrListPanelSelectedItemsCollection } from "./igr-list-panel-selected-items-collection";
import { ListPanelSelectedItemsChangedEventArgs as ListPanelSelectedItemsChangedEventArgs_internal } from "./ListPanelSelectedItemsChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Information about the changing selected items in the grid.
*/
export declare class IgrListPanelSelectedItemsChangedEventArgs {
    protected createImplementation(): ListPanelSelectedItemsChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): ListPanelSelectedItemsChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    private _currentItems;
    /**
     * The items added to the selection.
    */
    get currentItems(): IgrListPanelSelectedItemsCollection;
    set currentItems(v: IgrListPanelSelectedItemsCollection);
    private _addedItems;
    /**
     * The items added to the selection.
    */
    get addedItems(): IgrListPanelSelectedItemsCollection;
    set addedItems(v: IgrListPanelSelectedItemsCollection);
    private _removedItems;
    /**
     * The items removed from the selection.
    */
    get removedItems(): IgrListPanelSelectedItemsCollection;
    set removedItems(v: IgrListPanelSelectedItemsCollection);
}
