import { IgrListPanelSelectedKeysCollection } from "./igr-list-panel-selected-keys-collection";
import { ListPanelSelectedKeysChangedEventArgs as ListPanelSelectedKeysChangedEventArgs_internal } from "./ListPanelSelectedKeysChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Information about the change to the selected keys in the grid.
*/
export declare class IgrListPanelSelectedKeysChangedEventArgs {
    protected createImplementation(): ListPanelSelectedKeysChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): ListPanelSelectedKeysChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    private _currentKeys;
    /**
     * All keys in the selection.
    */
    get currentKeys(): IgrListPanelSelectedKeysCollection;
    set currentKeys(v: IgrListPanelSelectedKeysCollection);
    private _addedKeys;
    /**
     * The keys added to the selection.
    */
    get addedKeys(): IgrListPanelSelectedKeysCollection;
    set addedKeys(v: IgrListPanelSelectedKeysCollection);
    private _removedKeys;
    /**
     * The keys removed from the selection.
    */
    get removedKeys(): IgrListPanelSelectedKeysCollection;
    set removedKeys(v: IgrListPanelSelectedKeysCollection);
}
