import { IgrToolAction, IIgrToolActionProps } from "./igr-tool-action";
import { ToolActionColorEditor } from "./ToolActionColorEditor";
export declare class IgrToolActionColorEditor extends IgrToolAction<IIgrToolActionColorEditorProps> {
    protected createImplementation(): ToolActionColorEditor;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionColorEditor;
    constructor(props: IIgrToolActionColorEditorProps);
    /**
     * Gets or sets the value for the input.
    */
    get value(): string;
    set value(v: string);
}
export interface IIgrToolActionColorEditorProps extends IIgrToolActionProps {
    /**
     * Gets or sets the value for the input.
    */
    value?: string;
}
