import { ToolContextBindingMode } from "igniteui-react-core";
import { IgrPropertyUpdatedEventArgs } from "igniteui-react-core";
import { ToolContextBinding as ToolContextBinding_internal } from "./ToolContextBinding";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrToolContextBinding {
    protected createImplementation(): ToolContextBinding_internal;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): ToolContextBinding_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get bindingMode(): ToolContextBindingMode;
    set bindingMode(v: ToolContextBindingMode);
    get contextKey(): string;
    set contextKey(v: string);
    get propertyName(): string;
    set propertyName(v: string);
    findByName(name: string): any;
    private _propertyUpdated;
    private _propertyUpdated_wrapped;
    get propertyUpdated(): (s: IgrToolContextBinding, e: IgrPropertyUpdatedEventArgs) => void;
    set propertyUpdated(ev: (s: IgrToolContextBinding, e: IgrPropertyUpdatedEventArgs) => void);
}
