/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, typeCast, fromEnum, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, String_$type, delegateRemove, delegateCombine, Array_$type } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { NativeUIComponent } from "igniteui-react-core";
import { XInputGroup } from "igniteui-react-inputs";
import { XLabel } from "igniteui-react-inputs";
import { List$1 } from "igniteui-react-core";
import { XInput } from "igniteui-react-inputs";
import { NativeUIContent } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { StringComparer } from "igniteui-react-core";
import { InputGroupDisplayType_$type } from "igniteui-react-inputs";
import { ThemeResolver } from "igniteui-react-inputs";
import { ComboEditorTextChangedEventArgs } from "./ComboEditorTextChangedEventArgs";
import { ComboEditorValueChangedEventArgs } from "./ComboEditorValueChangedEventArgs";
import { FastReflectionHelper } from "igniteui-react-core";
import { ComboEditorVisualModelExport } from "./ComboEditorVisualModelExport";
import { AppearanceHelper } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { ComboEditorGotFocusEventArgs } from "./ComboEditorGotFocusEventArgs";
import { ComboEditorLostFocusEventArgs } from "./ComboEditorLostFocusEventArgs";
import { KeyEventArgs } from "igniteui-react-core";
import { InputChangeEventArgs } from "igniteui-react-inputs";
import { FilterFactory } from "igniteui-react-core";
import { IDataSourceUpdateNotifier_$type } from "igniteui-react-core";
import { ComboEditorMultipleDataSourceNotifier } from "./ComboEditorMultipleDataSourceNotifier";
import { BrushUtil } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { stringIsNullOrEmpty, stringEmpty, stringIsNullOrWhiteSpace } from "igniteui-react-core";
/**
 * @hidden
 */
export let ComboEditorView = /*@__PURE__*/ (() => {
    class ComboEditorView extends Base {
        constructor(a) {
            super();
            this.b = false;
            this.a = null;
            this.c = null;
            this.a = a;
        }
        g() {
        }
        r() {
            let a = this.c.rootWrapper.getNativeElement();
            let b = (a.getBoundingClientRect());
            return new Rect(0, b.left + window.pageXOffset, b.top + window.pageYOffset, b.width, b.height);
        }
        f(a, b) {
            this.c.getPortal(a.an, "ListPanel", (c) => {
                let d = c.componentRef;
                let e = (d.i);
                b(e);
            }, false);
        }
        i() {
            if (this.b) {
                this.b = false;
                window.addEventListener("resize", runOn(this, this.q), false);
            }
        }
        h() {
            if (!this.b) {
                this.b = true;
                window.removeEventListener("resize", runOn(this, this.q), false);
            }
        }
        q(a) {
            let b = this.a.bh;
            if (null == b || false == b.b6) {
                return;
            }
            let c = this.r();
            this.a.bh.cd(c);
        }
        k(a) {
            let b = this.a;
            let c = typeCast(XInputGroup.$, a.an);
            if (c != null) {
                c.oi = b.k3;
                c.ks = b.jf;
                c.no = b.j6;
                c.eg = b.cx;
                c.np = b.j7;
                c.eh = b.cy;
                c.ei = b.cz;
                c.nq = b.j8;
                c.ej = b.c0;
                c.ek = b.c1;
                c.n6 = b.kd;
                c.e5 = b.c2;
                c.n7 = b.ke;
                c.e6 = b.c3;
                c.e7 = b.c4;
                c.e8 = b.c5;
                for (let d of fromEnum(c.inputs)) {
                    if (d != null && typeCast(XInput.$, d) !== null) {
                        d.cg = b.gb;
                    }
                }
                for (let e of fromEnum(c.inputs)) {
                    if (e != null && typeCast(XLabel.$, e) !== null) {
                        e.di = b.j9;
                        let f = e;
                        if (b.av != null) {
                            f.y = b.av;
                        }
                    }
                }
            }
        }
        l(a) {
            if (this.a.be != null) {
                let b = this.a.be.an;
                for (let c = 0; c < b.inputs.count; c++) {
                    if (typeCast(XInput.$, b.inputs._inner[c]) !== null) {
                        b.inputs._inner[c].e = a;
                    }
                }
            }
        }
        o() {
            if (this.a.disallowTabFocus) {
                let a = this.a.bb.an;
                if (a != null) {
                    a.setAttribute("tabIndex", "-1");
                }
                if (this.a.be != null) {
                    let b = this.a.be.an;
                    for (let c = 0; c < b.inputs.count; c++) {
                        if (typeCast(XInput.$, b.inputs._inner[c]) !== null) {
                            b.inputs._inner[c].be = -1;
                        }
                    }
                }
            }
            else {
                let d = this.a.bb.an;
                if (d != null) {
                    d.setAttribute("tabIndex", "0");
                }
                if (this.a.be != null) {
                    let e = this.a.be.an;
                    for (let f = 0; f < e.inputs.count; f++) {
                        if (typeCast(XInput.$, e.inputs._inner[f]) !== null) {
                            e.inputs._inner[f].cu();
                        }
                    }
                }
            }
        }
        n() {
            if (this.a.bh != null) {
                let a = this.a.bh.an;
                a.ar = this.a.b4;
            }
        }
        p() {
            if (this.a.bh != null) {
                let a = this.a.bh.an;
                a.ay = this.a.cb;
            }
        }
        j(a) {
            if (a == null) {
                this.i();
                this.c = null;
                return;
            }
            this.c = a;
            NativeUIComponent.au(this.c, 7, (b) => {
                this.c.append(b.an);
                this.a.id(b);
            });
            this.h();
        }
        d() {
            return this.c;
        }
        m(a, b) {
        }
        e(a, b) {
            let c = (a.an);
            c.remove();
            c.append(b.view.j.rootWrapper);
        }
    }
    ComboEditorView.$t = /*@__PURE__*/ markType(ComboEditorView, 'ComboEditorView');
    return ComboEditorView;
})();
/**
 * @hidden
 */
export let ComboEditor = /*@__PURE__*/ (() => {
    class ComboEditor extends Base {
        constructor() {
            super();
            this.d0 = null;
            this.kk = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "BackgroundColor");
            this.kl = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "BorderColor");
            this.c8 = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "BorderWidth");
            this.k5 = XInputGroup.m.ai(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "ContentPadding");
            this.jh = XInputGroup.m.y(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "CornerRadius");
            this.km = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderColor");
            this.c9 = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderWidth");
            this.kn = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineColor");
            this.da = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineOpacity");
            this.db = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineRippleOpacity");
            this.ko = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineColor");
            this.dc = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineOpacity");
            this.dd = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineWidth");
            this.kp = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineColor");
            this.de = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineOpacity");
            this.kq = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleColor");
            this.df = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineRippleOpacity");
            this.dg = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleWidth");
            this.dh = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineWidth");
            this.bi = null;
            this.a0 = null;
            this.ab = null;
            this.bl = false;
            this.c = null;
            this.jt = null;
            this.ji = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "BackgroundColor");
            this.af = 0;
            this.ae = 1;
            this.ju = null;
            this.jj = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "BorderColor");
            this.cm = NaN;
            this.cc = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "BorderWidth");
            this.k2 = new Thickness(1, NaN, NaN, NaN, NaN);
            this.k1 = ThemeResolver.ak(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "ContentPadding");
            this.je = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.jd = ThemeResolver.aa(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "CornerRadius");
            this.b = null;
            this.al = 0;
            this.ak = 0;
            this.bw = true;
            this.jv = null;
            this.jk = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderColor");
            this.cn = NaN;
            this.cd = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderWidth");
            this.jw = null;
            this.jl = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineColor");
            this.co = NaN;
            this.ce = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineOpacity");
            this.cp = NaN;
            this.cf = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineRippleOpacity");
            this.jx = null;
            this.jm = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineColor");
            this.cq = NaN;
            this.cg = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineOpacity");
            this.cr = NaN;
            this.ch = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineWidth");
            this.du = null;
            this.f1 = null;
            this.jy = null;
            this.jn = ComboEditor.kh;
            this.as = null;
            this.ap = null;
            this.bs = false;
            this.f4 = null;
            this.er = "No Matches Found";
            this.jz = null;
            this.jo = ComboEditor.ki;
            this.j0 = null;
            this.jp = ComboEditor.kj;
            this.at = null;
            this.aq = null;
            this.gc = "";
            this.j1 = ComboEditor.kr;
            this.jq = ComboEditor.kr;
            this.au = null;
            this.ar = null;
            this.j2 = null;
            this.jr = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineColor");
            this.cs = NaN;
            this.ci = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineOpacity");
            this.j3 = null;
            this.js = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleColor");
            this.ct = NaN;
            this.cj = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleOpacity");
            this.cu = NaN;
            this.ck = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleWidth");
            this.cv = NaN;
            this.cl = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineWidth");
            this.bk = true;
            this.d6 = null;
            this.d5 = null;
            this.d = null;
            this.a = null;
            this.dv = null;
            this.q = 0;
            this.b2 = false;
            this.bn = false;
            this.bq = false;
            this.br = false;
            this.gotFocus = null;
            this.lostFocus = null;
            this.textValueChanged = null;
            this.selectedValueChanged = null;
            this.keyDown = null;
            this.change = null;
            this.changing = null;
            this.propertyChanged = null;
            this.a6 = null;
            this.a9 = null;
            this.a7 = null;
            this.bd = null;
            this.bg = null;
            this.ac = null;
            this.d7 = null;
            this.ca = true;
            this.dt = 0;
            this.b6 = false;
            this.l = null;
            this.v = 0;
            this.b5 = false;
            this.b1 = false;
            this.b0 = false;
            this.by = false;
            this.ba = null;
            this.a5 = null;
            this.n = null;
            this.ds = -1;
            this.bo = false;
            this.b8 = false;
            this.bp = false;
            this.bm = false;
            this.a8 = null;
            this.bf = null;
            let a = this.aa();
            this.ab = a;
        }
        gy() {
            let a = this.ad;
            a.dr = -1;
        }
        get bj() {
            if (this.bi == null) {
                this.bi = new SRProvider(this.ab.c);
                this.bi.cb("ComboEditor");
            }
            return this.bi;
        }
        aa() {
            return new ComboEditorView(this);
        }
        ip(a, b, c) {
            switch (a) {
                case "BackgroundColor":
                    this.j4 = this.kf != null ? this.kf : this.kk;
                    break;
                case "BorderColor":
                    this.j5 = this.kg != null ? this.kg : this.kl;
                    break;
                case "BorderWidth":
                    this.cw = !isNaN_(this.c6) ? this.c6 : this.c8;
                    break;
                case "ContentPadding":
                    this.k3 = XInputGroup.oh(this.k4, this.k5);
                    break;
                case "CornerRadius":
                    this.jf = XInputGroup.kr(this.jg, this.jh);
                    break;
                case "FocusBorderColor":
                    this.j6 = this.ks != null ? this.ks : this.km;
                    break;
                case "FocusBorderWidth":
                    this.cx = !isNaN_(this.di) ? this.di : this.c9;
                    break;
                case "FocusUnderlineColor":
                    this.j7 = this.kt != null ? this.kt : this.kn;
                    break;
                case "FocusUnderlineOpacity":
                    this.cy = !isNaN_(this.dj) ? this.dj : this.da;
                    break;
                case "FocusUnderlineRippleOpacity":
                    this.cz = !isNaN_(this.dk) ? this.dk : this.db;
                    break;
                case "HoverUnderlineColor":
                    this.j8 = this.ku != null ? this.ku : this.ko;
                    break;
                case "HoverUnderlineOpacity":
                    this.c0 = !isNaN_(this.dl) ? this.dl : this.dc;
                    break;
                case "HoverUnderlineWidth":
                    this.c1 = !isNaN_(this.dm) ? this.dm : this.dd;
                    break;
                case "ItemsSource":
                case "ValueField":
                case "DataSourceDesiredProperties":
                case "Fields":
                    this.ja();
                    break;
                case "LabelTextColor":
                    this.j9 = this.kv != null ? this.kv : ComboEditor.kh;
                    break;
                case "LabelTextStyle":
                    this.av = this.a2 != null ? this.a2 : ComboEditor.ay;
                    break;
                case "NoMatchesFoundLabelTextColor":
                    this.kb = this.kx != null ? this.kx : ComboEditor.kj;
                    break;
                case "NoMatchesFoundLabelBackgroundColor":
                    this.ka = this.kw != null ? this.kw : ComboEditor.ki;
                    break;
                case "NoMatchesFoundLabelTextStyle":
                    this.aw = this.a3 != null ? this.a3 : ComboEditor.az;
                    break;
                case "UnderlineColor":
                    this.kd = this.kz != null ? this.kz : this.kp;
                    break;
                case "UnderlineOpacity":
                    this.c2 = !isNaN_(this.dn) ? this.dn : this.de;
                    break;
                case "UnderlineRippleColor":
                    this.ke = this.k0 != null ? this.k0 : this.kq;
                    break;
                case "UnderlineRippleOpacity":
                    this.c3 = !isNaN_(this.dp) ? this.dp : this.df;
                    break;
                case "UnderlineRippleWidth":
                    this.c4 = !isNaN_(this.dq) ? this.dq : this.dg;
                    break;
                case "UnderlineWidth":
                    this.c5 = !isNaN_(this.dr) ? this.dr : this.dh;
                    break;
                case "BaseTheme":
                    this.ah = this.ai == 0 ? 1 : this.ai;
                    break;
                case "Density":
                    this.am = this.density == 0 ? 0 : this.density;
                    break;
                case "TextColor":
                    this.kc = this.ky != null ? this.ky : ComboEditor.kr;
                    break;
                case "TextStyle":
                    this.ax = this.a4 != null ? this.a4 : null;
                    break;
                case "ActualDensity":
                case "ActualBaseTheme":
                case "ActualTextColor":
                case "ActualTextStyle":
                case "DisplayType":
                case "ActualBackgroundColor":
                case "ActualBorderColor":
                case "ActualBorderWidth":
                case "ActualContentPadding":
                case "ActualCornerRadius":
                case "ActualFocusBorderColor":
                case "ActualFocusBorderWidth":
                case "ActualFocusUnderlineColor":
                case "ActualFocusUnderlineOpacity":
                case "ActualFocusUnderlineRippleOpacity":
                case "ActualHoverUnderlineColor":
                case "ActualHoverUnderlineOpacity":
                case "ActualHoverUnderlineWidth":
                case "ActualLabelTextColor":
                case "ActualLabelTextStyle":
                case "ActualUnderlineColor":
                case "ActualUnderlineOpacity":
                case "ActualUnderlineRippleColor":
                case "ActualUnderlineRippleOpacity":
                case "ActualUnderlineRippleWidth":
                case "ActualUnderlineWidth":
                case "DropDownButtonVisible":
                case "ActualNoMatchesFoundLabel":
                case "ActualNoMatchesFoundLabelTextColor":
                case "ActualNoMatchesFoundLabelTextStyle":
                case ComboEditor.et:
                    this.i1();
                    break;
                case "NoMatchesFoundLabel":
                    this.actualNoMatchesFoundLabel = stringIsNullOrEmpty(this.f5) ? "No Matches Found" : this.f5;
                    break;
                case "Label":
                case "PlaceholderText":
                    this.i1();
                    this.actualLabelVisible = !stringIsNullOrEmpty(this.f1);
                    break;
                case "Text":
                    this.i5();
                    let d = b != null ? b.toString() : null;
                    let e = c != null ? c.toString() : null;
                    this.ic(new ComboEditorTextChangedEventArgs(d, e));
                    this.io(1, e);
                    break;
                case "Value":
                    this.h9(new ComboEditorValueChangedEventArgs(b, c));
                    this.io(0, c);
                    break;
                case "AllowFilter":
                    this.g6(this.bu);
                    break;
                case "DisallowTabFocus":
                    this.ab.o();
                    break;
                case "IsFixed":
                    this.ab.n();
                    break;
                case "UseTopLayer":
                    this.ab.p();
                    break;
            }
        }
        get a1() {
            if (null == this.a0) {
                this.a0 = new FontInfo();
                this.a0.q = "Verdana";
                this.a0.f = DeviceUtils.f(16);
            }
            return this.a0;
        }
        focus(a) {
            this.g8(a);
        }
        setName(a) {
            this.ab.l(a);
        }
        get disallowTabFocus() {
            return this.bl;
        }
        set disallowTabFocus(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.h6("DisallowTabFocus", b, this.bl);
            }
        }
        get g() {
            return this.c;
        }
        set g(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.h6("Fields", b, this.c);
            }
        }
        get kf() {
            return this.jt;
        }
        set kf(a) {
            let b = this.jt;
            this.jt = a;
            if (b != this.jt) {
                this.h6("BackgroundColor", b, a);
            }
        }
        get j4() {
            return this.ji;
        }
        set j4(a) {
            let b = this.ji;
            this.ji = a;
            if (b != this.ji) {
                this.h6("ActualBackgroundColor", b, a);
            }
        }
        get ai() {
            return this.af;
        }
        set ai(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.h6("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get ah() {
            return this.ae;
        }
        set ah(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.h6("ActualBaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get kg() {
            return this.ju;
        }
        set kg(a) {
            let b = this.ju;
            this.ju = a;
            if (b != this.ju) {
                this.h6("BorderColor", b, a);
            }
        }
        get j5() {
            return this.jj;
        }
        set j5(a) {
            let b = this.jj;
            this.jj = a;
            if (b != this.jj) {
                this.h6("ActualBorderColor", b, a);
            }
        }
        get c6() {
            return this.cm;
        }
        set c6(a) {
            let b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.h6("BorderWidth", b, a);
            }
        }
        get cw() {
            return this.cc;
        }
        set cw(a) {
            let b = this.cc;
            this.cc = a;
            if (b != this.cc) {
                this.h6("ActualBorderWidth", b, a);
            }
        }
        get k4() {
            return this.k2;
        }
        set k4(a) {
            let b = this.k2;
            this.k2 = a;
            if (b != this.k2) {
                this.h6("ContentPadding", b, a);
            }
        }
        get k3() {
            return this.k1;
        }
        set k3(a) {
            let b = this.k1;
            this.k1 = a;
            if (b != this.k1) {
                this.h6("ActualContentPadding", b, a);
            }
        }
        get jg() {
            return this.je;
        }
        set jg(a) {
            let b = this.je;
            this.je = a;
            if (b != this.je) {
                this.h6("CornerRadius", b, a);
            }
        }
        get jf() {
            return this.jd;
        }
        set jf(a) {
            let b = this.jd;
            this.jd = a;
            if (b != this.jd) {
                this.h6("ActualCornerRadius", b, a);
            }
        }
        get f() {
            return this.b;
        }
        set f(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.h6("DataSourceDesiredProperties", b, this.b);
            }
        }
        get density() {
            return this.al;
        }
        set density(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.h6("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get am() {
            return this.ak;
        }
        set am(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.h6("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get dropDownButtonVisible() {
            return this.bw;
        }
        set dropDownButtonVisible(a) {
            let b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.h6("DropDownButtonVisible", b, a);
            }
        }
        get ks() {
            return this.jv;
        }
        set ks(a) {
            let b = this.jv;
            this.jv = a;
            if (b != this.jv) {
                this.h6("FocusBorderColor", b, a);
            }
        }
        get j6() {
            return this.jk;
        }
        set j6(a) {
            let b = this.jk;
            this.jk = a;
            if (b != this.jk) {
                this.h6("ActualFocusBorderColor", b, a);
            }
        }
        get di() {
            return this.cn;
        }
        set di(a) {
            let b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.h6("FocusBorderWidth", b, a);
            }
        }
        get cx() {
            return this.cd;
        }
        set cx(a) {
            let b = this.cd;
            this.cd = a;
            if (b != this.cd) {
                this.h6("ActualFocusBorderWidth", b, a);
            }
        }
        get kt() {
            return this.jw;
        }
        set kt(a) {
            let b = this.jw;
            this.jw = a;
            if (b != this.jw) {
                this.h6("FocusUnderlineColor", b, a);
            }
        }
        get j7() {
            return this.jl;
        }
        set j7(a) {
            let b = this.jl;
            this.jw = a;
            if (b != this.jl) {
                this.h6("ActualFocusUnderlineColor", b, a);
            }
        }
        get dj() {
            return this.co;
        }
        set dj(a) {
            let b = this.co;
            this.co = a;
            if (b != this.co) {
                this.h6("FocusUnderlineOpacity", b, a);
            }
        }
        get cy() {
            return this.ce;
        }
        set cy(a) {
            let b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.h6("ActualFocusUnderlineOpacity", b, a);
            }
        }
        get dk() {
            return this.cp;
        }
        set dk(a) {
            let b = this.cp;
            this.cp = a;
            if (b != this.cp) {
                this.h6("FocusUnderlineRippleOpacity", b, a);
            }
        }
        get cz() {
            return this.cf;
        }
        set cz(a) {
            let b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.h6("ActualFocusUnderlineRippleOpacity", b, a);
            }
        }
        get ku() {
            return this.jx;
        }
        set ku(a) {
            let b = this.jx;
            this.jx = a;
            if (b != this.jx) {
                this.h6("HoverUnderlineColor", b, a);
            }
        }
        get j8() {
            return this.jm;
        }
        set j8(a) {
            let b = this.jm;
            this.jm = a;
            if (b != this.jm) {
                this.h6("ActualHoverUnderlineColor", b, a);
            }
        }
        get dl() {
            return this.cq;
        }
        set dl(a) {
            let b = this.cq;
            this.cq = a;
            if (b != this.cq) {
                this.h6("HoverUnderlineOpacity", b, a);
            }
        }
        get c0() {
            return this.cg;
        }
        set c0(a) {
            let b = this.cg;
            this.cg = a;
            if (b != this.cg) {
                this.h6("ActualHoverUnderlineOpacity", b, a);
            }
        }
        get dm() {
            return this.cr;
        }
        set dm(a) {
            let b = this.cr;
            this.cr = a;
            if (b != this.cr) {
                this.h6("HoverUnderlineWidth", b, a);
            }
        }
        get c1() {
            return this.ch;
        }
        set c1(a) {
            let b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.h6("ActualHoverUnderlineWidth", b, a);
            }
        }
        get itemsSource() {
            return this.du;
        }
        set itemsSource(a) {
            let b = this.du;
            this.du = a;
            if (b != this.du) {
                this.h6("ItemsSource", b, this.du);
            }
        }
        get actualDataSource() {
            return this.m();
        }
        get fz() {
            return this.f1;
        }
        set fz(a) {
            let b = this.fz;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.f1 = a;
            this.h6("Label", b, this.f1);
        }
        get kv() {
            return this.jy;
        }
        set kv(a) {
            let b = this.jy;
            this.jy = a;
            if (b != this.jy) {
                this.h6("LabelTextColor", b, a);
            }
        }
        get j9() {
            return this.jn;
        }
        set j9(a) {
            let b = this.jn;
            this.jn = a;
            if (b != this.jn) {
                this.h6("ActualLabelTextColor", b, a);
            }
        }
        get a2() {
            return this.as;
        }
        set a2(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.h6("LabelTextStyle", b, this.as);
            }
        }
        get av() {
            return this.ap;
        }
        set av(a) {
            let b = this.ap;
            this.ap = a;
            if (this.ap != b) {
                this.h6("ActualLabelTextStyle", b, this.ap);
            }
        }
        get actualLabelVisible() {
            return this.bs;
        }
        set actualLabelVisible(a) {
            let b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.h6("ActualLabelVisible", b, a);
            }
        }
        get f5() {
            return this.f4;
        }
        set f5(a) {
            let b = this.f4;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.f4 = a;
            this.h6("NoMatchesFoundLabel", b, this.f4);
        }
        get actualNoMatchesFoundLabel() {
            return this.er;
        }
        set actualNoMatchesFoundLabel(a) {
            let b = this.er;
            this.er = a;
            if (b != this.er) {
                this.h6("ActualNoMatchesFoundLabel", b, a);
            }
        }
        get kw() {
            return this.jz;
        }
        set kw(a) {
            let b = this.jz;
            this.jz = a;
            if (b != this.jz) {
                this.h6("NoMatchesFoundLabelBackgroundColor", b, a);
            }
        }
        get ka() {
            return this.jo;
        }
        set ka(a) {
            let b = this.jo;
            this.jo = a;
            if (b != this.jo) {
                this.h6(ComboEditor.et, b, a);
            }
        }
        get kx() {
            return this.j0;
        }
        set kx(a) {
            let b = this.j0;
            this.j0 = a;
            if (b != this.j0) {
                this.h6("NoMatchesFoundLabelTextColor", b, a);
            }
        }
        get kb() {
            return this.jp;
        }
        set kb(a) {
            let b = this.jp;
            this.jp = a;
            if (b != this.jp) {
                this.h6("ActualNoMatchesFoundLabelTextColor", b, a);
            }
        }
        get a3() {
            return this.at;
        }
        set a3(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.h6("NoMatchesFoundLabelTextStyle", b, this.at);
            }
        }
        get aw() {
            return this.aq;
        }
        set aw(a) {
            let b = this.aq;
            this.aq = a;
            if (this.aq != b) {
                this.h6("ActualNoMatchesFoundLabelTextStyle", b, this.aq);
            }
        }
        get gb() {
            return this.gc;
        }
        set gb(a) {
            let b = this.gb;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.gc = a;
            this.h6("PlaceholderText", b, this.gc);
        }
        get ky() {
            return this.j1;
        }
        set ky(a) {
            let b = this.j1;
            this.j1 = a;
            if (b != this.j1) {
                this.h6("TextColor", b, a);
            }
        }
        get kc() {
            return this.jq;
        }
        set kc(a) {
            let b = this.jq;
            this.jq = a;
            if (b != this.jq) {
                this.h6("ActualTextColor", b, a);
            }
        }
        get a4() {
            return this.au;
        }
        set a4(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.h6("TextStyle", b, this.au);
            }
        }
        get ax() {
            return this.ar;
        }
        set ax(a) {
            let b = this.ar;
            this.ar = a;
            if (this.ar != b) {
                this.h6("ActualTextStyle", b, this.ar);
            }
        }
        get kz() {
            return this.j2;
        }
        set kz(a) {
            let b = this.j2;
            this.j2 = a;
            if (b != this.j2) {
                this.h6("UnderlineColor", b, a);
            }
        }
        get kd() {
            return this.jr;
        }
        set kd(a) {
            let b = this.jr;
            this.jr = a;
            if (b != this.jr) {
                this.h6("ActualUnderlineColor", b, a);
            }
        }
        get dn() {
            return this.cs;
        }
        set dn(a) {
            let b = this.cs;
            this.cs = a;
            if (b != this.cs) {
                this.h6("UnderlineOpacity", b, a);
            }
        }
        get c2() {
            return this.ci;
        }
        set c2(a) {
            let b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.h6("ActualUnderlineOpacity", b, a);
            }
        }
        get k0() {
            return this.j3;
        }
        set k0(a) {
            let b = this.j3;
            this.j3 = a;
            if (b != this.j3) {
                this.h6("UnderlineRippleColor", b, a);
            }
        }
        get ke() {
            return this.js;
        }
        set ke(a) {
            let b = this.js;
            this.js = a;
            if (b != this.js) {
                this.h6("ActualUnderlineRippleColor", b, a);
            }
        }
        get dp() {
            return this.ct;
        }
        set dp(a) {
            let b = this.ct;
            this.ct = a;
            if (b != this.ct) {
                this.h6("UnderlineRippleOpacity", b, a);
            }
        }
        get c3() {
            return this.cj;
        }
        set c3(a) {
            let b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.h6("ActualUnderlineRippleOpacity", b, a);
            }
        }
        get dq() {
            return this.cu;
        }
        set dq(a) {
            let b = this.cu;
            this.cu = a;
            if (b != this.cu) {
                this.h6("UnderlineRippleWidth", b, a);
            }
        }
        get c4() {
            return this.ck;
        }
        set c4(a) {
            let b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.h6("ActualUnderlineRippleWidth", b, a);
            }
        }
        get dr() {
            return this.cv;
        }
        set dr(a) {
            let b = this.cv;
            this.cv = a;
            if (b != this.cv) {
                this.h6("UnderlineWidth", b, a);
            }
        }
        get c5() {
            return this.cl;
        }
        set c5(a) {
            let b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.h6("ActualUnderlineWidth", b, a);
            }
        }
        get bu() {
            return this.bk;
        }
        set bu(a) {
            let b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.h6("AllowFilter", b, a);
            }
        }
        get gg() {
            return this.d6;
        }
        set gg(a) {
            let b = this.d6;
            this.d6 = a;
            if (b != this.d6) {
                this.h6("TextField", b, a);
            }
        }
        get text() {
            return this.d5;
        }
        set text(a) {
            let b = this.d5;
            this.d5 = a;
            if (b != this.d5) {
                this.h6("Text", b, a);
            }
        }
        get j() {
            return this.d;
        }
        set j(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.h6("ValueField", b, a);
            }
        }
        get e() {
            return this.a;
        }
        set e(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.h6("ActualValueField", b, a);
            }
        }
        get value() {
            return this.dv;
        }
        set value(a) {
            let b = this.dv;
            this.dv = a;
            if (b != this.dv) {
                this.h6("Value", b, a);
            }
        }
        get s() {
            return this.q;
        }
        set s(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.h6("DisplayType", enumGetBox(InputGroupDisplayType_$type, b), enumGetBox(InputGroupDisplayType_$type, a));
            }
        }
        dx(a, b) {
            let c = new FastReflectionHelper(false, b);
            return c.getPropertyValue(a);
        }
        ft() {
            return this.fs(this.gg);
        }
        dy(a) {
            let b = this.i();
            if (null == b || b.length == 0) {
                return null;
            }
            let c = new List$1(Base.$, 0);
            for (let e = 0; e < b.length; e++) {
                let d = b[e];
                let f = this.dx(a, d);
                c.add1(f);
            }
            if (c.count == 1) {
                return c._inner[0];
            }
            return c.toArray();
        }
        fr(a) {
            let b = this.ft();
            let c;
            if (null != b) {
                let d = this.dx(a, b);
                c = null != d ? d.toString() : null;
            }
            else {
                c = null;
            }
            return c;
        }
        fs(a) {
            if (stringIsNullOrEmpty(a)) {
                let b = this.actualDataSource;
                if (null == b) {
                    return null;
                }
                let c = b.actualSchema;
                if (null == c) {
                    return null;
                }
                let d = c.propertyNames;
                if (0 == d.length) {
                    return null;
                }
                return d[0];
            }
            return a;
        }
        h(a) {
            let b = new List$1(String_$type, 0);
            if (null == a || a.length == 0) {
                let c = this.fs(null);
                if (stringIsNullOrEmpty(c)) {
                    return null;
                }
                b.add(c);
                return b.toArray();
            }
            for (let e = 0; e < a.length; e++) {
                let d = a[e];
                let f = this.fs(d);
                if (null != f) {
                    b.add(f);
                }
            }
            if (b.count > 0) {
                return b.toArray();
            }
            return null;
        }
        i() {
            let a = this.j;
            return this.h(a);
        }
        h8(a) {
            this.io(2, a);
        }
        io(a, b) {
            if (this.b2) {
                return;
            }
            this.b2 = true;
            try {
                switch (a) {
                    case 2:
                        {
                            let c = b;
                            let d;
                            let e;
                            if (null != c) {
                                d = this.fr(c);
                                e = this.dy(c);
                            }
                            else {
                                d = stringEmpty();
                                e = null;
                            }
                            if (this.text != d) {
                                this.text = d;
                            }
                            if (this.value != e) {
                                this.value = e;
                            }
                        }
                        break;
                    case 1:
                        this.i0(b.toString());
                        break;
                    case 0:
                        this.iz(b);
                        break;
                }
            }
            finally {
                this.b2 = false;
            }
        }
        iy(a) {
            this.text = a;
        }
        jc() {
            this.ax = (null == this.a4) ? this.a1 : this.a4;
            this.av = (null == this.a2) ? this.a1 : this.a2;
        }
        i3() {
        }
        closeUp() {
            this.g0();
        }
        destroy() {
            this.provideRenderer(null);
        }
        dropDown() {
            this.g5();
        }
        select() {
            this.iu();
        }
        notifySizeChanged() {
            this.ab.g();
        }
        provideRenderer(a) {
            this.ab.j(a);
            this.actualNoMatchesFoundLabel = !stringIsNullOrWhiteSpace(this.bj.b1("NoMatches")) ? this.bj.b1("NoMatches") : "No Matches Found";
        }
        dw() {
            return this.u();
        }
        fk() {
            let a = this.u();
            return a.ak();
        }
        u() {
            let a = new ComboEditorVisualModelExport();
            a.a = AppearanceHelper.a(this.j4);
            a.i = this.ah;
            a.b = AppearanceHelper.a(this.j5);
            a.n = this.cw;
            a.as = this.k3;
            a.ar = this.jf;
            a.j = this.am;
            a.dropDownButtonVisible = this.dropDownButtonVisible;
            a.o = this.cy;
            a.y = this.fz;
            a.c = AppearanceHelper.a(this.j9);
            a.actualLabelVisible = this.actualLabelVisible;
            a.actualNoMatchesFoundLabel = this.actualNoMatchesFoundLabel;
            a.d = AppearanceHelper.a(this.ka);
            a.e = AppearanceHelper.a(this.kb);
            a.aj = this.gb;
            a.f = AppearanceHelper.a(this.kc);
            a.g = AppearanceHelper.a(this.kd);
            a.p = this.c2;
            a.h = AppearanceHelper.a(this.ke);
            a.q = this.c3;
            a.r = this.c4;
            a.s = this.c5;
            a.al = this.text;
            a.w = this.value;
            if (this.av != null) {
                let b = this.av;
                if (this.ab != null && b.q == null) {
                    let c = this.ab.c;
                    let d = FontUtil.getFontInfoFromString(c, b.fontString);
                    b.q = d.q;
                    b.f = d.f;
                    b.r = d.r;
                    b.t = d.t;
                    b.u = d.u;
                    b.v = d.v;
                }
                if (b.q != null) {
                    a.z = b.q;
                }
                if (!isNaN_(b.f)) {
                    a.t = b.f;
                }
                if (b.v != null) {
                    a.ad = b.v;
                }
                if (b.t != null) {
                    a.ab = b.t;
                }
                if (b.r != null) {
                    a.aa = b.t;
                }
            }
            if (this.aw != null) {
                let e = this.aw;
                if (this.ab != null && e.q == null) {
                    let f = this.ab.c;
                    let g = FontUtil.getFontInfoFromString(f, e.fontString);
                    e.q = g.q;
                    e.f = g.f;
                    e.r = g.r;
                    e.t = g.t;
                    e.u = g.u;
                    e.v = g.v;
                }
                if (e.q != null) {
                    a.ae = e.q;
                }
                if (!isNaN_(e.f)) {
                    a.u = e.f;
                }
                if (e.v != null) {
                    a.ai = e.v;
                }
                if (e.t != null) {
                    a.ag = e.t;
                }
                if (e.r != null) {
                    a.af = e.t;
                }
            }
            if (this.ax != null) {
                let h = this.ax;
                if (this.ab != null && h.q == null) {
                    let i = this.ab.c;
                    let j = FontUtil.getFontInfoFromString(i, h.fontString);
                    h.q = j.q;
                    h.f = j.f;
                    h.r = j.r;
                    h.t = j.t;
                    h.u = j.u;
                    h.v = j.v;
                }
                if (h.q != null) {
                    a.am = h.q;
                }
                if (!isNaN_(h.f)) {
                    a.v = h.f;
                }
                if (h.v != null) {
                    a.aq = h.v;
                }
                if (h.t != null) {
                    a.ao = h.t;
                }
                if (h.r != null) {
                    a.an = h.t;
                }
            }
            return a;
        }
        get b4() {
            return this.bn;
        }
        set b4(a) {
            let b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.h6("IsFixed", b, this.bn);
            }
        }
        get b9() {
            return this.bq;
        }
        set b9(a) {
            let b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.h6("OpenAsChild", b, this.bq);
            }
        }
        get cb() {
            return this.br;
        }
        set cb(a) {
            let b = this.br;
            this.br = a;
            if (b != this.br) {
                this.h6("UseTopLayer", b, this.br);
            }
        }
        h1(a) {
            if (null != this.gotFocus) {
                this.gotFocus(this, a);
            }
        }
        h4(a) {
            if (null != this.lostFocus) {
                this.lostFocus(this, a);
            }
        }
        ic(a) {
            if (null != this.textValueChanged) {
                this.textValueChanged(this, a);
            }
        }
        h9(a) {
            if (null != this.selectedValueChanged) {
                this.selectedValueChanged(this, a);
            }
        }
        h6(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.ip(a, b, c);
        }
        h3(a) {
            if (null != this.keyDown) {
                let b = new KeyEventArgs(1, a.g, a.a, a.e, a.b, a.h);
                this.keyDown(this, b);
            }
        }
        hq(a) {
            let b = new InputChangeEventArgs();
            b.isCompositionInProgress = a.a;
            b.value = a.b;
            if (null != this.changing) {
                this.changing(this, b);
            }
        }
        get ad() {
            return this.ac;
        }
        get b7() {
            return this.dt == 46;
        }
        get bh() {
            return this.bg;
        }
        id(a) {
            this.a9 = a;
            this.h5();
        }
        h0() {
            this.ab.i();
        }
        hp() {
            this.ab.h();
        }
        h5() {
            this.g2();
            this.i8();
            this.g1();
            this.bc.bn(this.a7);
            this.i1();
            this.i2();
            this.ab.h();
        }
        gv(a) {
            let b = this.m();
            if (this.n != null) {
                if (b != null) {
                    if (b.filterExpressions.k.contains(this.n)) {
                        b.filterExpressions.remove(this.n);
                    }
                }
            }
            this.n = a;
            this.by = false;
            if (a != null && b != null && !b.filterExpressions.k.contains(a)) {
                b.filterExpressions.add(a);
                this.by = true;
            }
            else {
                this.dropDown();
            }
        }
        gw() {
            let a = this.m();
            if (a != null) {
                if (a.filterExpressions.k.contains(this.n)) {
                    a.filterExpressions.remove(this.n);
                }
            }
            this.n = null;
        }
        g0() {
            let a = this.bh;
            if (null != a) {
                a.cb();
            }
            this.i2();
            this.gw();
        }
        get bb() {
            return this.a7;
        }
        b3(a) {
            if (null == a) {
                return false;
            }
            let b = this.a7;
            let c = this.ac;
            let d = this.a5;
            return this.bh.t(a) || this.bc.t(a);
        }
        g1() {
            let a = this.ab.d();
            NativeUIContent.av(a, [7, 2], [2, 2], (b) => {
                this.a7 = b[0];
                this.a7.h = 3;
                this.a7.n = runOn(this, this.hk);
                this.a7.o = runOn(this, this.hl);
                this.bd = b[1];
                this.a7.bn(this.bd);
                this.bd.b7 = this.text;
                this.bd.bs = runOn(this, this.hf);
                this.bd.bt = runOn(this, this.hg);
                this.bd.bx = runOn(this, this.hi);
                this.bd.n = runOn(this, this.hh);
                this.bd.bz = runOn(this, this.hj);
                this.g6(this.bu);
                this.bd.b6 = ComboEditor.d2;
                this.bd.bn = runOn(this, this.ib);
            });
        }
        get be() {
            return this.bd;
        }
        g2() {
            NativeUIContent.av(this.ab.d(), [7, 12, 0, 3, 7], [2, 2, 2, 2, 2], (a) => {
                let b = a[1];
                this.bg = b;
                this.a5 = a[2];
                this.a5.bi = new Thickness(0, 4);
                this.ba = a[0];
                this.ba.bn(this.a5);
                this.a8 = a[4];
                this.ba.bn(this.a8);
                this.a9.bn(this.bg);
                this.bf = a[3];
                this.bg.bn(this.ba);
                this.bg.bw = runOn(this, this.ig);
            });
        }
        ig(a, b) {
            if (this.ad != null && this.a8.bj == 0) {
                this.ad.notifySizeChanged();
            }
        }
        ht(a, b) {
        }
        hw(a, b, c) {
        }
        hs() {
            switch (this.v) {
                case 2:
                case 1:
                    if (null == this.l) {
                        this.v = 0;
                    }
                    break;
            }
            let a = null;
            switch (this.v) {
                case 2:
                    {
                        let b = this.l.actualCount;
                        if (b == 0) {
                            this.value = null;
                        }
                        else {
                            if (b > 1) {
                            }
                            a = this.l.getItemAtIndex(0);
                            let c = this.i();
                            let d = new List$1(Base.$, 0);
                            for (let f = 0; f < c.length; f++) {
                                let e = c[f];
                                let g = this.l.getItemProperty(a, e);
                                d.add1(g);
                            }
                            this.value = d.count == 1 ? d._inner[0] : d.toArray();
                        }
                    }
                    break;
                case 1:
                    {
                        let h = this.l.actualCount;
                        if (h == 0) {
                            this.text = stringEmpty();
                        }
                        else {
                            if (h > 1) {
                            }
                            let i = this.ft();
                            a = this.l.getItemAtIndex(0);
                            let j = this.l.getItemProperty(a, i).toString();
                            this.text = j;
                        }
                        let k = this.m();
                        let l = k.indexOfItem(a);
                        this.iw(l);
                    }
                    break;
                case 0:
                default: return;
            }
            if (null != a) {
                let m = this.m();
                let n = m.indexOfItem(a);
                this.iw(n);
            }
            else {
                this.iw(-1);
            }
            if (this.l != null) {
                this.l.updateNotifier = null;
                this.l = null;
            }
            this.v = 0;
        }
        hu(a, b) {
        }
        hv(a, b) {
        }
        hz(a, b) {
            let c = this.ad;
            if (null != c) {
                let d = c.dr;
                if (-1 != d) {
                    if (d >= a && d <= b) {
                        this.it(d);
                        this.i9();
                    }
                }
            }
        }
        ia(a, b, c) {
        }
        hr() {
            this.ii();
            if (this.b5) {
                let a = this.m();
                let b = a.actualCount;
                if (this.ca && b > 0) {
                    this.ik();
                }
                else {
                    this.il();
                }
            }
            else {
                this.i7();
            }
        }
        h2(a, b) {
        }
        h7(a, b) {
        }
        g5() {
            this.jb();
            this.hm();
            let a = this.bh;
            if (a.b6) {
                return;
            }
            let b = this.ab.r();
            a.b0 = !this.b5;
            a.ce(b, 1, 1);
            this.i2();
        }
        m() {
            let a = this.ad;
            if (null != a) {
                return a.actualDataSource;
            }
            return null;
        }
        bz(a) {
            let b = this.ac.ag;
            let c = b.count;
            if (0 == c) {
                a = null;
                return {
                    ret: true,
                    p0: a
                };
            }
            else if (1 == c) {
                a = b._inner[0];
            }
            else {
                a = b._inner[0];
            }
            return {
                ret: null != a,
                p0: a
            };
        }
        ha(a) {
            let b = -1 != a ? a : -1;
            this.it(b);
        }
        hc() {
            if (this.bo) {
                return;
            }
            let a;
            let b = ((() => { let c = this.bz(a); a = c.p0; return c.ret; })());
            if (!b) {
                return;
            }
            if (a == null) {
                return;
            }
            this.h8(a);
        }
        hm() {
            this.bh.cc();
        }
        ho() {
            let a = this.bh;
            if (a.b6) {
                this.closeUp();
                let b = this.bd;
                b.az();
                let c = b.b7;
                let d = null != c ? b.b7.length : 0;
                b.ca(d, d);
            }
        }
        hx() {
            this.bd.b1 = true;
            this.bd.b9();
            let a = new ComboEditorGotFocusEventArgs();
            this.h1(a);
        }
        hy() {
            this.closeUp();
            this.bd.b8();
            let a = new ComboEditorLostFocusEventArgs();
            this.h4(a);
        }
        il() {
            let a = this.ac;
            a.selectedItemsChanged = delegateRemove(a.selectedItemsChanged, runOn(this, this.hd));
            this.bo = true;
            try {
                this.iy(this.d7);
            }
            finally {
                this.bo = false;
                let b = this.ac;
                b.selectedItemsChanged = delegateCombine(b.selectedItemsChanged, runOn(this, this.hd));
            }
            this.b5 = false;
        }
        im() {
            this.b5 = true;
            if (stringIsNullOrEmpty(this.d7)) {
                if (this.n != null) {
                    this.gv(null);
                }
                else {
                    this.il();
                }
            }
            else {
                let a = FilterFactory.instance.property(this.ft()).toLower().startsWith(this.d7.toLowerCase());
                this.gv(a);
            }
        }
        ir() {
            this.dt = 0;
            this.b6 = false;
        }
        it(a) {
            let b = this.m();
            let c = b.isPlaceholderItem(a);
            if (c) {
            }
            else {
                let d = this.ad;
                if (a < 0) {
                    this.b1 = false;
                    d.ag.clear();
                    if (!this.b1) {
                        this.hc();
                    }
                    return;
                }
                d.selectedItemsChanged = delegateRemove(d.selectedItemsChanged, runOn(this, this.hd));
                try {
                    d.ag.clear();
                }
                finally {
                    d.selectedItemsChanged = delegateCombine(d.selectedItemsChanged, runOn(this, this.hd));
                }
                if (a >= 0) {
                    let e = b.getItemAtIndex(a);
                    this.b1 = false;
                    d.ag.add1(e);
                    if (!this.b1) {
                        this.hc();
                    }
                }
            }
        }
        iw(a) {
            let b = this.ad;
            if (-1 == a) {
                b.dr = -1;
                return;
            }
            let c = b.dr;
            let d = -1;
            let e;
            this.ds = a;
            d = a;
            this.b0 = false;
            b.dr = d;
            if (!this.b0) {
                this.ha(b.dr);
            }
            this.i9();
        }
        i0(a) {
            this.ie(2, a);
        }
        iz(a) {
            this.ie(1, a);
        }
        i1() {
            let a = this;
            if (null != this.bd) {
                this.bd.bp = a.density;
                this.bd.c = a.ah;
                this.bd.bu = a.s;
                this.bd.a8 = a.j4;
                this.bd.a9 = a.j5;
                this.bd.bg = new Thickness(0, a.cw);
                this.bd.bp = a.am;
                this.ab.k(this.bd);
            }
            if (null != this.bd) {
                this.bd.ce = a.kc;
                this.bd.bk = a.ax;
            }
            if (null != this.bd) {
                this.bd.b5 = a.fz;
            }
            if (null != this.a5) {
                this.a5.ba = a.kb;
                this.a5.a8 = a.ka;
                if (null != a.aw) {
                    let b = a.aw;
                    this.ab.m(this.a5, b);
                }
                this.a5.bs = this.bf;
                this.bf.bm = this.actualNoMatchesFoundLabel;
                this.hm();
            }
            if (null != this.ad) {
            }
        }
        i5() {
            if (!this.bo) {
                if (null != this.bd) {
                    let a = this.text;
                    this.bd.b7 = a;
                }
            }
        }
        i2() {
            let a = this.bh;
            let b = null != a ? a.b6 : false;
            this.bd.b6 = b ? ComboEditor.d3 : ComboEditor.d4;
        }
        i4() {
            this.jc();
            let a = this.ac.h1();
            let b = Math.min(a.height, 40 * 8);
            this.a8.y = b;
            let c = a.width;
            c = Math.max(c, 150);
            this.a8.ae = c;
        }
        i6() {
            if (this.b5) {
                return;
            }
            this.d7 = null;
            if (this.n != null) {
                this.gw();
            }
            else {
                this.i7();
            }
        }
        i7() {
            if (null != this.value) {
                let a = this.value;
                let b = typeCast(Array_$type, a) !== null ? a : [a];
                let c = this.m();
                let d = c.indexOfKey(b);
                if (-1 != d) {
                    this.iw(d);
                }
            }
        }
        i8() {
            if (null == this.ad) {
                this.jc();
                this.ab.f(this.a8, (a) => {
                    let b = a;
                    this.ac = b;
                    let c = this.ac;
                    c.rowUpdating = delegateCombine(c.rowUpdating, runOn(this, this.gt));
                    this.ja();
                    this.ad.aq = 1;
                    this.ad.al = 0;
                    this.ad.r = 1;
                    this.a8.a8 = BrushUtil.h(255, 255, 255, 255);
                    this.ac.hz = BrushUtil.h(255, 200, 200, 200);
                    this.ac.ht = BrushUtil.h(255, 100, 100, 100);
                    this.ac.ea = 32;
                    this.ad.hx = BrushUtil.h(0, 0, 0, 0);
                    this.ad.bv = false;
                    this.ad.bq = false;
                    let d = this.ad;
                    d.activeRowChanged = delegateCombine(d.activeRowChanged, runOn(this, this.g9));
                    let e = this.ad;
                    e.selectedItemsChanged = delegateCombine(e.selectedItemsChanged, runOn(this, this.hd));
                    let f = this.ad;
                    f.itemClicked = delegateCombine(f.itemClicked, runOn(this, this.hb));
                    this.ad.a7 = runOn(this, this.he);
                    this.i1();
                });
            }
        }
        gt(a, b) {
            if (b.b != null) {
                let c = null;
                if (b.b.ao != "comboItem") {
                    NativeUIComponent.au(this.ab.d(), 3, (d) => {
                        let e = d;
                        e.bk = this.ax;
                        b.b.bs = e;
                        b.b.ao = "comboItem";
                        e.f = 0;
                        e.h = 1;
                        e.bh = new Thickness(0, 5);
                        e.bm = this.ft() != null ? this.actualDataSource.getItemProperty(b.a.x, this.ft()).toString() : "";
                    });
                }
                else {
                    let d = b.b.bs;
                    d.bm = this.ft() != null ? this.actualDataSource.getItemProperty(b.a.x, this.ft()).toString() : "";
                }
            }
        }
        ie(a, b) {
            let c = this.m();
            if (null == c) {
                return;
            }
            if (null != this.l) {
                if (a != this.v) {
                }
                this.l.updateNotifier = null;
                this.l = null;
            }
            this.v = a;
            let d = new FilterFactory();
            let e = null;
            let f = null;
            switch (a) {
                case 2:
                    {
                        let g = this.ft();
                        if (stringIsNullOrEmpty(g)) {
                            return;
                        }
                        e = b.toString();
                        let h = d.property(g);
                        f = h.isEqualTo(e);
                    }
                    break;
                case 1:
                    {
                        let i = this.i();
                        if (i == null || i.length < 1) {
                            return;
                        }
                        let j = typeCast(Array_$type, b) !== null ? b : [b];
                        if (i.length != j.length) {
                            return;
                        }
                        for (let k = 0; k < i.length; k++) {
                            let l = i[k];
                            e = j[k];
                            let m = d.property(l);
                            let n = m.isEqualTo(e);
                            if (null == f) {
                                f = n;
                            }
                            else {
                                f.and(n);
                            }
                        }
                    }
                    break;
                case 0:
                default: return;
            }
            this.l = c.clone();
            this.l.filterExpressions.clear();
            this.l.updateNotifier = new ComboEditorDataSourceNotificationHandler(this, true);
            this.l.filterExpressions.add(f);
            if (!this.l.isVirtual) {
                this.l.flushAutoRefresh();
            }
        }
        ih() {
            this.i5();
            let a = this.text;
            let b = this.d7.length;
            let c = !stringIsNullOrEmpty(a) ? a.length : 0;
            if (this.b6 && !stringIsNullOrEmpty(this.d7) && b > 0) {
                b--;
            }
            this.bd.ca(b, c);
        }
        ii() {
            if (this.by) {
                this.by = false;
                this.dropDown();
            }
        }
        ij(a) {
            this.d7 = a;
            this.ca = !this.b7;
            this.im();
        }
        ik() {
            if (stringIsNullOrEmpty(this.d7)) {
                this.gx();
            }
            else {
                this.iw(0);
            }
            this.ih();
            this.b5 = false;
        }
        gx() {
            let a = this.ad;
            a.dr = -1;
        }
        g6(a) {
            if (this.bd != null) {
                this.bd.b0 = !a;
            }
        }
        i9() {
            if (!this.bp) {
                return;
            }
            let a = this.ad;
            let b = a.dr;
            if (-1 != b) {
                let c = this.m();
                if (null != c) {
                    let d = b < c.actualCount ? c.getItemAtIndex(b) : 0;
                    if (null == d) {
                        return;
                    }
                    a.ci(d);
                }
            }
            else {
                a.ha(0);
            }
        }
        ja() {
            if (this.ad != null) {
                let a = this.itemsSource;
                this.ad.ag.clear();
                if (this.ad.actualDataSource != null) {
                    let b = this.ad.actualDataSource;
                    b.schemaChanged = delegateRemove(b.schemaChanged, runOn(this, this.gu));
                }
                this.ad.g = null;
                this.ad.itemsSource = a;
                this.ad.f = this.i();
                this.ds = -1;
                let c = this.m();
                if (null != c) {
                    let d = c.updateNotifier;
                    let e = new ComboEditorDataSourceNotificationHandler(this, false);
                    let f = new ComboEditorMultipleDataSourceNotifier(1, [d, e]);
                    c.updateNotifier = f;
                    c.propertiesRequested = this.f;
                    c.schemaChanged = delegateCombine(c.schemaChanged, runOn(this, this.gu));
                    if (this.value != null) {
                        this.ie(1, this.value);
                    }
                }
                this.l = null;
            }
        }
        gu(a, b) {
            if (this.ds != -1) {
                this.iw(this.ds);
                this.ds = -1;
            }
        }
        iv(a) {
            if (this.bd != null) {
                this.bd.b0 = !a;
            }
        }
        jb() {
            this.i4();
            if (!this.b5) {
                this.b8 = false;
            }
            else {
                let a = this.m();
                this.b8 = a.actualCount == 0;
            }
            this.a5.bj = this.b8 ? 0 : 1;
            let b = this.a8.bj;
            this.a8.bj = !this.b8 ? 0 : 1;
        }
        g8(a) {
            if (this.bd != null) {
                if (a) {
                    this.bd.a0();
                }
                else {
                    this.bd.az();
                }
            }
        }
        iu() {
            if (this.bd != null) {
                this.bd.b9();
            }
        }
        get bc() {
            return this.a9;
        }
        ib(a, b) {
            b.a = true;
            let c = this.bh;
            if (c.b6) {
                this.closeUp();
            }
            else {
                this.gv(null);
            }
            if (null != this.bd) {
                this.bd.az();
                this.bd.b9();
            }
        }
        g9(a, b) {
            let c = b.newActiveRow;
            this.ha(c);
            this.b0 = true;
        }
        hb(a, b) {
            this.ho();
        }
        hd(a, b) {
            this.hc();
            this.b1 = true;
        }
        he() {
            this.bp = this.ad.aw.a;
            this.i9();
        }
        hf(a, b) {
            if (b.a) {
                return;
            }
            this.hq(b);
            let c = b.b;
            this.ij(c);
        }
        hg(a, b) {
            let c = this.bd.b7;
            this.ij(c);
        }
        hh(a, b) {
            this.ir();
        }
        hi(a, b) {
            this.h3(b);
            if (b.c) {
                return;
            }
            let c = b.g;
            this.dt = c;
            this.b6 = false;
            switch (c) {
                case 8:
                    let d = this.bd.b4;
                    if (0 == d) {
                        break;
                    }
                    let e = this.bd.b7;
                    if (stringIsNullOrEmpty(e)) {
                        break;
                    }
                    let f = e.length;
                    let g = this.bd.b3;
                    let h = g - d;
                    if (h > 0 && h < f && g == f) {
                        this.b6 = true;
                    }
                    break;
                case 40:
                    if (b.a) {
                        this.dropDown();
                        this.i6();
                        b.d = true;
                    }
                    else {
                        let i = this.ad;
                        if (null == i) {
                            return;
                        }
                        let j = this.ad.dr;
                        if (-1 != i.dr) {
                            this.ad.b1(false, false);
                            b.d = true;
                        }
                        else {
                            let k = this.m();
                            if (null != k) {
                                let l = k.actualCount;
                                if (l > 0) {
                                    this.iw(0);
                                    b.d = true;
                                }
                            }
                        }
                    }
                    break;
                case 38:
                    if (b.a) {
                        this.closeUp();
                        b.d = true;
                    }
                    else {
                        let m = this.ad;
                        if (null == m) {
                            return;
                        }
                        let n = this.ad.dr;
                        if (null != m.dr) {
                            this.ac.ce(false, false);
                            b.d = true;
                        }
                        else {
                            let o = this.m();
                            if (null != o) {
                                let p = o.actualCount;
                                if (p > 0) {
                                    this.iw(p - 1);
                                    b.d = true;
                                }
                            }
                        }
                    }
                    break;
                case 13:
                    if (this.bh.b6) {
                        b.f = true;
                    }
                    this.ho();
                    break;
                case 27:
                    this.closeUp();
                    break;
            }
        }
        hj(a, b) {
        }
        hk(a, b) {
            if (this.bm) {
                return;
            }
            this.bm = true;
            this.bd.az();
            this.bm = false;
            let c = b.b;
            if (!this.b3(c)) {
                this.hx();
            }
        }
        hl(a, b) {
            let c = b.b;
            if (!this.b3(c)) {
                this.hy();
            }
        }
    }
    ComboEditor.$t = /*@__PURE__*/ markType(ComboEditor, 'ComboEditor', Base.$, [INotifyPropertyChanged_$type]);
    ComboEditor.ag = 1;
    ComboEditor.kh = /*@__PURE__*/ ThemeResolver.ah(ComboEditor.ag, XLabel.dd, XLabel.c6);
    ComboEditor.kj = /*@__PURE__*/ ThemeResolver.ah(ComboEditor.ag, XLabel.dd, XLabel.c6);
    ComboEditor.ki = /*@__PURE__*/ BrushUtil.h(255, 255, 255, 255);
    ComboEditor.ay = null;
    ComboEditor.et = "ActualNoMatchesFoundLabelBackgroundColor";
    ComboEditor.az = null;
    ComboEditor.kr = /*@__PURE__*/ BrushUtil.h(221, 0, 0, 0);
    ComboEditor.d2 = "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z";
    ComboEditor.d4 = "M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z";
    ComboEditor.d3 = "M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z";
    return ComboEditor;
})();
/**
 * @hidden
 */
export let ComboEditorDataSourceNotificationHandler = /*@__PURE__*/ (() => {
    class ComboEditorDataSourceNotificationHandler extends Base {
        constructor(a, b) {
            super();
            this.a = null;
            this.b = false;
            this.a = a;
            this.b = b;
        }
        rangeActualized(a, b) {
            if (!this.b) {
                this.a.hz(a, b);
            }
            else {
                this.a.ht(a, b);
            }
        }
        notifySetItem(a, b, c) {
            if (!this.b) {
                this.a.ia(a, b, c);
            }
            else {
                this.a.hw(a, b, c);
            }
        }
        notifyClearItems() {
            if (!this.b) {
                this.a.hr();
            }
            else {
                this.a.hs();
            }
        }
        notifyInsertItem(a, b) {
            if (!this.b) {
                this.a.h2(a, b);
            }
            else {
                this.a.hu(a, b);
            }
        }
        notifyRemoveItem(a, b) {
            if (!this.b) {
                this.a.h7(a, b);
            }
            else {
                this.a.hv(a, b);
            }
        }
    }
    ComboEditorDataSourceNotificationHandler.$t = /*@__PURE__*/ markType(ComboEditorDataSourceNotificationHandler, 'ComboEditorDataSourceNotificationHandler', Base.$, [IDataSourceUpdateNotifier_$type]);
    return ComboEditorDataSourceNotificationHandler;
})();
