/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, fromEnum, runOn, Point_$type, Delegate_$type, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, Number_$type, delegateRemove, typeCast, delegateCombine, typeGetValue, fromEn, getInstanceType, EventArgs } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { DOMExecutionContext } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { NativeUIComponent } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { ListPanelVisualModel } from "./ListPanelVisualModel";
import { Rect } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { ListPanelSelectionMode_$type } from "./ListPanelSelectionMode";
import { ListPanelActivationMode_$type } from "./ListPanelActivationMode";
import { ListPanelSelectionBehavior_$type } from "./ListPanelSelectionBehavior";
import { ListPanelSelectedItemsCollection } from "./ListPanelSelectedItemsCollection";
import { ListPanelSelectedKeysCollection } from "./ListPanelSelectedKeysCollection";
import { IDataSource_$type } from "igniteui-react-core";
import { ScrollbarStyle_$type } from "igniteui-react-core";
import { ListPanelOrientation_$type } from "./ListPanelOrientation";
import { DeviceUtils } from "igniteui-react-core";
import { FastIterationDictionary$2 } from "igniteui-react-core";
import { Stack$1 } from "igniteui-react-core";
import { ListPanelPrimaryKeyValue } from "./ListPanelPrimaryKeyValue";
import { NativeUIInputsFactory } from "igniteui-react-core";
import { ListPanelViewportChangedEventArgs } from "./ListPanelViewportChangedEventArgs";
import { DataSourceSpecialRow } from "igniteui-react-core";
import { ListPanelSelectedItemsChangedEventArgs } from "./ListPanelSelectedItemsChangedEventArgs";
import { ListPanelSelectedKeysChangedEventArgs } from "./ListPanelSelectedKeysChangedEventArgs";
import { ListPanelSelectionChangedEventArgs } from "./ListPanelSelectionChangedEventArgs";
import { ListPanelActiveRowChangedEventArgs } from "./ListPanelActiveRowChangedEventArgs";
import { ListPanelContentRefreshedEventArgs } from "./ListPanelContentRefreshedEventArgs";
import { ListPanelItemPresenter } from "./ListPanelItemPresenter";
import { Thickness } from "igniteui-react-core";
import { ListPanelTemplateWidthRequestedEventArgs } from "./ListPanelTemplateWidthRequestedEventArgs";
import { ListPanelTemplateHeightRequestedEventArgs } from "./ListPanelTemplateHeightRequestedEventArgs";
import { ListPanelColumnDefinition } from "./ListPanelColumnDefinition";
import { ArrayExtension } from "igniteui-react-core";
import { ListPanelVisualData } from "./ListPanelVisualData";
import { ListPanelItemVisualData } from "./ListPanelItemVisualData";
import { BrushUtil } from "igniteui-react-core";
import { truncate, isNaN_ } from "igniteui-react-core";
import { IDataSourceUpdateNotifier_$type } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { HashSet$1 } from "igniteui-react-core";
import { ListPanelRowRange } from "./ListPanelRowRange";
/**
 * @hidden
 */
export let ListPanelView = /*@__PURE__*/ (() => {
    class ListPanelView extends Base {
        constructor() {
            super();
            this.p = null;
            this.o = null;
            this.a = null;
            this.j = null;
            this.n = null;
            this.e = null;
            this.m = null;
            this.g = new List$1(Delegate_$type, 0);
            this.b = ((() => {
                let $ret = new FontInfo();
                $ret.q = "Verdana";
                $ret.f = 13;
                $ret.t = "Normal";
                $ret.v = "Normal";
                $ret.r = "Normal";
                return $ret;
            })());
            this.ag = new Size();
            this.c = null;
            this._gridExternal = null;
            this.f = false;
            this.l = null;
            this.k = null;
        }
        s() {
            return this.j;
        }
        ab() {
        }
        z(a) {
            if (a == null) {
                for (let b of fromEnum(this.g)) {
                    b();
                }
                this.j = null;
                return;
            }
            this.a.k = new DOMExecutionContext(a);
            this.j = a;
            this.n = this.j.createElement("canvas");
            this.e = new RenderingContext(new CanvasViewRenderer(), this.j.get2DCanvasContext(this.n));
            this.m = this.j.createElement("div");
            this.ae();
            NativeUIComponent.au(this.s(), 9, (c) => {
                let d = c;
                this.a.fx(d);
                this.k = d.an;
            });
            let c = Math.round(a.rootWrapper.width());
            let d = Math.round(a.rootWrapper.height());
            this.j.rootWrapper.setStyleProperty("position", "relative");
            this.g.add(a.rootWrapper.listen("mousedown", runOn(this, this.t)));
            this.g.add(a.rootWrapper.listen("mouseup", runOn(this, this.u)));
        }
        t(a) {
            let b = { $type: Point_$type, x: a.pageX - this.j.rootWrapper.getOffset().left, y: a.pageY - this.j.rootWrapper.getOffset().top };
            this.a.gg(b, a.button == 0, a.shiftKey, a.ctrlKey);
        }
        u(a) {
            let b = { $type: Point_$type, x: a.pageX - this.j.rootWrapper.getOffset().left, y: a.pageY - this.j.rootWrapper.getOffset().top };
            this.a.gh(b, a.button == 0, a.shiftKey, a.ctrlKey);
        }
        get contentGrid() {
            return this.k;
        }
        ae() {
        }
        ad() {
            if (this.j != null) {
            }
        }
        y() {
            if (this.j == null) {
                return;
            }
            let a = this.j.rootWrapper.width();
            let b = this.j.rootWrapper.height();
            this.k.setRawStyleProperty("width", "");
            this.k.setRawStyleProperty("height", "");
            let c = this.k.outerWidth();
            let d = this.k.outerHeight();
            if (a != 0 && b != 0) {
                c = a;
                d = b;
            }
            this.ag = new Size(1, c, d);
            this.a.onSizeChanged(this.ag.width, this.ag.height);
            if (!this.a.aw.d.isEmpty && (a != this.a.aw.d.width || b != this.a.aw.d.height)) {
                this.a.setViewport(this.a.aw.d.left, this.a.aw.d.top, this.a.aw.d.left + a, this.a.aw.d.top + b);
            }
            if (this.a.aw.d.isEmpty && a > 0 && b > 0) {
                this.a.setViewport(0, 0, a, b);
            }
        }
        af() {
            let a = this.j;
            if (null == a) {
                return;
            }
            let b = a.rootWrapper;
            if (null != b) {
                NativeUI.q(b, this.a.h0);
                NativeUI.m(b, this.a.hu);
            }
        }
        d() {
            return this.b;
        }
        aa() {
        }
        ac() {
        }
        x(a, b) {
            this.k.setStyleProperty("min-width", a + "px");
            this.k.setStyleProperty("min-height", b + "px");
            this.a.externalListPanel.onContentSizeChanged();
        }
        h() {
            return this.ag.width;
        }
        i(a) {
            this.c = this.a.a3();
            return FontUtil.measureStringWidth(a, this.c, this.e);
        }
        w(a, b) {
            if (this.l == null) {
                this.l = this.j.createElement("div");
            }
            b(this.l.getNativeElement());
        }
        v() {
            this.a.externalObject.ensureStretch();
        }
    }
    ListPanelView.$t = /*@__PURE__*/ markType(ListPanelView, 'ListPanelView');
    return ListPanelView;
})();
/**
 * @hidden
 */
export let ListPanel = /*@__PURE__*/ (() => {
    class ListPanel extends Base {
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        get a6() {
            if (this.a5 == null) {
                this.a5 = new SRProvider(this.view.j);
                this.a5.cb("Layouts");
            }
            return this.a5;
        }
        fx(a) {
            this.y = new ListPanelLayoutPanel(a);
        }
        constructor() {
            super();
            this._view = null;
            this.a4 = null;
            this.bc = false;
            this.a5 = null;
            this.y = null;
            this.propertyChanged = null;
            this.eb = null;
            this.viewportChanged = null;
            this.aw = null;
            this.df = -1;
            this.dg = -1;
            this.ap = 0;
            this.bf = true;
            this.hr = null;
            this.a8 = true;
            this.hp = null;
            this.hn = null;
            this.c8 = truncate(DeviceUtils.g(1));
            this.da = truncate(DeviceUtils.g(1));
            this.c9 = truncate(DeviceUtils.g(1));
            this.c7 = truncate(DeviceUtils.g(1));
            this.q = 0;
            this.ak = 1;
            this.b = null;
            this.a = null;
            this.an = null;
            this.o = null;
            this.selectedItemsChanged = null;
            this.selectedKeysChanged = null;
            this.selectionChanged = null;
            this.activeRowChanged = null;
            this.af = new ListPanelSelectedItemsCollection();
            this.ai = new ListPanelSelectedKeysCollection();
            this.i = null;
            this.c = new Array(0);
            this.bs = false;
            this.di = -1;
            this.cy = DeviceUtils.g(42);
            this.a1 = null;
            this.bb = true;
            this.ec = null;
            this.cz = 0;
            this.cx = NaN;
            this.cw = 0;
            this.bl = false;
            this.be = false;
            this.bk = false;
            this.dh = -1;
            this.contentRefreshed = null;
            this.rowUpdating = null;
            this.a0 = new FastIterationDictionary$2(Number_$type, ListPanelItemModel.$, 0);
            this.itemWidthRequested = null;
            this.itemHeightRequested = null;
            this.az = new FastIterationDictionary$2(ListPanelItemModel.$, ListPanelItemModel.$, 0);
            this.cv = new Stack$1(ListPanelItemModel.$);
            this.cp = new List$1(Number_$type, 0);
            this.co = new List$1(Number_$type, 0);
            this.ct = new List$1(Number_$type, 0);
            this.cs = new List$1(Number_$type, 0);
            this.dl = -1;
            this.cu = null;
            this.ax = 1;
            this.hq = null;
            this.bp = true;
            this.bi = true;
            this.dc = -1;
            this.dd = -1;
            this.l = null;
            this.bw = false;
            this.k = null;
            this.ho = ListPanel.hv;
            this.z = ListPanel.aa;
            this.bg = ListPanel.br;
            this.hs = ListPanel.hw;
            this.dj = -1;
            this.dk = -1;
            this.bh = true;
            this.db = 0;
            this._viewportManager = null;
            this.cq = new List$1(Number_$type, 0);
            this.cr = new List$1(Number_$type, 0);
            this.ck = new List$1(Base.$, 0);
            this.cl = new List$1(ListPanelPrimaryKeyValue.$, 0);
            this.cm = new List$1(Base.$, 0);
            this.cn = new List$1(ListPanelPrimaryKeyValue.$, 0);
            this.ba = false;
            this.a9 = false;
            this.bd = false;
            this.bj = false;
            this.bn = false;
            this.bm = false;
            this.cj = false;
            this.de = -1;
            this.bo = false;
            this.a7 = null;
            this.v = null;
            this.itemClicked = null;
            this.ao = new ListPanelSelectionManager(this);
            this.p = new ListPanelActivationManager(this);
            NativeUIInputsFactory.n();
            this.aw = new ListPanelVisualModel();
            let a = new ListPanelView();
            a.a = this;
            this.view = a;
            this.view.ab();
            this.af.ag(runOn(this, this.hd));
            this.ai.an(runOn(this, this.he));
        }
        onSizeChanged(a, b) {
            let c = this.cx;
            let d = this.cw;
            this.cx = this.view.h();
            if (this.ab != 1) {
                if (d != this.cw || c != (isNaN_(this.cx) ? 0 : this.cx)) {
                    this.view.x(this.cx, this.cw);
                }
            }
            this.g3();
        }
        setViewport(a, b, c, d) {
            this.df = -1;
            this.dg = -1;
            let e = c - a;
            let f = new Rect(0, a, b, c - a, d - b);
            if (f.x != this.aw.d.x || f.y != this.aw.d.y || f.width != this.aw.d.width || f.height != this.aw.d.height) {
                let g = this.aw.d;
                this.aw.d = f;
                this.g4();
                if (this.viewportChanged != null) {
                    this.viewportChanged(this, ((() => {
                        let $ret = new ListPanelViewportChangedEventArgs();
                        $ret.g = f.x;
                        $ret.d = g.x;
                        $ret.h = f.y;
                        $ret.e = g.y;
                        $ret.f = f.width;
                        $ret.c = g.width;
                        $ret.a = f.height;
                        $ret.b = g.height;
                        return $ret;
                    })()));
                }
            }
        }
        ad(a, b) {
            if (this.actualDataSource == null) {
                return null;
            }
            if (b < 0 || b > this.actualDataSource.actualCount - 1) {
                return null;
            }
            let c = this.actualDataSource.getItemAtIndex(b);
            if (c == null) {
                return null;
            }
            return this.ac(a, c);
        }
        ac(a, item_) {
            let b = (item_ != null && item_.$$isSpecialRow !== undefined);
            if (a == null) {
                if (item_ == null) {
                    return null;
                }
                return ListPanelPrimaryKeyValue.createIdentityKey(item_);
            }
            if (b) {
                let c = item_;
                if (this.actualDataSource.isSectionContentVisible || !this.actualDataSource.isSectionHeaderNormalRow || c.rowType != 1) {
                    return ListPanelPrimaryKeyValue.createIdentityKey(item_);
                }
                else if (c.rowType == 1) {
                    let d = c.getSectionKeys();
                    for (let e = 0; e < d.length; e++) {
                        for (let f = 0; f < a.length; f++) {
                            if (a[f] != d[e]) {
                                return ListPanelPrimaryKeyValue.createIdentityKey(item_);
                            }
                        }
                    }
                }
            }
            let g = new Array(a.length);
            for (let h = 0; h < a.length; h++) {
                g[h] = this.actualDataSource.getItemProperty(item_, a[h]);
            }
            return new ListPanelPrimaryKeyValue(a, g);
        }
        d6(a) {
            if (this.actualDataSource == null) {
                return -1;
            }
            if (this.actualDataSource.actualPrimaryKey != null && this.actualDataSource.isKeyIndexLookupSupported) {
                return this.actualDataSource.indexOfKey(a.value);
            }
            return -1;
        }
        ee(a) {
            let b = this.d6(a);
            if (b == -1) {
                if (a.value != null && a.value.length == 1) {
                    return a.value[0];
                }
                return null;
            }
            return this.actualDataSource.getItemAtIndex(b);
        }
        e() {
            if (this.actualDataSource != null) {
                return this.actualDataSource.actualPrimaryKey;
            }
            return this.d;
        }
        get aq() {
            return this.ap;
        }
        set aq(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.gi("SelectionMode", enumGetBox(ListPanelSelectionMode_$type, b), enumGetBox(ListPanelSelectionMode_$type, this.ap));
            }
        }
        get bv() {
            return this.bf;
        }
        set bv(a) {
            let b = this.bf;
            this.bf = a;
            if (this.bf != b) {
                this.gi("IsActiveRowStyleEnabled", b, this.bf);
            }
        }
        get hz() {
            return this.hr;
        }
        set hz(a) {
            let b = this.hr;
            this.hr = a;
            if (this.hr != b) {
                this.gi("SelectedBackground", b, this.hr);
            }
        }
        get bq() {
            return this.a8;
        }
        set bq(a) {
            this.a8 = a;
        }
        get hx() {
            return this.hp;
        }
        set hx(a) {
            let b = this.hp;
            this.hp = a;
            if (this.hp != b) {
                this.gi("NormalBackground", b, this.hp);
            }
        }
        get ht() {
            return this.hn;
        }
        set ht(a) {
            let b = this.hn;
            this.hn = a;
            if (this.hn != b) {
                this.gi("ActivationBorder", b, this.hn);
            }
        }
        get dn() {
            return this.c8;
        }
        set dn(a) {
            let b = this.c8;
            this.c8 = a;
            if (this.c8 != b) {
                this.gi("ActivationBorderLeftWidth", b, this.c8);
            }
        }
        get dq() {
            return this.da;
        }
        set dq(a) {
            let b = this.da;
            this.da = a;
            if (this.da != b) {
                this.gi("ActivationBorderTopWidth", b, this.da);
            }
        }
        get dp() {
            return this.c9;
        }
        set dp(a) {
            let b = this.c9;
            this.c9 = a;
            if (this.c9 != b) {
                this.gi("ActivationBorderRightWidth", b, this.c9);
            }
        }
        get dm() {
            return this.c7;
        }
        set dm(a) {
            let b = this.c7;
            this.c7 = a;
            if (this.c7 != b) {
                this.gi("ActivationBorderBottomWidth", b, this.c7);
            }
        }
        get r() {
            return this.q;
        }
        set r(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.gi("ActivationMode", enumGetBox(ListPanelActivationMode_$type, b), enumGetBox(ListPanelActivationMode_$type, this.q));
            }
        }
        get al() {
            return this.ak;
        }
        set al(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.gi("SelectionBehavior", enumGetBox(ListPanelSelectionBehavior_$type, b), enumGetBox(ListPanelSelectionBehavior_$type, this.ak));
            }
        }
        get f() {
            return this.b;
        }
        set f(a) {
            let b = this.b;
            this.b = a;
            if (this.b != b) {
                this.gi("PrimaryKey", b, this.b);
            }
        }
        get d() {
            return this.a;
        }
        set d(a) {
            let b = this.a;
            this.a = a;
            if (this.a != b) {
                this.gi("ActualPrimaryKey", b, this.a);
            }
        }
        get ao() {
            return this.an;
        }
        set ao(a) {
            this.an = a;
        }
        get p() {
            return this.o;
        }
        set p(a) {
            this.o = a;
        }
        get ag() {
            return this.af;
        }
        get aj() {
            return this.ai;
        }
        get itemsSource() {
            return this.eb;
        }
        set itemsSource(a) {
            let b = this.eb;
            this.eb = a;
            if (b != this.eb) {
                this.gi("ItemsSource", b, this.eb);
            }
        }
        get g() {
            return this.c;
        }
        set g(a) {
            let b = this.c;
            this.c = a;
            if (this.c != b) {
                this.gi("SchemaIncludedProperties", b, this.c);
            }
        }
        get actualDataSource() {
            return this.i;
        }
        set actualDataSource(a) {
            let b = this.i;
            this.i = a;
            if (this.i != b) {
                this.gi("ActualDataSource", b, this.i);
            }
        }
        notifySizeChanged() {
            this.view.y();
        }
        destroy() {
            this.provideContainer(null);
        }
        provideContainer(a) {
            this.view.z(a);
        }
        get ea() {
            return this.di;
        }
        set ea(a) {
            let b = this.di;
            this.di = a;
            if (b != this.di) {
                this.gi("RowHeight", b, this.di);
            }
        }
        get c2() {
            return this.cy;
        }
        set c2(a) {
            let b = this.cy;
            this.cy = a;
            if (b != this.cy) {
                this.gi("ActualRowHeight", b, this.cy);
            }
        }
        get a2() {
            return this.a1;
        }
        set a2(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.gi("CellTextStyle", b, this.a1);
            }
        }
        a3() {
            if (this.a2 == null) {
                return this.view.d();
            }
            return this.a2;
        }
        get bt() {
            return this.ab == 1;
        }
        gi(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.gv(a, b, c);
        }
        fj(a, b) {
            this.ge();
        }
        gy() {
            if (this.bk) {
                return;
            }
            this.bk = true;
            this.k.enqueueAction(runOn(this, this.fm));
        }
        fm() {
            if (!this.bk) {
                return;
            }
            this.bk = false;
            this.fu();
            if (this.bp) {
                this.fh();
            }
            this.gz();
            this.g2();
            if (this.contentRefreshed != null) {
                this.contentRefreshed(this, new ListPanelContentRefreshedEventArgs());
            }
        }
        fu() {
            if (this.bi) {
                this.fg();
                if (this.ab == 1) {
                    this.y.g(new Size(1, this.cx, this.cw));
                }
            }
        }
        g2() {
            if (this.actualDataSource == null) {
                return;
            }
            this.dh = this.actualDataSource.actualCount;
            for (let a = 0; a < this.az.o.count; a++) {
                if (this.az.p._inner[a]) {
                    continue;
                }
                let b = this.az.o._inner[a];
                let c = this.az.q._inner[a];
                this.y.f(c);
            }
            let d = 0;
            let e = this.r != 0;
            for (let f = 0; f < this.a0.o.count; f++) {
                if (this.a0.p._inner[f]) {
                    continue;
                }
                let g = this.a0.o._inner[f];
                let h = this.a0.q._inner[f];
                this.fq(h);
                this.fs(h);
                this.fo(h);
                this.y.d(this, h);
            }
        }
        fs(a) {
            if (a.p) {
                if (a.k) {
                    a.b.a.bg = new Thickness(1, this.dn, this.dq, this.dp, this.dm);
                }
                else {
                    a.b.a.bg = new Thickness(0, 0);
                }
                a.p = false;
                if (a.j) {
                    a.b.a.a9 = this.ht;
                }
                else {
                    a.b.a.a9 = null;
                }
                if (a.n) {
                    a.b.a.a8 = this.hz;
                }
                else {
                    a.b.a.a8 = this.hx;
                }
            }
        }
        fo(a) {
            if (a.m) {
                a.m = false;
                this.ft(a);
            }
        }
        ft(a) {
            if (this.rowUpdating != null) {
                let b = this.c4(a.v);
                this.rowUpdating(this, ((() => {
                    let $ret = new ListPanelTemplateItemUpdatingEventArgs();
                    $ret.a = a;
                    $ret.b = a.b.a.bl(0);
                    $ret.d = a.b.a.an;
                    $ret.c = b;
                    return $ret;
                })()));
            }
        }
        fq(a) {
            if (a.b != null) {
                return;
            }
            a.b = new ListPanelItemPresenter();
            NativeUIComponent.av(this.view.s(), [7, 0], [2, 2], (b) => {
                let c = b[0];
                let d = b[1];
                d.h = 3;
                d.f = 3;
                c.bn(d);
                if (this.ab == 0) {
                    c.f = 3;
                }
                else {
                    c.f = 0;
                }
                a.b.a = c;
                if (this.hx != null) {
                    a.b.a.a8 = this.hx;
                }
            });
        }
        fh() {
            if (!this.bp) {
                return;
            }
            this.bp = false;
            this.fw();
            this.dc = this.d8();
            this.dd = this.d9();
            this.aw.c = this.dc;
            this.aw.b = this.dd;
            if (this.dc == -1 || this.dd == -1) {
                return;
            }
            let a = new List$1(Number_$type, 0);
            for (let b = 0; b < this.a0.o.count; b++) {
                if (this.a0.p._inner[b]) {
                    continue;
                }
                let c = this.a0.o._inner[b];
                let d = this.a0.q._inner[b];
                if (c < this.dc || c > this.dd) {
                    a.add(c);
                }
            }
            for (let e = 0; e < a.count; e++) {
                this.g5(a._inner[e]);
            }
            for (let f = this.dc; f <= this.dd; f++) {
                this.fp(f);
                let g = this.a0.item(f);
                g.u = this.c6(f);
                g.s = this.c5(f);
            }
        }
        c5(a) {
            if (this.ab == 0) {
                return 0;
            }
            else if (this.ab == 2) {
                let b = this.d4(a);
                return this.ct._inner[b];
            }
            else {
                return this.ct._inner[a];
            }
        }
        d4(a) {
            let b = a % this.cu.count;
            return b;
        }
        d5(a) {
            let b = Math.floor(a / this.cu.count);
            return truncate(b);
        }
        c6(a) {
            if (this.ab == 1) {
                return 0;
            }
            else if (this.ab == 2) {
                let b = this.d5(a);
                if (this.bx) {
                    return this.cp._inner[b];
                }
                else {
                    return b * this.c2;
                }
            }
            else {
                if (this.bx) {
                    return this.cp._inner[a];
                }
                else {
                    return a * this.c2;
                }
            }
        }
        fp(a) {
            if (this.a0.d(a)) {
                return;
            }
            let b = this.x(a);
            if (b.i) {
                this.az.f(b);
                b.i = false;
                b.o = true;
            }
            this.a0.s(a, b);
        }
        x(a) {
            let b = this.cv.f > 0 ? this.cv.e() : new ListPanelItemModel();
            b.v = a;
            b.t = this.c2;
            return b;
        }
        g5(a) {
            let b = this.a0.item(a);
            this.g1(b);
            this.a0.f(a);
            b.i = true;
            this.az.s(b, b);
        }
        g1(a) {
            this.cv.h(a);
        }
        d9() {
            if (this.actualDataSource == null || this.actualDataSource.actualSchema == null || this.actualDataSource.actualCount == 0) {
                return -1;
            }
            if (!this.aw.d.isEmpty) {
                if (this.ab == 0) {
                    if (this.bx) {
                        this.fu();
                        let a = this.aw.d.bottom;
                        let b = this.dw(a);
                        if (this.cp._inner[b] + this.co._inner[b] < a) {
                            b += 1;
                        }
                        return Math.max(0, Math.min(b, this.actualDataSource.actualCount - 1));
                    }
                    else {
                        let c = this.aw.d.bottom;
                        let d = truncate(Math.ceil(c / this.c2));
                        return Math.max(0, Math.min(d, this.actualDataSource.actualCount - 1));
                    }
                }
                else if (this.ab == 2) {
                    if (this.bx) {
                        this.fu();
                        let e = this.aw.d.bottom;
                        let f = this.dw(e);
                        if (this.cp._inner[f] + this.co._inner[f] < e) {
                            f += 1;
                        }
                        f = f * this.cu.count;
                        f += this.cu.count;
                        return Math.max(0, Math.min(f, this.actualDataSource.actualCount - 1));
                    }
                    else {
                        let g = this.aw.d.bottom;
                        let h = truncate(Math.floor(g / this.c2));
                        h = h * this.cu.count;
                        return Math.max(0, Math.min(h, this.actualDataSource.actualCount - 1));
                    }
                }
                else {
                    {
                        this.fu();
                        let i = this.aw.d.right;
                        let j = this.dx(i);
                        if (this.ct._inner[j] + this.cs._inner[j] < i) {
                            j += 1;
                        }
                        return Math.max(0, Math.min(j, this.actualDataSource.actualCount - 1));
                    }
                }
            }
            return this.actualDataSource.actualCount - 1;
        }
        dw(a) {
            let b = -1;
            b = ArrayExtension.binarySearch$11(Number_$type, this.cp, (c) => a < c ? -1 : (a > c ? 1 : 0));
            if (b < 0) {
                b = ~b;
                b--;
            }
            if (b < 0) {
                b = 0;
            }
            if (b > this.cp.count - 1) {
                b = this.cp.count - 1;
            }
            return b;
        }
        dx(a) {
            let b = -1;
            b = ArrayExtension.binarySearch$11(Number_$type, this.ct, (c) => a < c ? -1 : (a > c ? 1 : 0));
            if (b < 0) {
                b = ~b;
                b--;
            }
            if (b < 0) {
                b = 0;
            }
            if (b > this.ct.count - 1) {
                b = this.ct.count - 1;
            }
            return b;
        }
        d8() {
            if (this.actualDataSource == null || this.actualDataSource.actualSchema == null || this.actualDataSource.actualCount == 0) {
                return -1;
            }
            if (!this.aw.d.isEmpty) {
                if (this.ab == 0) {
                    if (this.bx) {
                        this.fu();
                        let a = this.aw.d.top;
                        let b = this.dw(a);
                        if (this.cp._inner[b] > a) {
                            b -= 1;
                        }
                        return Math.max(0, Math.min(b, this.actualDataSource.actualCount - 1));
                    }
                    else {
                        let c = this.aw.d.top;
                        let d = truncate(Math.floor(c / this.c2));
                        return Math.max(0, Math.min(d, this.actualDataSource.actualCount - 1));
                    }
                }
                else if (this.ab == 2) {
                    if (this.bx) {
                        this.fu();
                        let e = this.aw.d.top;
                        let f = this.dw(e);
                        if (this.cp._inner[f] > e) {
                            f -= 1;
                        }
                        f = f * this.cu.count;
                        return Math.max(0, Math.min(f, this.actualDataSource.actualCount - 1));
                    }
                    else {
                        let g = this.aw.d.top;
                        let h = truncate(Math.floor(g / this.c2));
                        h = h * this.cu.count;
                        return Math.max(0, Math.min(h, this.actualDataSource.actualCount - 1));
                    }
                }
                else {
                    {
                        this.fu();
                        let i = this.aw.d.left;
                        let j = this.dx(i);
                        if (this.ct._inner[j] > i) {
                            j -= 1;
                        }
                        return Math.max(0, Math.min(j, this.actualDataSource.actualCount - 1));
                    }
                }
            }
            return 0;
        }
        c4(a) {
            if (this.ab == 2) {
                a = this.d4(a);
            }
            if (this.cs.count > 0 && a < this.cs.count) {
                return this.cs._inner[a];
            }
            return 0;
        }
        c3(a) {
            if (this.ab == 2) {
                a = this.d5(a);
            }
            if (this.co.count > 0 && a < this.co.count) {
                return this.co._inner[a];
            }
            return this.c2;
        }
        fg() {
            this.co.clear();
            this.cp.clear();
            this.cs.clear();
            this.ct.clear();
            let a = this.r != 0;
            let b = this.dq + this.dm;
            let c = this.dn + this.dp;
            if (this.actualDataSource != null && this.actualDataSource.actualSchema != null) {
                let d = this.cw;
                let e = isNaN_(this.cx) ? 0 : this.cx;
                if (this.ab == 0) {
                    if (this.bx) {
                        let f = 0;
                        for (let g = 0; g < this.actualDataSource.actualCount; g++) {
                            this.cp.add(f);
                            let h = this.c2;
                            if (this.itemHeightRequested != null) {
                                let i = ((() => {
                                    let $ret = new ListPanelTemplateHeightRequestedEventArgs();
                                    $ret.b = g;
                                    $ret.c = this.actualDataSource.getItemAtIndex(g);
                                    $ret.a = h;
                                    return $ret;
                                })());
                                this.itemHeightRequested(this, i);
                                h = i.a;
                                if (a) {
                                    h += b;
                                }
                                f += h;
                            }
                            this.co.add(h);
                        }
                        this.cw = f;
                    }
                    else {
                        this.cw = this.c2 * this.actualDataSource.actualCount;
                    }
                }
                else if (this.ab == 2) {
                    let j = new List$1(ListPanelColumnDefinition.$, 0);
                    let k = this.ds(j, 0x7FFFFFFF);
                    if (this.bx) {
                        let l = 0;
                        for (let m = 0; m < k; m++) {
                            this.cp.add(l);
                            let n = this.c2;
                            let o = 0;
                            let p = m * j.count;
                            for (let q = 0; q < j.count; q++) {
                                let r = q + p;
                                if (r > this.actualDataSource.actualCount - 1) {
                                    continue;
                                }
                                if (this.itemHeightRequested != null) {
                                    let s = ((() => {
                                        let $ret = new ListPanelTemplateHeightRequestedEventArgs();
                                        $ret.b = r;
                                        $ret.c = this.actualDataSource.getItemAtIndex(r);
                                        $ret.a = n;
                                        return $ret;
                                    })());
                                    this.itemHeightRequested(this, s);
                                    let t = s.a;
                                    if (a) {
                                        t += b;
                                    }
                                    o = Math.max(o, t);
                                }
                            }
                            n = o;
                            l += n;
                            this.co.add(n);
                        }
                        this.cw = l;
                    }
                    else {
                        this.cw = this.c2 * k;
                    }
                    this.cu = j;
                    this.dl = k;
                    let u = 0;
                    for (let v = 0; v < this.cu.count; v++) {
                        this.ct.add(u);
                        this.cs.add(this.cu._inner[v].a);
                        u += this.cu._inner[v].a;
                    }
                }
                else {
                    this.cw = this.c2;
                    {
                        let w = 0;
                        for (let x = 0; x < this.actualDataSource.actualCount; x++) {
                            this.ct.add(w);
                            let y = 0;
                            if (this.itemWidthRequested != null) {
                                let z = ((() => {
                                    let $ret = new ListPanelTemplateWidthRequestedEventArgs();
                                    $ret.b = x;
                                    $ret.c = this.actualDataSource.getItemAtIndex(x);
                                    $ret.a = y;
                                    return $ret;
                                })());
                                this.itemWidthRequested(this, z);
                                y = z.a;
                                if (a) {
                                    y += c;
                                }
                                w += y;
                            }
                            this.cs.add(y);
                        }
                        this.cx = w;
                    }
                }
                if (d != this.cw || e != (isNaN_(this.cx) ? 0 : this.cx)) {
                    this.view.x(this.cx, this.cw);
                }
            }
        }
        ds(a, b) {
            let c = 0;
            let d = 0;
            let e = 0;
            let f = this.view.h();
            f -= 5;
            let g = 0;
            let h = f;
            let i = this.actualDataSource.actualCount;
            for (let j = 0; j < i; j++) {
                let k = 0;
                if (this.itemWidthRequested != null) {
                    let l = ((() => {
                        let $ret = new ListPanelTemplateWidthRequestedEventArgs();
                        $ret.b = j;
                        $ret.c = this.actualDataSource.getItemAtIndex(j);
                        $ret.a = k;
                        return $ret;
                    })());
                    this.itemWidthRequested(this, l);
                    k = l.a;
                }
                if ((g + k > f && e > 0) || e >= b) {
                    if (d != 0 && e < b && b > 1) {
                        let m = a._inner[e];
                        m.a = k;
                        this.g7(f, a);
                        if (a.count == 0) {
                            return 0;
                        }
                        return this.ds(a, a.count);
                    }
                    b = Math.max(Math.min(b, e), 1);
                    d++;
                    let n = f - g;
                    if (n < h) {
                        h = n;
                    }
                    g = 0;
                    e = 0;
                }
                if (a.count <= e) {
                    let o = new ListPanelColumnDefinition();
                    o.a = k;
                    a.add(o);
                    e++;
                }
                else {
                    let p = a._inner[e];
                    if (k > p.a) {
                        let q = k - p.a;
                        p.a = k;
                        if (q > h && b > 1) {
                            this.g7(f, a);
                            if (a.count == 0) {
                                return 0;
                            }
                            return this.ds(a, a.count);
                        }
                        else {
                            h -= q;
                            if (h < 0) {
                                h = 0;
                            }
                            e++;
                        }
                    }
                    else {
                        k = p.a;
                        e++;
                    }
                }
                g += k;
            }
            return d + 1;
        }
        g7(a, b) {
            let c = 0;
            for (let d of fromEnum(b)) {
                c += d.a;
            }
            while (c > a) {
                if (b.count < 1) {
                    return;
                }
                c -= b._inner[b.count - 1].a;
                b.removeAt(b.count - 1);
            }
        }
        fv() {
            if (this.bk) {
                this.fm();
            }
        }
        get ay() {
            return this.ax;
        }
        set ay(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.gi("ScrollbarStyle", enumGetBox(ScrollbarStyle_$type, b), enumGetBox(ScrollbarStyle_$type, this.ax));
            }
        }
        get hy() {
            return this.hq;
        }
        set hy(a) {
            let b = this.hq;
            this.hq = a;
            if (b != this.hq) {
                this.gi("ScrollbarBackground", b, this.hq);
            }
        }
        g3() {
            let a = isNaN_(this.cx) ? 0 : this.cx;
            let b = this.cw;
            this.bl = true;
            this.f1(this.cz);
            if (a != (isNaN_(this.cx) ? 0 : this.cx) || b != this.cw) {
                this.externalListPanel.onContentSizeChanged();
            }
            this.bl = false;
            this.f2();
            this.gy();
        }
        f2() {
            this.bp = true;
            this.dc = -1;
            this.dd = -1;
        }
        f1(a) {
            this.bi = true;
            this.cz = a;
        }
        fw() {
            if (this.be) {
                this.be = false;
                this.g3();
                this.f0();
            }
        }
        g4() {
            if (this.be) {
                this.fw();
            }
            else {
                this.f2();
                this.gy();
                this.fv();
            }
        }
        d0() {
            if (this.bp) {
                this.fh();
            }
            return this.dd;
        }
        dy() {
            if (this.bp) {
                this.fh();
            }
            return this.dc;
        }
        ch() {
            return this.dc >= 0 && this.dd >= 0;
        }
        f0() {
            if (!this.ch()) {
                return;
            }
            let a = this.dy();
            let b = this.d0();
            this.fz(a, b);
        }
        fz(a, b) {
            let c = this.dy();
            let d = this.d0();
            if (b < c || a > d) {
                return;
            }
            if (a < c) {
                a = c;
            }
            if (b > d) {
                b = d;
            }
            this.gz();
            this.g4();
        }
        gz() {
            if (this.actualDataSource == null || this.actualDataSource.actualCount == 0) {
                return;
            }
            let a = this.r != 0;
            let b = this.aq != 0;
            for (let c = 0; c < this.a0.q.count; c++) {
                if (this.a0.p._inner[c]) {
                    continue;
                }
                let d = this.a0.q._inner[c];
                d.x = this.actualDataSource.getItemAtIndex(d.v);
                d.t = this.c2;
                if (a) {
                    if (this.p.c(d)) {
                        d.j = true;
                    }
                    else {
                        d.j = false;
                    }
                    d.k = true;
                }
                if (b) {
                    if (this.ao.j(d)) {
                        d.n = true;
                    }
                    else {
                        d.n = false;
                    }
                    d.k = false;
                }
            }
        }
        g0(a) {
            if (this.actualDataSource == null || this.actualDataSource.actualCount == 0) {
                return;
            }
            if (this.a0.d(a)) {
                let b = this.a0.item(a);
                b.x = this.actualDataSource.getItemAtIndex(b.v);
                b.t = this.c2;
            }
        }
        gx() {
            if (!this.be) {
                this.be = true;
                this.f2();
                this.gy();
            }
        }
        fy(a) {
            this.g0(a);
        }
        ge() {
            if (this.be) {
                this.fw();
            }
            else {
                this.g3();
                this.f0();
            }
        }
        get externalListPanel() {
            return this.l;
        }
        set externalListPanel(a) {
            this.l = a;
        }
        cg() {
            return this.aq != 0 || this.r != 0;
        }
        gv(a, b, c) {
            switch (a) {
                case "SchemaIncludedProperties":
                    if (this.i != null) {
                        this.i.schemaIncludedProperties = this.g;
                    }
                    break;
                case "ItemsSource":
                    if (this.i != null) {
                        let d = this.i;
                        d.schemaChanged = delegateRemove(d.schemaChanged, runOn(this, this.fj));
                        this.i.updateNotifier = null;
                    }
                    if (typeCast(IDataSource_$type, this.itemsSource) !== null) {
                        this.actualDataSource = this.itemsSource;
                    }
                    else {
                        let e = this.externalListPanel.createLocalDataSource(this.itemsSource, this.g);
                        this.actualDataSource = e;
                    }
                    if (this.i != null) {
                        let f = this.i;
                        f.schemaChanged = delegateCombine(f.schemaChanged, runOn(this, this.fj));
                        this.i.updateNotifier = new ListPanelDataSourceNotificationBridge(this);
                        if (this.i.actualSchema != null) {
                            this.gx();
                            this.k.enqueueAction(() => this.ge());
                        }
                    }
                    break;
                case "RowHeight":
                    this.c2 = this.ea;
                    break;
                case "CellTextStyle":
                    this.f0();
                    break;
                case "BackgroundColor":
                    this.f0();
                    break;
                case "TextColor":
                    this.f0();
                    break;
                case "Orientation":
                case "ActualRowHeight":
                    this.g3();
                    break;
                case "ScrollbarStyle":
                    this.externalListPanel.setScrollbarStyle(this.ay);
                    break;
                case "ScrollbarBackground":
                    this.externalListPanel.setScrollbarColor(this.hy);
                    break;
                case "ActiveRow":
                    this.de = typeGetValue(b);
                    this.bo = true;
                    if (this.dr != -1 && this.dr >= 0) {
                        this.p.k(this.dr);
                    }
                    else {
                        this.p.o();
                    }
                    this.bo = false;
                    break;
                case "SelectedBackground":
                case "ActivationBorder":
                case "ActivationBorderLeftWidth":
                case "ActivationBorderRightWidth":
                case "ActivationBorderBottomWidth":
                case "ActivationBorderTopWidth":
                    this.gx();
                    break;
                case "ActivationMode":
                    this.bw = this.cg();
                    break;
                case "SelectionMode":
                    this.bw = this.cg();
                    switch (this.aq) {
                        case 1:
                            if (this.aj.count > 1) {
                                let g = this.aj._inner[this.aj.count - 1];
                                this.aj.clear();
                                this.aj.add(g);
                            }
                            break;
                        case 2: break;
                        case 0:
                            if (this.aj.count > 0) {
                                this.aj.clear();
                            }
                            break;
                    }
                    break;
            }
        }
        h1() {
            let a = this.cw;
            let b = 0;
            if (!isNaN_(a) && a >= 0) {
                b = a;
            }
            let c = 0;
            if (this.ab == 1) {
                for (let d = 0; d < this.cs.count; d++) {
                    let e = this.cs._inner[d];
                    if (!isNaN_(e) && e >= 0) {
                        c += e;
                    }
                }
            }
            else if (this.ab == 2) {
                for (let f = 0; f < this.cs.count; f++) {
                    let g = this.cs._inner[f];
                    if (!isNaN_(g) && g >= 0) {
                        c += g;
                    }
                }
            }
            else {
                if (!isNaN_(this.cx) && this.cx >= 0) {
                    c = this.cx;
                }
            }
            return new Size(1, c, b);
        }
        gd(a, b) {
            if (this.r == 1 && this.dr != -1) {
                if (this.dr >= a && this.dr <= b) {
                    if (this.activeRowChanged != null) {
                        let c = new ListPanelActiveRowChangedEventArgs();
                        c.newActiveRow = this.dr;
                        c.oldActiveRow = this.dr;
                        this.activeRowChanged(this, c);
                    }
                }
            }
            let d = this.dy();
            let e = this.d0();
            if (b < d || a > e) {
                return;
            }
            if (a < d) {
                a = d;
            }
            if (b > e) {
                b = e;
            }
            if (!this.ch()) {
                return;
            }
            if (this.d2() != this.dh) {
                this.g3();
            }
            else {
                this.g4();
            }
            this.fi();
        }
        fi() {
            if (this.aw.d.isEmpty) {
                return;
            }
            if (this.ab == 1) {
                if (this.aw.d.right > this.absoluteWidth || this.aw.d.left > this.absoluteWidth) {
                    let a = this.d2() - 1;
                    if (a < 0) {
                        a = 0;
                    }
                    this.ha(a);
                }
            }
            else {
                if (this.aw.d.bottom > this.absoluteHeight || this.aw.d.top > this.absoluteHeight) {
                    let b = this.d2() - 1;
                    if (b < 0) {
                        b = 0;
                    }
                    this.ha(b);
                }
            }
            if (this.ab == 2) {
                if (this.aw.d.right > this.absoluteWidth || this.aw.d.left > this.absoluteWidth) {
                    this.g9(this.cu.count - 1);
                }
            }
        }
        gs(a, b, c) {
            if (this.ab == 0) {
                if (this.bx) {
                    let d = this.c2;
                    if (this.itemHeightRequested != null) {
                        let e = new ListPanelTemplateHeightRequestedEventArgs();
                        e.c = c;
                        e.b = a;
                        e.a = d;
                        this.itemHeightRequested(this, e);
                        d = e.a;
                    }
                    let f = this.co._inner[a];
                    this.co._inner[a] = d;
                    let g = d - f;
                    for (let h = a; h < this.actualDataSource.actualCount; h++) {
                        this.cp._inner[h] += g;
                    }
                }
            }
            else if (this.ab == 2) {
                this.g3();
                return;
            }
            else {
                let i = 0;
                if (this.itemWidthRequested != null) {
                    let j = new ListPanelTemplateWidthRequestedEventArgs();
                    j.c = c;
                    j.b = a;
                    j.a = i;
                    this.itemWidthRequested(this, j);
                    i = j.a;
                }
                let k = this.cs._inner[a];
                this.cs._inner[a] = i;
                let l = i - k;
                for (let m = a; m < this.actualDataSource.actualCount; m++) {
                    this.ct._inner[m] += l;
                }
            }
            this.fy(a);
        }
        gc() {
            this.g3();
        }
        gf(a, b) {
            if (this.ab == 0) {
                if (this.bx) {
                    let c = this.c2;
                    if (this.itemHeightRequested != null) {
                        let d = new ListPanelTemplateHeightRequestedEventArgs();
                        d.c = b;
                        d.b = a;
                        d.a = c;
                        this.itemHeightRequested(this, d);
                        c = d.a;
                    }
                    this.co.insert(a, c);
                    let e = 0;
                    if (a > 0) {
                        let f = this.cp._inner[a - 1];
                        e = f + this.co._inner[a - 1];
                    }
                    this.cp.insert(a, e);
                    for (let g = a; g < this.actualDataSource.actualCount; g++) {
                        this.cp._inner[g] += c;
                    }
                }
            }
            else if (this.ab == 2) {
                this.g3();
                return;
            }
            else {
                let h = 0;
                if (this.itemWidthRequested != null) {
                    let i = new ListPanelTemplateWidthRequestedEventArgs();
                    i.c = b;
                    i.b = a;
                    i.a = h;
                    this.itemWidthRequested(this, i);
                    h = i.a;
                }
                this.cs.insert(a, h);
                let j = 0;
                if (a > 0) {
                    let k = this.ct._inner[a - 1];
                    j = k + this.cs._inner[a - 1];
                }
                this.ct.insert(a, j);
                for (let l = a; l < this.actualDataSource.actualCount; l++) {
                    this.ct._inner[l] += h;
                }
            }
            this.gx();
        }
        gj(a, b) {
            if (this.ab == 0) {
                let c = this.co._inner[a];
                for (let d = a + 1; d < this.actualDataSource.actualCount; d++) {
                    this.cp._inner[d] -= c;
                }
                this.co.removeAt(a);
                this.cp.removeAt(a);
            }
            else if (this.ab == 2) {
                this.g3();
                return;
            }
            else {
                let e = this.cs._inner[a];
                for (let f = a + 1; f < this.actualDataSource.actualCount; f++) {
                    this.ct._inner[f] -= e;
                }
                this.cs.removeAt(a);
                this.ct.removeAt(a);
            }
            this.gx();
        }
        f6(a, b, c) {
            if (this.i != null) {
                this.i.notifySetItem(a, b, c);
            }
        }
        f3() {
            if (this.i != null) {
                this.i.notifyClearItems();
            }
        }
        f4(a, b) {
            if (this.i != null) {
                this.i.notifyInsertItem(a, b);
            }
            ;
        }
        f5(a, b) {
            if (this.i != null) {
                this.i.notifyRemoveItem(a, b);
            }
            ;
        }
        dt(a) {
            if (this.i == null) {
                return -1;
            }
            return this.i.indexOfItem(a);
        }
        du(a) {
            if (this.i == null) {
                return -1;
            }
            return this.i.indexOfKey(a);
        }
        get hu() {
            return this.ho;
        }
        set hu(a) {
            let b = this.ho;
            this.ho = a;
            if (b != this.ho) {
                this.gi("BackgroundColor", b, a);
            }
        }
        get ab() {
            return this.z;
        }
        set ab(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.gi("Orientation", enumGetBox(ListPanelOrientation_$type, b), enumGetBox(ListPanelOrientation_$type, a));
            }
        }
        get bx() {
            return this.bg;
        }
        set bx(a) {
            let b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.gi("IsCustomRowHeightEnabled", b, a);
            }
        }
        get h0() {
            return this.hs;
        }
        set h0(a) {
            let b = this.hs;
            this.hs = a;
            if (b != this.hs) {
                this.gi("TextColor", b, a);
            }
        }
        get absoluteWidth() {
            return this.cx;
        }
        get absoluteHeight() {
            return this.cw;
        }
        ed() {
            let a = new ListPanelVisualData();
            let b = this.y.h();
            a.c = b.left;
            a.d = b.top;
            a.e = b.width;
            a.b = b.height;
            for (let c of fromEnum(this.a0.n)) {
                a.a.add(c.a(this.y));
            }
            a.a.aa((d, e) => {
                if (this.ab == 0) {
                    return d.c < e.c ? -1 : d.c == e.c ? 0 : 1;
                }
                else if (this.ab == 2) {
                    if (d.c == e.c) {
                        return d.b < e.b ? -1 : d.b == e.b ? 0 : 1;
                    }
                    return d.c < e.c ? -1 : d.c == e.c ? 0 : 1;
                }
                else {
                    return d.b < e.b ? -1 : d.b == e.b ? 0 : 1;
                }
            });
            return a;
        }
        ev() {
            let a = this.ed();
            return a.serialize();
        }
        get by() {
            return this.bh;
        }
        set by(a) {
            this.bh = a;
        }
        hc() {
            if (this.aq == 2) {
                this.ao.v();
            }
        }
        b7(a, b, c) {
            if (this.by) {
                switch (a) {
                    case 30:
                        if (c) {
                            this.hc();
                            return true;
                        }
                        break;
                    case 32:
                        let d = false;
                        return d;
                }
            }
            return false;
        }
        bz() {
            return this.db == -1;
        }
        get dr() {
            return this.db;
        }
        set dr(a) {
            let b = this.db;
            this.db = a;
            if (b != this.db) {
                this.gi("ActiveRow", b, this.db);
            }
        }
        ff(a, b, c = false) {
            if (!this.aw.a) {
                return;
            }
            if (!c) {
                if (a <= this.dy()) {
                    this.ha(a);
                }
                else if (a >= this.d0()) {
                    if (b) {
                        this.ha(a);
                    }
                    else {
                        this.g8(a);
                    }
                }
            }
            if (this.ab == 2) {
                let d = this.dz();
                let e = this.d1();
                let f = this.d3(a);
                if (f <= d) {
                    this.hb(f);
                }
                else if (f >= e) {
                    this.g9(f);
                }
            }
        }
        g9(a) {
            let b = truncate(this.aw.d.top);
            if (this.dg != -1) {
                b = this.dg;
            }
            if (this.ab == 2) {
                let c = 0;
                let d = 0;
                for (d = 0; d < this.cu.count; d++) {
                    c += this.cu._inner[d].a;
                    if (a == d) {
                        break;
                    }
                }
                c -= this.aw.d.width;
                if (c < 0) {
                    c = 0;
                }
                this.dg = b;
                this.df = truncate(c);
                this.viewportManager.moveViewportTo(truncate(c), b);
            }
        }
        hb(a) {
            let b = truncate(this.aw.d.top);
            if (this.dg != -1) {
                b = this.dg;
            }
            if (this.ab == 2) {
                let c = 0;
                let d = 0;
                for (d = 0; d < this.cu.count; d++) {
                    if (a == d) {
                        break;
                    }
                    c += this.cu._inner[d].a;
                }
                this.dg = b;
                this.df = truncate(c);
                this.viewportManager.moveViewportTo(truncate(c), b);
            }
        }
        d3(a) {
            if (this.ab == 2) {
                let b = this.d4(a);
                return b;
            }
            return -1;
        }
        d1() {
            if (this.ab == 2) {
                let a = 0;
                let b = 0;
                for (b = 0; b < this.cu.count; b++) {
                    a += this.cu._inner[b].a;
                    if (a > this.aw.d.right) {
                        return Math.min(Math.max(b - 1, 0), this.cu.count - 1);
                    }
                }
                return Math.min(b, this.cu.count - 1);
            }
            return -1;
        }
        dz() {
            if (this.ab == 2) {
                let a = 0;
                let b = 0;
                for (b = 0; b < this.cu.count; b++) {
                    a += this.cu._inner[b].a;
                    if (a > this.aw.d.left) {
                        return Math.min(Math.max(b, 0), this.cu.count - 1);
                    }
                }
                return b;
            }
            return -1;
        }
        ha(a) {
            if (this.aw.d.isEmpty) {
                return;
            }
            let b = truncate(this.aw.d.left);
            if (this.df != -1) {
                b = this.df;
            }
            let c = 0;
            let d = 0;
            if (a < 0) {
                a = 0;
            }
            if (a >= this.d2()) {
                a = this.d2() - 1;
            }
            let e = 0;
            e = truncate(Math.floor(a));
            if (this.ab == 2) {
                e = truncate(Math.floor(e / this.cu.count));
            }
            if (this.cp.count > 0) {
                c = truncate(Math.floor(this.cp._inner[e]));
            }
            else {
                c = truncate(Math.floor(this.c2 * e));
            }
            if (a - truncate(Math.floor(a)) > 0) {
                let f = a - truncate(Math.floor(a));
                let g = f * this.co._inner[e];
                c = truncate(Math.floor(c + g));
            }
            c = Math.max(c, 0);
            if (this.cw > 0 && this.aw.d.height > 0 && c + this.aw.d.height > this.cw) {
                c = truncate(Math.round(this.cw - this.aw.d.height));
            }
            if (c < 0) {
                c = 0;
            }
            this.dg = c;
            this.df = b;
            this.viewportManager.moveViewportTo(b, c);
        }
        g8(a) {
            let b = truncate(this.aw.d.left);
            if (this.df != -1) {
                b = this.df;
            }
            let c = 0;
            if (a < 0) {
                a = 0;
            }
            if (a >= this.d2()) {
                a = this.d2() - 1;
            }
            let d = truncate(Math.floor(a));
            if (this.ab == 2) {
                d = truncate(Math.floor(d / this.cu.count));
            }
            if (this.cp.count == 0) {
                c = truncate(Math.round((this.c2 * a) + this.c2));
            }
            else {
                c = truncate(Math.floor(this.cp._inner[d] + this.co._inner[d]));
            }
            if (a - truncate(Math.floor(a)) > 0) {
                let e = a - truncate(Math.floor(a));
                let f = e * this.co._inner[d];
                c = truncate(Math.floor(c + f));
            }
            c = Math.max(c, 0);
            if (this.cw > 0 && this.aw.d.height > 0) {
                c -= truncate(Math.round(this.aw.d.height));
            }
            if (this.cw > 0 && this.aw.d.height > 0 && c + this.aw.d.height > this.cw) {
                c = truncate(Math.round(this.cw - this.aw.d.height));
            }
            if (c < 0) {
                c = 0;
            }
            this.dg = c;
            this.df = b;
            this.viewportManager.moveViewportTo(b, c);
        }
        get viewportManager() {
            return this._viewportManager;
        }
        set viewportManager(a) {
            this._viewportManager = a;
        }
        b1(a, b) {
            if (this.ab == 1) {
                return false;
            }
            if (this.r == 0 || this.bz()) {
                return false;
            }
            let c = this.dr;
            if (c > this.d2() - 1) {
                return false;
            }
            let d = c + 1;
            if (this.ab == 2) {
                d = c + this.cu.count;
            }
            if (b) {
                d = this.d2() - 1;
            }
            if (d > this.d2() - 1) {
                d = this.d2() - 1;
            }
            if (d == c) {
                return false;
            }
            this.dr = d;
            if (this.aw.a) {
                this.ff(d, false);
            }
            this.bm = false;
            if (this.aq == 2 && a) {
                if (this.dk == -1) {
                    this.dk = c;
                }
                let e = Math.min(this.dk, d);
                let f = Math.max(this.dk, d);
                this.hf(e, f);
            }
            else {
                this.dk = -1;
                this.dj = -1;
                this.cq.clear();
                this.cr.clear();
            }
            this.gr();
            return true;
        }
        gr() {
            if (this.bm && this.selectionChanged != null) {
                this.selectionChanged(this, new ListPanelSelectionChangedEventArgs());
                this.bm = false;
            }
        }
        hf(a, b) {
            for (let c = a; c <= b; c++) {
                if (this.cq.contains(c)) {
                    continue;
                }
                if (!this.cr.contains(c)) {
                    let d = this.ad(this.e(), c);
                    if (d != null) {
                        if (this.ao.h(d)) {
                            this.cq.add(c);
                            continue;
                        }
                        else {
                            this.cr.add(c);
                            this.aj.add(d);
                            this.ao.z(c);
                        }
                    }
                }
            }
            for (let e = 0; e < this.cr.count; e++) {
                if (this.cr._inner[e] < a || this.cr._inner[e] > b) {
                    let f = this.ad(this.e(), this.cr._inner[e]);
                    if (f != null) {
                        this.cr.removeAt(e);
                        e--;
                        let g = this.aj.indexOf(f);
                        let h = this.ag._inner[g];
                        this.aj.remove(f);
                        this.cl.remove(f);
                        this.cn.remove(f);
                        this.ck.remove1(h);
                        this.cm.remove1(h);
                    }
                }
            }
        }
        b2(a, b) {
            if (this.r == 0 || this.bz()) {
                return false;
            }
            let c = this.dr;
            let d = this.dr;
            if (b) {
                if (d >= this.d2() - 1) {
                    return false;
                }
                d = this.d2() - 1;
            }
            else if (this.ab == 2 && this.d3(d) == this.cu.count - 1) {
                return false;
            }
            let e = -1;
            if (this.ab == 2) {
                e = this.d3(d);
                let f = (d - e) + this.cu.count;
                if (f > this.d2() - 1) {
                    f = this.d2() - 1;
                }
                d = f;
            }
            if (d == c) {
                return false;
            }
            this.dr = d;
            this.ff(d, false);
            return true;
        }
        b6(a, b) {
            let c = this.db;
            let d = this.db;
            if (b) {
                if (d <= 0) {
                    return false;
                }
                d = 0;
            }
            else if (this.ab == 2 && this.d3(d) == 0) {
                return false;
            }
            let e = -1;
            if (this.ab == 2) {
                e = this.d3(d);
                let f = (d - e);
                if (f < 0) {
                    f = 0;
                }
                d = f;
            }
            if (d == c) {
                return false;
            }
            this.dr = d;
            this.ff(d, false);
            return true;
        }
        b8(a, b) {
            if (this.ab == 0) {
                return false;
            }
            if (this.r == 0 || this.bz()) {
                return false;
            }
            let c = this.dr;
            if (c <= 0) {
                return false;
            }
            let d = c - 1;
            if (b) {
                d = 0;
            }
            if (b && this.ab == 2) {
                d = (c - this.d3(c));
                if (d < 0) {
                    d = 0;
                }
            }
            if (d < 0) {
                d = 0;
            }
            if (d == c) {
                return false;
            }
            this.dr = d;
            if (this.aw.a) {
                this.ff(d, false);
            }
            this.bm = false;
            if (this.aq == 2 && a) {
                if (this.dk == -1) {
                    this.dk = c;
                }
                let e = Math.min(this.dk, d);
                let f = Math.max(this.dk, d);
                this.hf(e, f);
            }
            else {
                this.dk = -1;
                this.dj = -1;
                this.cq.clear();
                this.cr.clear();
            }
            this.gr();
            return true;
        }
        b9(a, b) {
            if (this.r == 0 || this.bz()) {
                return false;
            }
            let c = this.dy();
            let d = this.d0();
            let e = d - c;
            let f = Math.min(d + 1, this.d2() - 1);
            {
                this.dr = f;
            }
            this.ff(f, true);
            return true;
        }
        ca(a, b) {
            if (this.r == 0 || this.bz()) {
                return false;
            }
            let c = this.dy();
            let d = this.d0();
            let e = d - c;
            let f = Math.max(c - e - 1, 0);
            {
                this.dr = f;
            }
            this.ff(f, false);
            return true;
        }
        cb(a, b) {
            if (this.ab == 0) {
                return false;
            }
            if (this.r == 0 || this.bz()) {
                return false;
            }
            let c = this.dr;
            if (c <= 0) {
                return false;
            }
            let d = c - 1;
            if (b) {
                d = this.d2() - 1;
            }
            if (b && this.ab == 2) {
                d = (c - this.d3(c)) + this.cu.count;
                if (d > this.d2() - 1) {
                    d = this.d2() - 1;
                }
            }
            if (d > this.d2() - 1) {
                d = this.d2() - 1;
            }
            if (d == c) {
                return false;
            }
            this.dr = d;
            if (this.aw.a) {
                this.ff(d, false);
            }
            this.bm = false;
            if (this.aq == 2 && a) {
                if (this.dk == -1) {
                    this.dk = c;
                }
                let e = Math.min(this.dk, d);
                let f = Math.max(this.dk, d);
                this.hf(e, f);
            }
            else {
                this.dk = -1;
                this.dj = -1;
                this.cq.clear();
                this.cr.clear();
            }
            this.gr();
            return true;
        }
        cd(a, b) {
            if (this.r == 0 || this.bz()) {
                return false;
            }
            if (this.ab == 0) {
                return this.b1(a, b);
            }
            return this.cb(a, b);
        }
        gu() {
        }
        ce(a, b) {
            if (this.ab == 1) {
                return false;
            }
            if (this.r == 0 || this.bz()) {
                return false;
            }
            let c = this.dr;
            if (c <= 0) {
                return false;
            }
            let d = c - 1;
            if (this.ab == 2) {
                d = c - this.cu.count;
                if (d < 0) {
                    d = 0;
                }
            }
            if (b) {
                d = 0;
            }
            if (d <= 0) {
                d = 0;
            }
            if (d == c) {
                return false;
            }
            this.dr = d;
            if (this.aw.a) {
                this.ff(d, false);
            }
            this.bm = false;
            if (this.aq == 2 && a) {
                if (this.dk == -1) {
                    this.dk = c;
                }
                let e = Math.min(this.dk, d);
                let f = Math.max(this.dk, d);
                this.hf(e, f);
            }
            else {
                this.dk = -1;
                this.dj = -1;
                this.cq.clear();
                this.cr.clear();
            }
            this.gr();
            return true;
        }
        b3(a, b) {
            return false;
        }
        b4() {
            return false;
        }
        b5() {
            return false;
        }
        cc(a, b) {
            return false;
        }
        fr() {
            this.view.v();
        }
        get bu() {
            return this.bd;
        }
        set bu(a) {
            this.bd = a;
        }
        fe(a = false) {
            this.ck.clear();
            this.cl.clear();
            this.cm.clear();
            this.cn.clear();
            this.a9 = true;
            this.ba = a;
        }
        fn() {
            if (this.a9) {
                this.bu = true;
                this.hm(this.ck, this.cl, this.cm, this.cn);
                this.bu = false;
            }
            this.a9 = false;
        }
        get b0() {
            return this.bj;
        }
        set b0(a) {
            let b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.gi("NotifyOnAllSelectionChanges", b, this.bj);
            }
        }
        hm(a, b, c, d) {
            if (a.count == 0 && b.count == 0 && c.count == 0 && d.count == 0) {
                return;
            }
            let e = this.b0;
            this.b0 = false;
            if (!this.bn) {
                if (!this.ba) {
                    if (a.count > 0) {
                        this.ag.o(a);
                        this.aj.o(b);
                        this.bm = true;
                    }
                    if (c.count > 0) {
                        this.aj.ah = true;
                        this.ag.af = true;
                        for (let f = c.count - 1; f >= 0; f--) {
                            let g = this.aj.al(d._inner[f]);
                            if (g >= 0) {
                                this.ag.removeAt(g);
                                this.aj.removeAt(g);
                            }
                        }
                        this.ag.af = false;
                        this.aj.ah = false;
                        this.bm = true;
                    }
                }
            }
            this.b0 = e;
            this.gm(c, a);
            this.gp(d, b);
        }
        hd(a, b) {
            this.bm = true;
            if (!this.bu && this.actualDataSource != null) {
                if (!this.bn) {
                    this.bn = true;
                    switch (b.action) {
                        case 0:
                            if (b.newItems != null) {
                                for (let c = 0; c < b.newItems.count; c++) {
                                    let d = this.ac(this.e(), b.newItems.item(c));
                                    this.aj.ae.insert(c + b.newStartingIndex, d);
                                }
                            }
                            break;
                        case 1:
                            if (b.oldItems != null) {
                                for (let e = 0; e < b.oldItems.count; e++) {
                                    this.aj.ae.removeAt(b.oldStartingIndex);
                                }
                            }
                            break;
                        case 2:
                            if (b.oldItems != null) {
                                for (let f = 0; f < b.oldItems.count; f++) {
                                    this.aj.ae.removeAt(b.oldStartingIndex);
                                }
                            }
                            if (b.newItems != null) {
                                for (let g = 0; g < b.newItems.count; g++) {
                                    let h = this.ac(this.e(), b.newItems.item(g));
                                    this.aj.ae.insert(g + b.newStartingIndex, h);
                                }
                            }
                            break;
                        case 4:
                            this.aj.clear();
                            for (let i of fromEnum(this.ag.ae)) {
                                let j = this.ac(this.e(), i);
                                this.aj.add(j);
                            }
                            break;
                    }
                    this.ao.af();
                    this.bn = false;
                }
            }
            if (this.b0) {
                if (this.selectedItemsChanged != null) {
                    let k = null;
                    if (b.newItems != null && b.newItems.count > 0) {
                        k = new ListPanelSelectedItemsCollection();
                        for (let l of fromEn(b.newItems)) {
                            k.add1(l);
                        }
                    }
                    let m = null;
                    if (b.oldItems != null && b.oldItems.count > 0) {
                        m = new ListPanelSelectedItemsCollection();
                        for (let n of fromEn(b.oldItems)) {
                            m.add1(n);
                        }
                    }
                    this.selectedItemsChanged(this, ((() => {
                        let $ret = new ListPanelSelectedItemsChangedEventArgs();
                        $ret.addedItems = k;
                        $ret.removedItems = m;
                        $ret.currentItems = this.ag;
                        return $ret;
                    })()));
                }
            }
        }
        he(a, b) {
            if (!this.bu && this.actualDataSource != null) {
                if (!this.bn) {
                    this.bn = true;
                    switch (b.action) {
                        case 0:
                            if (b.newItems != null) {
                                for (let c = 0; c < b.newItems.count; c++) {
                                    let d = this.ee(b.newItems.item(c));
                                    this.ag.ae.insert1(c + b.newStartingIndex, d);
                                }
                            }
                            break;
                        case 1:
                            if (b.oldItems != null) {
                                for (let e = 0; e < b.oldItems.count; e++) {
                                    this.ag.ae.removeAt(b.oldStartingIndex);
                                }
                            }
                            break;
                        case 2:
                            if (b.oldItems != null) {
                                for (let f = 0; f < b.oldItems.count; f++) {
                                    this.ag.ae.removeAt(b.oldStartingIndex);
                                }
                            }
                            if (b.newItems != null) {
                                for (let g = 0; g < b.newItems.count; g++) {
                                    let h = this.ee(b.newItems.item(g));
                                    this.ag.ae.insert1(g + b.newStartingIndex, h);
                                }
                            }
                            break;
                        case 4:
                            this.ag.clear();
                            for (let i of fromEnum(this.aj.ae)) {
                                let j = this.ee(i);
                                this.ag.add1(j);
                            }
                            break;
                    }
                    this.ao.af();
                    this.bn = false;
                }
            }
            if (this.b0) {
                if (this.selectedKeysChanged != null) {
                    let k = null;
                    if (b.newItems != null && b.newItems.count > 0) {
                        k = new ListPanelSelectedKeysCollection();
                        k.ag = false;
                        for (let l of fromEn(b.newItems)) {
                            k.add(l);
                        }
                    }
                    let m = null;
                    if (b.oldItems != null && b.oldItems.count > 0) {
                        m = new ListPanelSelectedKeysCollection();
                        m.ag = false;
                        for (let n of fromEn(b.oldItems)) {
                            m.add(n);
                        }
                    }
                    this.selectedKeysChanged(this, ((() => {
                        let $ret = new ListPanelSelectedKeysChangedEventArgs();
                        $ret.addedKeys = k;
                        $ret.removedKeys = m;
                        $ret.currentKeys = this.aj;
                        return $ret;
                    })()));
                }
            }
        }
        hj(a, b) {
            this.gx();
        }
        gk(a, b) {
            if (a == null) {
                let c = this.aj.ae.indexOf(b);
                if (c > -1 && this.ag.ae.count > 0) {
                    a = this.ag.ae._inner[c];
                }
            }
            if (a == null) {
                return;
            }
            this.bu = true;
            if (!this.a9) {
                this.fd(a, b, true);
            }
            else {
                this.ck.add1(a);
                this.cl.add(b);
                if (this.ba) {
                    this.fd(a, b, false);
                }
            }
            this.bu = false;
        }
        hk(a, b) {
            this.gx();
        }
        gl(a, b) {
            if (a == null) {
                let c = this.aj.ae.indexOf(b);
                if (c > -1 && this.ag.ae.count > 0) {
                    a = this.ag.ae._inner[c];
                }
            }
            if (a == null) {
                return;
            }
            this.bu = true;
            if (!this.a9) {
                this.g6(a, b, true);
            }
            else {
                this.cm.add1(a);
                this.cn.add(b);
                if (this.ba) {
                    this.g6(a, b, false);
                }
            }
            this.bu = false;
        }
        fd(a, b, c) {
            let d = this.b0;
            this.b0 = false;
            if (!this.bn) {
                this.ag.add1(a);
                this.aj.add(b);
            }
            this.b0 = d;
            if (c) {
                this.gn(null, a);
                this.go(null, b);
            }
        }
        hl(a, b, c) {
            let d = this.b0;
            this.b0 = false;
            let e = this.ag.ae._inner[a];
            if (!this.bn) {
                this.ag.ae._inner[a] = b;
            }
            this.b0 = d;
            this.gn(b, b);
        }
        g6(a, b, c) {
            let d = this.b0;
            this.b0 = false;
            if (!this.bn) {
                this.ag.remove1(a);
                this.aj.remove(b);
            }
            this.b0 = d;
            if (c) {
                this.gn(a, null);
                this.go(b, null);
            }
        }
        gn(a, b) {
            if (!this.cj && this.selectedItemsChanged != null) {
                let c = new ListPanelSelectedItemsChangedEventArgs();
                c.currentItems = this.ag;
                if (a != null) {
                    let d = new ListPanelSelectedItemsCollection();
                    d.add1(a);
                    c.removedItems = d;
                }
                if (b != null) {
                    let e = new ListPanelSelectedItemsCollection();
                    e.add1(b);
                    c.addedItems = e;
                }
                this.selectedItemsChanged(this, c);
            }
        }
        go(a, b) {
            if (!this.cj && this.selectedKeysChanged != null) {
                let c = new ListPanelSelectedKeysChangedEventArgs();
                c.currentKeys = this.aj;
                if (a != null) {
                    c.removedKeys = new ListPanelSelectedKeysCollection();
                    c.removedKeys.ag = false;
                    c.removedKeys.add(a);
                }
                if (b != null) {
                    c.addedKeys = new ListPanelSelectedKeysCollection();
                    c.addedKeys.ag = false;
                    c.addedKeys.add(b);
                }
                this.selectedKeysChanged(this, c);
            }
        }
        gm(a, b) {
            if (!this.cj && this.selectedItemsChanged != null) {
                let c = new ListPanelSelectedItemsChangedEventArgs();
                c.currentItems = this.ag;
                if (a != null) {
                    c.removedItems = new ListPanelSelectedItemsCollection();
                    c.removedItems.o(a);
                }
                if (b != null) {
                    c.addedItems = new ListPanelSelectedItemsCollection();
                    c.addedItems.o(b);
                }
                this.selectedItemsChanged(this, c);
            }
        }
        gp(a, b) {
            if (!this.cj && this.selectedKeysChanged != null) {
                let c = new ListPanelSelectedKeysChangedEventArgs();
                c.currentKeys = this.aj;
                if (a != null) {
                    c.removedKeys = new ListPanelSelectedKeysCollection();
                    c.removedKeys.ag = false;
                    c.removedKeys.o(a);
                }
                if (b != null) {
                    c.addedKeys = new ListPanelSelectedKeysCollection();
                    c.addedKeys.ag = false;
                    c.addedKeys.o(b);
                }
                this.selectedKeysChanged(this, c);
            }
        }
        fk() {
            if (this.aq == 1 || this.aq == 2) {
                if (this.ag.ae.count > 0) {
                    let a = new List$1(Base.$, 0);
                    let b = new List$1(ListPanelPrimaryKeyValue.$, 0);
                    for (let c = 0; c < this.ag.ae.count; c++) {
                        a.add1(this.ag.ae._inner[c]);
                        b.add(this.aj.ae._inner[c]);
                    }
                    this.bu = true;
                    this.ag.clear();
                    this.aj.clear();
                    this.cj = true;
                    this.ao.af();
                    this.cj = false;
                    this.bu = false;
                    this.gm(a, null);
                    this.gp(b, null);
                    this.ao.z(-1);
                }
            }
        }
        h(a) {
            if (this.actualDataSource == null) {
                return 0;
            }
            if (a < 0 || a >= this.d2()) {
                return 0;
            }
            return this.actualDataSource.getRowType(a);
        }
        d7(a, b, c, d) {
            if (this.actualDataSource == null || c < 0) {
                return -1;
            }
            for (let e = c; e <= d; e++) {
                if (e > this.actualDataSource.actualCount - 1) {
                    break;
                }
                let f = this.actualDataSource.getItemAtIndex(e);
                if (f == null) {
                    continue;
                }
                let g = this.ac(a, f);
                if (g == null) {
                    continue;
                }
                if (g.value != null && g.value.length == 1 && g.value[0] != null && getInstanceType(g.value[0]) == DataSourceSpecialRow.$ && b.value != null && b.value.length == 1 && b.value[0] != null && getInstanceType(b.value[0]) == DataSourceSpecialRow.$) {
                    let h = typeCast(DataSourceSpecialRow.$, g.value[0]);
                    let i = typeCast(DataSourceSpecialRow.$, b.value[0]);
                    if (h.rowType == i.rowType) {
                        if (h.rowType == 3 && h.targetRow == i.targetRow) {
                            return e;
                        }
                    }
                }
                if (g.equals(b)) {
                    return e;
                }
            }
            return -1;
        }
        eg(a) {
            if (a < 0 || a > this.actualDataSource.actualCount - 1) {
                return null;
            }
            return this.actualDataSource.getItemAtIndex(a);
        }
        dv(a, b, c, d) {
            let e = this.d7(a, b, c, d);
            if (e >= 0) {
                return e;
            }
            return this.d6(b);
        }
        d2() {
            if (this.actualDataSource == null) {
                return 0;
            }
            return this.actualDataSource.actualCount;
        }
        eh(a) {
            let b = a.v;
            if (b < 0 || b > this.actualDataSource.actualCount - 1) {
                return null;
            }
            return this.actualDataSource.getItemAtIndex(b);
        }
        gq(a, b, c) {
            this.bu = true;
            this.hl(a, b, c);
            this.bu = false;
        }
        hh(a, b) {
            this.gx();
        }
        f8(a) {
            if (!this.bo) {
                this.dr = a;
            }
            if (this.activeRowChanged != null) {
                let b = new ListPanelActiveRowChangedEventArgs();
                b.newActiveRow = this.dr;
                b.oldActiveRow = this.de;
                this.activeRowChanged(this, b);
            }
            this.f9();
        }
        hi(a, b) {
            this.gx();
        }
        gb(a) {
            let b = this.dr;
            if (!this.bo) {
                this.dr = a;
            }
            if (this.activeRowChanged != null) {
                let c = new ListPanelActiveRowChangedEventArgs();
                c.newActiveRow = this.dr;
                c.oldActiveRow = b;
                this.activeRowChanged(this, c);
            }
            this.f9();
        }
        f9() {
        }
        ci(a) {
            let b = this.dt(a);
            if (b == -1) {
                return false;
            }
            this.ha(b);
            return true;
        }
        gg(a, b, c, d) {
            if (this.bw) {
                let e = this.w(a);
                this.v = e;
            }
        }
        w(a) {
            for (let b = 0; b < this.a0.o.count; b++) {
                if (this.a0.p._inner[b]) {
                    continue;
                }
                let c = this.a0.o._inner[b];
                let d = this.a0.q._inner[b];
                if (this.cf(d, a)) {
                    return d;
                }
            }
            return null;
        }
        cf(a, b) {
            let c = b.y + this.aw.d.top;
            let d = b.x + this.aw.d.left;
            let e = this.cx;
            let f = this.c2;
            let g = a.v;
            let h = -1;
            if (this.ab == 2) {
                g = this.d5(g);
                h = this.d4(g);
                e = this.cu._inner[h].a;
            }
            if (this.bx) {
                f = this.co._inner[g];
            }
            if (this.ab == 1) {
                e = this.cs._inner[g];
            }
            if (d >= a.s && d <= a.s + e && c >= a.u && c <= a.u + f) {
                return true;
            }
            return false;
        }
        gh(a, b, c, d) {
            if (this.bw) {
                let e = this.w(a);
                if (e != null && e == this.v) {
                    this.ga(e, b, c, d);
                }
            }
        }
        ga(a, b, c, d) {
            if (b) {
                this.dk = -1;
                this.dj = -1;
                this.cq.clear();
                this.cr.clear();
                this.bm = false;
                this.ao.o(a, c, d, this.al == 0);
                this.gr();
                if (this.r == 1) {
                    this.p.n(a);
                }
            }
            if (this.itemClicked != null) {
                this.itemClicked(a, ((() => {
                    let $ret = new ListPanelItemEventArgs();
                    $ret.itemInfo = a;
                    $ret.listPanel = this;
                    $ret.isLeftButton = b;
                    $ret.isDoubleClick = false;
                    return $ret;
                })()));
            }
        }
    }
    ListPanel.$t = /*@__PURE__*/ markType(ListPanel, 'ListPanel', Base.$, [INotifyPropertyChanged_$type]);
    ListPanel.hv = null;
    ListPanel.aa = 0;
    ListPanel.br = false;
    ListPanel.hw = /*@__PURE__*/ BrushUtil.h(255, 24, 29, 31);
    return ListPanel;
})();
/**
 * @hidden
 */
export let ListPanelTemplateItemUpdatingEventArgs = /*@__PURE__*/ (() => {
    class ListPanelTemplateItemUpdatingEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.d = null;
            this.c = 0;
            this.b = null;
        }
    }
    ListPanelTemplateItemUpdatingEventArgs.$t = /*@__PURE__*/ markType(ListPanelTemplateItemUpdatingEventArgs, 'ListPanelTemplateItemUpdatingEventArgs');
    return ListPanelTemplateItemUpdatingEventArgs;
})();
/**
 * @hidden
 */
export let ListPanelDataSourceNotificationBridge = /*@__PURE__*/ (() => {
    class ListPanelDataSourceNotificationBridge extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        rangeActualized(a, b) {
            this.a.gd(a, b);
        }
        notifySetItem(a, b, c) {
            this.a.gs(a, b, c);
        }
        notifyClearItems() {
            this.a.gc();
        }
        notifyInsertItem(a, b) {
            this.a.gf(a, b);
        }
        notifyRemoveItem(a, b) {
            this.a.gj(a, b);
        }
    }
    ListPanelDataSourceNotificationBridge.$t = /*@__PURE__*/ markType(ListPanelDataSourceNotificationBridge, 'ListPanelDataSourceNotificationBridge', Base.$, [IDataSourceUpdateNotifier_$type]);
    return ListPanelDataSourceNotificationBridge;
})();
/**
 * @hidden
 */
export let ListPanelLayoutPanel = /*@__PURE__*/ (() => {
    class ListPanelLayoutPanel extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        g(a) {
            this.a.ae = a.width;
            this.a.y = a.height;
        }
        h() {
            return this.a.be();
        }
        b(a) {
            return this.a.bs(a);
        }
        c(a) {
            return this.a.bt(a);
        }
        d(a, b) {
            if (!b.l) {
                b.l = true;
                this.a.bn(b.b.a);
            }
            if (a.ab == 0) {
                if (!isNaN_(a.absoluteWidth)) {
                    b.b.a.ae = a.absoluteWidth;
                }
                b.b.a.y = a.c3(b.v);
            }
            else if (a.ab == 2) {
                b.b.a.ae = a.c4(b.v);
                b.b.a.y = a.c3(b.v);
            }
            else {
                b.b.a.ae = a.c4(b.v);
                b.b.a.y = a.absoluteHeight;
            }
            if (b.o) {
                b.o = false;
                this.a.bu(b.b.a, b.s);
                this.a.bv(b.b.a, b.u);
            }
        }
        e(a) {
            this.a.bv(a, -1000);
            this.a.bu(a, -1000);
        }
        f(a) {
            a.s = -1000;
            a.u = -1000;
            if (a.b != null) {
                this.e(a.b.a);
            }
        }
    }
    ListPanelLayoutPanel.$t = /*@__PURE__*/ markType(ListPanelLayoutPanel, 'ListPanelLayoutPanel');
    return ListPanelLayoutPanel;
})();
/**
 * @hidden
 */
export let ListPanelItemModel = /*@__PURE__*/ (() => {
    class ListPanelItemModel extends Base {
        constructor() {
            super(...arguments);
            this.i = false;
            this.v = 0;
            this.t = 0;
            this.w = null;
            this.b = null;
            this.e = false;
            this.l = false;
            this.g = true;
            this.h = true;
            this.q = 0;
            this.r = 0;
            this.c = false;
            this.d = false;
            this.f = false;
        }
        get x() {
            return this.w;
        }
        set x(a) {
            if (this.w != a) {
                this.m = true;
            }
            this.w = a;
        }
        get m() {
            return this.e;
        }
        set m(a) {
            this.e = a;
        }
        get o() {
            return this.g;
        }
        set o(a) {
            this.g = a;
        }
        get p() {
            return this.h;
        }
        set p(a) {
            this.h = a;
        }
        get s() {
            return this.q;
        }
        set s(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.o = true;
            }
        }
        get u() {
            return this.r;
        }
        set u(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.o = true;
            }
        }
        get j() {
            return this.c;
        }
        set j(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.p = true;
            }
        }
        get k() {
            return this.d;
        }
        set k(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.p = true;
            }
        }
        get n() {
            return this.f;
        }
        set n(a) {
            let b = this.f;
            this.f = a;
            if (b != this.f) {
                this.p = true;
            }
        }
        a(a) {
            let b = new ListPanelItemVisualData();
            b.b = a.b(this.b.a);
            b.c = a.c(this.b.a);
            let c = this.b.a.be();
            b.d = c.width;
            b.a = c.height;
            return b;
        }
    }
    ListPanelItemModel.$t = /*@__PURE__*/ markType(ListPanelItemModel, 'ListPanelItemModel');
    return ListPanelItemModel;
})();
/**
 * @hidden
 */
export let ListPanelItemEventArgs = /*@__PURE__*/ (() => {
    class ListPanelItemEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._itemInfo = null;
            this._listPanel = null;
            this._isLeftButton = false;
            this._isDoubleClick = false;
        }
        get itemInfo() {
            return this._itemInfo;
        }
        set itemInfo(a) {
            this._itemInfo = a;
        }
        get listPanel() {
            return this._listPanel;
        }
        set listPanel(a) {
            this._listPanel = a;
        }
        get isLeftButton() {
            return this._isLeftButton;
        }
        set isLeftButton(a) {
            this._isLeftButton = a;
        }
        get isDoubleClick() {
            return this._isDoubleClick;
        }
        set isDoubleClick(a) {
            this._isDoubleClick = a;
        }
    }
    ListPanelItemEventArgs.$t = /*@__PURE__*/ markType(ListPanelItemEventArgs, 'ListPanelItemEventArgs', EventArgs.$);
    return ListPanelItemEventArgs;
})();
/**
 * @hidden
 */
export let ListPanelSelectionManager = /*@__PURE__*/ (() => {
    class ListPanelSelectionManager extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.d = new FastIterationDictionary$2(ListPanelPrimaryKeyValue.$, Number_$type, 0);
            this.c = new FastIterationDictionary$2(ListPanelPrimaryKeyValue.$, FastIterationDictionary$2.$.specialize(Number_$type, Number_$type), 0);
            this.e = false;
            this.m = -1;
            this.b = null;
            this.a = a;
        }
        ab(a) {
            if (!this.f(a)) {
                return;
            }
            if (this.j(a)) {
                this.ac(a);
            }
            else {
                this.w(a);
            }
        }
        f(a) {
            return true;
        }
        aa(a) {
            if (!this.f(a)) {
                return;
            }
            this.e = true;
            this.w(a);
            this.e = false;
        }
        n(a) {
            return a.v;
        }
        j(a) {
            let b = this.n(a);
            if (b == -1) {
                return false;
            }
            if (this.g(b)) {
                return false;
            }
            let c = this.a.ad(this.a.e(), b);
            if (c == null) {
                return false;
            }
            let d = this.d.d(c);
            if (d) {
                let e = this.d.item(c);
                if (e == -1) {
                    this.d.item(c, b);
                }
                else if (this.d.item(c) != b) {
                    return false;
                }
                let f = this.a.aj.al(c);
                if (f >= 0) {
                    if (this.a.ag.ae._inner[f] == null) {
                        let g = this.a.eh(a);
                        this.a.gq(f, g, c);
                    }
                }
            }
            return d;
        }
        g(a) {
            return false;
        }
        h(a) {
            return this.d.d(a);
        }
        i() {
            return this.a.aq == 1 || this.a.aq == 2;
        }
        ac(a) {
            let b = this.n(a);
            if (b == -1) {
                return;
            }
            if (this.g(b)) {
                return;
            }
            let c = this.a.ad(this.a.e(), b);
            if (this.h(c)) {
                this.ad(c, b, false);
            }
        }
        w(a) {
            if (this.a.aq == 0) {
                return;
            }
            let b = false;
            let c = null;
            let d = null;
            let e = this.n(a);
            if (e > -1) {
                if (!this.g(e)) {
                    c = this.a.ad(this.a.e(), e);
                }
            }
            if (this.a.aq == 1 || this.e) {
                let f = this.d.o;
                let g = this.d.p;
                let h = new List$1(ListPanelPrimaryKeyValue.$, 0);
                let i = new List$1(Number_$type, 0);
                for (let j = 0; j < f.count; j++) {
                    if (g._inner[j]) {
                        continue;
                    }
                    if (f._inner[j].equals(c)) {
                        b = true;
                        continue;
                    }
                    if (d != null && f._inner[j].equals(d)) {
                        b = true;
                        continue;
                    }
                    h.add(f._inner[j]);
                    i.add(this.d.q._inner[j]);
                }
                this.a.fe();
                this.d.g = true;
                for (let k = 0; k < h.count; k++) {
                    this.ad(h._inner[k], i._inner[k], false);
                }
                this.d.g = false;
                this.a.fn();
            }
            if (c == null || b) {
                return;
            }
            if (this.i()) {
                this.x(c, e, false);
            }
        }
        x(a, b, c) {
            let d = true;
            let e = false;
            if (!c) {
                if (this.a.h(b) == 3) {
                    let f = typeCast(DataSourceSpecialRow.$, a.value[0]);
                    if (f.targetRow != null) {
                        let g = this.a.ac(this.a.e(), f.targetRow);
                        let h = this.a.d7(this.a.e(), g, this.a.dy(), this.a.d0());
                        this.y(g, h, f.targetRow, true);
                    }
                    e = true;
                    d = false;
                }
            }
            let i = null;
            if (!e) {
                i = this.a.eg(b);
            }
            this.y(a, b, i, d);
        }
        y(a, b, c, d) {
            if (!this.d.d(a)) {
                this.d.s(a, b);
                if (this.a.aw.c != null && this.a.aw.b != null) {
                    let e = (b >= this.a.aw.c && b <= this.a.aw.b);
                    if (c == null) {
                        e = true;
                    }
                    if (e) {
                        this.a.hj(this.a, b);
                    }
                }
            }
            if (d) {
                this.a.gk(c, a);
            }
        }
        ae(a, b, c, d) {
            if (this.d.d(a)) {
                this.d.f(a);
                if (this.a.aw.c != -1 && this.a.aw.b != -1) {
                    let e = (b >= this.a.aw.c && b <= this.a.aw.b);
                    if (c == null) {
                        e = true;
                    }
                    if (e) {
                        let f = this.a.ad(this.a.e(), b);
                        if (f != null && f.equals(a) && b >= 0) {
                            this.a.hk(this.a, b);
                        }
                    }
                }
            }
            if (d) {
                this.a.gl(c, a);
            }
        }
        ad(a, b, c) {
            let d = true;
            let e = false;
            if (!c) {
                if (this.a.h(b) == 3) {
                    let f = typeCast(DataSourceSpecialRow.$, a.value[0]);
                    if (f.targetRow != null) {
                        let g = this.a.ac(this.a.e(), f.targetRow);
                        let h = this.a.d7(this.a.e(), g, this.a.dy(), this.a.d0());
                        this.ae(g, h, f.targetRow, true);
                    }
                    e = true;
                    d = false;
                }
            }
            let i = null;
            if (!e) {
                i = this.a.eg(b);
            }
            this.ae(a, b, i, d);
        }
        af() {
            let a = this.l();
            let b = new Dictionary$2(ListPanelPrimaryKeyValue.$, Number_$type, 0);
            for (let c = 0; c < a.count; c++) {
                let d = a.item(c);
                let e = -1;
                if (this.d.d(d)) {
                    e = this.d.item(d);
                }
                if (e == -1) {
                    e = this.a.d7(this.a.e(), d, this.a.dy(), this.a.d0());
                }
                if (!b.containsKey(d)) {
                    b.addItem(d, e);
                }
                if (!this.h(d)) {
                    this.x(d, e, true);
                }
            }
            let f = this.d.o;
            let g = this.d.p;
            let h = new List$1(ListPanelPrimaryKeyValue.$, 0);
            let i = new List$1(Number_$type, 0);
            for (let j = 0; j < f.count; j++) {
                if (g._inner[j]) {
                    continue;
                }
                let k = f._inner[j];
                if (!b.containsKey(k)) {
                    h.add(k);
                    i.add(this.d.q._inner[j]);
                }
            }
            for (let l = 0; l < i.count; l++) {
                this.ad(h._inner[l], i._inner[l], false);
            }
            for (let m = 0; m < this.a.ag.ae.count; m++) {
                let n = this.a.ac(this.a.e(), this.a.ag.ae._inner[m]);
                if (n != null && !b.containsKey(n)) {
                    let o = -1;
                    if (this.d.d(n)) {
                        o = this.d.item(n);
                    }
                    if (o == -1) {
                        o = this.a.dv(this.a.e(), n, this.a.dy(), this.a.d0());
                    }
                    this.ad(n, o, false);
                }
            }
        }
        l() {
            return this.a.aj.ae;
        }
        q() {
            this.p();
        }
        r(a) {
            for (let b = 0; b < this.d.o.count; b++) {
                if (this.d.p._inner[b]) {
                    continue;
                }
                let c = this.d.o._inner[b];
                let d = this.d.q._inner[b];
                if (d >= a) {
                    this.d.item(c, d + 1);
                }
            }
            for (let e = 0; e < this.c.o.count; e++) {
                if (this.c.p._inner[e]) {
                    continue;
                }
                let f = this.c.o._inner[e];
                let g = this.c.q._inner[e];
                for (let h = 0; h < g.o.count; h++) {
                    if (this.c.item(f).p._inner[h]) {
                        continue;
                    }
                    let i = g.o._inner[h];
                    let j = this.c.item(f).item(i);
                    if (j >= a) {
                        this.c.item(f).item(i, j + 1);
                    }
                }
            }
        }
        u(a, b, c) {
            this.ae(a, b, c, true);
        }
        s(a, b) {
            let c = new List$1(ListPanelPrimaryKeyValue.$, 0);
            let d = new List$1(Number_$type, 0);
            for (let e = 0; e < this.d.o.count; e++) {
                if (this.d.p._inner[e]) {
                    continue;
                }
                let f = this.d.o._inner[e];
                let g = this.d.q._inner[e];
                if (g == a) {
                    c.add(f);
                    d.add(g);
                }
                if (g > a) {
                    this.d.item(f, g - 1);
                }
            }
            for (let h = 0; h < c.count; h++) {
                this.u(c._inner[h], d._inner[h], b);
            }
            for (let i = 0; i < this.c.o.count; i++) {
                if (this.c.p._inner[i]) {
                    continue;
                }
                let j = this.c.o._inner[i];
                let k = this.c.q._inner[i];
                for (let l = 0; l < k.o.count; l++) {
                    if (this.c.item(j).p._inner[l]) {
                        continue;
                    }
                    let m = k.o._inner[l];
                    let n = this.c.item(j).item(m);
                    if (n == a) {
                        this.c.item(j).item(m, -1);
                    }
                    if (n > a) {
                        this.c.item(j).item(m, n - 1);
                    }
                }
            }
        }
        t(a) {
            let b = new List$1(ListPanelPrimaryKeyValue.$, 0);
            let c = new List$1(Number_$type, 0);
            for (let d = 0; d < this.d.o.count; d++) {
                if (this.d.p._inner[d]) {
                    continue;
                }
                let e = this.d.o._inner[d];
                let f = this.d.q._inner[d];
                if (f == a) {
                    b.add(e);
                    c.add(f);
                }
            }
            for (let g = 0; g < b.count; g++) {
                this.ad(b._inner[g], c._inner[g], true);
            }
        }
        p() {
            let a = new List$1(Number_$type, 0);
            let b = new HashSet$1(Number_$type, 0);
            for (let c = 0; c < this.d.o.count; c++) {
                if (this.d.p._inner[c]) {
                    continue;
                }
                let d = this.d.o._inner[c];
                a.add(this.d.item(d));
                let e = this.a.d7(this.a.e(), d, this.a.dy(), this.a.d0());
                b.add_1(e);
                this.d.item(d, -1);
            }
            for (let f = 0; f < a.count; f++) {
                if (!b.contains(a._inner[f])) {
                    this.a.hk(this.a, a._inner[f]);
                }
            }
        }
        k(a) {
            return this.a.aq == 2;
        }
        z(a) {
            this.m = a;
        }
        o(a, b, c, d = false) {
            if (!this.f(a)) {
                return;
            }
            b = this.k(this.a.aq) ? b : false;
            if (!b || this.m == -1) {
                if (c || d) {
                    this.ab(a);
                }
                else {
                    this.aa(a);
                }
                this.b = null;
                if (this.j(a)) {
                    this.m = a.v;
                }
                else {
                    this.m = -1;
                }
            }
            else {
                let e = ((() => {
                    let $ret = new ListPanelRowRange();
                    $ret.f = Math.min(this.m, a.v);
                    $ret.d = Math.max(this.m, a.v);
                    return $ret;
                })());
                this.a.fe();
                if (this.b != null) {
                    for (let f = this.b.f; f <= this.b.d; f++) {
                        if (!e.b(f)) {
                            let g = this.a.ad(this.a.e(), f);
                            if (g != null && this.d.d(g)) {
                                this.ad(g, f, false);
                            }
                        }
                    }
                }
                for (let h = e.f; h <= e.d; h++) {
                    let i = this.a.ad(this.a.e(), h);
                    if (i != null && !this.d.d(i)) {
                        this.x(i, h, false);
                    }
                }
                this.a.fn();
                this.b = e;
            }
        }
        v() {
            if (this.a.actualDataSource == null) {
                return;
            }
            this.a.fe();
            let a = this.a.d2();
            for (let b = 0; b < a; b++) {
                let c = this.a.actualDataSource.getItemAtIndex(b);
                if (typeCast(DataSourceSpecialRow.$, c) !== null) {
                    continue;
                }
                let d = this.a.ad(this.a.e(), b);
                if (d != null && !this.d.d(d)) {
                    this.x(d, b, false);
                }
            }
            this.a.fn();
        }
    }
    ListPanelSelectionManager.$t = /*@__PURE__*/ markType(ListPanelSelectionManager, 'ListPanelSelectionManager');
    return ListPanelSelectionManager;
})();
/**
 * @hidden
 */
export let ListPanelActivationManager = /*@__PURE__*/ (() => {
    class ListPanelActivationManager extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.b = false;
            this.g = -1;
            this.h = -1;
            this.j = null;
            this.a = a;
        }
        v(a) {
            if (!this.f(a)) {
                return;
            }
            if (this.c(a)) {
                this.q(a);
            }
            else {
                this.n(a);
            }
        }
        f(a) {
            return true;
        }
        c(a) {
            let b = false;
            let c = this.i(a);
            if (c == -1) {
                return false;
            }
            if (this.g < 0) {
                return false;
            }
            if (c != this.g) {
                return false;
            }
            b = this.d(c);
            return b;
        }
        i(a) {
            return a.v;
        }
        d(a) {
            return this.g == a;
        }
        e() {
            return this.a.r == 1;
        }
        o() {
            if (this.g >= 0) {
                this.p(this.g, true);
            }
        }
        q(a) {
            let b = this.i(a);
            if (b == -1) {
                return;
            }
            if (this.d(b)) {
                this.p(b, true);
            }
        }
        n(a) {
            this.m(a);
        }
        m(a) {
            if (!this.f(a)) {
                return;
            }
            if (!this.e()) {
                return;
            }
            if (this.g >= 0) {
                this.p(this.g, false);
            }
            let b = this.i(a);
            if (b == -1) {
                return;
            }
            if (!this.d(b)) {
                this.l(b, true);
            }
        }
        k(a) {
            if (!this.e()) {
                return;
            }
            if (a == this.g) {
                return;
            }
            if (this.g >= 0) {
                this.p(this.g, false);
            }
            let b = a;
            if (b == -1) {
                return;
            }
            if (!this.d(b)) {
                this.l(b, true);
            }
        }
        l(a, b) {
            if (a != this.g) {
                this.g = a;
                if (a >= 0) {
                    if (a >= 0 && a < this.a.d2()) {
                    }
                    this.a.hh(this.a, a);
                }
                if (b) {
                    this.a.f8(a);
                }
            }
        }
        p(a, b) {
            if (this.d(a)) {
                this.g = -1;
                if (a >= 0) {
                    {
                        {
                            if (a >= 0 && a < this.a.d2()) {
                            }
                            this.a.hi(this.a, a);
                        }
                    }
                }
                if (b) {
                    this.a.gb(a);
                }
            }
        }
        r() {
            this.g = -1;
        }
        s(a) {
        }
        t(a) {
        }
        u(a) {
        }
    }
    ListPanelActivationManager.$t = /*@__PURE__*/ markType(ListPanelActivationManager, 'ListPanelActivationManager');
    return ListPanelActivationManager;
})();
