/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, markType } from "igniteui-react-core";
import { ToolContextBindingMode_$type } from "igniteui-react-core";
import { PropertyUpdatedEventArgs } from "igniteui-react-core";
/**
 * @hidden
 */
export let ToolContextBinding = /*@__PURE__*/ (() => {
    class ToolContextBinding extends Base {
        constructor() {
            super();
            this.c = 1;
            this.e = null;
            this.f = null;
            this.propertyChanged = null;
            this.propertyUpdated = null;
        }
        static b(a) {
            return ((() => {
                let $ret = new ToolContextBinding();
                $ret.d = a.bindingMode;
                $ret.h = a.contextKey;
                $ret.j = a.propertyName;
                return $ret;
            })());
        }
        get d() {
            return this.c;
        }
        set d(a) {
            let b = this.c;
            this.c = a;
            if (b != a) {
                this.l("BindingMode", enumGetBox(ToolContextBindingMode_$type, b), enumGetBox(ToolContextBindingMode_$type, a));
            }
        }
        get h() {
            return this.e;
        }
        set h(a) {
            let b = this.e;
            this.e = a;
            if (b != a) {
                this.l("ContextKey", b, a);
            }
        }
        get j() {
            return this.f;
        }
        set j(a) {
            let b = this.f;
            this.f = a;
            if (b != a) {
                this.l("PropertyName", b, a);
            }
        }
        l(a, b, c) {
            this.m(a, b, c);
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
            }
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
        m(a, b, c) {
        }
    }
    ToolContextBinding.$t = /*@__PURE__*/ markType(ToolContextBinding, 'ToolContextBinding', Base.$, [INotifyPropertyChanged_$type]);
    return ToolContextBinding;
})();
