import { ListPanelActiveRowChangedEventArgs as ListPanelActiveRowChangedEventArgs_internal } from "./ListPanelActiveRowChangedEventArgs";
/**
 * Information about the change to the selected cells in the grid.
*/
export class IgrListPanelActiveRowChangedEventArgs {
    createImplementation() {
        return new ListPanelActiveRowChangedEventArgs_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * The new active row.
    */
    get newActiveRow() {
        return this.i.newActiveRow;
    }
    set newActiveRow(v) {
        this.i.newActiveRow = +v;
    }
    /**
     * The old active row.
    */
    get oldActiveRow() {
        return this.i.oldActiveRow;
    }
    set oldActiveRow(v) {
        this.i.oldActiveRow = +v;
    }
}
