import { ListPanelSelectionChangedEventArgs as ListPanelSelectionChangedEventArgs_internal } from "./ListPanelSelectionChangedEventArgs";
/**
 * Event arguments for the SelectionChanged event.
*/
export class IgrListPanelSelectionChangedEventArgs {
    createImplementation() {
        return new ListPanelSelectionChangedEventArgs_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
}
