import { ToolCommandEventArgs as ToolCommandEventArgs_internal } from "./ToolCommandEventArgs";
import { ensureBool } from "igniteui-react-core";
export class IgrToolCommandEventArgs {
    createImplementation() {
        return new ToolCommandEventArgs_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get command() {
        return this.i.a;
    }
    set command(v) {
        this.i.a = v;
    }
    get closeOnExecute() {
        return this.i.b;
    }
    set closeOnExecute(v) {
        this.i.b = ensureBool(v);
    }
}
