/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, runOn, typeCast, fromEnum, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, String_$type, delegateRemove, delegateCombine, Array_$type } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { NativeUIComponent } from "igniteui-react-core";
import { XInputGroup } from "igniteui-react-inputs";
import { XLabel } from "igniteui-react-inputs";
import { List$1 } from "igniteui-react-core";
import { XInput } from "igniteui-react-inputs";
import { NativeUIContent } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { StringComparer } from "igniteui-react-core";
import { InputGroupDisplayType_$type } from "igniteui-react-inputs";
import { ThemeResolver } from "igniteui-react-inputs";
import { ComboEditorTextChangedEventArgs } from "./ComboEditorTextChangedEventArgs";
import { ComboEditorValueChangedEventArgs } from "./ComboEditorValueChangedEventArgs";
import { FastReflectionHelper } from "igniteui-react-core";
import { ComboEditorVisualModelExport } from "./ComboEditorVisualModelExport";
import { AppearanceHelper } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { ComboEditorGotFocusEventArgs } from "./ComboEditorGotFocusEventArgs";
import { ComboEditorLostFocusEventArgs } from "./ComboEditorLostFocusEventArgs";
import { KeyEventArgs } from "igniteui-react-core";
import { InputChangeEventArgs } from "igniteui-react-inputs";
import { FilterFactory } from "igniteui-react-core";
import { IDataSourceUpdateNotifier_$type } from "igniteui-react-core";
import { ComboEditorMultipleDataSourceNotifier } from "./ComboEditorMultipleDataSourceNotifier";
import { BrushUtil } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { stringIsNullOrEmpty, stringEmpty, stringIsNullOrWhiteSpace } from "igniteui-react-core";
/**
 * @hidden
 */
var ComboEditorView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ComboEditorView, _super);
    function ComboEditorView(a) {
        var _this = _super.call(this) || this;
        _this.b = false;
        _this.a = null;
        _this.c = null;
        _this.a = a;
        return _this;
    }
    ComboEditorView.prototype.g = function () {
    };
    ComboEditorView.prototype.r = function () {
        var a = this.c.rootWrapper.getNativeElement();
        var b = (a.getBoundingClientRect());
        return new Rect(0, b.left + window.pageXOffset, b.top + window.pageYOffset, b.width, b.height);
    };
    ComboEditorView.prototype.f = function (a, b) {
        this.c.getPortal(a.an, "ListPanel", function (c) {
            var d = c.componentRef;
            var e = (d.i);
            b(e);
        }, false);
    };
    ComboEditorView.prototype.i = function () {
        if (this.b) {
            this.b = false;
            window.addEventListener("resize", runOn(this, this.q), false);
        }
    };
    ComboEditorView.prototype.h = function () {
        if (!this.b) {
            this.b = true;
            window.removeEventListener("resize", runOn(this, this.q), false);
        }
    };
    ComboEditorView.prototype.q = function (a) {
        var b = this.a.bh;
        if (null == b || false == b.b6) {
            return;
        }
        var c = this.r();
        this.a.bh.cd(c);
    };
    ComboEditorView.prototype.k = function (a) {
        var e_1, _a, e_2, _b;
        var b = this.a;
        var c = typeCast(XInputGroup.$, a.an);
        if (c != null) {
            c.oi = b.k3;
            c.ks = b.jf;
            c.no = b.j6;
            c.eg = b.cx;
            c.np = b.j7;
            c.eh = b.cy;
            c.ei = b.cz;
            c.nq = b.j8;
            c.ej = b.c0;
            c.ek = b.c1;
            c.n6 = b.kd;
            c.e5 = b.c2;
            c.n7 = b.ke;
            c.e6 = b.c3;
            c.e7 = b.c4;
            c.e8 = b.c5;
            try {
                for (var _c = __values(fromEnum(c.inputs)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var d = _d.value;
                    if (d != null && typeCast(XInput.$, d) !== null) {
                        d.cg = b.gb;
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            try {
                for (var _e = __values(fromEnum(c.inputs)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    if (e != null && typeCast(XLabel.$, e) !== null) {
                        e.di = b.j9;
                        var f = e;
                        if (b.av != null) {
                            f.y = b.av;
                        }
                    }
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
    };
    ComboEditorView.prototype.l = function (a) {
        if (this.a.be != null) {
            var b = this.a.be.an;
            for (var c = 0; c < b.inputs.count; c++) {
                if (typeCast(XInput.$, b.inputs._inner[c]) !== null) {
                    b.inputs._inner[c].e = a;
                }
            }
        }
    };
    ComboEditorView.prototype.o = function () {
        if (this.a.disallowTabFocus) {
            var a = this.a.bb.an;
            if (a != null) {
                a.setAttribute("tabIndex", "-1");
            }
            if (this.a.be != null) {
                var b = this.a.be.an;
                for (var c = 0; c < b.inputs.count; c++) {
                    if (typeCast(XInput.$, b.inputs._inner[c]) !== null) {
                        b.inputs._inner[c].be = -1;
                    }
                }
            }
        }
        else {
            var d = this.a.bb.an;
            if (d != null) {
                d.setAttribute("tabIndex", "0");
            }
            if (this.a.be != null) {
                var e = this.a.be.an;
                for (var f = 0; f < e.inputs.count; f++) {
                    if (typeCast(XInput.$, e.inputs._inner[f]) !== null) {
                        e.inputs._inner[f].cu();
                    }
                }
            }
        }
    };
    ComboEditorView.prototype.n = function () {
        if (this.a.bh != null) {
            var a = this.a.bh.an;
            a.ar = this.a.b4;
        }
    };
    ComboEditorView.prototype.p = function () {
        if (this.a.bh != null) {
            var a = this.a.bh.an;
            a.ay = this.a.cb;
        }
    };
    ComboEditorView.prototype.j = function (a) {
        var _this = this;
        if (a == null) {
            this.i();
            this.c = null;
            return;
        }
        this.c = a;
        NativeUIComponent.au(this.c, 7, function (b) {
            _this.c.append(b.an);
            _this.a.id(b);
        });
        this.h();
    };
    ComboEditorView.prototype.d = function () {
        return this.c;
    };
    ComboEditorView.prototype.m = function (a, b) {
    };
    ComboEditorView.prototype.e = function (a, b) {
        var c = (a.an);
        c.remove();
        c.append(b.view.j.rootWrapper);
    };
    ComboEditorView.$t = markType(ComboEditorView, 'ComboEditorView');
    return ComboEditorView;
}(Base));
export { ComboEditorView };
/**
 * @hidden
 */
var ComboEditor = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ComboEditor, _super);
    function ComboEditor() {
        var _this = _super.call(this) || this;
        _this.d0 = null;
        _this.kk = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "BackgroundColor");
        _this.kl = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "BorderColor");
        _this.c8 = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "BorderWidth");
        _this.k5 = XInputGroup.m.ai(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "ContentPadding");
        _this.jh = XInputGroup.m.y(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "CornerRadius");
        _this.km = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderColor");
        _this.c9 = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderWidth");
        _this.kn = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineColor");
        _this.da = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineOpacity");
        _this.db = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineRippleOpacity");
        _this.ko = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineColor");
        _this.dc = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineOpacity");
        _this.dd = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineWidth");
        _this.kp = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineColor");
        _this.de = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineOpacity");
        _this.kq = XInputGroup.m.ad(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleColor");
        _this.df = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineRippleOpacity");
        _this.dg = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleWidth");
        _this.dh = XInputGroup.m.i(ComboEditor.ag, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineWidth");
        _this.bi = null;
        _this.a0 = null;
        _this.ab = null;
        _this.bl = false;
        _this.c = null;
        _this.jt = null;
        _this.ji = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "BackgroundColor");
        _this.af = 0;
        _this.ae = 1;
        _this.ju = null;
        _this.jj = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "BorderColor");
        _this.cm = NaN;
        _this.cc = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "BorderWidth");
        _this.k2 = new Thickness(1, NaN, NaN, NaN, NaN);
        _this.k1 = ThemeResolver.ak(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "ContentPadding");
        _this.je = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.jd = ThemeResolver.aa(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "CornerRadius");
        _this.b = null;
        _this.al = 0;
        _this.ak = 0;
        _this.bw = true;
        _this.jv = null;
        _this.jk = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderColor");
        _this.cn = NaN;
        _this.cd = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderWidth");
        _this.jw = null;
        _this.jl = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineColor");
        _this.co = NaN;
        _this.ce = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineOpacity");
        _this.cp = NaN;
        _this.cf = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineRippleOpacity");
        _this.jx = null;
        _this.jm = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineColor");
        _this.cq = NaN;
        _this.cg = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineOpacity");
        _this.cr = NaN;
        _this.ch = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineWidth");
        _this.du = null;
        _this.f1 = null;
        _this.jy = null;
        _this.jn = ComboEditor.kh;
        _this.as = null;
        _this.ap = null;
        _this.bs = false;
        _this.f4 = null;
        _this.er = "No Matches Found";
        _this.jz = null;
        _this.jo = ComboEditor.ki;
        _this.j0 = null;
        _this.jp = ComboEditor.kj;
        _this.at = null;
        _this.aq = null;
        _this.gc = "";
        _this.j1 = ComboEditor.kr;
        _this.jq = ComboEditor.kr;
        _this.au = null;
        _this.ar = null;
        _this.j2 = null;
        _this.jr = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineColor");
        _this.cs = NaN;
        _this.ci = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineOpacity");
        _this.j3 = null;
        _this.js = ThemeResolver.af(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleColor");
        _this.ct = NaN;
        _this.cj = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleOpacity");
        _this.cu = NaN;
        _this.ck = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleWidth");
        _this.cv = NaN;
        _this.cl = ThemeResolver.k(ComboEditor.ag, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineWidth");
        _this.bk = true;
        _this.d6 = null;
        _this.d5 = null;
        _this.d = null;
        _this.a = null;
        _this.dv = null;
        _this.q = 0;
        _this.b2 = false;
        _this.bn = false;
        _this.bq = false;
        _this.br = false;
        _this.gotFocus = null;
        _this.lostFocus = null;
        _this.textValueChanged = null;
        _this.selectedValueChanged = null;
        _this.keyDown = null;
        _this.change = null;
        _this.changing = null;
        _this.propertyChanged = null;
        _this.a6 = null;
        _this.a9 = null;
        _this.a7 = null;
        _this.bd = null;
        _this.bg = null;
        _this.ac = null;
        _this.d7 = null;
        _this.ca = true;
        _this.dt = 0;
        _this.b6 = false;
        _this.l = null;
        _this.v = 0;
        _this.b5 = false;
        _this.b1 = false;
        _this.b0 = false;
        _this.by = false;
        _this.ba = null;
        _this.a5 = null;
        _this.n = null;
        _this.ds = -1;
        _this.bo = false;
        _this.b8 = false;
        _this.bp = false;
        _this.bm = false;
        _this.a8 = null;
        _this.bf = null;
        var a = _this.aa();
        _this.ab = a;
        return _this;
    }
    ComboEditor.prototype.gy = function () {
        var a = this.ad;
        a.dr = -1;
    };
    Object.defineProperty(ComboEditor.prototype, "bj", {
        get: function () {
            if (this.bi == null) {
                this.bi = new SRProvider(this.ab.c);
                this.bi.cb("ComboEditor");
            }
            return this.bi;
        },
        enumerable: false,
        configurable: true
    });
    ComboEditor.prototype.aa = function () {
        return new ComboEditorView(this);
    };
    ComboEditor.prototype.ip = function (a, b, c) {
        switch (a) {
            case "BackgroundColor":
                this.j4 = this.kf != null ? this.kf : this.kk;
                break;
            case "BorderColor":
                this.j5 = this.kg != null ? this.kg : this.kl;
                break;
            case "BorderWidth":
                this.cw = !isNaN_(this.c6) ? this.c6 : this.c8;
                break;
            case "ContentPadding":
                this.k3 = XInputGroup.oh(this.k4, this.k5);
                break;
            case "CornerRadius":
                this.jf = XInputGroup.kr(this.jg, this.jh);
                break;
            case "FocusBorderColor":
                this.j6 = this.ks != null ? this.ks : this.km;
                break;
            case "FocusBorderWidth":
                this.cx = !isNaN_(this.di) ? this.di : this.c9;
                break;
            case "FocusUnderlineColor":
                this.j7 = this.kt != null ? this.kt : this.kn;
                break;
            case "FocusUnderlineOpacity":
                this.cy = !isNaN_(this.dj) ? this.dj : this.da;
                break;
            case "FocusUnderlineRippleOpacity":
                this.cz = !isNaN_(this.dk) ? this.dk : this.db;
                break;
            case "HoverUnderlineColor":
                this.j8 = this.ku != null ? this.ku : this.ko;
                break;
            case "HoverUnderlineOpacity":
                this.c0 = !isNaN_(this.dl) ? this.dl : this.dc;
                break;
            case "HoverUnderlineWidth":
                this.c1 = !isNaN_(this.dm) ? this.dm : this.dd;
                break;
            case "ItemsSource":
            case "ValueField":
            case "DataSourceDesiredProperties":
            case "Fields":
                this.ja();
                break;
            case "LabelTextColor":
                this.j9 = this.kv != null ? this.kv : ComboEditor.kh;
                break;
            case "LabelTextStyle":
                this.av = this.a2 != null ? this.a2 : ComboEditor.ay;
                break;
            case "NoMatchesFoundLabelTextColor":
                this.kb = this.kx != null ? this.kx : ComboEditor.kj;
                break;
            case "NoMatchesFoundLabelBackgroundColor":
                this.ka = this.kw != null ? this.kw : ComboEditor.ki;
                break;
            case "NoMatchesFoundLabelTextStyle":
                this.aw = this.a3 != null ? this.a3 : ComboEditor.az;
                break;
            case "UnderlineColor":
                this.kd = this.kz != null ? this.kz : this.kp;
                break;
            case "UnderlineOpacity":
                this.c2 = !isNaN_(this.dn) ? this.dn : this.de;
                break;
            case "UnderlineRippleColor":
                this.ke = this.k0 != null ? this.k0 : this.kq;
                break;
            case "UnderlineRippleOpacity":
                this.c3 = !isNaN_(this.dp) ? this.dp : this.df;
                break;
            case "UnderlineRippleWidth":
                this.c4 = !isNaN_(this.dq) ? this.dq : this.dg;
                break;
            case "UnderlineWidth":
                this.c5 = !isNaN_(this.dr) ? this.dr : this.dh;
                break;
            case "BaseTheme":
                this.ah = this.ai == 0 ? 1 : this.ai;
                break;
            case "Density":
                this.am = this.density == 0 ? 0 : this.density;
                break;
            case "TextColor":
                this.kc = this.ky != null ? this.ky : ComboEditor.kr;
                break;
            case "TextStyle":
                this.ax = this.a4 != null ? this.a4 : null;
                break;
            case "ActualDensity":
            case "ActualBaseTheme":
            case "ActualTextColor":
            case "ActualTextStyle":
            case "DisplayType":
            case "ActualBackgroundColor":
            case "ActualBorderColor":
            case "ActualBorderWidth":
            case "ActualContentPadding":
            case "ActualCornerRadius":
            case "ActualFocusBorderColor":
            case "ActualFocusBorderWidth":
            case "ActualFocusUnderlineColor":
            case "ActualFocusUnderlineOpacity":
            case "ActualFocusUnderlineRippleOpacity":
            case "ActualHoverUnderlineColor":
            case "ActualHoverUnderlineOpacity":
            case "ActualHoverUnderlineWidth":
            case "ActualLabelTextColor":
            case "ActualLabelTextStyle":
            case "ActualUnderlineColor":
            case "ActualUnderlineOpacity":
            case "ActualUnderlineRippleColor":
            case "ActualUnderlineRippleOpacity":
            case "ActualUnderlineRippleWidth":
            case "ActualUnderlineWidth":
            case "DropDownButtonVisible":
            case "ActualNoMatchesFoundLabel":
            case "ActualNoMatchesFoundLabelTextColor":
            case "ActualNoMatchesFoundLabelTextStyle":
            case ComboEditor.et:
                this.i1();
                break;
            case "NoMatchesFoundLabel":
                this.actualNoMatchesFoundLabel = stringIsNullOrEmpty(this.f5) ? "No Matches Found" : this.f5;
                break;
            case "Label":
            case "PlaceholderText":
                this.i1();
                this.actualLabelVisible = !stringIsNullOrEmpty(this.f1);
                break;
            case "Text":
                this.i5();
                var d = b != null ? b.toString() : null;
                var e = c != null ? c.toString() : null;
                this.ic(new ComboEditorTextChangedEventArgs(d, e));
                this.io(1, e);
                break;
            case "Value":
                this.h9(new ComboEditorValueChangedEventArgs(b, c));
                this.io(0, c);
                break;
            case "AllowFilter":
                this.g6(this.bu);
                break;
            case "DisallowTabFocus":
                this.ab.o();
                break;
            case "IsFixed":
                this.ab.n();
                break;
            case "UseTopLayer":
                this.ab.p();
                break;
        }
    };
    Object.defineProperty(ComboEditor.prototype, "a1", {
        get: function () {
            if (null == this.a0) {
                this.a0 = new FontInfo();
                this.a0.q = "Verdana";
                this.a0.f = DeviceUtils.f(16);
            }
            return this.a0;
        },
        enumerable: false,
        configurable: true
    });
    ComboEditor.prototype.focus = function (a) {
        this.g8(a);
    };
    ComboEditor.prototype.setName = function (a) {
        this.ab.l(a);
    };
    Object.defineProperty(ComboEditor.prototype, "disallowTabFocus", {
        get: function () {
            return this.bl;
        },
        set: function (a) {
            var b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.h6("DisallowTabFocus", b, this.bl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "g", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.h6("Fields", b, this.c);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "kf", {
        get: function () {
            return this.jt;
        },
        set: function (a) {
            var b = this.jt;
            this.jt = a;
            if (b != this.jt) {
                this.h6("BackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "j4", {
        get: function () {
            return this.ji;
        },
        set: function (a) {
            var b = this.ji;
            this.ji = a;
            if (b != this.ji) {
                this.h6("ActualBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "ai", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.af;
            this.af = a;
            if (b != this.af) {
                this.h6("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "ah", {
        get: function () {
            return this.ae;
        },
        set: function (a) {
            var b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.h6("ActualBaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "kg", {
        get: function () {
            return this.ju;
        },
        set: function (a) {
            var b = this.ju;
            this.ju = a;
            if (b != this.ju) {
                this.h6("BorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "j5", {
        get: function () {
            return this.jj;
        },
        set: function (a) {
            var b = this.jj;
            this.jj = a;
            if (b != this.jj) {
                this.h6("ActualBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "c6", {
        get: function () {
            return this.cm;
        },
        set: function (a) {
            var b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.h6("BorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "cw", {
        get: function () {
            return this.cc;
        },
        set: function (a) {
            var b = this.cc;
            this.cc = a;
            if (b != this.cc) {
                this.h6("ActualBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "k4", {
        get: function () {
            return this.k2;
        },
        set: function (a) {
            var b = this.k2;
            this.k2 = a;
            if (b != this.k2) {
                this.h6("ContentPadding", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "k3", {
        get: function () {
            return this.k1;
        },
        set: function (a) {
            var b = this.k1;
            this.k1 = a;
            if (b != this.k1) {
                this.h6("ActualContentPadding", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "jg", {
        get: function () {
            return this.je;
        },
        set: function (a) {
            var b = this.je;
            this.je = a;
            if (b != this.je) {
                this.h6("CornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "jf", {
        get: function () {
            return this.jd;
        },
        set: function (a) {
            var b = this.jd;
            this.jd = a;
            if (b != this.jd) {
                this.h6("ActualCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "f", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (b != this.b) {
                this.h6("DataSourceDesiredProperties", b, this.b);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "density", {
        get: function () {
            return this.al;
        },
        set: function (a) {
            var b = this.al;
            this.al = a;
            if (b != this.al) {
                this.h6("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "am", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.h6("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "dropDownButtonVisible", {
        get: function () {
            return this.bw;
        },
        set: function (a) {
            var b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.h6("DropDownButtonVisible", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "ks", {
        get: function () {
            return this.jv;
        },
        set: function (a) {
            var b = this.jv;
            this.jv = a;
            if (b != this.jv) {
                this.h6("FocusBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "j6", {
        get: function () {
            return this.jk;
        },
        set: function (a) {
            var b = this.jk;
            this.jk = a;
            if (b != this.jk) {
                this.h6("ActualFocusBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "di", {
        get: function () {
            return this.cn;
        },
        set: function (a) {
            var b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.h6("FocusBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "cx", {
        get: function () {
            return this.cd;
        },
        set: function (a) {
            var b = this.cd;
            this.cd = a;
            if (b != this.cd) {
                this.h6("ActualFocusBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "kt", {
        get: function () {
            return this.jw;
        },
        set: function (a) {
            var b = this.jw;
            this.jw = a;
            if (b != this.jw) {
                this.h6("FocusUnderlineColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "j7", {
        get: function () {
            return this.jl;
        },
        set: function (a) {
            var b = this.jl;
            this.jw = a;
            if (b != this.jl) {
                this.h6("ActualFocusUnderlineColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "dj", {
        get: function () {
            return this.co;
        },
        set: function (a) {
            var b = this.co;
            this.co = a;
            if (b != this.co) {
                this.h6("FocusUnderlineOpacity", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "cy", {
        get: function () {
            return this.ce;
        },
        set: function (a) {
            var b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.h6("ActualFocusUnderlineOpacity", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "dk", {
        get: function () {
            return this.cp;
        },
        set: function (a) {
            var b = this.cp;
            this.cp = a;
            if (b != this.cp) {
                this.h6("FocusUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "cz", {
        get: function () {
            return this.cf;
        },
        set: function (a) {
            var b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.h6("ActualFocusUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "ku", {
        get: function () {
            return this.jx;
        },
        set: function (a) {
            var b = this.jx;
            this.jx = a;
            if (b != this.jx) {
                this.h6("HoverUnderlineColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "j8", {
        get: function () {
            return this.jm;
        },
        set: function (a) {
            var b = this.jm;
            this.jm = a;
            if (b != this.jm) {
                this.h6("ActualHoverUnderlineColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "dl", {
        get: function () {
            return this.cq;
        },
        set: function (a) {
            var b = this.cq;
            this.cq = a;
            if (b != this.cq) {
                this.h6("HoverUnderlineOpacity", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "c0", {
        get: function () {
            return this.cg;
        },
        set: function (a) {
            var b = this.cg;
            this.cg = a;
            if (b != this.cg) {
                this.h6("ActualHoverUnderlineOpacity", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "dm", {
        get: function () {
            return this.cr;
        },
        set: function (a) {
            var b = this.cr;
            this.cr = a;
            if (b != this.cr) {
                this.h6("HoverUnderlineWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "c1", {
        get: function () {
            return this.ch;
        },
        set: function (a) {
            var b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.h6("ActualHoverUnderlineWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "itemsSource", {
        get: function () {
            return this.du;
        },
        set: function (a) {
            var b = this.du;
            this.du = a;
            if (b != this.du) {
                this.h6("ItemsSource", b, this.du);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "actualDataSource", {
        get: function () {
            return this.m();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "fz", {
        get: function () {
            return this.f1;
        },
        set: function (a) {
            var b = this.fz;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.f1 = a;
            this.h6("Label", b, this.f1);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "kv", {
        get: function () {
            return this.jy;
        },
        set: function (a) {
            var b = this.jy;
            this.jy = a;
            if (b != this.jy) {
                this.h6("LabelTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "j9", {
        get: function () {
            return this.jn;
        },
        set: function (a) {
            var b = this.jn;
            this.jn = a;
            if (b != this.jn) {
                this.h6("ActualLabelTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "a2", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.as;
            this.as = a;
            if (b != this.as) {
                this.h6("LabelTextStyle", b, this.as);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "av", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.ap;
            this.ap = a;
            if (this.ap != b) {
                this.h6("ActualLabelTextStyle", b, this.ap);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "actualLabelVisible", {
        get: function () {
            return this.bs;
        },
        set: function (a) {
            var b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.h6("ActualLabelVisible", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "f5", {
        get: function () {
            return this.f4;
        },
        set: function (a) {
            var b = this.f4;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.f4 = a;
            this.h6("NoMatchesFoundLabel", b, this.f4);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "actualNoMatchesFoundLabel", {
        get: function () {
            return this.er;
        },
        set: function (a) {
            var b = this.er;
            this.er = a;
            if (b != this.er) {
                this.h6("ActualNoMatchesFoundLabel", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "kw", {
        get: function () {
            return this.jz;
        },
        set: function (a) {
            var b = this.jz;
            this.jz = a;
            if (b != this.jz) {
                this.h6("NoMatchesFoundLabelBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "ka", {
        get: function () {
            return this.jo;
        },
        set: function (a) {
            var b = this.jo;
            this.jo = a;
            if (b != this.jo) {
                this.h6(ComboEditor.et, b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "kx", {
        get: function () {
            return this.j0;
        },
        set: function (a) {
            var b = this.j0;
            this.j0 = a;
            if (b != this.j0) {
                this.h6("NoMatchesFoundLabelTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "kb", {
        get: function () {
            return this.jp;
        },
        set: function (a) {
            var b = this.jp;
            this.jp = a;
            if (b != this.jp) {
                this.h6("ActualNoMatchesFoundLabelTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "a3", {
        get: function () {
            return this.at;
        },
        set: function (a) {
            var b = this.at;
            this.at = a;
            if (b != this.at) {
                this.h6("NoMatchesFoundLabelTextStyle", b, this.at);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "aw", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.aq;
            this.aq = a;
            if (this.aq != b) {
                this.h6("ActualNoMatchesFoundLabelTextStyle", b, this.aq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "gb", {
        get: function () {
            return this.gc;
        },
        set: function (a) {
            var b = this.gb;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.gc = a;
            this.h6("PlaceholderText", b, this.gc);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "ky", {
        get: function () {
            return this.j1;
        },
        set: function (a) {
            var b = this.j1;
            this.j1 = a;
            if (b != this.j1) {
                this.h6("TextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "kc", {
        get: function () {
            return this.jq;
        },
        set: function (a) {
            var b = this.jq;
            this.jq = a;
            if (b != this.jq) {
                this.h6("ActualTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "a4", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            var b = this.au;
            this.au = a;
            if (b != this.au) {
                this.h6("TextStyle", b, this.au);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "ax", {
        get: function () {
            return this.ar;
        },
        set: function (a) {
            var b = this.ar;
            this.ar = a;
            if (this.ar != b) {
                this.h6("ActualTextStyle", b, this.ar);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "kz", {
        get: function () {
            return this.j2;
        },
        set: function (a) {
            var b = this.j2;
            this.j2 = a;
            if (b != this.j2) {
                this.h6("UnderlineColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "kd", {
        get: function () {
            return this.jr;
        },
        set: function (a) {
            var b = this.jr;
            this.jr = a;
            if (b != this.jr) {
                this.h6("ActualUnderlineColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "dn", {
        get: function () {
            return this.cs;
        },
        set: function (a) {
            var b = this.cs;
            this.cs = a;
            if (b != this.cs) {
                this.h6("UnderlineOpacity", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "c2", {
        get: function () {
            return this.ci;
        },
        set: function (a) {
            var b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.h6("ActualUnderlineOpacity", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "k0", {
        get: function () {
            return this.j3;
        },
        set: function (a) {
            var b = this.j3;
            this.j3 = a;
            if (b != this.j3) {
                this.h6("UnderlineRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "ke", {
        get: function () {
            return this.js;
        },
        set: function (a) {
            var b = this.js;
            this.js = a;
            if (b != this.js) {
                this.h6("ActualUnderlineRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "dp", {
        get: function () {
            return this.ct;
        },
        set: function (a) {
            var b = this.ct;
            this.ct = a;
            if (b != this.ct) {
                this.h6("UnderlineRippleOpacity", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "c3", {
        get: function () {
            return this.cj;
        },
        set: function (a) {
            var b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.h6("ActualUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "dq", {
        get: function () {
            return this.cu;
        },
        set: function (a) {
            var b = this.cu;
            this.cu = a;
            if (b != this.cu) {
                this.h6("UnderlineRippleWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "c4", {
        get: function () {
            return this.ck;
        },
        set: function (a) {
            var b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.h6("ActualUnderlineRippleWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "dr", {
        get: function () {
            return this.cv;
        },
        set: function (a) {
            var b = this.cv;
            this.cv = a;
            if (b != this.cv) {
                this.h6("UnderlineWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "c5", {
        get: function () {
            return this.cl;
        },
        set: function (a) {
            var b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.h6("ActualUnderlineWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "bu", {
        get: function () {
            return this.bk;
        },
        set: function (a) {
            var b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.h6("AllowFilter", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "gg", {
        get: function () {
            return this.d6;
        },
        set: function (a) {
            var b = this.d6;
            this.d6 = a;
            if (b != this.d6) {
                this.h6("TextField", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "text", {
        get: function () {
            return this.d5;
        },
        set: function (a) {
            var b = this.d5;
            this.d5 = a;
            if (b != this.d5) {
                this.h6("Text", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "j", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            var b = this.d;
            this.d = a;
            if (b != this.d) {
                this.h6("ValueField", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "e", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.h6("ActualValueField", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "value", {
        get: function () {
            return this.dv;
        },
        set: function (a) {
            var b = this.dv;
            this.dv = a;
            if (b != this.dv) {
                this.h6("Value", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "s", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            if (b != this.q) {
                this.h6("DisplayType", enumGetBox(InputGroupDisplayType_$type, b), enumGetBox(InputGroupDisplayType_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    ComboEditor.prototype.dx = function (a, b) {
        var c = new FastReflectionHelper(false, b);
        return c.getPropertyValue(a);
    };
    ComboEditor.prototype.ft = function () {
        return this.fs(this.gg);
    };
    ComboEditor.prototype.dy = function (a) {
        var b = this.i();
        if (null == b || b.length == 0) {
            return null;
        }
        var c = new List$1(Base.$, 0);
        for (var e = 0; e < b.length; e++) {
            var d = b[e];
            var f = this.dx(a, d);
            c.add1(f);
        }
        if (c.count == 1) {
            return c._inner[0];
        }
        return c.toArray();
    };
    ComboEditor.prototype.fr = function (a) {
        var b = this.ft();
        var c;
        if (null != b) {
            var d = this.dx(a, b);
            c = null != d ? d.toString() : null;
        }
        else {
            c = null;
        }
        return c;
    };
    ComboEditor.prototype.fs = function (a) {
        if (stringIsNullOrEmpty(a)) {
            var b = this.actualDataSource;
            if (null == b) {
                return null;
            }
            var c = b.actualSchema;
            if (null == c) {
                return null;
            }
            var d = c.propertyNames;
            if (0 == d.length) {
                return null;
            }
            return d[0];
        }
        return a;
    };
    ComboEditor.prototype.h = function (a) {
        var b = new List$1(String_$type, 0);
        if (null == a || a.length == 0) {
            var c = this.fs(null);
            if (stringIsNullOrEmpty(c)) {
                return null;
            }
            b.add(c);
            return b.toArray();
        }
        for (var e = 0; e < a.length; e++) {
            var d = a[e];
            var f = this.fs(d);
            if (null != f) {
                b.add(f);
            }
        }
        if (b.count > 0) {
            return b.toArray();
        }
        return null;
    };
    ComboEditor.prototype.i = function () {
        var a = this.j;
        return this.h(a);
    };
    ComboEditor.prototype.h8 = function (a) {
        this.io(2, a);
    };
    ComboEditor.prototype.io = function (a, b) {
        if (this.b2) {
            return;
        }
        this.b2 = true;
        try {
            switch (a) {
                case 2:
                    {
                        var c = b;
                        var d = void 0;
                        var e = void 0;
                        if (null != c) {
                            d = this.fr(c);
                            e = this.dy(c);
                        }
                        else {
                            d = stringEmpty();
                            e = null;
                        }
                        if (this.text != d) {
                            this.text = d;
                        }
                        if (this.value != e) {
                            this.value = e;
                        }
                    }
                    break;
                case 1:
                    this.i0(b.toString());
                    break;
                case 0:
                    this.iz(b);
                    break;
            }
        }
        finally {
            this.b2 = false;
        }
    };
    ComboEditor.prototype.iy = function (a) {
        this.text = a;
    };
    ComboEditor.prototype.jc = function () {
        this.ax = (null == this.a4) ? this.a1 : this.a4;
        this.av = (null == this.a2) ? this.a1 : this.a2;
    };
    ComboEditor.prototype.i3 = function () {
    };
    ComboEditor.prototype.closeUp = function () {
        this.g0();
    };
    ComboEditor.prototype.destroy = function () {
        this.provideRenderer(null);
    };
    ComboEditor.prototype.dropDown = function () {
        this.g5();
    };
    ComboEditor.prototype.select = function () {
        this.iu();
    };
    ComboEditor.prototype.notifySizeChanged = function () {
        this.ab.g();
    };
    ComboEditor.prototype.provideRenderer = function (a) {
        this.ab.j(a);
        this.actualNoMatchesFoundLabel = !stringIsNullOrWhiteSpace(this.bj.b1("NoMatches")) ? this.bj.b1("NoMatches") : "No Matches Found";
    };
    ComboEditor.prototype.dw = function () {
        return this.u();
    };
    ComboEditor.prototype.fk = function () {
        var a = this.u();
        return a.ak();
    };
    ComboEditor.prototype.u = function () {
        var a = new ComboEditorVisualModelExport();
        a.a = AppearanceHelper.a(this.j4);
        a.i = this.ah;
        a.b = AppearanceHelper.a(this.j5);
        a.n = this.cw;
        a.as = this.k3;
        a.ar = this.jf;
        a.j = this.am;
        a.dropDownButtonVisible = this.dropDownButtonVisible;
        a.o = this.cy;
        a.y = this.fz;
        a.c = AppearanceHelper.a(this.j9);
        a.actualLabelVisible = this.actualLabelVisible;
        a.actualNoMatchesFoundLabel = this.actualNoMatchesFoundLabel;
        a.d = AppearanceHelper.a(this.ka);
        a.e = AppearanceHelper.a(this.kb);
        a.aj = this.gb;
        a.f = AppearanceHelper.a(this.kc);
        a.g = AppearanceHelper.a(this.kd);
        a.p = this.c2;
        a.h = AppearanceHelper.a(this.ke);
        a.q = this.c3;
        a.r = this.c4;
        a.s = this.c5;
        a.al = this.text;
        a.w = this.value;
        if (this.av != null) {
            var b = this.av;
            if (this.ab != null && b.q == null) {
                var c = this.ab.c;
                var d = FontUtil.getFontInfoFromString(c, b.fontString);
                b.q = d.q;
                b.f = d.f;
                b.r = d.r;
                b.t = d.t;
                b.u = d.u;
                b.v = d.v;
            }
            if (b.q != null) {
                a.z = b.q;
            }
            if (!isNaN_(b.f)) {
                a.t = b.f;
            }
            if (b.v != null) {
                a.ad = b.v;
            }
            if (b.t != null) {
                a.ab = b.t;
            }
            if (b.r != null) {
                a.aa = b.t;
            }
        }
        if (this.aw != null) {
            var e = this.aw;
            if (this.ab != null && e.q == null) {
                var f = this.ab.c;
                var g = FontUtil.getFontInfoFromString(f, e.fontString);
                e.q = g.q;
                e.f = g.f;
                e.r = g.r;
                e.t = g.t;
                e.u = g.u;
                e.v = g.v;
            }
            if (e.q != null) {
                a.ae = e.q;
            }
            if (!isNaN_(e.f)) {
                a.u = e.f;
            }
            if (e.v != null) {
                a.ai = e.v;
            }
            if (e.t != null) {
                a.ag = e.t;
            }
            if (e.r != null) {
                a.af = e.t;
            }
        }
        if (this.ax != null) {
            var h = this.ax;
            if (this.ab != null && h.q == null) {
                var i = this.ab.c;
                var j = FontUtil.getFontInfoFromString(i, h.fontString);
                h.q = j.q;
                h.f = j.f;
                h.r = j.r;
                h.t = j.t;
                h.u = j.u;
                h.v = j.v;
            }
            if (h.q != null) {
                a.am = h.q;
            }
            if (!isNaN_(h.f)) {
                a.v = h.f;
            }
            if (h.v != null) {
                a.aq = h.v;
            }
            if (h.t != null) {
                a.ao = h.t;
            }
            if (h.r != null) {
                a.an = h.t;
            }
        }
        return a;
    };
    Object.defineProperty(ComboEditor.prototype, "b4", {
        get: function () {
            return this.bn;
        },
        set: function (a) {
            var b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.h6("IsFixed", b, this.bn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "b9", {
        get: function () {
            return this.bq;
        },
        set: function (a) {
            var b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.h6("OpenAsChild", b, this.bq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "cb", {
        get: function () {
            return this.br;
        },
        set: function (a) {
            var b = this.br;
            this.br = a;
            if (b != this.br) {
                this.h6("UseTopLayer", b, this.br);
            }
        },
        enumerable: false,
        configurable: true
    });
    ComboEditor.prototype.h1 = function (a) {
        if (null != this.gotFocus) {
            this.gotFocus(this, a);
        }
    };
    ComboEditor.prototype.h4 = function (a) {
        if (null != this.lostFocus) {
            this.lostFocus(this, a);
        }
    };
    ComboEditor.prototype.ic = function (a) {
        if (null != this.textValueChanged) {
            this.textValueChanged(this, a);
        }
    };
    ComboEditor.prototype.h9 = function (a) {
        if (null != this.selectedValueChanged) {
            this.selectedValueChanged(this, a);
        }
    };
    ComboEditor.prototype.h6 = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.ip(a, b, c);
    };
    ComboEditor.prototype.h3 = function (a) {
        if (null != this.keyDown) {
            var b = new KeyEventArgs(1, a.g, a.a, a.e, a.b, a.h);
            this.keyDown(this, b);
        }
    };
    ComboEditor.prototype.hq = function (a) {
        var b = new InputChangeEventArgs();
        b.isCompositionInProgress = a.a;
        b.value = a.b;
        if (null != this.changing) {
            this.changing(this, b);
        }
    };
    Object.defineProperty(ComboEditor.prototype, "ad", {
        get: function () {
            return this.ac;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "b7", {
        get: function () {
            return this.dt == 46;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditor.prototype, "bh", {
        get: function () {
            return this.bg;
        },
        enumerable: false,
        configurable: true
    });
    ComboEditor.prototype.id = function (a) {
        this.a9 = a;
        this.h5();
    };
    ComboEditor.prototype.h0 = function () {
        this.ab.i();
    };
    ComboEditor.prototype.hp = function () {
        this.ab.h();
    };
    ComboEditor.prototype.h5 = function () {
        this.g2();
        this.i8();
        this.g1();
        this.bc.bn(this.a7);
        this.i1();
        this.i2();
        this.ab.h();
    };
    ComboEditor.prototype.gv = function (a) {
        var b = this.m();
        if (this.n != null) {
            if (b != null) {
                if (b.filterExpressions.k.contains(this.n)) {
                    b.filterExpressions.remove(this.n);
                }
            }
        }
        this.n = a;
        this.by = false;
        if (a != null && b != null && !b.filterExpressions.k.contains(a)) {
            b.filterExpressions.add(a);
            this.by = true;
        }
        else {
            this.dropDown();
        }
    };
    ComboEditor.prototype.gw = function () {
        var a = this.m();
        if (a != null) {
            if (a.filterExpressions.k.contains(this.n)) {
                a.filterExpressions.remove(this.n);
            }
        }
        this.n = null;
    };
    ComboEditor.prototype.g0 = function () {
        var a = this.bh;
        if (null != a) {
            a.cb();
        }
        this.i2();
        this.gw();
    };
    Object.defineProperty(ComboEditor.prototype, "bb", {
        get: function () {
            return this.a7;
        },
        enumerable: false,
        configurable: true
    });
    ComboEditor.prototype.b3 = function (a) {
        if (null == a) {
            return false;
        }
        var b = this.a7;
        var c = this.ac;
        var d = this.a5;
        return this.bh.t(a) || this.bc.t(a);
    };
    ComboEditor.prototype.g1 = function () {
        var _this = this;
        var a = this.ab.d();
        NativeUIContent.av(a, [7, 2], [2, 2], function (b) {
            _this.a7 = b[0];
            _this.a7.h = 3;
            _this.a7.n = runOn(_this, _this.hk);
            _this.a7.o = runOn(_this, _this.hl);
            _this.bd = b[1];
            _this.a7.bn(_this.bd);
            _this.bd.b7 = _this.text;
            _this.bd.bs = runOn(_this, _this.hf);
            _this.bd.bt = runOn(_this, _this.hg);
            _this.bd.bx = runOn(_this, _this.hi);
            _this.bd.n = runOn(_this, _this.hh);
            _this.bd.bz = runOn(_this, _this.hj);
            _this.g6(_this.bu);
            _this.bd.b6 = ComboEditor.d2;
            _this.bd.bn = runOn(_this, _this.ib);
        });
    };
    Object.defineProperty(ComboEditor.prototype, "be", {
        get: function () {
            return this.bd;
        },
        enumerable: false,
        configurable: true
    });
    ComboEditor.prototype.g2 = function () {
        var _this = this;
        NativeUIContent.av(this.ab.d(), [7, 12, 0, 3, 7], [2, 2, 2, 2, 2], function (a) {
            var b = a[1];
            _this.bg = b;
            _this.a5 = a[2];
            _this.a5.bi = new Thickness(0, 4);
            _this.ba = a[0];
            _this.ba.bn(_this.a5);
            _this.a8 = a[4];
            _this.ba.bn(_this.a8);
            _this.a9.bn(_this.bg);
            _this.bf = a[3];
            _this.bg.bn(_this.ba);
            _this.bg.bw = runOn(_this, _this.ig);
        });
    };
    ComboEditor.prototype.ig = function (a, b) {
        if (this.ad != null && this.a8.bj == 0) {
            this.ad.notifySizeChanged();
        }
    };
    ComboEditor.prototype.ht = function (a, b) {
    };
    ComboEditor.prototype.hw = function (a, b, c) {
    };
    ComboEditor.prototype.hs = function () {
        switch (this.v) {
            case 2:
            case 1:
                if (null == this.l) {
                    this.v = 0;
                }
                break;
        }
        var a = null;
        switch (this.v) {
            case 2:
                {
                    var b = this.l.actualCount;
                    if (b == 0) {
                        this.value = null;
                    }
                    else {
                        if (b > 1) {
                        }
                        a = this.l.getItemAtIndex(0);
                        var c = this.i();
                        var d = new List$1(Base.$, 0);
                        for (var f = 0; f < c.length; f++) {
                            var e = c[f];
                            var g = this.l.getItemProperty(a, e);
                            d.add1(g);
                        }
                        this.value = d.count == 1 ? d._inner[0] : d.toArray();
                    }
                }
                break;
            case 1:
                {
                    var h = this.l.actualCount;
                    if (h == 0) {
                        this.text = stringEmpty();
                    }
                    else {
                        if (h > 1) {
                        }
                        var i = this.ft();
                        a = this.l.getItemAtIndex(0);
                        var j = this.l.getItemProperty(a, i).toString();
                        this.text = j;
                    }
                    var k = this.m();
                    var l = k.indexOfItem(a);
                    this.iw(l);
                }
                break;
            case 0:
            default: return;
        }
        if (null != a) {
            var m = this.m();
            var n = m.indexOfItem(a);
            this.iw(n);
        }
        else {
            this.iw(-1);
        }
        if (this.l != null) {
            this.l.updateNotifier = null;
            this.l = null;
        }
        this.v = 0;
    };
    ComboEditor.prototype.hu = function (a, b) {
    };
    ComboEditor.prototype.hv = function (a, b) {
    };
    ComboEditor.prototype.hz = function (a, b) {
        var c = this.ad;
        if (null != c) {
            var d = c.dr;
            if (-1 != d) {
                if (d >= a && d <= b) {
                    this.it(d);
                    this.i9();
                }
            }
        }
    };
    ComboEditor.prototype.ia = function (a, b, c) {
    };
    ComboEditor.prototype.hr = function () {
        this.ii();
        if (this.b5) {
            var a = this.m();
            var b = a.actualCount;
            if (this.ca && b > 0) {
                this.ik();
            }
            else {
                this.il();
            }
        }
        else {
            this.i7();
        }
    };
    ComboEditor.prototype.h2 = function (a, b) {
    };
    ComboEditor.prototype.h7 = function (a, b) {
    };
    ComboEditor.prototype.g5 = function () {
        this.jb();
        this.hm();
        var a = this.bh;
        if (a.b6) {
            return;
        }
        var b = this.ab.r();
        a.b0 = !this.b5;
        a.ce(b, 1, 1);
        this.i2();
    };
    ComboEditor.prototype.m = function () {
        var a = this.ad;
        if (null != a) {
            return a.actualDataSource;
        }
        return null;
    };
    ComboEditor.prototype.bz = function (a) {
        var b = this.ac.ag;
        var c = b.count;
        if (0 == c) {
            a = null;
            return {
                ret: true,
                p0: a
            };
        }
        else if (1 == c) {
            a = b._inner[0];
        }
        else {
            a = b._inner[0];
        }
        return {
            ret: null != a,
            p0: a
        };
    };
    ComboEditor.prototype.ha = function (a) {
        var b = -1 != a ? a : -1;
        this.it(b);
    };
    ComboEditor.prototype.hc = function () {
        var _this = this;
        if (this.bo) {
            return;
        }
        var a;
        var b = ((function () { var c = _this.bz(a); a = c.p0; return c.ret; })());
        if (!b) {
            return;
        }
        if (a == null) {
            return;
        }
        this.h8(a);
    };
    ComboEditor.prototype.hm = function () {
        this.bh.cc();
    };
    ComboEditor.prototype.ho = function () {
        var a = this.bh;
        if (a.b6) {
            this.closeUp();
            var b = this.bd;
            b.az();
            var c = b.b7;
            var d = null != c ? b.b7.length : 0;
            b.ca(d, d);
        }
    };
    ComboEditor.prototype.hx = function () {
        this.bd.b1 = true;
        this.bd.b9();
        var a = new ComboEditorGotFocusEventArgs();
        this.h1(a);
    };
    ComboEditor.prototype.hy = function () {
        this.closeUp();
        this.bd.b8();
        var a = new ComboEditorLostFocusEventArgs();
        this.h4(a);
    };
    ComboEditor.prototype.il = function () {
        var a = this.ac;
        a.selectedItemsChanged = delegateRemove(a.selectedItemsChanged, runOn(this, this.hd));
        this.bo = true;
        try {
            this.iy(this.d7);
        }
        finally {
            this.bo = false;
            var b = this.ac;
            b.selectedItemsChanged = delegateCombine(b.selectedItemsChanged, runOn(this, this.hd));
        }
        this.b5 = false;
    };
    ComboEditor.prototype.im = function () {
        this.b5 = true;
        if (stringIsNullOrEmpty(this.d7)) {
            if (this.n != null) {
                this.gv(null);
            }
            else {
                this.il();
            }
        }
        else {
            var a = FilterFactory.instance.property(this.ft()).toLower().startsWith(this.d7.toLowerCase());
            this.gv(a);
        }
    };
    ComboEditor.prototype.ir = function () {
        this.dt = 0;
        this.b6 = false;
    };
    ComboEditor.prototype.it = function (a) {
        var b = this.m();
        var c = b.isPlaceholderItem(a);
        if (c) {
        }
        else {
            var d = this.ad;
            if (a < 0) {
                this.b1 = false;
                d.ag.clear();
                if (!this.b1) {
                    this.hc();
                }
                return;
            }
            d.selectedItemsChanged = delegateRemove(d.selectedItemsChanged, runOn(this, this.hd));
            try {
                d.ag.clear();
            }
            finally {
                d.selectedItemsChanged = delegateCombine(d.selectedItemsChanged, runOn(this, this.hd));
            }
            if (a >= 0) {
                var e = b.getItemAtIndex(a);
                this.b1 = false;
                d.ag.add1(e);
                if (!this.b1) {
                    this.hc();
                }
            }
        }
    };
    ComboEditor.prototype.iw = function (a) {
        var b = this.ad;
        if (-1 == a) {
            b.dr = -1;
            return;
        }
        var c = b.dr;
        var d = -1;
        var e;
        this.ds = a;
        d = a;
        this.b0 = false;
        b.dr = d;
        if (!this.b0) {
            this.ha(b.dr);
        }
        this.i9();
    };
    ComboEditor.prototype.i0 = function (a) {
        this.ie(2, a);
    };
    ComboEditor.prototype.iz = function (a) {
        this.ie(1, a);
    };
    ComboEditor.prototype.i1 = function () {
        var a = this;
        if (null != this.bd) {
            this.bd.bp = a.density;
            this.bd.c = a.ah;
            this.bd.bu = a.s;
            this.bd.a8 = a.j4;
            this.bd.a9 = a.j5;
            this.bd.bg = new Thickness(0, a.cw);
            this.bd.bp = a.am;
            this.ab.k(this.bd);
        }
        if (null != this.bd) {
            this.bd.ce = a.kc;
            this.bd.bk = a.ax;
        }
        if (null != this.bd) {
            this.bd.b5 = a.fz;
        }
        if (null != this.a5) {
            this.a5.ba = a.kb;
            this.a5.a8 = a.ka;
            if (null != a.aw) {
                var b = a.aw;
                this.ab.m(this.a5, b);
            }
            this.a5.bs = this.bf;
            this.bf.bm = this.actualNoMatchesFoundLabel;
            this.hm();
        }
        if (null != this.ad) {
        }
    };
    ComboEditor.prototype.i5 = function () {
        if (!this.bo) {
            if (null != this.bd) {
                var a = this.text;
                this.bd.b7 = a;
            }
        }
    };
    ComboEditor.prototype.i2 = function () {
        var a = this.bh;
        var b = null != a ? a.b6 : false;
        this.bd.b6 = b ? ComboEditor.d3 : ComboEditor.d4;
    };
    ComboEditor.prototype.i4 = function () {
        this.jc();
        var a = this.ac.h1();
        var b = Math.min(a.height, 40 * 8);
        this.a8.y = b;
        var c = a.width;
        c = Math.max(c, 150);
        this.a8.ae = c;
    };
    ComboEditor.prototype.i6 = function () {
        if (this.b5) {
            return;
        }
        this.d7 = null;
        if (this.n != null) {
            this.gw();
        }
        else {
            this.i7();
        }
    };
    ComboEditor.prototype.i7 = function () {
        if (null != this.value) {
            var a = this.value;
            var b = typeCast(Array_$type, a) !== null ? a : [a];
            var c = this.m();
            var d = c.indexOfKey(b);
            if (-1 != d) {
                this.iw(d);
            }
        }
    };
    ComboEditor.prototype.i8 = function () {
        var _this = this;
        if (null == this.ad) {
            this.jc();
            this.ab.f(this.a8, function (a) {
                var b = a;
                _this.ac = b;
                var c = _this.ac;
                c.rowUpdating = delegateCombine(c.rowUpdating, runOn(_this, _this.gt));
                _this.ja();
                _this.ad.aq = 1;
                _this.ad.al = 0;
                _this.ad.r = 1;
                _this.a8.a8 = BrushUtil.h(255, 255, 255, 255);
                _this.ac.hz = BrushUtil.h(255, 200, 200, 200);
                _this.ac.ht = BrushUtil.h(255, 100, 100, 100);
                _this.ac.ea = 32;
                _this.ad.hx = BrushUtil.h(0, 0, 0, 0);
                _this.ad.bv = false;
                _this.ad.bq = false;
                var d = _this.ad;
                d.activeRowChanged = delegateCombine(d.activeRowChanged, runOn(_this, _this.g9));
                var e = _this.ad;
                e.selectedItemsChanged = delegateCombine(e.selectedItemsChanged, runOn(_this, _this.hd));
                var f = _this.ad;
                f.itemClicked = delegateCombine(f.itemClicked, runOn(_this, _this.hb));
                _this.ad.a7 = runOn(_this, _this.he);
                _this.i1();
            });
        }
    };
    ComboEditor.prototype.gt = function (a, b) {
        var _this = this;
        if (b.b != null) {
            var c = null;
            if (b.b.ao != "comboItem") {
                NativeUIComponent.au(this.ab.d(), 3, function (d) {
                    var e = d;
                    e.bk = _this.ax;
                    b.b.bs = e;
                    b.b.ao = "comboItem";
                    e.f = 0;
                    e.h = 1;
                    e.bh = new Thickness(0, 5);
                    e.bm = _this.ft() != null ? _this.actualDataSource.getItemProperty(b.a.x, _this.ft()).toString() : "";
                });
            }
            else {
                var d = b.b.bs;
                d.bm = this.ft() != null ? this.actualDataSource.getItemProperty(b.a.x, this.ft()).toString() : "";
            }
        }
    };
    ComboEditor.prototype.ie = function (a, b) {
        var c = this.m();
        if (null == c) {
            return;
        }
        if (null != this.l) {
            if (a != this.v) {
            }
            this.l.updateNotifier = null;
            this.l = null;
        }
        this.v = a;
        var d = new FilterFactory();
        var e = null;
        var f = null;
        switch (a) {
            case 2:
                {
                    var g = this.ft();
                    if (stringIsNullOrEmpty(g)) {
                        return;
                    }
                    e = b.toString();
                    var h = d.property(g);
                    f = h.isEqualTo(e);
                }
                break;
            case 1:
                {
                    var i = this.i();
                    if (i == null || i.length < 1) {
                        return;
                    }
                    var j = typeCast(Array_$type, b) !== null ? b : [b];
                    if (i.length != j.length) {
                        return;
                    }
                    for (var k = 0; k < i.length; k++) {
                        var l = i[k];
                        e = j[k];
                        var m = d.property(l);
                        var n = m.isEqualTo(e);
                        if (null == f) {
                            f = n;
                        }
                        else {
                            f.and(n);
                        }
                    }
                }
                break;
            case 0:
            default: return;
        }
        this.l = c.clone();
        this.l.filterExpressions.clear();
        this.l.updateNotifier = new ComboEditorDataSourceNotificationHandler(this, true);
        this.l.filterExpressions.add(f);
        if (!this.l.isVirtual) {
            this.l.flushAutoRefresh();
        }
    };
    ComboEditor.prototype.ih = function () {
        this.i5();
        var a = this.text;
        var b = this.d7.length;
        var c = !stringIsNullOrEmpty(a) ? a.length : 0;
        if (this.b6 && !stringIsNullOrEmpty(this.d7) && b > 0) {
            b--;
        }
        this.bd.ca(b, c);
    };
    ComboEditor.prototype.ii = function () {
        if (this.by) {
            this.by = false;
            this.dropDown();
        }
    };
    ComboEditor.prototype.ij = function (a) {
        this.d7 = a;
        this.ca = !this.b7;
        this.im();
    };
    ComboEditor.prototype.ik = function () {
        if (stringIsNullOrEmpty(this.d7)) {
            this.gx();
        }
        else {
            this.iw(0);
        }
        this.ih();
        this.b5 = false;
    };
    ComboEditor.prototype.gx = function () {
        var a = this.ad;
        a.dr = -1;
    };
    ComboEditor.prototype.g6 = function (a) {
        if (this.bd != null) {
            this.bd.b0 = !a;
        }
    };
    ComboEditor.prototype.i9 = function () {
        if (!this.bp) {
            return;
        }
        var a = this.ad;
        var b = a.dr;
        if (-1 != b) {
            var c = this.m();
            if (null != c) {
                var d = b < c.actualCount ? c.getItemAtIndex(b) : 0;
                if (null == d) {
                    return;
                }
                a.ci(d);
            }
        }
        else {
            a.ha(0);
        }
    };
    ComboEditor.prototype.ja = function () {
        if (this.ad != null) {
            var a = this.itemsSource;
            this.ad.ag.clear();
            if (this.ad.actualDataSource != null) {
                var b = this.ad.actualDataSource;
                b.schemaChanged = delegateRemove(b.schemaChanged, runOn(this, this.gu));
            }
            this.ad.g = null;
            this.ad.itemsSource = a;
            this.ad.f = this.i();
            this.ds = -1;
            var c = this.m();
            if (null != c) {
                var d = c.updateNotifier;
                var e = new ComboEditorDataSourceNotificationHandler(this, false);
                var f = new ComboEditorMultipleDataSourceNotifier(1, [d, e]);
                c.updateNotifier = f;
                c.propertiesRequested = this.f;
                c.schemaChanged = delegateCombine(c.schemaChanged, runOn(this, this.gu));
                if (this.value != null) {
                    this.ie(1, this.value);
                }
            }
            this.l = null;
        }
    };
    ComboEditor.prototype.gu = function (a, b) {
        if (this.ds != -1) {
            this.iw(this.ds);
            this.ds = -1;
        }
    };
    ComboEditor.prototype.iv = function (a) {
        if (this.bd != null) {
            this.bd.b0 = !a;
        }
    };
    ComboEditor.prototype.jb = function () {
        this.i4();
        if (!this.b5) {
            this.b8 = false;
        }
        else {
            var a = this.m();
            this.b8 = a.actualCount == 0;
        }
        this.a5.bj = this.b8 ? 0 : 1;
        var b = this.a8.bj;
        this.a8.bj = !this.b8 ? 0 : 1;
    };
    ComboEditor.prototype.g8 = function (a) {
        if (this.bd != null) {
            if (a) {
                this.bd.a0();
            }
            else {
                this.bd.az();
            }
        }
    };
    ComboEditor.prototype.iu = function () {
        if (this.bd != null) {
            this.bd.b9();
        }
    };
    Object.defineProperty(ComboEditor.prototype, "bc", {
        get: function () {
            return this.a9;
        },
        enumerable: false,
        configurable: true
    });
    ComboEditor.prototype.ib = function (a, b) {
        b.a = true;
        var c = this.bh;
        if (c.b6) {
            this.closeUp();
        }
        else {
            this.gv(null);
        }
        if (null != this.bd) {
            this.bd.az();
            this.bd.b9();
        }
    };
    ComboEditor.prototype.g9 = function (a, b) {
        var c = b.newActiveRow;
        this.ha(c);
        this.b0 = true;
    };
    ComboEditor.prototype.hb = function (a, b) {
        this.ho();
    };
    ComboEditor.prototype.hd = function (a, b) {
        this.hc();
        this.b1 = true;
    };
    ComboEditor.prototype.he = function () {
        this.bp = this.ad.aw.a;
        this.i9();
    };
    ComboEditor.prototype.hf = function (a, b) {
        if (b.a) {
            return;
        }
        this.hq(b);
        var c = b.b;
        this.ij(c);
    };
    ComboEditor.prototype.hg = function (a, b) {
        var c = this.bd.b7;
        this.ij(c);
    };
    ComboEditor.prototype.hh = function (a, b) {
        this.ir();
    };
    ComboEditor.prototype.hi = function (a, b) {
        this.h3(b);
        if (b.c) {
            return;
        }
        var c = b.g;
        this.dt = c;
        this.b6 = false;
        switch (c) {
            case 8:
                var d = this.bd.b4;
                if (0 == d) {
                    break;
                }
                var e = this.bd.b7;
                if (stringIsNullOrEmpty(e)) {
                    break;
                }
                var f = e.length;
                var g = this.bd.b3;
                var h = g - d;
                if (h > 0 && h < f && g == f) {
                    this.b6 = true;
                }
                break;
            case 40:
                if (b.a) {
                    this.dropDown();
                    this.i6();
                    b.d = true;
                }
                else {
                    var i = this.ad;
                    if (null == i) {
                        return;
                    }
                    var j = this.ad.dr;
                    if (-1 != i.dr) {
                        this.ad.b1(false, false);
                        b.d = true;
                    }
                    else {
                        var k = this.m();
                        if (null != k) {
                            var l = k.actualCount;
                            if (l > 0) {
                                this.iw(0);
                                b.d = true;
                            }
                        }
                    }
                }
                break;
            case 38:
                if (b.a) {
                    this.closeUp();
                    b.d = true;
                }
                else {
                    var m = this.ad;
                    if (null == m) {
                        return;
                    }
                    var n = this.ad.dr;
                    if (null != m.dr) {
                        this.ac.ce(false, false);
                        b.d = true;
                    }
                    else {
                        var o = this.m();
                        if (null != o) {
                            var p = o.actualCount;
                            if (p > 0) {
                                this.iw(p - 1);
                                b.d = true;
                            }
                        }
                    }
                }
                break;
            case 13:
                if (this.bh.b6) {
                    b.f = true;
                }
                this.ho();
                break;
            case 27:
                this.closeUp();
                break;
        }
    };
    ComboEditor.prototype.hj = function (a, b) {
    };
    ComboEditor.prototype.hk = function (a, b) {
        if (this.bm) {
            return;
        }
        this.bm = true;
        this.bd.az();
        this.bm = false;
        var c = b.b;
        if (!this.b3(c)) {
            this.hx();
        }
    };
    ComboEditor.prototype.hl = function (a, b) {
        var c = b.b;
        if (!this.b3(c)) {
            this.hy();
        }
    };
    ComboEditor.$t = markType(ComboEditor, 'ComboEditor', Base.$, [INotifyPropertyChanged_$type]);
    ComboEditor.ag = 1;
    ComboEditor.kh = ThemeResolver.ah(ComboEditor.ag, XLabel.dd, XLabel.c6);
    ComboEditor.kj = ThemeResolver.ah(ComboEditor.ag, XLabel.dd, XLabel.c6);
    ComboEditor.ki = BrushUtil.h(255, 255, 255, 255);
    ComboEditor.ay = null;
    ComboEditor.et = "ActualNoMatchesFoundLabelBackgroundColor";
    ComboEditor.az = null;
    ComboEditor.kr = BrushUtil.h(221, 0, 0, 0);
    ComboEditor.d2 = "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z";
    ComboEditor.d4 = "M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z";
    ComboEditor.d3 = "M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z";
    return ComboEditor;
}(Base));
export { ComboEditor };
/**
 * @hidden
 */
var ComboEditorDataSourceNotificationHandler = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ComboEditorDataSourceNotificationHandler, _super);
    function ComboEditorDataSourceNotificationHandler(a, b) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.b = false;
        _this.a = a;
        _this.b = b;
        return _this;
    }
    ComboEditorDataSourceNotificationHandler.prototype.rangeActualized = function (a, b) {
        if (!this.b) {
            this.a.hz(a, b);
        }
        else {
            this.a.ht(a, b);
        }
    };
    ComboEditorDataSourceNotificationHandler.prototype.notifySetItem = function (a, b, c) {
        if (!this.b) {
            this.a.ia(a, b, c);
        }
        else {
            this.a.hw(a, b, c);
        }
    };
    ComboEditorDataSourceNotificationHandler.prototype.notifyClearItems = function () {
        if (!this.b) {
            this.a.hr();
        }
        else {
            this.a.hs();
        }
    };
    ComboEditorDataSourceNotificationHandler.prototype.notifyInsertItem = function (a, b) {
        if (!this.b) {
            this.a.h2(a, b);
        }
        else {
            this.a.hu(a, b);
        }
    };
    ComboEditorDataSourceNotificationHandler.prototype.notifyRemoveItem = function (a, b) {
        if (!this.b) {
            this.a.h7(a, b);
        }
        else {
            this.a.hv(a, b);
        }
    };
    ComboEditorDataSourceNotificationHandler.$t = markType(ComboEditorDataSourceNotificationHandler, 'ComboEditorDataSourceNotificationHandler', Base.$, [IDataSourceUpdateNotifier_$type]);
    return ComboEditorDataSourceNotificationHandler;
}(Base));
export { ComboEditorDataSourceNotificationHandler };
