/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, INotifyPropertyChanged_$type, PropertyChangedEventArgs, String_$type, typeCast, markType, enumGetBox, EventArgs } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { PropertyEditorValueType_$type } from "./PropertyEditorValueType";
import { List$1 } from "igniteui-react-core";
import { stringEndsWith, stringContains, stringReplace } from "igniteui-react-core";
import { stringSplit } from "igniteui-react-core";
import { PropertyEditorPropertyDescriptionButtonClickEventArgs } from "./PropertyEditorPropertyDescriptionButtonClickEventArgs";
import { PropertyEditorPropertyDescriptionChangedEventArgs } from "./PropertyEditorPropertyDescriptionChangedEventArgs";
import { PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs } from "./PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs";
import { ObservableCollection$1 } from "igniteui-react-core";
/**
 * @hidden
 */
var PropertyEditorDataSource = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PropertyEditorDataSource, _super);
    function PropertyEditorDataSource() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.k = null;
        _this.a = null;
        _this.g = null;
        _this.propertyChanged = null;
        _this.j = null;
        return _this;
    }
    Object.defineProperty(PropertyEditorDataSource.prototype, "n", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            var b = this.k;
            this.k = a;
            this.p("DescriptionType", b, this.k);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorDataSource.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            this.p("Context", b, this.a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorDataSource.prototype, "h", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            var b = this.g;
            this.g = a;
            this.p("Data", b, this.g);
        },
        enumerable: false,
        configurable: true
    });
    PropertyEditorDataSource.prototype.p = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.q(a, b, c);
    };
    PropertyEditorDataSource.prototype.q = function (a, b, c) {
        switch (a) {
            case "DescriptionType":
                this.r();
                break;
            case "Context":
                this.r();
                break;
        }
    };
    PropertyEditorDataSource.d = function (a, b, c) {
        var d = new PropertyEditorDataSource();
        d.j = c;
        d.b = a;
        d.n = b;
        d.j = null;
        return d;
    };
    PropertyEditorDataSource.prototype.f = function (a) {
        var b = new PropertyEditorPropertyDescription();
        b.a3 = a.propertyName;
        b.w = this.i(a);
        b.a2 = a.specificExternalType != null ? a.specificExternalType : a.specificType;
        if (a.knownType == 9) {
            b.ay = a.collectionElementType;
            if (this.j != null && this.j.containsKey(b.ay)) {
                b.e = this.j.item(b.ay);
            }
            else {
                b.e = PropertyEditorDataSource.d(this.a, b.ay, this.j);
            }
        }
        if (b.w == 8) {
            if (this.j != null && this.j.containsKey(b.a2)) {
                b.e = this.j.item(b.a2);
            }
            else {
                b.e = PropertyEditorDataSource.d(this.a, b.a2, this.j);
            }
        }
        if (b.w == 15) {
            b.c = this.a.c(this.n, b.a3);
            b.d = b.d;
        }
        return b;
    };
    PropertyEditorDataSource.prototype.i = function (a) {
        switch (a.knownType) {
            case 10: return 10;
            case 7: return 7;
            case 4: return 4;
            case 6: return 6;
            case 23: return 23;
            case 9: return 9;
            case 5: return 5;
            case 16: return 14;
            case 20: return 18;
            case 22: return 22;
            case 15: return 0;
            case 3: return 3;
            case 19: return 17;
            case 8:
                if (a.specificExternalType == "string") {
                    return 15;
                }
                return 8;
            case 13: return 0;
            case 18: return 0;
            case 1: return 1;
            case 11: return 11;
            case 14: return 13;
            case 12: return 12;
            case 2: return 2;
            case 21: return 19;
            case 17: return 0;
            case 0: return 0;
        }
        return 0;
    };
    PropertyEditorDataSource.prototype.r = function () {
        var a = new PropertyEditorPropertyDescriptionCollection();
        if (this.n != null && this.b != null) {
            var b = false;
            if (this.j == null) {
                b = true;
                this.j = new Dictionary$2(String_$type, PropertyEditorDataSource.$, 0);
            }
            this.j.item(this.n, this);
            var c = this.b.b(this.n);
            if (c == null) {
                return;
            }
            for (var d = 0; d < c.length; d++) {
                if (stringEndsWith(c[d], "@names")) {
                    continue;
                }
                if (stringEndsWith(c[d], "@nameBinding")) {
                    continue;
                }
                if (stringEndsWith(c[d], "@ngQueryList")) {
                    continue;
                }
                if (stringEndsWith(c[d], "@mustSetInCode")) {
                    continue;
                }
                if (stringEndsWith(c[d], "@stringUnion")) {
                    continue;
                }
                var e = this.b.getMetadata(this.n, c[d]);
                var f = this.f(e);
                if (f.w == 0) {
                    continue;
                }
                a.add(f);
            }
            if (b) {
                this.j = null;
            }
        }
        this.h = a;
    };
    PropertyEditorDataSource.prototype.e = function (a, b) {
        if (a == null) {
            return null;
        }
        var c = stringSplit(a, ['.', '['], 0);
        var d = new List$1(String_$type, 1, c);
        var e = null;
        var f = null;
        var g = null;
        while (d.count > 0) {
            var h = d._inner[0];
            d.removeAt(0);
            var i = false;
            if (stringContains(h, "]")) {
                h = stringReplace(h, "]", "");
                i = true;
                var j = h.split(',');
                h = j[0].trim();
                if (stringContains(h, "as")) {
                    var k = h.indexOf("as");
                    g = h.substr(0, k).trim();
                    f = h.substr(k + 2).trim();
                }
                if (f != null && f != this.n) {
                    var l = this.c();
                    l.n = f;
                    e = l;
                    continue;
                }
            }
            if (b) {
                i = true;
            }
            if (e != null && typeCast(PropertyEditorPropertyDescription.$, e) !== null) {
                var m = e.aq(h, i);
                if (m == null) {
                    return null;
                }
                e = m;
            }
            else {
                if (e != null) {
                    var n = e;
                    var o = n.e(h, i);
                    if (o == null) {
                        return null;
                    }
                    e = o;
                }
                else {
                    if (this.h == null) {
                        return null;
                    }
                    for (var p = 0; p < this.h.count; p++) {
                        if (Base.equalsStatic(this.h._inner[p].a3, h)) {
                            e = this.h._inner[p];
                            break;
                        }
                    }
                    if (e == null) {
                        return null;
                    }
                }
            }
        }
        return typeCast(PropertyEditorPropertyDescription.$, e);
    };
    PropertyEditorDataSource.prototype.c = function () {
        var _this = this;
        return ((function () {
            var $ret = new PropertyEditorDataSource();
            $ret.b = _this.b;
            $ret.n = _this.n;
            return $ret;
        })());
    };
    PropertyEditorDataSource.$t = markType(PropertyEditorDataSource, 'PropertyEditorDataSource', Base.$, [INotifyPropertyChanged_$type]);
    return PropertyEditorDataSource;
}(Base));
export { PropertyEditorDataSource };
/**
 * @hidden
 */
var PropertyEditorPropertyDescription = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PropertyEditorPropertyDescription, _super);
    function PropertyEditorPropertyDescription() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.au = null;
        _this.aw = null;
        _this.at = null;
        _this.ax = null;
        _this.u = 0;
        _this.t = 0;
        _this.av = null;
        _this.x = false;
        _this.as = null;
        _this.a = null;
        _this.b = null;
        _this.aa = false;
        _this.ao = null;
        _this.an = null;
        _this.ag = NaN;
        _this.ad = NaN;
        _this.ae = NaN;
        _this.af = NaN;
        _this.ah = NaN;
        _this.g = null;
        _this.f = null;
        _this.k = new PropertyEditorDescriptionObjectCollection();
        _this.j = new PropertyEditorDescriptionObjectCollection();
        _this.y = false;
        _this.q = new PropertyEditorPropertyDescriptionCollection();
        _this.e = null;
        _this.propertyChanged = null;
        _this.buttonClicked = null;
        _this.changed = null;
        _this.targetPropertyUpdating = null;
        _this.coercingValue = null;
        return _this;
    }
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "a0", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            var b = this.au;
            this.au = a;
            if (b != this.au) {
                this.a8("Name", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "a3", {
        get: function () {
            return this.aw;
        },
        set: function (a) {
            var b = this.aw;
            this.aw = a;
            if (this.aw != b) {
                this.a8("PropertyPath", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "az", {
        get: function () {
            return this.at;
        },
        set: function (a) {
            var b = this.at;
            this.at = a;
            if (this.at != b) {
                this.a8("Label", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "a4", {
        get: function () {
            return this.ax;
        },
        set: function (a) {
            var b = this.ax;
            this.ax = a;
            if (this.ax != b) {
                this.a8("Subtitle", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "w", {
        get: function () {
            return this.u;
        },
        set: function (a) {
            var b = this.u;
            this.u = a;
            if (this.u != b) {
                this.a8("ValueType", enumGetBox(PropertyEditorValueType_$type, b), enumGetBox(PropertyEditorValueType_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "v", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.t;
            this.t = a;
            if (this.t != b) {
                this.a8("CoercedValueType", enumGetBox(PropertyEditorValueType_$type, b), enumGetBox(PropertyEditorValueType_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "a2", {
        get: function () {
            return this.av;
        },
        set: function (a) {
            var b = this.av;
            this.av = a;
            if (this.av != b) {
                this.a8("PropertyDescriptionType", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "ab", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.x;
            this.x = a;
            if (this.x != b) {
                this.a8("ShouldOverrideDefaultEditor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "ay", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.as;
            this.as = a;
            if (this.as != b) {
                this.a8("ElementDescriptionType", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "c", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (this.a != b) {
                this.a8("DropDownNames", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "d", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (this.b != b) {
                this.a8("DropDownValues", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "ar", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.ao;
            this.ao = a;
            if (this.ao != b) {
                this.a8("PrimitiveValue", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "ap", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.an;
            this.an = a;
            if (this.ao != b) {
                this.a8("CoercedPrimitiveValue", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "al", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            var b = this.ag;
            this.ag = a;
            if (this.ag != b) {
                this.a8("Min", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "ai", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ad;
            this.ad = a;
            if (this.ad != b) {
                this.a8("EditorWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "aj", {
        get: function () {
            return this.ae;
        },
        set: function (a) {
            var b = this.ae;
            this.ae = a;
            if (this.ae != b) {
                this.a8("LabelWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "ak", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.af;
            this.af = a;
            if (this.af != b) {
                this.a8("Max", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "am", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ah;
            this.ah = a;
            if (this.ah != b) {
                this.a8("Step", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "i", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            var b = this.g;
            this.g = a;
            if (this.g != b) {
                this.a8("ComplexValue", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "h", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            var b = this.f;
            this.f = a;
            if (this.f != b) {
                this.a8("CoercedComplexValue", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "m", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            var b = this.k;
            this.k = a;
            if (this.k != b) {
                this.a8("ComplexValues", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "l", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            var b = this.j;
            this.j = a;
            if (this.j != b) {
                this.a8("CoercedComplexValues", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "ac", {
        get: function () {
            return this.y;
        },
        set: function (a) {
            var b = this.y;
            this.y = a;
            if (this.y != b) {
                this.a8("UseCoercedValue", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "r", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            if (this.q != b) {
                this.a8("Properties", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    PropertyEditorPropertyDescription.prototype.a8 = function (a, b, c) {
        if (a == "PrimitiveValue") {
            this.a7();
        }
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    PropertyEditorPropertyDescription.prototype.z = function (a) {
        var b = false;
        if (a == null) {
            return false;
        }
        if (a.c != null && (this.c == null || !this.ab)) {
            this.c = a.c;
        }
        if (a.d != null && (this.d == null || !this.ab)) {
            this.d = a.d;
        }
        if (a.ay != null && (this.ay == null || !this.ab)) {
            this.ay = a.ay;
        }
        if (a.a2 != null && (this.a2 == null || !this.ab)) {
            this.a2 = a.a2;
        }
        if (a.w != 0 && (this.w == 0 || !this.ab)) {
            this.w = a.w;
            b = true;
        }
        if (a.v != 0 && (this.v == 0 || !this.ab)) {
            this.v = a.v;
            b = true;
        }
        if (a.ac) {
            this.ac = a.ac;
        }
        return true;
    };
    PropertyEditorPropertyDescription.prototype.aq = function (a, b) {
        if (b) {
            return this.e;
        }
        if (this.e != null) {
            return this.e.e(a, false);
        }
        return null;
    };
    PropertyEditorPropertyDescription.prototype.a6 = function () {
        if (this.buttonClicked != null) {
            this.buttonClicked(this, new PropertyEditorPropertyDescriptionButtonClickEventArgs());
        }
    };
    PropertyEditorPropertyDescription.prototype.a5 = function () {
        var _this = this;
        if (this.changed != null) {
            this.changed(this, ((function () {
                var $ret = new PropertyEditorPropertyDescriptionChangedEventArgs();
                $ret.newValue = _this.ar;
                return $ret;
            })()));
        }
    };
    PropertyEditorPropertyDescription.prototype.a9 = function (a, b, c) {
        if (this.targetPropertyUpdating != null) {
            this.targetPropertyUpdating(this, ((function () {
                var $ret = new PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs();
                $ret.propertyPath = a;
                $ret.target = b;
                $ret.value = c;
                return $ret;
            })()));
        }
    };
    PropertyEditorPropertyDescription.prototype.a7 = function () {
        var _this = this;
        if (this.coercingValue != null) {
            var a = ((function () {
                var $ret = new PropertyEditorPropertyDescriptionCoercingValueEventArgs();
                $ret.value = _this.ar;
                $ret.complexValue = _this.i;
                $ret.complexValues = _this.m;
                return $ret;
            })());
            this.coercingValue(this, a);
            this.ap = a.value;
            this.h = a.complexValue;
            this.l = a.complexValues;
        }
    };
    PropertyEditorPropertyDescription.$t = markType(PropertyEditorPropertyDescription, 'PropertyEditorPropertyDescription', Base.$, [INotifyPropertyChanged_$type]);
    return PropertyEditorPropertyDescription;
}(Base));
export { PropertyEditorPropertyDescription };
/**
 * @hidden
 */
var PropertyEditorPropertyDescriptionCoercingValueEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PropertyEditorPropertyDescriptionCoercingValueEventArgs, _super);
    function PropertyEditorPropertyDescriptionCoercingValueEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._value = null;
        _this._complexValue = null;
        _this._complexValues = null;
        return _this;
    }
    Object.defineProperty(PropertyEditorPropertyDescriptionCoercingValueEventArgs.prototype, "value", {
        get: function () {
            return this._value;
        },
        set: function (a) {
            this._value = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescriptionCoercingValueEventArgs.prototype, "complexValue", {
        get: function () {
            return this._complexValue;
        },
        set: function (a) {
            this._complexValue = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescriptionCoercingValueEventArgs.prototype, "complexValues", {
        get: function () {
            return this._complexValues;
        },
        set: function (a) {
            this._complexValues = a;
        },
        enumerable: false,
        configurable: true
    });
    PropertyEditorPropertyDescriptionCoercingValueEventArgs.$t = markType(PropertyEditorPropertyDescriptionCoercingValueEventArgs, 'PropertyEditorPropertyDescriptionCoercingValueEventArgs', EventArgs.$);
    return PropertyEditorPropertyDescriptionCoercingValueEventArgs;
}(EventArgs));
export { PropertyEditorPropertyDescriptionCoercingValueEventArgs };
/**
 * @hidden
 */
var PropertyEditorDescriptionObject = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PropertyEditorDescriptionObject, _super);
    function PropertyEditorDescriptionObject() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        _this.a = null;
        return _this;
    }
    PropertyEditorDescriptionObject.$t = markType(PropertyEditorDescriptionObject, 'PropertyEditorDescriptionObject');
    return PropertyEditorDescriptionObject;
}(Base));
export { PropertyEditorDescriptionObject };
/**
 * @hidden
 */
var PropertyEditorDescriptionObjectCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PropertyEditorDescriptionObjectCollection, _super);
    function PropertyEditorDescriptionObjectCollection() {
        return _super.call(this, PropertyEditorDescriptionObject.$, 0) || this;
    }
    PropertyEditorDescriptionObjectCollection.$t = markType(PropertyEditorDescriptionObjectCollection, 'PropertyEditorDescriptionObjectCollection', ObservableCollection$1.$.specialize(PropertyEditorDescriptionObject.$));
    return PropertyEditorDescriptionObjectCollection;
}(ObservableCollection$1));
export { PropertyEditorDescriptionObjectCollection };
/**
 * @hidden
 */
var PropertyEditorPropertyDescriptionCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PropertyEditorPropertyDescriptionCollection, _super);
    function PropertyEditorPropertyDescriptionCollection() {
        return _super.call(this, PropertyEditorPropertyDescription.$, 0) || this;
    }
    PropertyEditorPropertyDescriptionCollection.$t = markType(PropertyEditorPropertyDescriptionCollection, 'PropertyEditorPropertyDescriptionCollection', ObservableCollection$1.$.specialize(PropertyEditorPropertyDescription.$));
    return PropertyEditorPropertyDescriptionCollection;
}(ObservableCollection$1));
export { PropertyEditorPropertyDescriptionCollection };
