import { __extends } from "tslib";
import { IgrToolAction } from "./igr-tool-action";
import { ToolActionColorEditor } from "./ToolActionColorEditor";
import { brushToString, stringToBrush } from "igniteui-react-core";
var IgrToolActionColorEditor = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrToolActionColorEditor, _super);
    function IgrToolActionColorEditor(props) {
        return _super.call(this, props) || this;
    }
    IgrToolActionColorEditor.prototype.createImplementation = function () {
        return new ToolActionColorEditor();
    };
    Object.defineProperty(IgrToolActionColorEditor.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionColorEditor.prototype, "value", {
        /**
         * Gets or sets the value for the input.
        */
        get: function () {
            return brushToString(this.i.hb);
        },
        set: function (v) {
            this.i.hb = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrToolActionColorEditor;
}(IgrToolAction));
export { IgrToolActionColorEditor };
