import { __extends } from "tslib";
import { delegateCombine, delegateRemove } from "igniteui-react-core";
import { IgrToolActionPopupOpeningEventArgs } from "./igr-tool-action-popup-opening-event-args";
import { IgrToolAction } from "./igr-tool-action";
import { ToolActionIconButton } from "./ToolActionIconButton";
var IgrToolActionIconButton = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrToolActionIconButton, _super);
    function IgrToolActionIconButton(props) {
        var _this = _super.call(this, props) || this;
        _this._popupOpening = null;
        _this._popupOpening_wrapped = null;
        return _this;
    }
    IgrToolActionIconButton.prototype.createImplementation = function () {
        return new ToolActionIconButton();
    };
    Object.defineProperty(IgrToolActionIconButton.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "tooltipDelay", {
        /**
         * Gets or sets how long it takes before the tooltip is displayed (in milliseconds).
        */
        get: function () {
            return this.i.ib;
        },
        set: function (v) {
            this.i.ib = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "actualTooltipDelay", {
        /**
         * Gets the actual delay before the tooltip is displayed (in milliseconds).
        */
        get: function () {
            return this.i.ia;
        },
        set: function (v) {
            this.i.ia = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "contentPaddingLeft", {
        get: function () {
            return this.i.h4;
        },
        set: function (v) {
            this.i.h4 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "actualContentPaddingLeft", {
        get: function () {
            return this.i.h0;
        },
        set: function (v) {
            this.i.h0 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "contentPaddingTop", {
        get: function () {
            return this.i.h6;
        },
        set: function (v) {
            this.i.h6 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "actualContentPaddingTop", {
        get: function () {
            return this.i.h2;
        },
        set: function (v) {
            this.i.h2 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "contentPaddingRight", {
        get: function () {
            return this.i.h5;
        },
        set: function (v) {
            this.i.h5 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "actualContentPaddingRight", {
        get: function () {
            return this.i.h1;
        },
        set: function (v) {
            this.i.h1 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "contentPaddingBottom", {
        get: function () {
            return this.i.h3;
        },
        set: function (v) {
            this.i.h3 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "actualContentPaddingBottom", {
        get: function () {
            return this.i.hz;
        },
        set: function (v) {
            this.i.hz = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "isOpen", {
        get: function () {
            return this.i.a7;
        },
        enumerable: false,
        configurable: true
    });
    IgrToolActionIconButton.prototype.cleanUp = function () {
        this.i.e0();
    };
    IgrToolActionIconButton.prototype.openSubMenu = function () {
        this.i.f0();
    };
    IgrToolActionIconButton.prototype.closeSubmenu = function () {
        this.i.e2();
    };
    IgrToolActionIconButton.prototype.exportVisualData = function () {
        var iv = this.i.ck();
        return (iv);
    };
    Object.defineProperty(IgrToolActionIconButton.prototype, "popupOpening", {
        get: function () {
            return this._popupOpening;
        },
        set: function (ev) {
            var _this = this;
            if (this._popupOpening_wrapped !== null) {
                this.i.popupOpening = delegateRemove(this.i.popupOpening, this._popupOpening_wrapped);
                this._popupOpening_wrapped = null;
                this._popupOpening = null;
            }
            this._popupOpening = ev;
            this._popupOpening_wrapped = function (o, e) {
                var outerArgs = new IgrToolActionPopupOpeningEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforePopupOpening) {
                    _this.beforePopupOpening(_this, outerArgs);
                }
                if (_this._popupOpening) {
                    _this._popupOpening(_this, outerArgs);
                }
            };
            this.i.popupOpening = delegateCombine(this.i.popupOpening, this._popupOpening_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    return IgrToolActionIconButton;
}(IgrToolAction));
export { IgrToolActionIconButton };
