import { IgrToolAction } from "./igr-tool-action";
import { ToolActionPopupOpeningEventArgs as ToolActionPopupOpeningEventArgs_internal } from "./ToolActionPopupOpeningEventArgs";
import { ensureBool } from "igniteui-react-core";
var IgrToolActionPopupOpeningEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrToolActionPopupOpeningEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrToolActionPopupOpeningEventArgs.prototype.createImplementation = function () {
        return new ToolActionPopupOpeningEventArgs_internal();
    };
    Object.defineProperty(IgrToolActionPopupOpeningEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionPopupOpeningEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrToolActionPopupOpeningEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrToolActionPopupOpeningEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrToolActionPopupOpeningEventArgs.prototype, "sourceAction", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrToolAction._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionPopupOpeningEventArgs.prototype, "cancel", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrToolActionPopupOpeningEventArgs;
}());
export { IgrToolActionPopupOpeningEventArgs };
