import { Type } from "igniteui-react-core";
/**
 * Indicates the activation mode to use for the grid.
 */
export declare enum ListPanelActivationMode {
    /**
     * No activation should be peformed based on interaction.
     */
    None = 0,
    /**
     * A single cell is permitted to be activated at a time.
     */
    Cell = 1
}
/**
 * @hidden
 */
export declare let ListPanelActivationMode_$type: Type;
