import { Type } from "igniteui-react-core";
/**
 * Indicates the selection mode to use for the grid.
 */
export declare enum ListPanelSelectionMode {
    /**
     * No selection should be peformed based on interaction.
     */
    None = 0,
    /**
     * A single row is permitted to be selected at a time from interaction.
     */
    SingleRow = 1,
    /**
     * Multiple rows are permitted to be selected at a time from interaction.
     */
    MultipleRow = 2
}
/**
 * @hidden
 */
export declare let ListPanelSelectionMode_$type: Type;
