import { Base, Point, Type, INotifyPropertyChanged, PropertyChangedEventArgs, EventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { NativeUIComponent } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { ListPanelVisualModel } from "./ListPanelVisualModel";
import { Rect } from "igniteui-react-core";
import { IExternalListPanel } from "./IExternalListPanel";
import { NativeUIAbsolutePanel } from "igniteui-react-core";
import { NativeUIGrid } from "igniteui-react-core";
import { ListPanelSelectionMode } from "./ListPanelSelectionMode";
import { Brush } from "igniteui-react-core";
import { ListPanelActivationMode } from "./ListPanelActivationMode";
import { ListPanelSelectionBehavior } from "./ListPanelSelectionBehavior";
import { ListPanelSelectedItemsCollection } from "./ListPanelSelectedItemsCollection";
import { ListPanelSelectedKeysCollection } from "./ListPanelSelectedKeysCollection";
import { IDataSource } from "igniteui-react-core";
import { ScrollbarStyle } from "igniteui-react-core";
import { IExecutionContext } from "igniteui-react-core";
import { ListPanelOrientation } from "./ListPanelOrientation";
import { IListPanelViewportManager } from "./IListPanelViewportManager";
import { ListPanelPrimaryKeyValue } from "./ListPanelPrimaryKeyValue";
import { ListPanelViewportChangedEventArgs } from "./ListPanelViewportChangedEventArgs";
import { ListPanelSelectedItemsChangedEventArgs } from "./ListPanelSelectedItemsChangedEventArgs";
import { ListPanelSelectedKeysChangedEventArgs } from "./ListPanelSelectedKeysChangedEventArgs";
import { ListPanelSelectionChangedEventArgs } from "./ListPanelSelectionChangedEventArgs";
import { ListPanelActiveRowChangedEventArgs } from "./ListPanelActiveRowChangedEventArgs";
import { ListPanelContentRefreshedEventArgs } from "./ListPanelContentRefreshedEventArgs";
import { ListPanelItemPresenter } from "./ListPanelItemPresenter";
import { NativeUIContainer } from "igniteui-react-core";
import { NativeUIContent } from "igniteui-react-core";
import { ListPanelTemplateWidthRequestedEventArgs } from "./ListPanelTemplateWidthRequestedEventArgs";
import { ListPanelTemplateHeightRequestedEventArgs } from "./ListPanelTemplateHeightRequestedEventArgs";
import { ListPanelItemVisualData } from "./ListPanelItemVisualData";
import { Key } from "igniteui-react-core";
import { DataSourceRowType } from "igniteui-react-core";
import { IDataSourceUpdateNotifier } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class ListPanelView extends Base {
    static $t: Type;
    private p;
    private o;
    constructor();
    s(): any;
    a: ListPanel;
    ab(): void;
    j: DomRenderer;
    n: DomWrapper;
    e: RenderingContext;
    m: DomWrapper;
    z(a: DomRenderer): void;
    private t;
    private g;
    private u;
    get contentGrid(): any;
    ae(): void;
    ad(): void;
    y(): void;
    af(): void;
    private b;
    private ag;
    private c;
    private _gridExternal;
    d(): FontInfo;
    aa(): void;
    ac(): void;
    x(a: number, b: number): void;
    h(): number;
    i(a: string): number;
    f: boolean;
    private l;
    private k;
    w(a: any, b: (arg1: any) => void): void;
    v(): void;
}
/**
 * @hidden
 */
export declare class ListPanel extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private _view;
    get view(): ListPanelView;
    set view(a: ListPanelView);
    a4: NativeUIGrid;
    private bc;
    private a5;
    private get a6();
    private y;
    fx(a: NativeUIAbsolutePanel): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    private eb;
    onSizeChanged(a: number, b: number): void;
    viewportChanged: (sender: any, e: ListPanelViewportChangedEventArgs) => void;
    aw: ListPanelVisualModel;
    private df;
    private dg;
    setViewport(a: number, b: number, c: number, d: number): void;
    ad(a: string[], b: number): ListPanelPrimaryKeyValue;
    ac(a: string[], item_: any): ListPanelPrimaryKeyValue;
    d6(a: ListPanelPrimaryKeyValue): number;
    ee(a: ListPanelPrimaryKeyValue): any;
    e(): string[];
    private ap;
    get aq(): ListPanelSelectionMode;
    set aq(a: ListPanelSelectionMode);
    private bf;
    get bv(): boolean;
    set bv(a: boolean);
    private hr;
    get hz(): Brush;
    set hz(a: Brush);
    private a8;
    get bq(): boolean;
    set bq(a: boolean);
    private hp;
    get hx(): Brush;
    set hx(a: Brush);
    private hn;
    get ht(): Brush;
    set ht(a: Brush);
    private c8;
    get dn(): number;
    set dn(a: number);
    private da;
    get dq(): number;
    set dq(a: number);
    private c9;
    get dp(): number;
    set dp(a: number);
    private c7;
    get dm(): number;
    set dm(a: number);
    private q;
    get r(): ListPanelActivationMode;
    set r(a: ListPanelActivationMode);
    private ak;
    get al(): ListPanelSelectionBehavior;
    set al(a: ListPanelSelectionBehavior);
    private b;
    get f(): string[];
    set f(a: string[]);
    private a;
    get d(): string[];
    set d(a: string[]);
    private an;
    get ao(): ListPanelSelectionManager;
    set ao(a: ListPanelSelectionManager);
    private o;
    get p(): ListPanelActivationManager;
    set p(a: ListPanelActivationManager);
    selectedItemsChanged: (sender: any, args: ListPanelSelectedItemsChangedEventArgs) => void;
    selectedKeysChanged: (sender: any, args: ListPanelSelectedKeysChangedEventArgs) => void;
    selectionChanged: (sender: any, args: ListPanelSelectionChangedEventArgs) => void;
    activeRowChanged: (sender: any, args: ListPanelActiveRowChangedEventArgs) => void;
    private af;
    get ag(): ListPanelSelectedItemsCollection;
    private ai;
    get aj(): ListPanelSelectedKeysCollection;
    get itemsSource(): any;
    set itemsSource(a: any);
    private i;
    private c;
    get g(): string[];
    set g(a: string[]);
    get actualDataSource(): IDataSource;
    set actualDataSource(a: IDataSource);
    private bs;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private di;
    get ea(): number;
    set ea(a: number);
    private cy;
    get c2(): number;
    set c2(a: number);
    private a1;
    get a2(): FontInfo;
    set a2(a: FontInfo);
    a3(): FontInfo;
    private bb;
    get bt(): boolean;
    private ec;
    protected gi(a: string, b: any, c: any): void;
    private fj;
    private cz;
    private cx;
    private cw;
    private bl;
    private be;
    private bk;
    gy(): void;
    private fm;
    private fu;
    private dh;
    contentRefreshed: (sender: any, args: ListPanelContentRefreshedEventArgs) => void;
    private g2;
    private fs;
    private fo;
    rowUpdating: (sender: any, args: ListPanelTemplateItemUpdatingEventArgs) => void;
    private ft;
    private fq;
    private a0;
    itemWidthRequested: (sender: any, args: ListPanelTemplateWidthRequestedEventArgs) => void;
    itemHeightRequested: (sender: any, args: ListPanelTemplateHeightRequestedEventArgs) => void;
    private fh;
    private c5;
    private d4;
    private d5;
    private c6;
    private fp;
    private x;
    private az;
    private g5;
    private cv;
    private g1;
    private d9;
    private dw;
    private dx;
    private d8;
    private cp;
    private co;
    private ct;
    private cs;
    c4(a: number): number;
    c3(a: number): number;
    private dl;
    private cu;
    private fg;
    private ds;
    private g7;
    fv(): void;
    private ax;
    get ay(): ScrollbarStyle;
    set ay(a: ScrollbarStyle);
    private hq;
    get hy(): Brush;
    set hy(a: Brush);
    g3(): void;
    private f2;
    private bp;
    private bi;
    private f1;
    fw(): void;
    g4(): void;
    d0(): number;
    dy(): number;
    private dc;
    private dd;
    private ch;
    f0(): void;
    private fz;
    private gz;
    private g0;
    gx(): void;
    private fy;
    private ge;
    private l;
    get externalListPanel(): IExternalListPanel;
    set externalListPanel(a: IExternalListPanel);
    bw: boolean;
    private cg;
    protected gv(a: string, b: any, c: any): void;
    k: IExecutionContext;
    h1(): Size;
    gd(a: number, b: number): void;
    private fi;
    gs(a: number, b: any, c: any): void;
    gc(): void;
    gf(a: number, b: any): void;
    gj(a: number, b: any): void;
    f6(a: number, b: any, c: any): void;
    f3(): void;
    f4(a: number, b: any): void;
    f5(a: number, b: any): void;
    dt(a: any): number;
    du(a: any[]): number;
    static hv: Brush;
    private ho;
    get hu(): Brush;
    set hu(a: Brush);
    static aa: ListPanelOrientation;
    private z;
    get ab(): ListPanelOrientation;
    set ab(a: ListPanelOrientation);
    static br: boolean;
    private bg;
    get bx(): boolean;
    set bx(a: boolean);
    static hw: Brush;
    hs: Brush;
    get h0(): Brush;
    set h0(a: Brush);
    get absoluteWidth(): number;
    get absoluteHeight(): number;
    ed(): any;
    ev(): string;
    private dj;
    private dk;
    private bh;
    get by(): boolean;
    set by(a: boolean);
    hc(): void;
    b7(a: Key, b: boolean, c: boolean): boolean;
    private db;
    bz(): boolean;
    get dr(): number;
    set dr(a: number);
    ff(a: number, b: boolean, c?: boolean): void;
    private g9;
    private hb;
    private d3;
    private d1;
    private dz;
    ha(a: number): void;
    g8(a: number): void;
    private _viewportManager;
    get viewportManager(): IListPanelViewportManager;
    set viewportManager(a: IListPanelViewportManager);
    b1(a: boolean, b: boolean): boolean;
    private gr;
    private cq;
    private cr;
    private hf;
    b2(a: boolean, b: boolean): boolean;
    b6(a: boolean, b: boolean): boolean;
    b8(a: boolean, b: boolean): boolean;
    b9(a: boolean, b: boolean): boolean;
    ca(a: boolean, b: boolean): boolean;
    cb(a: boolean, b: boolean): boolean;
    cd(a: boolean, b: boolean): boolean;
    gu(): void;
    ce(a: boolean, b: boolean): boolean;
    b3(a: boolean, b: boolean): boolean;
    b4(): boolean;
    b5(): boolean;
    cc(a: boolean, b: boolean): boolean;
    fr(): void;
    private ck;
    private cl;
    private cm;
    private cn;
    private ba;
    private a9;
    private bd;
    get bu(): boolean;
    set bu(a: boolean);
    fe(a?: boolean): void;
    fn(): void;
    private bj;
    get b0(): boolean;
    set b0(a: boolean);
    private bn;
    private bm;
    hm(a: List$1<any>, b: List$1<ListPanelPrimaryKeyValue>, c: List$1<any>, d: List$1<ListPanelPrimaryKeyValue>): void;
    private hd;
    private he;
    hj(a: ListPanel, b: number): void;
    gk(a: any, b: ListPanelPrimaryKeyValue): void;
    hk(a: ListPanel, b: number): void;
    gl(a: any, b: ListPanelPrimaryKeyValue): void;
    fd(a: any, b: ListPanelPrimaryKeyValue, c: boolean): void;
    hl(a: number, b: any, c: ListPanelPrimaryKeyValue): void;
    g6(a: any, b: ListPanelPrimaryKeyValue, c: boolean): void;
    private gn;
    private go;
    private gm;
    private gp;
    private cj;
    fk(): void;
    h(a: number): DataSourceRowType;
    d7(a: string[], b: ListPanelPrimaryKeyValue, c: number, d: number): number;
    eg(a: number): any;
    dv(a: string[], b: ListPanelPrimaryKeyValue, c: number, d: number): number;
    d2(): number;
    eh(a: ListPanelItemModel): any;
    gq(a: number, b: any, c: ListPanelPrimaryKeyValue): void;
    hh(a: ListPanel, b: number): void;
    private de;
    private bo;
    f8(a: number): void;
    hi(a: ListPanel, b: number): void;
    gb(a: number): void;
    private f9;
    ci(a: any): boolean;
    a7: () => void;
    private v;
    gg(a: Point, b: boolean, c: boolean, d: boolean): void;
    private w;
    private cf;
    gh(a: Point, b: boolean, c: boolean, d: boolean): void;
    private ga;
    itemClicked: (sender: any, args: ListPanelItemEventArgs) => void;
}
/**
 * @hidden
 */
export declare class ListPanelTemplateItemUpdatingEventArgs extends Base {
    static $t: Type;
    a: ListPanelItemModel;
    d: any;
    c: number;
    b: NativeUIContent;
}
/**
 * @hidden
 */
export declare class ListPanelDataSourceNotificationBridge extends Base implements IDataSourceUpdateNotifier {
    static $t: Type;
    private a;
    constructor(a: ListPanel);
    rangeActualized(a: number, b: number): void;
    notifySetItem(a: number, b: any, c: any): void;
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
}
/**
 * @hidden
 */
export declare class ListPanelLayoutPanel extends Base {
    static $t: Type;
    private a;
    constructor(a: NativeUIAbsolutePanel);
    g(a: Size): void;
    h(): Rect;
    b(a: NativeUIComponent): number;
    c(a: NativeUIComponent): number;
    d(a: ListPanel, b: ListPanelItemModel): void;
    e(a: NativeUIContainer): void;
    f(a: ListPanelItemModel): void;
}
/**
 * @hidden
 */
export declare class ListPanelItemModel extends Base {
    static $t: Type;
    i: boolean;
    v: number;
    t: number;
    private w;
    get x(): any;
    set x(a: any);
    b: ListPanelItemPresenter;
    private e;
    get m(): boolean;
    set m(a: boolean);
    l: boolean;
    private g;
    get o(): boolean;
    set o(a: boolean);
    private h;
    get p(): boolean;
    set p(a: boolean);
    private q;
    get s(): number;
    set s(a: number);
    private r;
    get u(): number;
    set u(a: number);
    private c;
    get j(): boolean;
    set j(a: boolean);
    private d;
    get k(): boolean;
    set k(a: boolean);
    private f;
    get n(): boolean;
    set n(a: boolean);
    a(a: ListPanelLayoutPanel): ListPanelItemVisualData;
}
/**
 * @hidden
 */
export declare class ListPanelItemEventArgs extends EventArgs {
    static $t: Type;
    private _itemInfo;
    get itemInfo(): ListPanelItemModel;
    set itemInfo(a: ListPanelItemModel);
    private _listPanel;
    get listPanel(): ListPanel;
    set listPanel(a: ListPanel);
    private _isLeftButton;
    get isLeftButton(): boolean;
    set isLeftButton(a: boolean);
    private _isDoubleClick;
    get isDoubleClick(): boolean;
    set isDoubleClick(a: boolean);
}
/**
 * @hidden
 */
export declare class ListPanelSelectionManager extends Base {
    static $t: Type;
    private a;
    private d;
    private c;
    private e;
    constructor(a: ListPanel);
    ab(a: ListPanelItemModel): void;
    private f;
    aa(a: ListPanelItemModel): void;
    private n;
    j(a: ListPanelItemModel): boolean;
    private g;
    h(a: ListPanelPrimaryKeyValue): boolean;
    private i;
    private ac;
    private w;
    private x;
    private y;
    private ae;
    private ad;
    af(): void;
    private l;
    q(): void;
    r(a: number): void;
    private u;
    s(a: number, b: any): void;
    t(a: number): void;
    private p;
    private m;
    private b;
    private k;
    z(a: number): void;
    o(a: ListPanelItemModel, b: boolean, c: boolean, d?: boolean): void;
    v(): void;
}
/**
 * @hidden
 */
export declare class ListPanelActivationManager extends Base {
    static $t: Type;
    private a;
    private b;
    private g;
    constructor(a: ListPanel);
    v(a: ListPanelItemModel): void;
    private f;
    c(a: ListPanelItemModel): boolean;
    private i;
    private d;
    private e;
    o(): void;
    private q;
    n(a: ListPanelItemModel): void;
    m(a: ListPanelItemModel): void;
    k(a: number): void;
    private h;
    private j;
    private l;
    private p;
    r(): void;
    s(a: number): void;
    t(a: number): void;
    u(a: number): void;
}
