import { Base, INotifyPropertyChanged, PropertyChangedEventArgs, Type, EventArgs } from "igniteui-react-core";
import { TypeDescriptionContext } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { PropertyEditorValueType } from "./PropertyEditorValueType";
import { PropertyEditorPropertyDescriptionButtonClickEventArgs } from "./PropertyEditorPropertyDescriptionButtonClickEventArgs";
import { PropertyEditorPropertyDescriptionChangedEventArgs } from "./PropertyEditorPropertyDescriptionChangedEventArgs";
import { PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs } from "./PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs";
import { ObservableCollection$1 } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class PropertyEditorDataSource extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private k;
    get n(): string;
    set n(a: string);
    private a;
    get b(): TypeDescriptionContext;
    set b(a: TypeDescriptionContext);
    private g;
    get h(): PropertyEditorPropertyDescriptionCollection;
    set h(a: PropertyEditorPropertyDescriptionCollection);
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected p(a: string, b: any, c: any): void;
    protected q(a: string, b: any, c: any): void;
    static d(a: TypeDescriptionContext, b: string, c: Dictionary$2<string, PropertyEditorDataSource>): PropertyEditorDataSource;
    private j;
    private f;
    private i;
    private r;
    e(a: string, b: boolean): PropertyEditorPropertyDescription;
    private c;
}
/**
 * @hidden
 */
export declare class PropertyEditorPropertyDescription extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private au;
    get a0(): string;
    set a0(a: string);
    private aw;
    get a3(): string;
    set a3(a: string);
    private at;
    get az(): string;
    set az(a: string);
    private ax;
    get a4(): string;
    set a4(a: string);
    private u;
    get w(): PropertyEditorValueType;
    set w(a: PropertyEditorValueType);
    private t;
    get v(): PropertyEditorValueType;
    set v(a: PropertyEditorValueType);
    private av;
    get a2(): string;
    set a2(a: string);
    private x;
    get ab(): boolean;
    set ab(a: boolean);
    private as;
    get ay(): string;
    set ay(a: string);
    private a;
    get c(): string[];
    set c(a: string[]);
    private b;
    get d(): string[];
    set d(a: string[]);
    aa: boolean;
    private ao;
    get ar(): any;
    set ar(a: any);
    private an;
    get ap(): any;
    set ap(a: any);
    private ag;
    get al(): number;
    set al(a: number);
    private ad;
    get ai(): number;
    set ai(a: number);
    private ae;
    get aj(): number;
    set aj(a: number);
    private af;
    get ak(): number;
    set ak(a: number);
    private ah;
    get am(): number;
    set am(a: number);
    private g;
    get i(): PropertyEditorDescriptionObject;
    set i(a: PropertyEditorDescriptionObject);
    private f;
    get h(): PropertyEditorDescriptionObject;
    set h(a: PropertyEditorDescriptionObject);
    private k;
    get m(): PropertyEditorDescriptionObjectCollection;
    set m(a: PropertyEditorDescriptionObjectCollection);
    private j;
    get l(): PropertyEditorDescriptionObjectCollection;
    set l(a: PropertyEditorDescriptionObjectCollection);
    private y;
    get ac(): boolean;
    set ac(a: boolean);
    private q;
    get r(): PropertyEditorPropertyDescriptionCollection;
    set r(a: PropertyEditorPropertyDescriptionCollection);
    e: PropertyEditorDataSource;
    private a8;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    z(a: PropertyEditorPropertyDescription): boolean;
    aq(a: string, b: boolean): any;
    a6(): void;
    a5(): void;
    buttonClicked: (sender: any, args: PropertyEditorPropertyDescriptionButtonClickEventArgs) => void;
    changed: (sender: any, args: PropertyEditorPropertyDescriptionChangedEventArgs) => void;
    targetPropertyUpdating: (sender: any, args: PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs) => void;
    coercingValue: (sender: any, args: PropertyEditorPropertyDescriptionCoercingValueEventArgs) => void;
    a9(a: string, b: any, c: any): void;
    a7(): void;
}
/**
 * @hidden
 */
export declare class PropertyEditorPropertyDescriptionCoercingValueEventArgs extends EventArgs {
    static $t: Type;
    private _value;
    get value(): any;
    set value(a: any);
    private _complexValue;
    get complexValue(): PropertyEditorDescriptionObject;
    set complexValue(a: PropertyEditorDescriptionObject);
    private _complexValues;
    get complexValues(): PropertyEditorDescriptionObjectCollection;
    set complexValues(a: PropertyEditorDescriptionObjectCollection);
}
/**
 * @hidden
 */
export declare class PropertyEditorDescriptionObject extends Base {
    static $t: Type;
    b: string;
    a: PropertyEditorPropertyDescriptionCollection;
}
/**
 * @hidden
 */
export declare class PropertyEditorDescriptionObjectCollection extends ObservableCollection$1<PropertyEditorDescriptionObject> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class PropertyEditorPropertyDescriptionCollection extends ObservableCollection$1<PropertyEditorPropertyDescription> {
    static $t: Type;
    constructor();
}
