import { IgrListPanelItemModel } from "./igr-list-panel-item-model";
import { IgrListPanel } from "./igr-list-panel";
import { ListPanelItemEventArgs as ListPanelItemEventArgs_internal } from "./ListPanelItemEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Event arguments for the SelectionChanged event.
*/
export declare class IgrListPanelItemEventArgs {
    protected createImplementation(): ListPanelItemEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): ListPanelItemEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get itemInfo(): IgrListPanelItemModel;
    set itemInfo(v: IgrListPanelItemModel);
    get listPanel(): IgrListPanel;
    set listPanel(v: IgrListPanel);
    get isLeftButton(): boolean;
    set isLeftButton(v: boolean);
    get isDoubleClick(): boolean;
    set isDoubleClick(v: boolean);
}
