import { IgrToolAction, IIgrToolActionProps } from "./igr-tool-action";
import { ToolActionTextInput } from "./ToolActionTextInput";
export declare class IgrToolActionTextInput extends IgrToolAction<IIgrToolActionTextInputProps> {
    protected createImplementation(): ToolActionTextInput;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionTextInput;
    constructor(props: IIgrToolActionTextInputProps);
    /**
     * Gets or sets the value for the input.
    */
    get value(): string;
    set value(v: string);
}
export interface IIgrToolActionTextInputProps extends IIgrToolActionProps {
    /**
     * Gets or sets the value for the input.
    */
    value?: string;
}
